(* $Id: NatbibConvert.m,v 1.1 2004/10/19 18:35:00 andre Exp $ *)

(* :Title: *)

(* :Context: NatbibConvert` *)

(* :Author: Andre Kuzniarek *)

(* :Summary:
  Conversion rule for etracting natbib bibliography format via TeXExport *)

(* :Copyright: 2004 *)


BeginPackage["NatbibConvert`"];

ConvertAsNatbib::usage = "ConvertAsNatbib takes the entire reference cell and extracts and formats the data required by the natbib \
LaTeX package. This conversion rule needs to be applied ahead of the rest of the converted cell contents, typically in the style \
definition for RefReturnPointer";

Begin["`Private`"];

ConvertAsNatbib[] := Module[{cellExp, nmList, nmString, year, key},

       cellExp = #;
       
       nmList = Flatten @ (Cases[ cellExp,
                  {___, StyleBox[ authLN_, "RefAuthorLN"], ___, StyleBox[ authFN_, "RefAuthorFN"], ___}, Infinity] //. { 
                    StyleBox[ aL_,"RefAuthorLN"], ___, StyleBox[ aF_, "RefAuthorFN"], ___} :> { 
                      aL <> ", " <> aF<> "."});

       nmString = StringJoin @ BoxForm`Intercalate[ nmList, ", "];

       year = cellExp /. Cell[ TextData[{___, StyleBox[ year_,"RefYear"], ___}], ___] :> year;

       key = StringReplace[ cellExp /. Cell[ TextData[{ ButtonBox[ _, ___, ButtonData :> bibKey_, ___], ___}], ___] :> bibKey, ":bib:" -> ""];

       "\bibitem["
         <> 
           If[ StringQ[ nmString], nmString, "NameError"]
             <>
               "("
                 <>
                   If[ StringQ[ year], year, "YearError"]
                     <>
                       ")]{"
                         <>
                           If[ StringQ[ key], key, "KeyError"]
                             <>
                               "}"
                                 <>
                                   Publicon`Utilities`Convert[ cellExp, Publicon`Utilities`ConversionRulesDone -> True] 
                                                                        (* Special option to convert which avoids infinite recursion *)
       ] &
       
End[];

EndPackage[];
