(************** Content-type: application/mathematica **************
                       CreatedBy='Publicon 1.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    125226,       4799]*)
(*NotebookOutlinePosition[    126328,       4835]*)
(*  CellTagsIndexPosition[    126168,       4827]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Elsevier.nb Style Definitions", "Title"],

Cell["\<\
Modify the definitions below to change the default appearance of all cells in \
a given style.  Make modifications to any definition using commands in the \
Format menu.\
\>", "Text"],

Cell[CellGroupData[{

Cell["TeX Configuration", "Section"],

Cell["\<\

\\documentclass{elsart}

\\usepackage{graphicx,amsmath,amscd,amssymb,verbatim,natbib}
\\usepackage[dvips]{hyperref}
\\usepackage[TS1,OT1,T1]{fontenc}\
\>", "Text",
  ShowCellTags->True,
  CellTags->"TeXPreamble"],

Cell[TextData[StyleBox["(Add \[OpenCurlyDoubleQuote]superscriptaddress\
\[CloseCurlyDoubleQuote] to the document class options if you use multiple \
authors and institutions.)",
  FontColor->RGBColor[0, 0, 1]]], "Text"]
}, Closed]],

Cell[CellGroupData[{

Cell["CSS", "Section"],

Cell["\<\
<style type=\"text/css\">
/* global */
body { margin: 10pt }

p.NoSpace { margin: 0pt }

img { vertical-align: middle;  } 

/* Frontmatter */

h1 { margin: 20pt 2pt 4pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 14pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\ttext-transform: uppercase;
\t}

.Subtitle { margin: 4pt 2pt 4pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.Subsubtitle { margin: 4pt 2pt 4pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 14pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: center;
\tcolor: #000000;
\t}

.Date { margin: 3pt 2pt 3pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

a.AuthorData { text-decoration:none; }

.AuthorGroup { margin: 18pt 2pt 0pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.AuthorPACS { margin: 24pt 48pt 12pt 48pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.Institution { margin: 0pt 2pt 0pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: center;
\tcolor: #000000;
\t}

.InstitutionNumber { font-weight:bold; }

.Abstract { margin: 24pt 48pt 3pt 48pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\ttext-indent: 10pt;
\ttext-align: justify;
\t}

/* mainmatter */

h3 { margin: 24pt 2pt 10pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\ttext-transform: uppercase; 
\t}

h4 { margin: 16pt 2pt 10pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

h5 { margin: 16pt 2pt 10pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: center;
\tcolor: #000000;
\t}

.Subsubsubsection {
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000000;
\t}

.Text { margin: 4pt 2pt 4pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\ttext-indent: 12pt;
\ttext-align: justify;
\t}

.TextNoIndent, .TextContinuation, .SubsubsubsectionText { margin: 4pt 2pt 4pt \
2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\ttext-align: justify;
\t}

/* Itemized Lists */

li { margin: 3pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size:10pt;
\t}

ul, ol { margin-left:18pt; margin-top: 3pt; margin-bottom: 3pt; }
ul ul, ul ul ul, ol ol, ol ol ol { margin-left:18pt }

ul { list-style: disc; }

ol ol { list-style: lower-alpha; }

ol ol ol{ list-style: lower-roman; }

.Item1Paragraph, .Item2Paragraph, .Item3Paragraph { margin-top: 3pt; \
margin-bottom: 3pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* Illustrations */

.Figure, .Picture, .Graphics { margin: 7pt 2pt 7pt 2pt; text-align:center;  }

.FigureCaption { margin: 3pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\tcolor: #000000;
\ttext-align: center;
\t}

table { margin: 1pt 2pt 1pt 2pt; }

table.TableMasterGrid { width:100%; 
\tmargin: 3pt 2pt 3pt 2pt;
\tborder-bottom: 1pt solid #000000;
\tborder-top: 1pt solid #000000;
\t}

table.TableMasterGrid td.TableLineElement {
\tborder-bottom: solid 1pt #000000;
\tfont-size: 1pt;
\tline-height: 0pt;
\t}

.TableTitle { margin: 7pt 2pt 0pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\ttext-indent: 12pt;
\tborder-bottom: 1px solid black;
\t}

table { margin: 1pt 2pt 1pt 2pt; }

.TableNote { margin: 0pt 2pt 7pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\tborder-top: 1px solid black;
\t}

.TableColumnHead, .TableSpanHead { 
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic; 
\tcolor: #000000;
\t}

.TableText, .TableSpanText {
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal; 
\tcolor: #000000;
\t}

/* mathematics */

.Equation, .EquationWide, 
.EquationNumbered, .EquationWideNumbered, 
.AppendixEquation,
.EquationGroupAlignedNumbered, .EquationGroupAligned,
.EquationGroupNumbered, .EquationGroup {
\tmargin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal; 
\ttext-align: center; 
\tfont-style: normal; 
\tcolor: #000000;
\t}

table.EquationNumbered {
\twidth: 100%;
\t}

table.AppendixEquation {
\twidth: 100%;
\t}

table.AppendixEquation td.AppendixEquationLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationNumbered td.EquationNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationGroup,
table.EquationGroupNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

p.EquationGroup {
\tpadding-left: 4.5%;
\t}

table.EquationGroupNumbered td.EquationGroupNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

.EquationGroupAligned table {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tpadding-left: 4.5%;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

.EquationGroupAligned table td,
.EquationGroupAligned table th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

table.EquationGroupAlignedNumbered td,
table.EquationGroupAlignedNumbered th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered td.EquationGroupAlignedNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

/* Cross-References */

.XRef { color: #000000; text-decoration:none }
.DkBlue { color: #000080; }

/* Backmatter */

.Reference, .Endnote { margin: 1pt 2pt 1pt 2pt;
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

td.EndnoteLabel { width: 32px; }
td.ReferenceLabel { width: 32px; }

.RefJournalVolume { font-weight:bold; }
.RefTitle,.RefBookTitle { font-style:italic; }

/* miscellaneous */

.PageBreak { page-break-before:always; }

/* Common Inline */

.RM  { font-style: normal; font-weight: normal }
.BF  { font-style: normal; font-weight: bold }
.IT  { font-style: italic; font-weight: normal }
.TR  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: normal }
.TI  { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: normal }
.TB  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: bold }
.TBI { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: bold }
.MR  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MO  { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: normal }
.MB  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MBO { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: bold }
.SR  { font-family: Helvetica, Arial; font-style: normal; font-weight: normal \
}
.SO  { font-family: Helvetica, Arial; font-style: italic; font-weight: normal \
}
.SB  { font-family: Helvetica, Arial; font-style: normal; font-weight: bold }
.SBO { font-family: Helvetica, Arial; font-style: italic; font-weight: bold }

/* conformance */

.Input { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.Output { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.CellLabel { margin: 7pt 2pt 2pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #0000ff;
\t}

</style>\
\>", "Text",
  CellTags->"CSSDefinitions"]
}, Closed]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Screen"],
  CellBracketOptions->{"Color"->RGBColor[0, 0.2, 1]},
  ScriptMinSize->9],

Cell[StyleData[All, "Presentation"],
  PageWidth->WindowWidth,
  ScrollingOptions->{"PagewiseDisplay"->True},
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
  ScriptMinSize->12],

Cell[StyleData[All, "Printout"],
  PageWidth->PaperWidth,
  Hyphenation->True,
  PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "Preprint"],
  Hyphenation->True,
  LineSpacing->{2, 1},
  ScriptMinSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
The options defined for the style below will be used at the Notebook level. \
\
\>", "Text"],

Cell[StyleData["Notebook"],
  PageHeaders->{{Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
          TextData[ {
            OptionValueBox[ "FileName"]}], "Header"]}, {Cell[ 
          TextData[ {
            OptionValueBox[ "FileName"]}], "Header"], None, Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"]}},
  PrintingOptions->{"FirstPageHeader"->False,
  "FacingPages"->True},
  CellElementSpacings->{"ClosedCellHeight"->9},
  CellLabelAutoDelete->False,
  CellFrameLabelMargins->6,
  InputAutoReplacements->{"TeX"->FormBox[ 
          StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}], SingleLetterItalics -> False], TraditionalForm], 
      "LaTeX"->FormBox[ 
          StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.5, -0.3}, {0, -0}}, 
                  BoxBaselineShift -> -0.4], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}], SingleLetterItalics -> False], TraditionalForm], 
      "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
      "--"->"\[Dash]", "---"->"\[LongDash]", 
      " \""->" \[OpenCurlyDoubleQuote]", 
      "\"'"->"\[OpenCurlyDoubleQuote]\[OpenCurlyQuote]", 
      "'\""->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ".\""->".\[CloseCurlyDoubleQuote]", ",\""->",\[CloseCurlyDoubleQuote]", 
      "?\""->"?\[CloseCurlyDoubleQuote]", ";\""->";\[CloseCurlyDoubleQuote]", 
      ":\""->":\[CloseCurlyDoubleQuote]", "!\""->"!\[CloseCurlyDoubleQuote]", 
      " '"->" \[OpenCurlyQuote]", "',"->"\[CloseCurlyQuote],", 
      "'."->"\[CloseCurlyQuote].", "';"->"\[CloseCurlyQuote];", 
      "':"->"\[CloseCurlyQuote]:", "'!"->"\[CloseCurlyQuote]!", 
      ",\""->",\[CloseCurlyQuote]", ".'"->".\[CloseCurlyQuote]", 
      "?'"->"?\[CloseCurlyQuote]", ";'"->";\[CloseCurlyQuote]", 
      ":'"->":\[CloseCurlyQuote]", "!'"->"!\[CloseCurlyQuote]", 
      ". '"->". \[OpenCurlyQuote]", ", '"->", \[OpenCurlyQuote]", 
      "? '"->"? \[OpenCurlyQuote]", "; '"->"; \[OpenCurlyQuote]", 
      ": '"->": \[OpenCurlyQuote]", "! '"->"! \[OpenCurlyQuote]", 
      ", \""->", \[OpenCurlyDoubleQuote]", 
      ". \""->". \[OpenCurlyDoubleQuote]", 
      "? \""->"? \[OpenCurlyDoubleQuote]", 
      "; \""->"; \[OpenCurlyDoubleQuote]", 
      ": \""->": \[OpenCurlyDoubleQuote]", 
      "! \""->"! \[OpenCurlyDoubleQuote]", "\","->"\[CloseCurlyDoubleQuote],",
       "\"."->"\[CloseCurlyDoubleQuote].", "\";"->"\[CloseCurlyDoubleQuote];",
       "\":"->"\[CloseCurlyDoubleQuote]:", "\"!"->"\[CloseCurlyDoubleQuote]!",
       "'a "->"\[CloseCurlyQuote]a ", "'d "->"\[CloseCurlyQuote]d ", 
      "'l "->"\[CloseCurlyQuote]l ", "'ll "->"\[CloseCurlyQuote]ll ", 
      "'m "->"\[CloseCurlyQuote]m ", "'o "->"\[CloseCurlyQuote]o ", 
      "'ol "->"\[CloseCurlyQuote]ol ", "'Ol "->"\[CloseCurlyQuote]Ol ", 
      "'r "->"\[CloseCurlyQuote]r ", "'s "->"\[CloseCurlyQuote]s ", 
      "'t "->"\[CloseCurlyQuote]t ", "'ve "->"\[CloseCurlyQuote]ve ", 
      "'er "->"\[CloseCurlyQuote]er ", "'re "->"\[CloseCurlyQuote]re ", 
      "'y "->"\[CloseCurlyQuote]y ", "'z "->"\[CloseCurlyQuote]z ", 
      "'x "->"\[CloseCurlyQuote]x ", "\" "->"\[CloseCurlyDoubleQuote] ", 
      "\"\""->"\[OpenCurlyDoubleQuote]", "''"->"\[OpenCurlyQuote]", 
      "'tis "->"\[CloseCurlyQuote]tis ", "'ts "->"\[CloseCurlyQuote]ts ", 
      "' "->"\[CloseCurlyQuote] ", "'am "->"\[CloseCurlyQuote]am ", 
      ",'\" "->",\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ".'\""->".\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "?'\""->"?\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ";'\""->";\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ":'\""->":\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "!'\""->"!\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "'\","->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote],", 
      "'\"."->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote].", 
      "'\"?"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]?", 
      "'\";"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote];", 
      "'\":"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]:", 
      "'\"!"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]!"},
  StyleMenuListing->None],

Cell["\"AllowsIndexedHeadersFooters\"->False", "MiscSettings"]
}, Closed]],

Cell[CellGroupData[{

Cell["Frontmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["FrontmatterGroup"],
  Editable->False,
  CellMargins->{{12, 10}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"\n\\begin{frontmatter}", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["FrontmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["FrontmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["FrontmatterGroup", "Preprint"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell["Title", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Title"],
  CellMargins->{{12, 12}, {4, 20}},
  CellGroupingRules->{"SectionGrouping", 20},
  ConversionRules:>{"TeX" -> {"\n\\title{", Automatic, "}"}},
  PageBreakBelow->False,
  TextAlignment->Center,
  LineSpacing->{1, 2},
  CounterIncrements->"Title",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->18,
  FontWeight->"Bold"],

Cell[StyleData["Title", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {6, 30}},
  FontSize->27],

Cell[StyleData["Title", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14],

Cell[StyleData["Title", "Preprint"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
  CellMargins->{{12, 12}, {4, 4}},
  CellGroupingRules->"NormalGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  PageBreakBelow->False,
  TextAlignment->Center,
  LineSpacing->{1, 2},
  CounterIncrements->"Subtitle",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["Subtitle", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {6, 6}},
  FontSize->24],

Cell[StyleData["Subtitle", "Printout"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->12],

Cell[StyleData["Subtitle", "Preprint"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
  CellMargins->{{12, 12}, {4, 4}},
  CellGroupingRules->"NormalGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  PageBreakBelow->False,
  TextAlignment->Center,
  LineSpacing->{1, 2},
  CounterIncrements->"Subsubtitle",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->16,
  FontSlant->"Italic"],

Cell[StyleData["Subsubtitle", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {6, 6}},
  FontSize->24],

Cell[StyleData["Subsubtitle", "Printout"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->12],

Cell[StyleData["Subsubtitle", "Preprint"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->12]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Date", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Date"],
  CellMargins->{{12, 12}, {3, 3}},
  ConversionRules:>{"TeX" -> {"\n", 
    NoOutput[ ], "\\date{\\today}"}},
  TextAlignment->Center,
  ParagraphSpacing->{0, 8},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Date", "Presentation"],
  CellMargins->{{12, 12}, {5, 5}},
  FontSize->17],

Cell[StyleData["Date", "Printout"],
  CellMargins->{{2, 2}, {2, 2}},
  LineSpacing->{1, 1},
  FontSize->9],

Cell[StyleData["Date", "Preprint"],
  CellMargins->{{12, 12}, {3, 3}},
  FontSize->11]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Author", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Author"],
  Selectable->False,
  CellMargins->{{12, 12}, {0, 18}},
  ConversionRules:>{"TeX" -> {"", 
    ExtractCellTaggingRules[ "AuthorData", "TeX", 1], ""}},
  TextAlignment->Left,
  ParagraphSpacing->{0, 0},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->16],

Cell[StyleData["Author", "Presentation"],
  CellMargins->{{12, 12}, {0, 27}},
  FontSize->21],

Cell[StyleData["Author", "Printout"],
  CellMargins->{{2, 2}, {0, 15}},
  FontSize->10],

Cell[StyleData["Author", "Preprint"],
  CellMargins->{{2, 2}, {0, 15}},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorData"],
  Selectable->False,
  ConversionRules:>{"HTML" -> {"<sup>", 
    GetAuthorData[ ], "</sup>"}},
  ScriptMinSize->10,
  StyleMenuListing->None],

Cell[StyleData["AuthorData", "Printout"],
  ScriptMinSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorGroup"],
  Editable->False,
  CellMargins->{{12, 12}, {0, 18}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n", Automatic, ""}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontSize->16,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["AuthorGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {0, 27}},
  FontSize->21],

Cell[StyleData["AuthorGroup", "Printout"],
  CellMargins->{{2, 2}, {0, 15}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AuthorGroup", "Preprint"],
  CellMargins->{{2, 2}, {0, 15}},
  FontSize->12,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["AuthorFirstName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorMiddleName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorLastName"],
  Editable->True,
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorNameSuffix"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorAffiliation"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[CellGroupData[{

Cell[StyleData["AuthorEmail"],
  SingleLetterItalics->False,
  StyleMenuListing->None,
  FontSize->18,
  FontWeight->"Plain",
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None",
  ButtonNote->ButtonData}],

Cell[StyleData["AuthorEmail", "Presentation"],
  FontSize->26],

Cell[StyleData["AuthorEmail", "Printout"],
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["AuthorEmail", "Preprint"],
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Author Form Customization", "Subsection"],

Cell["\<\
Field Correlations:

AUTHORNAME -> \\author{}
Email -> \\ead{}
Homepage -> \\ead[url]{}
Institution -> \\address{}\
\>", "AuthorFormCustomizationTemplate",
  FontFamily->"Courier",
  CellTags->"AuthorFormCustomization"]
}, Closed]],

Cell[CellGroupData[{

Cell["Institution", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Institution"],
  Editable->False,
  CellMargins->{{12, 12}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Center,
  CounterIncrements->"Institution",
  StyleMenuListing->None,
  FontSize->12,
  FontSlant->"Italic"],

Cell[StyleData["Institution", "Presentation"],
  Editable->False,
  CellMargins->{{12, 12}, {0, 0}},
  FontSize->17],

Cell[StyleData["Institution", "Printout"],
  Editable->False,
  CellMargins->{{2, 2}, {0, 0}},
  FontSize->9],

Cell[StyleData["Institution", "Preprint"],
  Editable->False,
  CellMargins->{{12, 12}, {0, 0}},
  FontSize->12]
}, Closed]],

Cell[StyleData["InstitutionNumber"],
  StyleMenuListing->None,
  FontSlant->"Plain",
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["InstitutionName"],
  Editable->True,
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}]
}, Closed]],

Cell[CellGroupData[{

Cell["Abstract", "Subsection"],

Cell[StyleData["AbstractSection"],
  CellFrame->{{0, 0}, {0, 1}},
  CellMargins->{{50, 50}, {4, 18}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", 
    NoOutput[ ], ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[StyleData["Abstract"],
  CellMargins->{{50, 50}, {4, 4}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90}, "TeX" -> {"CellGroupEnvironment" -> "abstract"}}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->12,
  CounterIncrements->"Abstract",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Abstract", "Presentation"],
  CellMargins->{{54, 54}, {5, 36}},
  ParagraphIndent->17,
  FontSize->17],

Cell[StyleData["Abstract", "Printout"],
  CellMargins->{{48, 48}, {2, 21}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Abstract", "Preprint"],
  CellMargins->{{12, 12}, {3, 24}},
  CellFrameLabels->{{Inherited, Inherited}, {Inherited, Cell[ 
          TextData[ 
            StyleBox[ "Abstract", FontSize -> 14]], "Nil"]}},
  ParagraphIndent->12,
  FontSize->12]
}, Closed]],

Cell[StyleData["Keywords"],
  CellMargins->{{50, 50}, {0, 4}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n", ReplaceCharacter[ "," -> " \\sep "][ 
      ExtractElement[ 1, 1, 1][ #]]&, ""}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90}, "TeX" -> {"CellGroupEnvironment" -> "keyword"}}},
  CellFrameLabels->{{
    Cell[ "Key words:", FontSlant -> "Italic"], Inherited}, {
      Inherited, Inherited}},
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["PACS"],
  CellMargins->{{50, 50}, {12, 0}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\n\\PACS ", ReplaceCharacter[ 
    "," -> " \\sep "][ 
      ExtractElement[ 1, 1, 1][ #]]&, ""}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90}, "TeX" -> {"CellGroupEnvironment" -> "keyword"}}},
  CellFrameLabels->{{
    Cell[ "PACS:", FontSlant -> "Italic"], Inherited}, {
      Inherited, Inherited}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["AuthorPACS", "Presentation"],
  CellMargins->{{54, 54}, {18, 36}},
  FontSize->17],

Cell[StyleData["AuthorPACS", "Printout"],
  CellMargins->{{48, 48}, {10, 21}},
  FontSize->9],

Cell[StyleData["AuthorPACS", "Preprint"],
  CellMargins->{{0, 0}, {0, 0}},
  CellOpen->False]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mainmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["MainmatterGroup"],
  Editable->False,
  CellMargins->{{12, 10}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"\n\n\\end{frontmatter}", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["MainmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["MainmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["MainmatterGroup", "Preprint"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[StyleData["Section"],
  CellMargins->{{12, 12}, {16, 27}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\\section{", Automatic, "}"}, "HTML" -> {
    IncludeCount[ 
    "<h3 class='Section'><span class='Ignore'>`1` &nbsp;</span>", "Section"], 
    "</h3>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "Cell", 
    "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CellFrameLabels->{{Cell[ 
          TextData[ 
            CounterBox[ "Section"]], "SectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->15,
  FontWeight->"Bold"],

Cell[StyleData["Subsection"],
  CellDingbat->None,
  CellMargins->{{12, 12}, {12, 23}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 40},
  ConversionRules:>{"TeX" -> {"\n\\subsection{", Automatic, "}"}, "HTML" -> {
    IncludeCount[ 
    "<h4 class='Subsection'><span class='Ignore'>`1`.`2` &nbsp;</span>", 
      "Section", "Subsection"], "</h4>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection"}, "CounterTarget" -> "Cell", "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"]}], "SubsectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->6,
  TextAlignment->Left,
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->15,
  FontSlant->"Italic"],

Cell[StyleData["Subsubsection"],
  CellMargins->{{12, 12}, {12, 20}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 50},
  ConversionRules:>{"TeX" -> {"\n\\subsubsection{", Automatic, "}"}, 
    "HTML" -> {
    IncludeCount[ 
    "<h5 class='Subsubsection'><span class='Ignore'>`1`.`2`.`3` \
&nbsp;</span>", "Section", "Subsection", "Subsubsection"], "</h5>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection", ".", "Subsubsection"}, "CounterTarget" -> "Cell", 
    "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"], ".", 
            CounterBox[ "Subsubsection"]}], "SubsubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  CounterIncrements->"Subsubsection",
  CounterAssignments->{{"Subsubsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->15,
  FontSlant->"Italic"],

Cell[CellGroupData[{

Cell["Section Heading Inline Cells", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SectionLabel"],
  Editable->False,
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["SectionLabel", "Presentation"]],

Cell[StyleData["SectionLabel", "Printout"]],

Cell[StyleData["SectionLabel", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionLabel"],
  Editable->False,
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["SubsectionLabel", "Presentation"]],

Cell[StyleData["SubsectionLabel", "Printout"]],

Cell[StyleData["SubsectionLabel", "Preprint"],
  ParagraphIndent->0]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionLabel"],
  Editable->False,
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["SubsubsectionLabel", "Presentation"]],

Cell[StyleData["SubsubsectionLabel", "Printout"]],

Cell[StyleData["SubsubsectionLabel", "Preprint"],
  ParagraphIndent->0]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionLabel"],
  Editable->False,
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["SubsubsubsectionLabel", "Presentation"]],

Cell[StyleData["SubsubsubsectionLabel", "Printout"]],

Cell[StyleData["SubsubsubsectionLabel", "Preprint"],
  ParagraphIndent->0,
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionText"],
  CellMargins->{{12, 10}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 60},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection", ".", "Subsubsection", ".", "SubsubsubsectionText"}, 
    "CounterTarget" -> "CellGroup", "XRefPrefix" -> "Section"}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 3},
  CounterIncrements->"SubsubsubsectionText",
  CounterAssignments->{{"Text", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["SubsubsubsectionText", "Presentation"],
  CellMargins->{{23, 10}, {2, 2}},
  FontSize->17],

Cell[StyleData["SubsubsubsectionText", "Printout"],
  CellMargins->{{2, 10}, {1, 1}},
  FontSize->10],

Cell[StyleData["SubsubsubsectionText", "Preprint"],
  CellMargins->{{12, 10}, {1, 1}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{2, 1},
  ParagraphIndent->12,
  FontSize->12]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Body Text", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
  CellMargins->{{12, 10}, {1, 1}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 3},
  ParagraphIndent->12,
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Text", "Presentation"],
  CellMargins->{{23, 10}, {2, 2}},
  FontSize->17],

Cell[StyleData["Text", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Text", "Preprint"],
  CellMargins->{{12, 10}, {1, 1}},
  LineSpacing->{2, 1},
  ParagraphIndent->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextNoIndent"],
  CellMargins->{{12, 10}, {1, 1}},
  ConversionRules:>{"TeX" -> {{"\\noindent ", Automatic, ""}, {
    "\n\n\\noindent ", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["TextNoIndent", "Presentation"],
  CellMargins->{{23, 10}, {2, 2}},
  FontSize->17],

Cell[StyleData["TextNoIndent", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["TextNoIndent", "Preprint"],
  CellMargins->{{12, 10}, {1, 1}},
  LineSpacing->{1.5, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextContinuation"],
  CellMargins->{{12, 10}, {1, 1}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
  TextAlignment->Left,
  TextJustification->1,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["TextContinuation", "Presentation"],
  CellMargins->{{23, 10}, {2, 2}},
  FontSize->17],

Cell[StyleData["TextContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["TextContinuation", "Preprint"],
  CellMargins->{{12, 10}, {1, 1}},
  LineSpacing->{1.5, 1}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Itemized Lists", "Section"],

Cell[CellGroupData[{

Cell["Bulleted Lists", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item1Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item2Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item2", "Presentation"],
  CellMargins->{{59, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2", "Printout"],
  CellMargins->{{20, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item3Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3",
  StyleMenuListing->None],

Cell[StyleData["Item3", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1Label"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item1Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Label"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item2Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item2Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Label"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item3Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item3Label", "Preprint"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numbered Lists", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1Numbered"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item1Numbered"], "."}], "Item1NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1Numbered", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Numbered", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Numbered", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Numbered"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"(", 
            CounterBox[ "Item2Numbered"], ")"}], "Item2NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["Item2Numbered", "Presentation"],
  CellMargins->{{59, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Numbered", "Printout"],
  CellMargins->{{20, 2}, {1, 2}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2Numbered", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Numbered"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\n\\item ", Automatic, ""}}, {"HTML" -> {
    "<li>", Automatic, "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item3Numbered"], "."}], "Item3NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>RomanNumeral}],

Cell[StyleData["Item3Numbered", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Numbered", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3Numbered", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1NumberedLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<!--", Automatic, "-->"}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item1NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1NumberedLabel", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2NumberedLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<!--", Automatic, "-->"}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item2NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item2NumberedLabel", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3NumberedLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<!--", Automatic, "-->"}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain"],

Cell[StyleData["Item3NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item3NumberedLabel", "Preprint"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["List Paragraphs", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1Paragraph"],
  CellMargins->{{40, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
    False}}},
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1Paragraph", "Presentation"],
  CellMargins->{{63, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Paragraph", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Paragraph", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Paragraph"],
  CellMargins->{{64, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
    False}}},
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item2Paragraph", "Presentation"],
  CellMargins->{{99, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Paragraph", "Printout"],
  CellMargins->{{42, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2Paragraph", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Paragraph"],
  CellMargins->{{88, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
    False}}},
  StyleMenuListing->None],

Cell[StyleData["Item3Paragraph", "Presentation"],
  CellMargins->{{135, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Paragraph", "Printout"],
  CellMargins->{{62, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3Paragraph", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Illustrations and Examples", "Section"],

Cell[CellGroupData[{

Cell["Figure", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Figure"],
  Editable->False,
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
    ExtractFigure[ ], "\n\\end{center}"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
    "Style:FigureCaption"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  PageBreakWithin->False,
  ShowCellLabel->False,
  DefaultFormatType->DefaultOutputFormatType,
  TextAlignment->Center,
  LanguageCategory->None,
  CounterIncrements->"Figure",
  ImageMargins->{{43, Inherited}, {Inherited, 0}},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->10],

Cell[StyleData["Figure", "Presentation"],
  CellMargins->{{12, 12}, {11, 11}},
  Magnification->1.5],

Cell[StyleData["Figure", "Printout"],
  ImageMargins->{{2, 2}, {6, 6}},
  Magnification->0.8],

Cell[StyleData["Figure", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureCaption"],
  CellMargins->{{12, 12}, {7, 3}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", "}\n"}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Figure"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Figure"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  PageBreakAbove->False,
  TextAlignment->Center,
  TextJustification->1,
  CounterIncrements->"FigureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["FigureCaption", "Presentation"],
  CellMargins->{{23, 12}, {11, 5}},
  FontSize->15],

Cell[StyleData["FigureCaption", "Printout"],
  CellMargins->{{2, 2}, {6, 2}},
  TextJustification->1,
  FontSize->9],

Cell[StyleData["FigureCaption", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[StyleData["FigureCaptionLabel"],
  CellGroupingRules->{"GraphicsGrouping", 0},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Tables", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Table"],
  Editable->False,
  PageWidth->WindowWidth,
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{ruledtabular}\n", Automatic, 
    "\n\\end{ruledtabular}"}, "HTML" -> {{"", Automatic, ""}, {"", Automatic, 
    ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
    "CounterTarget" -> "CellGroup"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90}, "TeX" -> {"CellGroupEnvironment" -> "table"}}},
  CellHorizontalScrolling->True,
  CounterIncrements->"Table",
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->0.503,
  RowAlignments->Center,
  ColumnAlignments->{Left, Center},
  GridFrame->{{0, 0}, {0.5, 0.5}},
  ColumnLines->False,
  GridDefaultElement:>Cell[ "Data", "TableText"]}],

Cell[StyleData["Table", "Presentation"],
  CellMargins->{{23, 10}, {2, 2}},
  FontSize->17],

Cell[StyleData["Table", "Printout"],
  PageWidth->PaperWidth,
  CellMargins->{{0, 3}, {1, 1}},
  FontSize->10],

Cell[StyleData["Table", "Preprint"],
  PageWidth->PaperWidth]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableTitle"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{14, 12}, {0, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\caption{", Automatic, "} "}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Table"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90, 
    "AlwaysStartEnvironment" -> True}, "TeX" -> {"CellGroupEnvironment" -> 
    "table"}}},
  PageBreakBelow->False,
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->12,
  CounterIncrements->"TableTitle",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],

Cell[StyleData["TableTitle", "Presentation"],
  CellMargins->{{25, 12}, {18, 11}},
  FontSize->17],

Cell[StyleData["TableTitle", "Printout"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{2, 2}, {0, 6}},
  FontSize->10],

Cell[StyleData["TableTitle", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableTitleLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  ParagraphIndent->0,
  CounterIncrements->"TableTitle",
  StyleMenuListing->None],

Cell[StyleData["TableTitleLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["TableTitleLabel", "Printout"],
  FontSize->10],

Cell[StyleData["TableTitleLabel", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableNote"],
  Editable->False,
  PageWidth->WindowWidth,
  CellMargins->{{12, 10}, {7, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  LineSpacing->{1, 1},
  ParagraphSpacing->{0.3, 0},
  CounterIncrements->"TableNote",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->10],

Cell[StyleData["TableNote", "Printout"],
  CellMargins->{{2, 10}, {5, 1}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Styles for Tables", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TableColumnHead"],
  Editable->True,
  ConversionRules:>{"TeX" -> {"\\textit{", Automatic, "}"}},
  CounterIncrements->"Table",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSlant->"Italic",
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableColumnHead", "Presentation"],
  FontSize->17],

Cell[StyleData["TableColumnHead", "Printout"],
  FontSize->10],

Cell[StyleData["TableColumnHead", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableSpanHead"],
  Editable->True,
  ConversionRules:>{"TeX" -> {"\\textit{", Automatic, "}"}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSlant->"Italic",
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableSpanHead", "Presentation"],
  FontSize->17],

Cell[StyleData["TableSpanHead", "Printout"],
  FontSize->10],

Cell[StyleData["TableSpanHead", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText"],
  Editable->True,
  TextAlignment->Left,
  LineSpacing->{1, 1},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableText", "Presentation"],
  FontSize->17],

Cell[StyleData["TableText", "Printout"],
  FontSize->10],

Cell[StyleData["TableText", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableSpanText"],
  Editable->True,
  TextAlignment->Center,
  LineSpacing->{1, 1},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  GridBoxOptions->{ColumnSpacings->0,
  ColumnAlignments->{Center},
  GridFrame->False,
  RowLines->False}],

Cell[StyleData["TableSpanText", "Presentation"],
  FontSize->17],

Cell[StyleData["TableSpanText", "Printout"],
  FontSize->10],

Cell[StyleData["TableSpanText", "Preprint"]]
}, Closed]],

Cell[StyleData["TableSubGrid"],
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->0.7,
  ColumnSpacings->0.8,
  ColumnAlignments->{Left, Center},
  GridFrame->False,
  RowLines->False,
  RowMinHeight->0.1,
  GridDefaultElement:>Cell[ "Data", "TableText"]}],

Cell[StyleData["TableMasterGrid"],
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->0.01,
  ColumnWidths->0.999}],

Cell[StyleData["TableLineElement"],
  Editable->False,
  CellFrame->{{0, 0}, {0.5, 0}},
  CellElementSpacings->{"CellMinHeight"->1},
  ConversionRules:>{"HTML" -> {{"&nbsp;", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  CellSize->{Inherited, 1.25},
  TabFilling->" ",
  TabSpacings->1000,
  StyleMenuListing->None,
  FontSize->1],

Cell[StyleData["TableBlankElement"],
  Editable->False,
  CellElementSpacings->{"CellMinHeight"->1},
  CellSize->{Inherited, 1.25},
  StyleMenuListing->None,
  FontSize->1],

Cell[CellGroupData[{

Cell[StyleData["SpanLeft"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanLeft", "Presentation"],
  FontSize->24],

Cell[StyleData["SpanLeft", "Printout"],
  FontSize->14],

Cell[StyleData["SpanLeft", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SpanCenter"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanCenter", "Presentation"],
  FontSize->24],

Cell[StyleData["SpanCenter", "Printout"],
  FontSize->14],

Cell[StyleData["SpanCenter", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SpanRight"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanRight", "Presentation"],
  FontSize->24],

Cell[StyleData["SpanRight", "Printout"],
  FontSize->14],

Cell[StyleData["SpanRight", "Preprint"]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematics", "Section"],

Cell[CellGroupData[{

Cell["Equations", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Equation"],
  CellMargins->{{12, 42}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}},
  
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"Equation",
  StyleMenuListing->None],

Cell[StyleData["Equation", "Presentation"],
  CellMargins->{{12, 55}, {10, 10}},
  FontSize->19],

Cell[StyleData["Equation", "Printout"],
  CellMargins->{{2, 28}, {5, 5}},
  FontSize->10],

Cell[StyleData["Equation", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationWide"],
  CellMargins->{{12, 42}, {7, 7}},
  ConversionRules:>{"TeX" -> {"\n\\begin{widetext}\n", "\n\\end{widetext}\n"},
     "HTML" -> {{"", ""}, {"<p class=\"EquationWide\">", "</p>"}}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"Equation",
  StyleMenuListing->None],

Cell[StyleData["EquationWide", "Presentation"],
  CellMargins->{{12, 55}, {10, 10}},
  FontSize->19],

Cell[StyleData["EquationWide", "Printout"],
  CellMargins->{{2, 28}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationWide", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroup"],
  CellMargins->{{12, 42}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 1,
     "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> "gather*"}}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  StyleMenuListing->None],

Cell[StyleData["EquationGroup", "Presentation"],
  CellMargins->{{12, 55}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroup", "Printout"],
  CellMargins->{{2, 28}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroup", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupAligned"],
  CellMargins->{{12, 42}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 1,
     "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> "align*"}}},
  TextAlignment->Center,
  SpanMinSize->2,
  StyleMenuListing->None,
  UnderoverscriptBoxOptions->{LimitsPositioning->False},
  UnderscriptBoxOptions->{LimitsPositioning->False},
  OverscriptBoxOptions->{LimitsPositioning->False},
  GridBoxOptions->{AllowScriptLevelChange->False}],

Cell[StyleData["EquationGroupAligned", "Presentation"],
  CellMargins->{{12, 55}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupAligned", "Printout"],
  CellMargins->{{2, 28}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupAligned", "Preprint"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numbered Equations", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["EquationNumbered"],
  CellMargins->{{12, 12}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='EquationNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> 
    True}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationNumbered", "Presentation"],
  CellMargins->{{12, 12}, {10, 10}},
  FontSize->19],

Cell[StyleData["EquationNumbered", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationNumbered", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationWideNumbered"],
  CellMargins->{{12, 12}, {7, 7}},
  ConversionRules:>{"TeX" -> {"\n\\begin{widetext}", "\n\\end{widetext}\n"}, 
    "HTML" -> {{"", ""}, {"<table class='EquationWideNumbered'><tr><td>", 
    Automatic, 
    IncludeCount[ 
    "</td><td class='EquationNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> 
    True}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationWideNumbered", "Presentation"],
  CellMargins->{{12, 12}, {10, 10}},
  FontSize->19],

Cell[StyleData["EquationWideNumbered", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationWideNumbered", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationGroupNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='EquationGroupNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True},
     "TeX" -> {"CellGroupEnvironment" -> "gather"}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationGroupNumbered", "Presentation"],
  CellMargins->{{12, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupNumbered", "Preprint"],
  CellMargins->{{12, 12}, {0, 2}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupAlignedNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationGroupAlignedNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td \
class='EquationGroupAlignedNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True},
     "TeX" -> {"CellGroupEnvironment" -> "align"}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  SpanMinSize->2,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None,
  UnderoverscriptBoxOptions->{LimitsPositioning->False},
  UnderscriptBoxOptions->{LimitsPositioning->False},
  OverscriptBoxOptions->{LimitsPositioning->False},
  GridBoxOptions->{AllowScriptLevelChange->False}],

Cell[StyleData["EquationGroupAlignedNumbered", "Presentation"],
  CellMargins->{{12, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupAlignedNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupAlignedNumbered", "Preprint"],
  CellMargins->{{12, 12}, {0, 2}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationNumber"],
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["EquationNumber", "Presentation"],
  CellSize->{36, Inherited}],

Cell[StyleData["EquationNumber", "Printout"],
  CellSize->{20, Inherited}],

Cell[StyleData["EquationNumber", "Preprint"],
  CellSize->{24, Inherited}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Equation Grid Tag Styles", "Subsection"],

Cell[StyleData["EquationGrid"],
  StyleMenuListing->None],

Cell[StyleData["SplitEquation"],
  StyleMenuListing->None],

Cell[StyleData["Piecewise"],
  StyleMenuListing->None],

Cell[StyleData["Matrix"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Cross-References", "Section"],

Cell[StyleData["XRef"],
  ConversionRules:>{"TeX" -> {"\\ref{", 
    ExtractButtonData[ "CounterTag"], "}"}, "HTML" -> {"", 
    XRefToHtmlHyperlink, ""}},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Backmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["BackmatterGroup"],
  Editable->False,
  CellMargins->{{12, 10}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"\n\n\\appendix", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["BackmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["BackmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["BackmatterGroup", "Preprint"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell["Appendix", "Subsection"],

Cell[StyleData["AppendixSection"],
  CellMargins->{{12, 12}, {10, 27}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\n\\section{", Automatic, "}"}, "HTML" -> {
    IncludeCount[ 
    "<h3 class='AppendixSection'><span class='Ignore'>`1` &nbsp;</span>", 
      "AppendixSection"], "</h3>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"AppendixSection"},
     "CounterTarget" -> "CellGroup"}},
  PageBreakBelow->False,
  CellFrameLabels->{{Cell[ 
          TextData[ 
            CounterBox[ "AppendixSection"]], "AppendixSectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"AppendixSection",
  CounterAssignments->{{"AppendixEquation", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->15,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[CellGroupData[{

Cell[StyleData["AppendixSectionLabel"],
  Editable->False,
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["AppendixSectionLabel", "Presentation"],
  StyleMenuListing->None],

Cell[StyleData["AppendixSectionLabel", "Printout"]],

Cell[StyleData["AppendixSectionLabel", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AppendixEquation"],
  CellMargins->{{26, 6}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='AppendixEquation'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='AppendixEquationLabel'>(`1``2`)</td></tr></table>", 
      "AppendixSection", "AppendixEquation"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"AppendixSection", 
    "", "AppendixEquation"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "AppendixSection"], 
            CounterBox[ "AppendixEquation"], ")"}]]}, {None, None}},
  DefaultFormatType->DefaultInputFormatType,
  TextAlignment->Center,
  CounterIncrements->"AppendixEquation",
  StyleMenuListing->None],

Cell[StyleData["AppendixEquation", "Presentation"],
  CellMargins->{{26, 6}, {11, 11}},
  FontSize->19],

Cell[StyleData["AppendixEquation", "Printout"],
  FontSize->10],

Cell[StyleData["AppendixEquation", "Preprint"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Endnotes", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["EndnoteSection"],
  CellMargins->{{12, 12}, {10, 48}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<h3 class=\"EndnoteSection\">", Automatic, 
    "</h3>"}},
  PageBreakBelow->False,
  DefaultNewInlineCellStyle->"None",
  TextAlignment->Center,
  LineSpacing->{1, 7},
  LanguageCategory->"NaturalLanguage",
  SpanSymmetric->True,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Endnote", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["EndnoteSection", "Presentation"],
  CellMargins->{{12, 12}, {15, 36}},
  FontSize->21],

Cell[StyleData["EndnoteSection", "Printout"],
  CellMargins->{{13, 0}, {7, 21}},
  FontSize->10],

Cell[StyleData["EndnoteSection", "Preprint"],
  CellMargins->{{12, 12}, {10, 24}},
  TextAlignment->Left,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Endnote"],
  CellMargins->{{12, 10}, {2, 2}},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {
    "<table class=\"Endnote\"><tr valign=\"top\">", Automatic, 
    "</td></tr></table>"}},
  Hyphenation->True,
  LineSpacing->{1, 2},
  ParagraphIndent->-38,
  SpanMaxSize->1,
  CounterIncrements->"Endnote",
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Endnote", "Presentation"],
  CellMargins->{{23, 10}, {3, 3}},
  FontSize->17],

Cell[StyleData["Endnote", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  TextJustification->0.5,
  FontSize->10],

Cell[StyleData["Endnote", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteLabel"],
  ConversionRules:>{"HTML" -> {"<td class=\"EndnoteLabel\" align=\"right\">", 
    Automatic, "&nbsp;</td><td>"}},
  CellSize->{36, Inherited},
  TextAlignment->Right,
  CounterIncrements->"EndnoteLabel",
  StyleMenuListing->None],

Cell[StyleData["EndnoteLabel", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteNumber"],
  CellSize->{36, Inherited},
  TextAlignment->Right,
  CounterIncrements->"EndnoteNumber",
  StyleMenuListing->None],

Cell[StyleData["EndnoteNumber", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NoteKey"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(EditNote[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["NoteKey", "Presentation"],
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["NoteKey", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["NoteKey", "Preprint"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteReturnLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["EndnoteReturnLink", "Presentation"],
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["EndnoteReturnLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["EndnoteReturnLink", "Preprint"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Note"],
  Editable->False,
  Deletable->False,
  ConversionRules:>{"TeX" -> {{"\\footnote{", Convert[ 
      ExtractElement[ ][ 
        ExtractButtonData[ ][ #]]]&, "}"}, {"", Automatic, ""}}},
  ScriptMinSize->10,
  SpanMaxSize->1,
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Note", "Printout"],
  ScriptMinSize->8]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSection"],
  CellMargins->{{12, 12}, {10, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<h3 class=\"ReferenceSection\">", Automatic,
     "</h3>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> {"thebibliography", "{000}"}}}},
  PageBreakBelow->False,
  TextAlignment->Center,
  CounterIncrements->"ReferenceSection",
  CounterAssignments->{{"ReferenceText", 0}, {"BiblioEquation", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[StyleData["ReferenceSection", "Presentation"],
  CellMargins->{{12, 12}, {15, 36}},
  FontSize->21],

Cell[StyleData["ReferenceSection", "Printout"],
  CellMargins->{{13, 0}, {7, 21}},
  FontSize->10],

Cell[StyleData["ReferenceSection", "Preprint"],
  CellMargins->{{12, 12}, {10, 24}},
  TextAlignment->Left,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Reference"],
  CellMargins->{{18, 10}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\n", 
    ConvertAsNatbib[ ], ""}, "HTML" -> {
    "<table class=\"Reference\"><tr valign=\"top\">", Automatic, 
    "</td></tr></table>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> {"thebibliography", "{000}"}}}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-8,
  CounterIncrements->"BibliographyItem",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Reference", "Presentation"],
  CellMargins->{{29, 10}, {2, 2}},
  LineSpacing->{1, 2},
  ParagraphIndent->-12,
  FontSize->17],

Cell[StyleData["Reference", "Printout"],
  CellMargins->{{2, 2}, {2, 0}},
  LineSpacing->{1, 2},
  ParagraphIndent->-5,
  FontSize->10],

Cell[StyleData["Reference", "Preprint"],
  LineSpacing->{2, 1}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceLabel"],
  ConversionRules:>{"HTML" -> {
    "<td class=\"ReferenceLabel\" align=\"right\">", Automatic, 
    "&nbsp;</td><td>"}},
  CellSize->{36, Inherited},
  TextAlignment->Right,
  SpanMaxSize->1,
  CounterIncrements->"RefDingbat",
  StyleMenuListing->None],

Cell[StyleData["ReferenceLabel", "Presentation"],
  CellSize->{54, Inherited}],

Cell[StyleData["ReferenceLabel", "Printout"],
  CellSize->{32, Inherited}],

Cell[StyleData["ReferenceLabel", "Preprint"]]
}, Closed]],

Cell[StyleData["RefSep"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["RefReturnLink"],
  ConversionRules:>{"TeX" -> {"\n\\bibitem{", DeleteCharacter[ 5][ 
      ExtractButtonData[ ][ #]]&, "}"}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Times",
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefReturnLink", "Presentation"],
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["RefReturnLink", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["RefReturnLink", "Preprint"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefReturnPointer"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {
    "<table class=\"Reference\"><tr valign=\"top\">", "</td></tr></table>"}}},
  
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Mathematica4",
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefReturnPointer", "Printout"],
  StyleMenuListing->None,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSourceLink"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Mathematica4",
  FontSize->1,
  FontColor->GrayLevel[1],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["ReferenceSourceLink", "Printout"],
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Citation"],
  ConversionRules:>{"TeX" -> {"\\cite{", 
    ExtractButtonData[ ], "}"}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(ListDataLink[ #2]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["Citation", "Presentation"],
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Citation", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["Citation", "Preprint"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefKey"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(EditRef[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefKey", "Presentation"],
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["RefKey", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["RefKey", "Preprint"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell["References Templates", "Subsubsection",
  StyleMenuListing->None],

Cell["FirstAuthor:<Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["OtherAuthors:, <Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["LastAuthor:, & <Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["FirstEditor:<FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["OtherEditors:, <FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["LastEditor: & <FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["Sorting:Author", "ReferenceTemplate"],

Cell["ReferenceAuthorMax:4", "ReferenceTemplate"],

Cell["ReferenceEditorMax:4", "ReferenceTemplate"],

Cell["ReferenceAuthorMin:1", "ReferenceTemplate"],

Cell["ReferenceEditorMin:1", "ReferenceTemplate"],

Cell["AbbreviatedAuthors:, et al.", "ReferenceTemplate"],

Cell["AbbreviatedEditors:, et al.", "ReferenceTemplate"],

Cell[CellGroupData[{

Cell["Article Templates", "Subsubsubsection"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>. \
Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>. \
\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>. \
Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>. \
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"Article\" references \
that don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["In Book Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"InBook\" references.)\
\>", "Text"],

Cell["\<\
InBook:<Author> (<Year>). <Title>. In <Editor> (Ed.), <BookTitle> (pp. \
<PageRange>). <City>: <Publisher>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Whole Book Templates", "Subsubsubsection"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>. Retrieved \
<RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>.\
\>", "ReferenceTemplate"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"Book\" references that \
don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Thesis Templates", "Subsubsubsection"],

Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, <School>, \
<City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
PhdThesis:<Author> (<Year>). <BookTitle>. Unpublished doctoral dissertation, \
<School>, <City>.\
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"PhdThesis\" references \
that don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, <School>, \
<City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Technical Report Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"TechReport\" \
references.)\
\>", "Text"],

Cell["\<\
TechReport:<Author> (<Year>). <Title>. <School>, <City>. <ReportNumber>, \
<Submittedby>\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Source Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"OnlineSource\" \
references.)\
\>", "Text"],

Cell["\<\
OnlineSource:<Author>, <Title>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Preprint Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"Preprint\" references.)\
\
\>", "Text"],

Cell["Preprint:<Author> (<Year>). <Title>. <PublicationStatus>", \
"ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plain Insertion Template", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \
\[OpenCurlyDoubleQuote]PlainInsert\" references.)\
\>", "Text"],

Cell["PlainInsert:<InsertedBibText>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Note Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"Note\" references.)\
\>", "Text"],

Cell["Note:<NoteText>", "ReferenceTemplate"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Common Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefTitle"],
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["RefTitle", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefType"],
  CellSize->{0, 12},
  StyleMenuListing->None],

Cell[StyleData["RefType", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefURL"],
  StyleMenuListing->None],

Cell[StyleData["RefURL", "Printout"]]
}, Closed]],

Cell[StyleData["RefInsertedBibText"],
  StyleMenuListing->None],

Cell[StyleData["RefNote"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefBookTitle"],
  ConversionRules:>{"TeX" -> {"\\textit{", Automatic, "}"}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["RefBookTitle", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Journal Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefJournalTitle"],
  StyleMenuListing->None],

Cell[StyleData["RefJournalTitle", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefJournalVolume"],
  ConversionRules:>{"TeX" -> {"\\textbf{", Automatic, "}"}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["RefJournalVolume", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefJournalNumber"],
  StyleMenuListing->None],

Cell[StyleData["RefJournalNumber", "Printout"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Publisher Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefPublisher"],
  StyleMenuListing->None],

Cell[StyleData["RefPublisher", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefCity"],
  ParagraphIndent->0,
  StyleMenuListing->None],

Cell[StyleData["RefCity", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Author Data Field Styles", "Subsubsection"],

Cell[StyleData["RefAuthorGroup"],
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["RefAuthorFN"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorFN", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefAuthorLN"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorLN", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefAuthorMN"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorMN", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Editor Data Field Styles", "Subsubsection"],

Cell[StyleData["RefEditorGroup"],
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["RefEditorFN"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorFN", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefEditorMN"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorMN", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefEditorLN"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorLN", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["School Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefSchool"],
  StyleMenuListing->None],

Cell[StyleData["RefSchool", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Publication Date Data Field Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefYear"],
  StyleMenuListing->None],

Cell[StyleData["RefYear", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Data Field Styles: Auto Generated and Contiguous Pages", \
"Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["RefFirstPage"],
  ParagraphIndent->0,
  StyleMenuListing->None],

Cell[StyleData["RefFirstPage", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefLastPage"],
  ParagraphIndent->0,
  StyleMenuListing->None],

Cell[StyleData["RefLastPage", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["In Note Ref Type", "Subsubsection"],

Cell[StyleData["RefNoteText"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section"],

Cell[StyleData["TextSuperscript"],
  ConversionRules:>(Times[ {"TeX" -> {{"", 
      ConvertTextSuperscriptToLaTeX[ ], ""}, {"", Automatic, ""}}}, 
      SingleLetterItalics] -> False),
  ScriptMinSize->10,
  StyleMenuListing->None],

Cell[StyleData["TextSubscript"],
  ScriptMinSize->10,
  SingleLetterItalics->False,
  StyleMenuListing->None],

Cell[StyleData["Nil"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["Verbatim"],
  StyleMenuListing->None,
  FontSize->12],

Cell[StyleData["TeXName"],
  ConversionRules:>{"TeX" -> {"\\TeX\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["LaTeXName"],
  ConversionRules:>{"TeX" -> {"\\LaTeX\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["LaTeXeName"],
  ConversionRules:>{"TeX" -> {"\\LaTeXe\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["ChemicalElement"],
  SingleLetterItalics->False,
  ZeroWidthTimes->True,
  StyleMenuListing->None],

Cell[StyleData["CustomCharacter"],
  SingleLetterItalics->False,
  StyleMenuListing->None],

Cell[StyleData["Palette"],
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["PageBreak"],
  Editable->False,
  CellMargins->{{0, 0}, {1, 1}},
  CellBracketOptions->{"Thickness"->1,
  "Color"->RGBColor[0.500008, 0.500008, 1],
  "Margins"->{Inherited, 3},
  "Widths"->{5, 5}},
  CellElementSpacings->{"CellMinHeight"->1},
  ConversionRules:>{"TeX" -> {"\n\n\\pagebreak", 
    NoOutput[ ], ""}, "HTML" -> {"<br class=\"PageBreak\">", 
    NoOutput[ ], ""}},
  PageBreakAbove->True,
  CellSize->{Inherited, 6},
  TabFilling->"- ",
  TabSpacings->1000,
  StyleMenuListing->None,
  FontSize->6,
  FontColor->GrayLevel[0.700008]],

Cell[StyleData["PageBreak", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  CellSize->{Inherited, 2},
  TabFilling->""]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CreationDate"],
  CellFrame->0.5,
  CellMargins->{{10, 10}, {4, 4}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10],

Cell[StyleData["CreationDate", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  LineSpacing->{1, 1},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell["Lines and Spacers", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SingleLine"],
  CellFrame->{{0, 0}, {0, 1}},
  CellMargins->{{50, 50}, {0, 0}},
  CellBracketOptions->{"Color"->RGBColor[0.900008, 0.900008, 1]},
  CellElementSpacings->{"CellMinHeight"->2},
  CellGroupingRules->{"GraphicsGrouping", 0},
  StyleMenuListing->None,
  FontSize->2],

Cell[StyleData["SingleLine", "Printout"],
  CellMargins->{{2, 10}, {1, 1}},
  CellGroupingRules->{"GraphicsGrouping", 0},
  FontSize->2]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DoubleLine"],
  Editable->False,
  PageWidth->400,
  CellFrame->{{0, 0}, {0.25, 0.25}},
  CellMargins->{{12, 10}, {1, 1}},
  CellElementSpacings->{"CellMinHeight"->0},
  CellFrameMargins->{{2, 10}, {0, 0}},
  StyleMenuListing->None,
  FontSize->4],

Cell[StyleData["DoubleLine", "Printout"],
  CellMargins->{{2, 10}, {1, 1}},
  FontSize->2]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThinLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["ThinLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MediumLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 2}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["MediumLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThickLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 3}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["ThickLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Spacer"],
  CellMargins->{{Inherited, Inherited}, {4, 4}},
  StyleMenuListing->None],

Cell[StyleData["Spacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextSpacer"],
  StyleMenuListing->None],

Cell[StyleData["TextSpacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SectionSpacer"],
  StyleMenuListing->None],

Cell[StyleData["SectionSpacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GraphicsSpacer"],
  StyleMenuListing->None],

Cell[StyleData["GraphicsSpacer", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Outline", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Outline1"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 30},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline1"], ". "}], "Outline1Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}},
  StyleMenuListing->None,
  FontSize->18,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],

Cell[StyleData["Outline1", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {7, 7}},
  FontSize->27],

Cell[StyleData["Outline1", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->16],

Cell[StyleData["Outline1", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline1Label"],
  CellSize->{40, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline1Label", "Presentation"],
  CellSize->{60, Inherited}],

Cell[StyleData["Outline1Label", "Printout"],
  CellSize->{36, Inherited}],

Cell[StyleData["Outline1Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline2"],
  CellMargins->{{32, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 40},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline2"], ". "}], "Outline2Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}},
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[StyleData["Outline2", "Presentation"],
  CellMargins->{{52, 12}, {11, 11}},
  FontSize->24],

Cell[StyleData["Outline2", "Printout"],
  CellMargins->{{22, 2}, {6, 6}},
  FontSize->14],

Cell[StyleData["Outline2", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline2Label"],
  CellSize->{30, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline2Label", "Presentation"],
  CellSize->{45, Inherited}],

Cell[StyleData["Outline2Label", "Printout"],
  CellSize->{27, Inherited}],

Cell[StyleData["Outline2Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline3"],
  CellMargins->{{52, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 50},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline3"], ". "}], "Outline3Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}},
  StyleMenuListing->None,
  FontSize->14,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Outline3", "Presentation"],
  CellMargins->{{92, 12}, {11, 11}},
  FontSize->21],

Cell[StyleData["Outline3", "Printout"],
  CellMargins->{{42, 2}, {6, 6}},
  FontSize->12],

Cell[StyleData["Outline3", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline3Label"],
  CellSize->{21, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline3Label", "Presentation"],
  CellSize->{32, Inherited}],

Cell[StyleData["Outline3Label", "Printout"],
  CellSize->{18, Inherited}],

Cell[StyleData["Outline3Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline4"],
  CellMargins->{{67, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 60},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline4"], ". "}], "Outline4Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline4",
  StyleMenuListing->None,
  FontSize->12,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["Outline4", "Presentation"],
  CellMargins->{{122, 12}, {11, 11}},
  FontSize->17],

Cell[StyleData["Outline4", "Printout"],
  CellMargins->{{57, 2}, {6, 6}},
  FontSize->10],

Cell[StyleData["Outline4", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline4Label"],
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline4Label", "Presentation"],
  CellSize->{27, Inherited}],

Cell[StyleData["Outline4Label", "Printout"],
  CellSize->{16, Inherited}],

Cell[StyleData["Outline4Label", "Preprint"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OutlineText"],
  CellMargins->{{91, 12}, {3, 5}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["OutlineText", "Presentation"],
  CellMargins->{{155, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["OutlineText", "Printout"],
  CellMargins->{{79, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["OutlineText", "Preprint"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Slide Show", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SlideShowNavigationBar"],
  Editable->False,
  CellFrame->True,
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->0.8125},
  CellGroupingRules->{"TitleGrouping", 1},
  PageBreakAbove->True,
  CellFrameMargins->False,
  CellFrameColor->GrayLevel[0.8],
  CellFrameLabelMargins->False,
  TextAlignment->Center,
  CounterIncrements->"SlideShowNavigationBar",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontSize->10,
  Background->GrayLevel[0.8],
  Magnification->1,
  GridBoxOptions->{GridBaseline->Center,
  RowSpacings->0,
  ColumnSpacings->0,
  ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
  RowAlignments->Baseline,
  ColumnAlignments->{
    Center, Center, Center, Center, Center, Center, Right, Center}}],

Cell[StyleData["SlideShowNavigationBar", "Printout"],
  Deletable->False,
  ShowCellBracket->False,
  CellMargins->{{-1, -1}, {-1, -1}},
  PageBreakAbove->True,
  CellFrameMargins->{{1, 1}, {0, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideHyperlink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontSize->26,
  FontColor->GrayLevel[0.400015],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonMinHeight->0.85,
  ButtonMargins->0.5,
  ButtonNote->None}],

Cell[StyleData["SlideHyperlink", "Presentation"]],

Cell[StyleData["SlideHyperlink", "Printout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Common Inline", "Section"],

Cell[CellGroupData[{

Cell["General Text Attributes", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["RM"],
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["BF"],
  ConversionRules:>{"TeX" -> {"\\textbf{", "}"}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["IT"],
  ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["SmallCaps"],
  ConversionRules:>{"TeX" -> {{"", ChangeCase[ "Lower"][ 
      ExtractWord[ ][ #]]&, ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell["Font Specific Text Attributes", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["TR"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["TI"],
  ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["TB"],
  ConversionRules:>{"TeX" -> {{"\\textbf{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["TBI"],
  ConversionRules:>{"TeX" -> {{"\\textbf{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["MR"],
  ConversionRules:>{"TeX" -> {{"\\texttt{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["MO"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["MB"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["MBO"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{\\textit{", Automatic, 
    "}}}"}, {"", Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["SR"],
  ConversionRules:>{"TeX" -> {{"\\textsf{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SO"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SB"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["SBO"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{\\textit{", Automatic, 
    "}}}"}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
  ConversionRules:>{"TeX" -> {{"", 
    ExportAsHyperRef[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["Hyperlink", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["XMLWebLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(OpenAllTypes[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["XMLWebLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell["On-line Help System Links", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["UserGuideLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "UserGuide", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["UserGuideLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "Reference", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["ReferenceLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["System", "Section"],

Cell[CellGroupData[{

Cell["Format Type Style", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that are mixed in with the styles of 
most cells.  If a cell's FormatType matches the name of one of the styles 
defined below, then that style is applied between the cell's style and its 
own options. This is particularly true of Input and Output.
\
\>", "Text"],

Cell[StyleData["CellExpression"],
  PageWidth->Infinity,
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  ShowSpecialCharacters->False,
  AllowInlineCells->False,
  AutoItalicWords->{},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  Background->GrayLevel[1]],

Cell[StyleData["InputForm"],
  AllowInlineCells->False,
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["OutputForm"],
  PageWidth->Infinity,
  TextAlignment->Left,
  LineSpacing->{0.6, 1},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["StandardForm"],
  LineSpacing->{1.25, 0},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["TraditionalForm"],
  LineSpacing->{1.25, 0},
  SingleLetterItalics->True,
  TraditionalFunctionNotation->True,
  DelimiterMatching->None,
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Document Settings and Templates", "Subsection"],

Cell[StyleData["ReferenceTemplate"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["AuthorFormCustomizationTemplate"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["CSSDefinitions"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["LaTeXPreamble"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["DOCTYPEFormat"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["ValidationSetting"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["XRefPaletteSettings"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["MiscSettings"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Cells", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The style defined below is mixed in to any cell that is in an 
inline cell within another.
\
\>", "Text"],

Cell[StyleData["InlineCell"],
  InputAutoReplacements->{"-"->"-"},
  ScriptLevel->1,
  StyleMenuListing->None],

Cell[StyleData["InlineCellEditing"],
  StyleMenuListing->None,
  Background->RGBColor[0.880003, 0.899992, 0.959991]]
}, Closed]],

Cell[CellGroupData[{

Cell["Palette", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that define standard ButtonFunctions, 
for use in palette buttons.
\
\>", "Text"],

Cell[StyleData["Paste"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, After]}]&)}],

Cell[StyleData["StyleApply"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(CellWriteStyle[ #]&),
  ButtonEvaluator->Automatic}],

Cell[StyleData["StyleApplyWithVerification"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
      CheckDocStyleMatch[ ], 
      CellWriteStyle[ #]]&),
  ButtonEvaluator->Automatic}],

Cell[StyleData["ConvertCharacter"],
  ConversionRules:>{"TeX" -> {"", 
    ExtractButtonData[ "TeX"], ""}, "HTML" :> {"", 
    ExtractButtonData[ "HTML"], ""}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonEvaluator->Automatic,
  ButtonFrame->"None"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Automatic", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that are used to affect the display 
of certain types of objects in typeset expressions.  For example, 
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and 
parenthesis characters are displayed (typically by coloring them to make them \

stand out).
\
\>", "Text"],

Cell[StyleData["UnmatchedBracket"],
  StyleMenuListing->None,
  FontColor->RGBColor[0.760006, 0.330007, 0.8]]
}, Closed]],

Cell[CellGroupData[{

Cell["DialogEffects", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["DialogStyleSheetMisapplicationEscape"],
  ShowCellBracket->False,
  CellMargins->{{12, 12}, {2000, 40}},
  CellOpen->True,
  TextAlignment->Center,
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conformance", "Section"],

Cell[CellGroupData[{

Cell["Input/Output", "Subsection",
  StyleMenuListing->None],

Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names. \
Some attributes for these styles are actually set in FormatType Styles (in \
the last section of this stylesheet). \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
  CellMargins->{{72, 72}, {6, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  LinebreakAdjustments->{0.85, 2, 10, 0, 1},
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Input", "Printout"],
  CellMargins->{{21, 6}, {3, 6}},
  LinebreakAdjustments->{0.85, 2, 10, 1, 1},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputNumbered"],
  CellMargins->{{72, 6}, {6, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellFrameLabels->{{None, Cell[ 
          BoxData[ 
            StyleBox[ 
              RowBox[ {"(", 
                CounterBox[ "Input"], ")"}], FontWeight -> "Plain", 
              FontFamily -> "Times"]]]}, {None, None}},
  CellFrameLabelMargins->{{0, 42}, {0, 0}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  LinebreakAdjustments->{0.85, 2, 10, 0, 1},
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["InputNumbered", "Printout"],
  CellMargins->{{21, 6}, {3, 6}},
  LinebreakAdjustments->{0.85, 2, 10, 1, 1},
  FontSize->9]
}, Closed]],

Cell[StyleData["InputOnly"],
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[StyleData["Output"],
  CellMargins->{{72, 72}, {7, 5}},
  CellEditDuplicate->True,
  CellGroupingRules->"OutputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Output",
  StyleMenuListing->None],

Cell[StyleData["Output", "Printout"],
  CellMargins->{{21, 0}, {6, 3}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
  CellMargins->{{45, Inherited}, {Inherited, Inherited}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Message",
  StyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["Message", "Printout"],
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontSize->8,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
  CellMargins->{{45, Inherited}, {Inherited, Inherited}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Print",
  StyleMenuListing->None],

Cell[StyleData["Print", "Printout"],
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontSize->8]
}, Closed]],

Cell["\<\
Do not remove TextAlignment->Left from \"Graphics\" style definitions or else \
graphics may behave badly as inline cells:\
\>", "Text",
  CellMargins->{{72, Inherited}, {Inherited, Inherited}},
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
  Editable->True,
  CellMargins->{{36, Inherited}, {0, 7}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->False,
  PageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  TextAlignment->Left,
  LanguageCategory->None,
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Graphics",
  ImageMargins->{{0, 0}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["Graphics", "Printout"],
  CellMargins->{{27, 0}, {6, 3}},
  ImageMargins->{{0, 0}, {0, 0}},
  FontSize->9,
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
  SpanMaxSize->Automatic,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["CellLabel", "Printout"],
  FontFamily->"Courier",
  FontSize->8,
  FontSlant->"Italic",
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Help Browser Styles", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["MathCaption"],
  StyleMenuListing->None],

Cell[StyleData["MathCaption", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserTips"],
  StyleMenuListing->None],

Cell[StyleData["UserTips", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserTipsList"],
  StyleMenuListing->None],

Cell[StyleData["UserTipsList", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndentedText"],
  StyleMenuListing->None],

Cell[StyleData["IndentedText", "Printout"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Alternative Item Styles", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Item1NumberedNew"],
  CellMargins->{{12, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item1Numbered"], ". "}], "Item1NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Item1NumberedNew", "Printout"],
  CellMargins->{{0, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2NumberedNew"],
  CellMargins->{{24, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item2Numbered"], ". "}], "Item2NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item2Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Item2NumberedNew", "Printout"],
  CellMargins->{{12, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3NumberedNew"],
  CellMargins->{{36, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item3Numbered"], ". "}], "Item3NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item3Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Item3NumberedNew", "Printout"],
  CellMargins->{{24, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1024}, {0, 685}},
WindowSize->{550, 594},
WindowMargins->{{39, Automatic}, {Automatic, 25}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "TeXPreamble"->{
    Cell[2081, 65, 223, 9, 136, "Text",
      CellTags->"TeXPreamble"]},
  "CSSDefinitions"->{
    Cell[2588, 86, 8948, 414, 7608, "Text",
      CellTags->"CSSDefinitions"]},
  "AuthorFormCustomization"->{
    Cell[23849, 919, 229, 9, 128, "AuthorFormCustomizationTemplate",
      CellTags->"AuthorFormCustomization"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"TeXPreamble", 125823, 4814},
  {"CSSDefinitions", 125918, 4817},
  {"AuthorFormCustomization", 126029, 4820}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1775, 53, 46, 0, 77, "Title"],
Cell[1824, 55, 193, 4, 46, "Text"],

Cell[CellGroupData[{
Cell[2042, 63, 36, 0, 54, "Section"],
Cell[2081, 65, 223, 9, 136, "Text",
  CellTags->"TeXPreamble"],
Cell[2307, 76, 219, 3, 46, "Text"]
}, Closed]],

Cell[CellGroupData[{
Cell[2563, 84, 22, 0, 34, "Section"],
Cell[2588, 86, 8948, 414, 7608, "Text",
  CellTags->"CSSDefinitions"]
}, Closed]],

Cell[CellGroupData[{
Cell[11573, 505, 42, 0, 34, "Section"],
Cell[11618, 507, 104, 2, 70, 30, 0, "StyleData", "All", "Screen"],
Cell[11725, 511, 251, 6, 70, 36, 0, "StyleData", "All", "Presentation"],
Cell[11979, 519, 125, 3, 70, 32, 0, "StyleData", "All", "Printout"],
Cell[12107, 524, 96, 3, 70, 32, 0, "StyleData", "All", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[12240, 532, 35, 0, 34, "Section"],
Cell[12278, 534, 102, 3, 27, "Text"],
Cell[12383, 539, 4470, 80, 40, 27, 0, "StyleData", "Notebook", "All",
  StyleMenuListing->None],
Cell[16856, 621, 62, 0, 33, "MiscSettings"]
}, Closed]],

Cell[CellGroupData[{
Cell[16955, 626, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[17010, 630, 355, 10, 60, 35, 0, "StyleData", "FrontmatterGroup", "All",
  StyleMenuListing->None],
Cell[17368, 642, 159, 4, 70, 51, 0, "StyleData", "FrontmatterGroup", \
"Presentation"],
Cell[17530, 648, 122, 3, 70, 47, 0, "StyleData", "FrontmatterGroup", \
"Printout"],
Cell[17655, 653, 122, 3, 70, 47, 0, "StyleData", "FrontmatterGroup", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[17814, 661, 27, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[17866, 665, 358, 11, 61, 24, 0, "StyleData", "Title", "All",
  CounterIncrements->"Title",
  StyleMenuListing->None],
Cell[18227, 678, 125, 3, 70, 40, 0, "StyleData", "Title", "Presentation"],
Cell[18355, 683, 86, 2, 70, 36, 0, "StyleData", "Title", "Printout"],
Cell[18444, 687, 86, 2, 70, 36, 0, "StyleData", "Title", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[18567, 694, 352, 12, 44, 27, 0, "StyleData", "Subtitle", "All",
  CounterIncrements->"Subtitle",
  StyleMenuListing->None],
Cell[18922, 708, 127, 3, 70, 43, 0, "StyleData", "Subtitle", "Presentation"],
Cell[19052, 713, 88, 2, 70, 39, 0, "StyleData", "Subtitle", "Printout"],
Cell[19143, 717, 88, 2, 70, 39, 0, "StyleData", "Subtitle", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[19268, 724, 359, 12, 44, 30, 0, "StyleData", "Subsubtitle", "All",
  CounterIncrements->"Subsubtitle",
  StyleMenuListing->None],
Cell[19630, 738, 130, 3, 70, 46, 0, "StyleData", "Subsubtitle", \
"Presentation"],
Cell[19763, 743, 91, 2, 70, 42, 0, "StyleData", "Subsubtitle", "Printout"],
Cell[19857, 747, 91, 2, 70, 42, 0, "StyleData", "Subsubtitle", "Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[19997, 755, 26, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[20048, 759, 280, 9, 70, 23, 0, "StyleData", "Date", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[20331, 770, 90, 2, 70, 39, 0, "StyleData", "Date", "Presentation"],
Cell[20424, 774, 106, 3, 70, 35, 0, "StyleData", "Date", "Printout"],
Cell[20533, 779, 86, 2, 70, 35, 0, "StyleData", "Date", "Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[20668, 787, 28, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[20721, 791, 322, 10, 54, 25, 0, "StyleData", "Author", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[21046, 803, 93, 2, 70, 41, 0, "StyleData", "Author", "Presentation"],
Cell[21142, 807, 87, 2, 70, 37, 0, "StyleData", "Author", "Printout"],
Cell[21232, 811, 87, 2, 70, 37, 0, "StyleData", "Author", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[21356, 818, 172, 5, 40, 29, 0, "StyleData", "AuthorData", "All",
  StyleMenuListing->None],
Cell[21531, 825, 61, 1, 70, 41, 0, "StyleData", "AuthorData", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[21629, 831, 275, 8, 40, 30, 0, "StyleData", "AuthorGroup", "All",
  StyleMenuListing->None],
Cell[21907, 841, 131, 3, 70, 46, 0, "StyleData", "AuthorGroup", \
"Presentation"],
Cell[22041, 846, 119, 3, 70, 42, 0, "StyleData", "AuthorGroup", "Printout"],
Cell[22163, 851, 119, 3, 70, 42, 0, "StyleData", "AuthorGroup", "Preprint"]
}, Closed]],
Cell[22297, 857, 169, 4, 40, 34, 0, "StyleData", "AuthorFirstName", "All",
  StyleMenuListing->None],
Cell[22469, 863, 170, 4, 40, 35, 0, "StyleData", "AuthorMiddleName", "All",
  StyleMenuListing->None],
Cell[22642, 869, 186, 5, 40, 33, 0, "StyleData", "AuthorLastName", "All",
  StyleMenuListing->None],
Cell[22831, 876, 170, 4, 40, 35, 0, "StyleData", "AuthorNameSuffix", "All",
  StyleMenuListing->None],
Cell[23004, 882, 194, 5, 40, 36, 0, "StyleData", "AuthorAffiliation", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[23223, 891, 288, 9, 45, 30, 0, "StyleData", "AuthorEmail", "All",
  StyleMenuListing->None],
Cell[23514, 902, 62, 1, 70, 46, 0, "StyleData", "AuthorEmail", \
"Presentation"],
Cell[23579, 905, 84, 2, 70, 42, 0, "StyleData", "AuthorEmail", "Printout"],
Cell[23666, 909, 84, 2, 70, 42, 0, "StyleData", "AuthorEmail", "Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[23799, 917, 47, 0, 35, "Subsection"],
Cell[23849, 919, 229, 9, 128, "AuthorFormCustomizationTemplate",
  CellTags->"AuthorFormCustomization"]
}, Closed]],

Cell[CellGroupData[{
Cell[24115, 933, 33, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[24173, 937, 307, 10, 70, 30, 0, "StyleData", "Institution", "All",
  CounterIncrements->"Institution",
  StyleMenuListing->None],
Cell[24483, 949, 116, 3, 70, 46, 0, "StyleData", "Institution", \
"Presentation"],
Cell[24602, 954, 109, 3, 70, 42, 0, "StyleData", "Institution", "Printout"],
Cell[24714, 959, 112, 3, 70, 42, 0, "StyleData", "Institution", "Preprint"]
}, Closed]],
Cell[24841, 965, 193, 5, 70, 36, 0, "StyleData", "InstitutionNumber", "All",
  StyleMenuListing->None],
Cell[25037, 972, 187, 5, 70, 34, 0, "StyleData", "InstitutionName", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[25261, 982, 30, 0, 35, "Subsection"],
Cell[25294, 984, 317, 10, 65, 34, 0, "StyleData", "AbstractSection", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[25636, 998, 509, 13, 40, 27, 0, "StyleData", "Abstract", "All",
  CounterIncrements->"Abstract",
  StyleMenuListing->None],
Cell[26148, 1013, 118, 3, 70, 43, 0, "StyleData", "Abstract", \
"Presentation"],
Cell[26269, 1018, 114, 3, 70, 39, 0, "StyleData", "Abstract", "Printout"],
Cell[26386, 1023, 260, 6, 70, 39, 0, "StyleData", "Abstract", "Preprint"]
}, Closed]],
Cell[26661, 1032, 497, 10, 36, 27, 0, "StyleData", "Keywords", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[27183, 1046, 641, 17, 44, 23, 0, "StyleData", "PACS", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[27827, 1065, 98, 2, 70, 45, 0, "StyleData", "AuthorPACS", \
"Presentation"],
Cell[27928, 1069, 93, 2, 70, 41, 0, "StyleData", "AuthorPACS", "Printout"],
Cell[28024, 1073, 93, 2, 70, 41, 0, "StyleData", "AuthorPACS", "Preprint"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[28178, 1082, 29, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[28232, 1086, 354, 10, 60, 34, 0, "StyleData", "MainmatterGroup", "All",
  StyleMenuListing->None],
Cell[28589, 1098, 158, 4, 70, 50, 0, "StyleData", "MainmatterGroup", \
"Presentation"],
Cell[28750, 1104, 121, 3, 70, 46, 0, "StyleData", "MainmatterGroup", \
"Printout"],
Cell[28874, 1109, 121, 3, 70, 46, 0, "StyleData", "MainmatterGroup", \
"Preprint"]
}, Closed]],
Cell[29010, 1115, 784, 20, 54, 26, 0, "StyleData", "Section", "All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}},
  StyleMenuListing->None],
Cell[29797, 1137, 1023, 24, 69, 29, 0, "StyleData", "Subsection", "All",
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}},
  StyleMenuListing->None],
Cell[30823, 1163, 1088, 25, 66, 32, 0, "StyleData", "Subsubsection", "All",
  CounterIncrements->"Subsubsection",
  CounterAssignments->{{"Subsubsubsection", 0}},
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[31936, 1192, 50, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[32011, 1196, 157, 5, 70, 31, 0, "StyleData", "SectionLabel", "All",
  StyleMenuListing->None],
Cell[32171, 1203, 47, 0, 70, 47, 0, "StyleData", "SectionLabel", \
"Presentation"],
Cell[32221, 1205, 43, 0, 70, 43, 0, "StyleData", "SectionLabel", "Printout"],
Cell[32267, 1207, 43, 0, 70, 43, 0, "StyleData", "SectionLabel", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[32347, 1212, 160, 5, 70, 34, 0, "StyleData", "SubsectionLabel", "All",
  StyleMenuListing->None],
Cell[32510, 1219, 50, 0, 70, 50, 0, "StyleData", "SubsectionLabel", \
"Presentation"],
Cell[32563, 1221, 46, 0, 70, 46, 0, "StyleData", "SubsectionLabel", \
"Printout"],
Cell[32612, 1223, 68, 1, 70, 46, 0, "StyleData", "SubsectionLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[32717, 1229, 163, 5, 70, 37, 0, "StyleData", "SubsubsectionLabel", "All",
  
  StyleMenuListing->None],
Cell[32883, 1236, 53, 0, 70, 53, 0, "StyleData", "SubsubsectionLabel", \
"Presentation"],
Cell[32939, 1238, 49, 0, 70, 49, 0, "StyleData", "SubsubsectionLabel", \
"Printout"],
Cell[32991, 1240, 71, 1, 70, 49, 0, "StyleData", "SubsubsectionLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[33099, 1246, 165, 5, 70, 40, 0, "StyleData", "SubsubsubsectionLabel", \
"All",
  StyleMenuListing->None],
Cell[33267, 1253, 56, 0, 70, 56, 0, "StyleData", "SubsubsubsectionLabel", \
"Presentation"],
Cell[33326, 1255, 52, 0, 70, 52, 0, "StyleData", "SubsubsubsectionLabel", \
"Printout"],
Cell[33381, 1257, 97, 2, 70, 52, 0, "StyleData", "SubsubsubsectionLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[33515, 1264, 636, 15, 70, 39, 0, "StyleData", "SubsubsubsectionText", \
"All",
  CounterIncrements->"SubsubsubsectionText",
  CounterAssignments->{{"Text", 0}},
  StyleMenuListing->None],
Cell[34154, 1281, 106, 2, 70, 55, 0, "StyleData", "SubsubsubsectionText", \
"Presentation"],
Cell[34263, 1285, 101, 2, 70, 51, 0, "StyleData", "SubsubsubsectionText", \
"Printout"],
Cell[34367, 1289, 195, 6, 70, 51, 0, "StyleData", "SubsubsubsectionText", \
"Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[34611, 1301, 31, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[34667, 1305, 369, 11, 70, 23, 0, "StyleData", "Text", "All",
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[35039, 1318, 90, 2, 70, 39, 0, "StyleData", "Text", "Presentation"],
Cell[35132, 1322, 107, 3, 70, 35, 0, "StyleData", "Text", "Printout"],
Cell[35242, 1327, 116, 3, 70, 35, 0, "StyleData", "Text", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[35395, 1335, 454, 12, 70, 31, 0, "StyleData", "TextNoIndent", "All",
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[35852, 1349, 98, 2, 70, 47, 0, "StyleData", "TextNoIndent", \
"Presentation"],
Cell[35953, 1353, 92, 2, 70, 43, 0, "StyleData", "TextNoIndent", "Printout"],
Cell[36048, 1357, 103, 2, 70, 43, 0, "StyleData", "TextNoIndent", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[36188, 1364, 429, 11, 70, 35, 0, "StyleData", "TextContinuation", "All",
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[36620, 1377, 102, 2, 70, 51, 0, "StyleData", "TextContinuation", \
"Presentation"],
Cell[36725, 1381, 96, 2, 70, 47, 0, "StyleData", "TextContinuation", \
"Printout"],
Cell[36824, 1385, 107, 2, 70, 47, 0, "StyleData", "TextContinuation", \
"Preprint"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[36992, 1394, 33, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[37050, 1398, 62, 1, 39, "Subsection"],

Cell[CellGroupData[{
Cell[37137, 1403, 689, 14, 35, 24, 0, "StyleData", "Item1", "All",
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[37829, 1419, 117, 3, 41, 40, 0, "StyleData", "Item1", "Presentation",
  StyleMenuListing->None],
Cell[37949, 1424, 111, 3, 31, 36, 0, "StyleData", "Item1", "Printout",
  StyleMenuListing->None],
Cell[38063, 1429, 59, 1, 35, 36, 0, "StyleData", "Item1", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[38159, 1435, 667, 14, 35, 24, 0, "StyleData", "Item2", "All",
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[38829, 1451, 117, 3, 41, 40, 0, "StyleData", "Item2", "Presentation",
  StyleMenuListing->None],
Cell[38949, 1456, 112, 3, 31, 36, 0, "StyleData", "Item2", "Printout",
  StyleMenuListing->None],
Cell[39064, 1461, 59, 1, 35, 36, 0, "StyleData", "Item2", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[39160, 1467, 621, 13, 35, 24, 0, "StyleData", "Item3", "All",
  CounterIncrements->"Item3",
  StyleMenuListing->None],
Cell[39784, 1482, 117, 3, 41, 40, 0, "StyleData", "Item3", "Presentation",
  StyleMenuListing->None],
Cell[39904, 1487, 112, 3, 31, 36, 0, "StyleData", "Item3", "Printout",
  StyleMenuListing->None],
Cell[40019, 1492, 59, 1, 35, 36, 0, "StyleData", "Item3", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[40115, 1498, 227, 7, 40, 29, 0, "StyleData", "Item1Label", "All",
  StyleMenuListing->None],
Cell[40345, 1507, 116, 3, 44, 45, 0, "StyleData", "Item1Label", \
"Presentation",
  StyleMenuListing->None],
Cell[40464, 1512, 112, 3, 37, 41, 0, "StyleData", "Item1Label", "Printout",
  StyleMenuListing->None],
Cell[40579, 1517, 41, 0, 40, 41, 0, "StyleData", "Item1Label", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[40657, 1522, 227, 7, 40, 29, 0, "StyleData", "Item2Label", "All",
  StyleMenuListing->None],
Cell[40887, 1531, 116, 3, 44, 45, 0, "StyleData", "Item2Label", \
"Presentation",
  StyleMenuListing->None],
Cell[41006, 1536, 96, 2, 40, 41, 0, "StyleData", "Item2Label", "Printout",
  StyleMenuListing->None],
Cell[41105, 1540, 41, 0, 40, 41, 0, "StyleData", "Item2Label", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[41183, 1545, 227, 7, 40, 29, 0, "StyleData", "Item3Label", "All",
  StyleMenuListing->None],
Cell[41413, 1554, 116, 3, 44, 45, 0, "StyleData", "Item3Label", \
"Presentation",
  StyleMenuListing->None],
Cell[41532, 1559, 96, 2, 40, 41, 0, "StyleData", "Item3Label", "Printout",
  StyleMenuListing->None],
Cell[41631, 1563, 41, 0, 40, 41, 0, "StyleData", "Item3Label", "Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[41721, 1569, 62, 1, 39, "Subsection"],

Cell[CellGroupData[{
Cell[41808, 1574, 760, 15, 35, 32, 0, "StyleData", "Item1Numbered", "All",
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[42571, 1591, 125, 3, 41, 48, 0, "StyleData", "Item1Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[42699, 1596, 119, 3, 31, 44, 0, "StyleData", "Item1Numbered", "Printout",
  
  StyleMenuListing->None],
Cell[42821, 1601, 67, 1, 35, 44, 0, "StyleData", "Item1Numbered", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[42925, 1607, 830, 17, 35, 32, 0, "StyleData", "Item2Numbered", "All",
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[43758, 1626, 125, 3, 41, 48, 0, "StyleData", "Item2Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[43886, 1631, 120, 3, 32, 44, 0, "StyleData", "Item2Numbered", "Printout",
  
  StyleMenuListing->None],
Cell[44009, 1636, 67, 1, 35, 44, 0, "StyleData", "Item2Numbered", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[44113, 1642, 746, 15, 35, 32, 0, "StyleData", "Item3Numbered", "All",
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None],
Cell[44862, 1659, 125, 3, 41, 48, 0, "StyleData", "Item3Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[44990, 1664, 120, 3, 31, 44, 0, "StyleData", "Item3Numbered", "Printout",
  
  StyleMenuListing->None],
Cell[45113, 1669, 67, 1, 35, 44, 0, "StyleData", "Item3Numbered", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[45217, 1675, 235, 6, 40, 37, 0, "StyleData", "Item1NumberedLabel", "All",
  
  StyleMenuListing->None],
Cell[45455, 1683, 124, 3, 44, 53, 0, "StyleData", "Item1NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[45582, 1688, 120, 3, 37, 49, 0, "StyleData", "Item1NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[45705, 1693, 49, 0, 40, 49, 0, "StyleData", "Item1NumberedLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[45791, 1698, 235, 6, 40, 37, 0, "StyleData", "Item2NumberedLabel", "All",
  
  StyleMenuListing->None],
Cell[46029, 1706, 124, 3, 44, 53, 0, "StyleData", "Item2NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[46156, 1711, 104, 2, 40, 49, 0, "StyleData", "Item2NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[46263, 1715, 49, 0, 40, 49, 0, "StyleData", "Item2NumberedLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[46349, 1720, 235, 6, 40, 37, 0, "StyleData", "Item3NumberedLabel", "All",
  
  StyleMenuListing->None],
Cell[46587, 1728, 124, 3, 44, 53, 0, "StyleData", "Item3NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[46714, 1733, 104, 2, 40, 49, 0, "StyleData", "Item3NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[46821, 1737, 49, 0, 40, 49, 0, "StyleData", "Item3NumberedLabel", \
"Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[46919, 1743, 63, 1, 39, "Subsection"],

Cell[CellGroupData[{
Cell[47007, 1748, 371, 7, 34, 33, 0, "StyleData", "Item1Paragraph", "All",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[47381, 1757, 126, 3, 40, 49, 0, "StyleData", "Item1Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[47510, 1762, 121, 3, 31, 45, 0, "StyleData", "Item1Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[47634, 1767, 68, 1, 34, 45, 0, "StyleData", "Item1Paragraph", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[47739, 1773, 349, 7, 34, 33, 0, "StyleData", "Item2Paragraph", "All",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[48091, 1782, 126, 3, 40, 49, 0, "StyleData", "Item2Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[48220, 1787, 121, 3, 31, 45, 0, "StyleData", "Item2Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[48344, 1792, 68, 1, 34, 45, 0, "StyleData", "Item2Paragraph", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[48449, 1798, 303, 6, 34, 33, 0, "StyleData", "Item3Paragraph", "All",
  StyleMenuListing->None],
Cell[48755, 1806, 127, 3, 40, 49, 0, "StyleData", "Item3Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[48885, 1811, 121, 3, 31, 45, 0, "StyleData", "Item3Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[49009, 1816, 68, 1, 34, 45, 0, "StyleData", "Item3Paragraph", \
"Preprint"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[49138, 1824, 45, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[49208, 1828, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[49261, 1832, 761, 19, 43, 25, 0, "StyleData", "Figure", "All",
  CounterIncrements->"Figure",
  StyleMenuListing->None],
Cell[50025, 1853, 100, 2, 70, 41, 0, "StyleData", "Figure", "Presentation"],
Cell[50128, 1857, 93, 2, 70, 37, 0, "StyleData", "Figure", "Printout"],
Cell[50224, 1861, 37, 0, 70, 37, 0, "StyleData", "Figure", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[50298, 1866, 635, 14, 40, 32, 0, "StyleData", "FigureCaption", "All",
  CounterIncrements->"FigureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[50936, 1882, 100, 2, 50, 48, 0, "StyleData", "FigureCaption", \
"Presentation"],
Cell[51039, 1886, 116, 3, 37, 44, 0, "StyleData", "FigureCaption", \
"Printout"],
Cell[51158, 1891, 67, 1, 39, 44, 0, "StyleData", "FigureCaption", "Preprint"]
}, Closed]],
Cell[51240, 1895, 167, 4, 40, 37, 0, "StyleData", "FigureCaptionLabel", "All",
  
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[51444, 1904, 28, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[51497, 1908, 831, 19, 34, 24, 0, "StyleData", "Table", "All",
  CounterIncrements->"Table",
  StyleMenuListing->None],
Cell[52331, 1929, 91, 2, 70, 40, 0, "StyleData", "Table", "Presentation"],
Cell[52425, 1933, 110, 3, 70, 36, 0, "StyleData", "Table", "Printout"],
Cell[52538, 1938, 61, 1, 70, 36, 0, "StyleData", "Table", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[52636, 1944, 746, 17, 44, 29, 0, "StyleData", "TableTitle", "All",
  CounterIncrements->"TableTitle",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[53385, 1963, 98, 2, 73, 45, 0, "StyleData", "TableTitle", \
"Presentation"],
Cell[53486, 1967, 123, 3, 43, 41, 0, "StyleData", "TableTitle", "Printout"],
Cell[53612, 1972, 64, 1, 47, 41, 0, "StyleData", "TableTitle", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[53713, 1978, 175, 5, 40, 34, 0, "StyleData", "TableTitleLabel", "All",
  CounterIncrements->"TableTitle",
  StyleMenuListing->None],
Cell[53891, 1985, 66, 1, 70, 50, 0, "StyleData", "TableTitleLabel", \
"Presentation"],
Cell[53960, 1988, 62, 1, 70, 46, 0, "StyleData", "TableTitleLabel", \
"Printout"],
Cell[54025, 1991, 46, 0, 70, 46, 0, "StyleData", "TableTitleLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[54108, 1996, 359, 12, 40, 28, 0, "StyleData", "TableNote", "All",
  CounterIncrements->"TableNote",
  StyleMenuListing->None],
Cell[54470, 2010, 89, 2, 70, 40, 0, "StyleData", "TableNote", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[54596, 2017, 49, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[54670, 2021, 589, 20, 40, 34, 0, "StyleData", "TableColumnHead", "All",
  CounterIncrements->"Table",
  StyleMenuListing->None],
Cell[55262, 2043, 66, 1, 70, 50, 0, "StyleData", "TableColumnHead", \
"Presentation"],
Cell[55331, 2046, 62, 1, 70, 46, 0, "StyleData", "TableColumnHead", \
"Printout"],
Cell[55396, 2049, 46, 0, 70, 46, 0, "StyleData", "TableColumnHead", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[55479, 2054, 582, 20, 40, 32, 0, "StyleData", "TableSpanHead", "All",
  StyleMenuListing->None],
Cell[56064, 2076, 64, 1, 70, 48, 0, "StyleData", "TableSpanHead", \
"Presentation"],
Cell[56131, 2079, 60, 1, 70, 44, 0, "StyleData", "TableSpanHead", \
"Printout"],
Cell[56194, 2082, 44, 0, 70, 44, 0, "StyleData", "TableSpanHead", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[56275, 2087, 531, 20, 40, 28, 0, "StyleData", "TableText", "All",
  StyleMenuListing->None],
Cell[56809, 2109, 60, 1, 44, 44, 0, "StyleData", "TableText", \
"Presentation"],
Cell[56872, 2112, 56, 1, 37, 40, 0, "StyleData", "TableText", "Printout"],
Cell[56931, 2115, 63, 1, 40, 40, 0, "StyleData", "TableText", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[57031, 2121, 271, 10, 40, 32, 0, "StyleData", "TableSpanText", "All",
  StyleMenuListing->None],
Cell[57305, 2133, 64, 1, 70, 48, 0, "StyleData", "TableSpanText", \
"Presentation"],
Cell[57372, 2136, 60, 1, 70, 44, 0, "StyleData", "TableSpanText", \
"Printout"],
Cell[57435, 2139, 44, 0, 70, 44, 0, "StyleData", "TableSpanText", "Preprint"]
}, Closed]],
Cell[57494, 2142, 264, 8, 40, 31, 0, "StyleData", "TableSubGrid", "All",
  StyleMenuListing->None],
Cell[57761, 2152, 122, 3, 40, 34, 0, "StyleData", "TableMasterGrid", "All",
  StyleMenuListing->None],
Cell[57886, 2157, 332, 10, 17, 35, 0, "StyleData", "TableLineElement", "All",
  StyleMenuListing->None],
Cell[58221, 2169, 172, 5, 9, 36, 0, "StyleData", "TableBlankElement", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[58418, 2178, 133, 5, 44, 27, 0, "StyleData", "SpanLeft", "All",
  StyleMenuListing->None],
Cell[58554, 2185, 59, 1, 70, 43, 0, "StyleData", "SpanLeft", "Presentation"],
Cell[58616, 2188, 55, 1, 70, 39, 0, "StyleData", "SpanLeft", "Printout"],
Cell[58674, 2191, 39, 0, 70, 39, 0, "StyleData", "SpanLeft", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[58750, 2196, 135, 5, 44, 29, 0, "StyleData", "SpanCenter", "All",
  StyleMenuListing->None],
Cell[58888, 2203, 61, 1, 70, 45, 0, "StyleData", "SpanCenter", \
"Presentation"],
Cell[58952, 2206, 57, 1, 70, 41, 0, "StyleData", "SpanCenter", "Printout"],
Cell[59012, 2209, 41, 0, 70, 41, 0, "StyleData", "SpanCenter", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[59090, 2214, 134, 5, 44, 28, 0, "StyleData", "SpanRight", "All",
  StyleMenuListing->None],
Cell[59227, 2221, 60, 1, 70, 44, 0, "StyleData", "SpanRight", \
"Presentation"],
Cell[59290, 2224, 56, 1, 70, 40, 0, "StyleData", "SpanRight", "Printout"],
Cell[59349, 2227, 40, 0, 70, 40, 0, "StyleData", "SpanRight", "Preprint"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[59462, 2235, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[59517, 2239, 31, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[59573, 2243, 273, 7, 70, 27, 0, "StyleData", "Equation", "All",
  CounterIncrements->"Equation",
  StyleMenuListing->None],
Cell[59849, 2252, 96, 2, 70, 43, 0, "StyleData", "Equation", "Presentation"],
Cell[59948, 2256, 89, 2, 70, 39, 0, "StyleData", "Equation", "Printout"],
Cell[60040, 2260, 39, 0, 70, 39, 0, "StyleData", "Equation", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[60116, 2265, 342, 7, 70, 31, 0, "StyleData", "EquationWide", "All",
  CounterIncrements->"Equation",
  StyleMenuListing->None],
Cell[60461, 2274, 100, 2, 70, 47, 0, "StyleData", "EquationWide", \
"Presentation"],
Cell[60564, 2278, 93, 2, 70, 43, 0, "StyleData", "EquationWide", "Printout"],
Cell[60660, 2282, 43, 0, 70, 43, 0, "StyleData", "EquationWide", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[60740, 2287, 360, 7, 70, 32, 0, "StyleData", "EquationGroup", "All",
  StyleMenuListing->None],
Cell[61103, 2296, 99, 2, 70, 48, 0, "StyleData", "EquationGroup", \
"Presentation"],
Cell[61205, 2300, 94, 2, 70, 44, 0, "StyleData", "EquationGroup", \
"Printout"],
Cell[61302, 2304, 44, 0, 70, 44, 0, "StyleData", "EquationGroup", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[61383, 2309, 552, 11, 70, 39, 0, "StyleData", "EquationGroupAligned", \
"All",
  StyleMenuListing->None],
Cell[61938, 2322, 106, 2, 70, 55, 0, "StyleData", "EquationGroupAligned", \
"Presentation"],
Cell[62047, 2326, 101, 2, 70, 51, 0, "StyleData", "EquationGroupAligned", \
"Printout"],
Cell[62151, 2330, 51, 0, 70, 51, 0, "StyleData", "EquationGroupAligned", \
"Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[62251, 2336, 40, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[62316, 2340, 800, 18, 70, 35, 0, "StyleData", "EquationNumbered", "All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[63119, 2360, 104, 2, 70, 51, 0, "StyleData", "EquationNumbered", \
"Presentation"],
Cell[63226, 2364, 96, 2, 70, 47, 0, "StyleData", "EquationNumbered", \
"Printout"],
Cell[63325, 2368, 47, 0, 70, 47, 0, "StyleData", "EquationNumbered", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[63409, 2373, 870, 19, 70, 39, 0, "StyleData", "EquationWideNumbered", \
"All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[64282, 2394, 108, 2, 70, 55, 0, "StyleData", "EquationWideNumbered", \
"Presentation"],
Cell[64393, 2398, 100, 2, 70, 51, 0, "StyleData", "EquationWideNumbered", \
"Printout"],
Cell[64496, 2402, 51, 0, 70, 51, 0, "StyleData", "EquationWideNumbered", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[64584, 2407, 902, 19, 70, 40, 0, "StyleData", "EquationGroupNumbered", \
"All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[65489, 2428, 106, 2, 70, 56, 0, "StyleData", "EquationGroupNumbered", \
"Presentation"],
Cell[65598, 2432, 101, 2, 70, 52, 0, "StyleData", "EquationGroupNumbered", \
"Printout"],
Cell[65702, 2436, 87, 1, 70, 52, 0, "StyleData", "EquationGroupNumbered", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[65826, 2442, 1155, 25, 70, 47, 0, "StyleData", \
"EquationGroupAlignedNumbered", "All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[66984, 2469, 113, 2, 70, 63, 0, "StyleData", \
"EquationGroupAlignedNumbered", "Presentation"],
Cell[67100, 2473, 108, 2, 70, 59, 0, "StyleData", \
"EquationGroupAlignedNumbered", "Printout"],
Cell[67211, 2477, 94, 1, 70, 59, 0, "StyleData", \
"EquationGroupAlignedNumbered", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[67342, 2483, 112, 3, 70, 33, 0, "StyleData", "EquationNumber", "All",
  StyleMenuListing->None],
Cell[67457, 2488, 78, 1, 70, 49, 0, "StyleData", "EquationNumber", \
"Presentation"],
Cell[67538, 2491, 74, 1, 70, 45, 0, "StyleData", "EquationNumber", \
"Printout"],
Cell[67615, 2494, 74, 1, 70, 45, 0, "StyleData", "EquationNumber", \
"Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[67738, 2501, 46, 0, 70, "Subsection"],
Cell[67787, 2503, 57, 1, 70, 31, 0, "StyleData", "EquationGrid", "All",
  StyleMenuListing->None],
Cell[67847, 2506, 58, 1, 70, 32, 0, "StyleData", "SplitEquation", "All",
  StyleMenuListing->None],
Cell[67908, 2509, 54, 1, 70, 28, 0, "StyleData", "Piecewise", "All",
  StyleMenuListing->None],
Cell[67965, 2512, 51, 1, 70, 25, 0, "StyleData", "Matrix", "All",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[68065, 2519, 35, 0, 34, "Section"],
Cell[68103, 2521, 181, 4, 70, 23, 0, "StyleData", "XRef", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[68321, 2530, 29, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[68375, 2534, 346, 10, 60, 34, 0, "StyleData", "BackmatterGroup", "All",
  StyleMenuListing->None],
Cell[68724, 2546, 158, 4, 70, 50, 0, "StyleData", "BackmatterGroup", \
"Presentation"],
Cell[68885, 2552, 121, 3, 70, 46, 0, "StyleData", "BackmatterGroup", \
"Printout"],
Cell[69009, 2557, 121, 3, 70, 46, 0, "StyleData", "BackmatterGroup", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[69167, 2565, 30, 0, 35, "Subsection"],
Cell[69200, 2567, 924, 21, 71, 34, 0, "StyleData", "AppendixSection", "All",
  CounterIncrements->"AppendixSection",
  CounterAssignments->{{"AppendixEquation", 0}},
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[70149, 2592, 165, 5, 40, 39, 0, "StyleData", "AppendixSectionLabel", \
"All",
  StyleMenuListing->None],
Cell[70317, 2599, 81, 1, 70, 55, 0, "StyleData", "AppendixSectionLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[70401, 2602, 51, 0, 70, 51, 0, "StyleData", "AppendixSectionLabel", \
"Printout"],
Cell[70455, 2604, 51, 0, 70, 51, 0, "StyleData", "AppendixSectionLabel", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[70543, 2609, 796, 17, 43, 35, 0, "StyleData", "AppendixEquation", "All",
  CounterIncrements->"AppendixEquation",
  StyleMenuListing->None],
Cell[71342, 2628, 103, 2, 70, 51, 0, "StyleData", "AppendixEquation", \
"Presentation"],
Cell[71448, 2632, 63, 1, 70, 47, 0, "StyleData", "AppendixEquation", \
"Printout"],
Cell[71514, 2635, 47, 0, 70, 47, 0, "StyleData", "AppendixEquation", \
"Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[71610, 2641, 56, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[71691, 2646, 623, 18, 92, 33, 0, "StyleData", "EndnoteSection", "All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Endnote", 0}},
  StyleMenuListing->None],
Cell[72317, 2666, 102, 2, 70, 49, 0, "StyleData", "EndnoteSection", \
"Presentation"],
Cell[72422, 2670, 96, 2, 70, 45, 0, "StyleData", "EndnoteSection", \
"Printout"],
Cell[72521, 2674, 121, 3, 70, 45, 0, "StyleData", "EndnoteSection", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[72679, 2682, 389, 12, 38, 26, 0, "StyleData", "Endnote", "All",
  CounterIncrements->"Endnote",
  StyleMenuListing->None],
Cell[73071, 2696, 93, 2, 42, 42, 0, "StyleData", "Endnote", "Presentation"],
Cell[73167, 2700, 113, 3, 41, 38, 0, "StyleData", "Endnote", "Printout"],
Cell[73283, 2705, 61, 1, 36, 38, 0, "StyleData", "Endnote", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[73381, 2711, 262, 6, 40, 31, 0, "StyleData", "EndnoteLabel", "All",
  CounterIncrements->"EndnoteLabel",
  StyleMenuListing->None],
Cell[73646, 2719, 43, 0, 70, 43, 0, "StyleData", "EndnoteLabel", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[73726, 2724, 149, 4, 40, 32, 0, "StyleData", "EndnoteNumber", "All",
  CounterIncrements->"EndnoteNumber",
  StyleMenuListing->None],
Cell[73878, 2730, 44, 0, 70, 44, 0, "StyleData", "EndnoteNumber", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[73959, 2735, 247, 7, 40, 26, 0, "StyleData", "NoteKey", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[74209, 2744, 81, 1, 70, 42, 0, "StyleData", "NoteKey", "Presentation"],
Cell[74293, 2747, 65, 1, 70, 38, 0, "StyleData", "NoteKey", "Printout"],
Cell[74361, 2750, 65, 1, 70, 38, 0, "StyleData", "NoteKey", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[74463, 2756, 266, 7, 40, 36, 0, "StyleData", "EndnoteReturnLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[74732, 2765, 84, 1, 70, 52, 0, "StyleData", "EndnoteReturnLink", \
"Presentation"],
Cell[74819, 2768, 115, 2, 70, 48, 0, "StyleData", "EndnoteReturnLink", \
"Printout"],
Cell[74937, 2772, 115, 2, 70, 48, 0, "StyleData", "EndnoteReturnLink", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[75089, 2779, 325, 9, 40, 23, 0, "StyleData", "Note", "All",
  StyleMenuListing->None],
Cell[75417, 2790, 55, 1, 70, 35, 0, "StyleData", "Note", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[75521, 2797, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[75578, 2801, 721, 17, 68, 35, 0, "StyleData", "ReferenceSection", "All",
  CounterIncrements->"ReferenceSection",
  CounterAssignments->{{"ReferenceText", 0}, {"BiblioEquation", 0}},
  StyleMenuListing->None],
Cell[76302, 2820, 104, 2, 70, 51, 0, "StyleData", "ReferenceSection", \
"Presentation"],
Cell[76409, 2824, 98, 2, 70, 47, 0, "StyleData", "ReferenceSection", \
"Printout"],
Cell[76510, 2828, 123, 3, 70, 47, 0, "StyleData", "ReferenceSection", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[76670, 2836, 642, 16, 37, 28, 0, "StyleData", "Reference", "All",
  CounterIncrements->"BibliographyItem",
  StyleMenuListing->None],
Cell[77315, 2854, 142, 4, 40, 44, 0, "StyleData", "Reference", \
"Presentation"],
Cell[77460, 2860, 135, 4, 31, 40, 0, "StyleData", "Reference", "Printout"],
Cell[77598, 2866, 63, 1, 34, 40, 0, "StyleData", "Reference", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[77698, 2872, 287, 8, 40, 33, 0, "StyleData", "ReferenceLabel", "All",
  CounterIncrements->"RefDingbat",
  StyleMenuListing->None],
Cell[77988, 2882, 78, 1, 70, 49, 0, "StyleData", "ReferenceLabel", \
"Presentation"],
Cell[78069, 2885, 74, 1, 70, 45, 0, "StyleData", "ReferenceLabel", \
"Printout"],
Cell[78146, 2888, 45, 0, 70, 45, 0, "StyleData", "ReferenceLabel", \
"Preprint"]
}, Closed]],
Cell[78206, 2891, 109, 3, 40, 25, 0, "StyleData", "RefSep", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[78340, 2898, 398, 10, 40, 32, 0, "StyleData", "RefReturnLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[78741, 2910, 87, 1, 70, 48, 0, "StyleData", "RefReturnLink", \
"Presentation"],
Cell[78831, 2913, 71, 1, 70, 44, 0, "StyleData", "RefReturnLink", \
"Printout"],
Cell[78905, 2916, 71, 1, 70, 44, 0, "StyleData", "RefReturnLink", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[79013, 2922, 453, 12, 39, 35, 0, "StyleData", "RefReturnPointer", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[79469, 2936, 100, 2, 39, 47, 0, "StyleData", "RefReturnPointer", \
"Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[79606, 2943, 397, 11, 28, 38, 0, "StyleData", "ReferenceSourceLink", \
"All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[80006, 2956, 77, 1, 70, 50, 0, "StyleData", "ReferenceSourceLink", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[80120, 2962, 328, 9, 40, 27, 0, "StyleData", "Citation", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[80451, 2973, 82, 1, 70, 43, 0, "StyleData", "Citation", "Presentation"],
Cell[80536, 2976, 66, 1, 70, 39, 0, "StyleData", "Citation", "Printout"],
Cell[80605, 2979, 66, 1, 70, 39, 0, "StyleData", "Citation", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[80708, 2985, 245, 7, 40, 25, 0, "StyleData", "RefKey", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[80956, 2994, 80, 1, 70, 41, 0, "StyleData", "RefKey", "Presentation"],
Cell[81039, 2997, 64, 1, 70, 37, 0, "StyleData", "RefKey", "Printout"],
Cell[81106, 3000, 64, 1, 70, 37, 0, "StyleData", "RefKey", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[81207, 3006, 71, 1, 34, "Subsubsection"],
Cell[81281, 3009, 83, 1, 33, "ReferenceTemplate"],
Cell[81367, 3012, 86, 1, 33, "ReferenceTemplate"],
Cell[81456, 3015, 86, 1, 33, "ReferenceTemplate"],
Cell[81545, 3018, 82, 1, 33, "ReferenceTemplate"],
Cell[81630, 3021, 85, 1, 33, "ReferenceTemplate"],
Cell[81718, 3024, 84, 1, 33, "ReferenceTemplate"],
Cell[81805, 3027, 43, 0, 33, "ReferenceTemplate"],
Cell[81851, 3029, 49, 0, 33, "ReferenceTemplate"],
Cell[81903, 3031, 49, 0, 33, "ReferenceTemplate"],
Cell[81955, 3033, 49, 0, 33, "ReferenceTemplate"],
Cell[82007, 3035, 49, 0, 33, "ReferenceTemplate"],
Cell[82059, 3037, 56, 0, 33, "ReferenceTemplate"],
Cell[82118, 3039, 56, 0, 33, "ReferenceTemplate"],

Cell[CellGroupData[{
Cell[82199, 3043, 45, 0, 28, "Subsubsubsection"],
Cell[82247, 3045, 191, 4, 70, "ReferenceTemplate"],
Cell[82441, 3051, 152, 3, 70, "ReferenceTemplate"],
Cell[82596, 3056, 177, 3, 70, "ReferenceTemplate"],
Cell[82776, 3061, 139, 3, 70, "ReferenceTemplate"],
Cell[82918, 3066, 172, 3, 70, "ReferenceTemplate"],
Cell[83093, 3071, 136, 3, 70, "ReferenceTemplate"],
Cell[83232, 3076, 159, 3, 70, "ReferenceTemplate"],
Cell[83394, 3081, 123, 3, 70, "ReferenceTemplate"],
Cell[83520, 3086, 185, 4, 70, "ReferenceTemplate"],
Cell[83708, 3092, 146, 3, 70, "ReferenceTemplate"],
Cell[83857, 3097, 171, 3, 70, "ReferenceTemplate"],
Cell[84031, 3102, 133, 3, 70, "ReferenceTemplate"],
Cell[84167, 3107, 166, 3, 70, "ReferenceTemplate"],
Cell[84336, 3112, 130, 3, 70, "ReferenceTemplate"],
Cell[84469, 3117, 153, 3, 70, "ReferenceTemplate"],
Cell[84625, 3122, 117, 3, 70, "ReferenceTemplate"],
Cell[84745, 3127, 176, 4, 70, "ReferenceTemplate"],
Cell[84924, 3133, 137, 3, 70, "ReferenceTemplate"],
Cell[85064, 3138, 162, 3, 70, "ReferenceTemplate"],
Cell[85229, 3143, 124, 3, 70, "ReferenceTemplate"],
Cell[85356, 3148, 157, 3, 70, "ReferenceTemplate"],
Cell[85516, 3153, 121, 3, 70, "ReferenceTemplate"],
Cell[85640, 3158, 144, 3, 70, "ReferenceTemplate"],
Cell[85787, 3163, 106, 2, 70, "ReferenceTemplate"],
Cell[85896, 3167, 146, 3, 70, "Text"],
Cell[86045, 3172, 152, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[86234, 3180, 45, 0, 26, "Subsubsubsection"],
Cell[86282, 3182, 99, 2, 70, "Text"],
Cell[86384, 3186, 144, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[86565, 3194, 48, 0, 26, "Subsubsubsection"],
Cell[86616, 3196, 138, 3, 70, "ReferenceTemplate"],
Cell[86757, 3201, 99, 2, 70, "ReferenceTemplate"],
Cell[86859, 3205, 117, 3, 70, "ReferenceTemplate"],
Cell[86979, 3210, 143, 3, 70, "Text"],
Cell[87125, 3215, 99, 2, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[87261, 3222, 44, 0, 26, "Subsubsubsection"],
Cell[87308, 3224, 168, 3, 70, "ReferenceTemplate"],
Cell[87479, 3229, 133, 3, 70, "ReferenceTemplate"],
Cell[87615, 3234, 148, 3, 70, "Text"],
Cell[87766, 3239, 168, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[87971, 3247, 54, 0, 26, "Subsubsubsection"],
Cell[88028, 3249, 105, 3, 70, "Text"],
Cell[88136, 3254, 125, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[88298, 3262, 51, 0, 26, "Subsubsubsection"],
Cell[88352, 3264, 107, 3, 70, "Text"],
Cell[88462, 3269, 105, 2, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[88604, 3276, 46, 0, 26, "Subsubsubsection"],
Cell[88653, 3278, 103, 3, 70, "Text"],
Cell[88759, 3283, 87, 1, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[88883, 3289, 52, 0, 26, "Subsubsubsection"],
Cell[88938, 3291, 127, 3, 70, "Text"],
Cell[89068, 3296, 58, 0, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[89163, 3301, 42, 0, 26, "Subsubsubsection"],
Cell[89208, 3303, 97, 2, 70, "Text"],
Cell[89308, 3307, 44, 0, 70, "ReferenceTemplate"]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{
Cell[89401, 3313, 49, 0, 31, "Subsubsection"],

Cell[CellGroupData[{
Cell[89475, 3317, 98, 3, 70, 27, 0, "StyleData", "RefTitle", "All",
  StyleMenuListing->None],
Cell[89576, 3322, 39, 0, 70, 39, 0, "StyleData", "RefTitle", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[89652, 3327, 73, 2, 70, 26, 0, "StyleData", "RefType", "All",
  StyleMenuListing->None],
Cell[89728, 3331, 38, 0, 70, 38, 0, "StyleData", "RefType", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[89803, 3336, 51, 1, 70, 25, 0, "StyleData", "RefURL", "All",
  StyleMenuListing->None],
Cell[89857, 3339, 37, 0, 70, 37, 0, "StyleData", "RefURL", "Printout"]
}, Closed]],
Cell[89909, 3342, 63, 1, 70, 37, 0, "StyleData", "RefInsertedBibText", "All",
  StyleMenuListing->None],
Cell[89975, 3345, 52, 1, 70, 26, 0, "StyleData", "RefNote", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[90064, 3351, 47, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[90136, 3355, 141, 3, 70, 31, 0, "StyleData", "RefBookTitle", "All",
  StyleMenuListing->None],
Cell[90280, 3360, 43, 0, 70, 43, 0, "StyleData", "RefBookTitle", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[90372, 3366, 50, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[90447, 3370, 60, 1, 70, 34, 0, "StyleData", "RefJournalTitle", "All",
  StyleMenuListing->None],
Cell[90510, 3373, 46, 0, 70, 46, 0, "StyleData", "RefJournalTitle", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[90593, 3378, 144, 3, 70, 35, 0, "StyleData", "RefJournalVolume", "All",
  StyleMenuListing->None],
Cell[90740, 3383, 47, 0, 70, 47, 0, "StyleData", "RefJournalVolume", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[90824, 3388, 61, 1, 70, 35, 0, "StyleData", "RefJournalNumber", "All",
  StyleMenuListing->None],
Cell[90888, 3391, 73, 1, 70, 47, 0, "StyleData", "RefJournalNumber", \
"Printout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[91010, 3398, 52, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[91087, 3402, 57, 1, 70, 31, 0, "StyleData", "RefPublisher", "All",
  StyleMenuListing->None],
Cell[91147, 3405, 43, 0, 70, 43, 0, "StyleData", "RefPublisher", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[91227, 3410, 74, 2, 70, 26, 0, "StyleData", "RefCity", "All",
  StyleMenuListing->None],
Cell[91304, 3414, 38, 0, 70, 38, 0, "StyleData", "RefCity", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[91391, 3420, 49, 0, 34, "Subsubsection"],
Cell[91443, 3422, 59, 1, 70, 33, 0, "StyleData", "RefAuthorGroup", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[91527, 3427, 56, 1, 70, 30, 0, "StyleData", "RefAuthorFN", "All",
  StyleMenuListing->None],
Cell[91586, 3430, 42, 0, 70, 42, 0, "StyleData", "RefAuthorFN", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[91665, 3435, 56, 1, 70, 30, 0, "StyleData", "RefAuthorLN", "All",
  StyleMenuListing->None],
Cell[91724, 3438, 42, 0, 70, 42, 0, "StyleData", "RefAuthorLN", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[91803, 3443, 56, 1, 70, 30, 0, "StyleData", "RefAuthorMN", "All",
  StyleMenuListing->None],
Cell[91862, 3446, 42, 0, 70, 42, 0, "StyleData", "RefAuthorMN", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[91953, 3452, 49, 0, 34, "Subsubsection"],
Cell[92005, 3454, 59, 1, 70, 33, 0, "StyleData", "RefEditorGroup", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[92089, 3459, 56, 1, 70, 30, 0, "StyleData", "RefEditorFN", "All",
  StyleMenuListing->None],
Cell[92148, 3462, 42, 0, 70, 42, 0, "StyleData", "RefEditorFN", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[92227, 3467, 56, 1, 70, 30, 0, "StyleData", "RefEditorMN", "All",
  StyleMenuListing->None],
Cell[92286, 3470, 42, 0, 70, 42, 0, "StyleData", "RefEditorMN", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[92365, 3475, 56, 1, 70, 30, 0, "StyleData", "RefEditorLN", "All",
  StyleMenuListing->None],
Cell[92424, 3478, 42, 0, 70, 42, 0, "StyleData", "RefEditorLN", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[92515, 3484, 49, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[92589, 3488, 54, 1, 70, 28, 0, "StyleData", "RefSchool", "All",
  StyleMenuListing->None],
Cell[92646, 3491, 40, 0, 70, 40, 0, "StyleData", "RefSchool", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[92735, 3497, 59, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[92819, 3501, 52, 1, 70, 26, 0, "StyleData", "RefYear", "All",
  StyleMenuListing->None],
Cell[92874, 3504, 38, 0, 70, 38, 0, "StyleData", "RefYear", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[92961, 3510, 86, 1, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[93072, 3515, 79, 2, 70, 31, 0, "StyleData", "RefFirstPage", "All",
  StyleMenuListing->None],
Cell[93154, 3519, 43, 0, 70, 43, 0, "StyleData", "RefFirstPage", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[93234, 3524, 78, 2, 70, 30, 0, "StyleData", "RefLastPage", "All",
  StyleMenuListing->None],
Cell[93315, 3528, 42, 0, 70, 42, 0, "StyleData", "RefLastPage", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[93406, 3534, 41, 0, 34, "Subsubsection"],
Cell[93450, 3536, 56, 1, 70, 30, 0, "StyleData", "RefNoteText", "All",
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[93567, 3544, 32, 0, 34, "Section"],
Cell[93602, 3546, 232, 5, 40, 34, 0, "StyleData", "TextSuperscript", "All",
  StyleMenuListing->None],
Cell[93837, 3553, 109, 3, 40, 32, 0, "StyleData", "TextSubscript", "All",
  StyleMenuListing->None],
Cell[93949, 3558, 106, 3, 40, 22, 0, "StyleData", "Nil", "All",
  StyleMenuListing->None],
Cell[94058, 3563, 69, 2, 40, 27, 0, "StyleData", "Verbatim", "All",
  StyleMenuListing->None],
Cell[94130, 3567, 117, 3, 40, 26, 0, "StyleData", "TeXName", "All",
  StyleMenuListing->None],
Cell[94250, 3572, 121, 3, 40, 28, 0, "StyleData", "LaTeXName", "All",
  StyleMenuListing->None],
Cell[94374, 3577, 123, 3, 40, 29, 0, "StyleData", "LaTeXeName", "All",
  StyleMenuListing->None],
Cell[94500, 3582, 114, 3, 40, 34, 0, "StyleData", "ChemicalElement", "All",
  StyleMenuListing->None],
Cell[94617, 3587, 90, 2, 40, 34, 0, "StyleData", "CustomCharacter", "All",
  StyleMenuListing->None],
Cell[94710, 3591, 52, 1, 40, 26, 0, "StyleData", "Palette", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[94787, 3596, 561, 17, 8, 28, 0, "StyleData", "PageBreak", "All",
  StyleMenuListing->None],
Cell[95351, 3615, 119, 3, 70, 40, 0, "StyleData", "PageBreak", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[95507, 3623, 178, 6, 55, 31, 0, "StyleData", "CreationDate", "All",
  StyleMenuListing->None],
Cell[95688, 3631, 114, 3, 70, 43, 0, "StyleData", "CreationDate", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[95839, 3639, 39, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[95903, 3643, 293, 7, 28, 29, 0, "StyleData", "SingleLine", "All",
  StyleMenuListing->None],
Cell[96199, 3652, 136, 3, 21, 41, 0, "StyleData", "SingleLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[96372, 3660, 263, 8, 27, 29, 0, "StyleData", "DoubleLine", "All",
  StyleMenuListing->None],
Cell[96638, 3670, 90, 2, 70, 41, 0, "StyleData", "DoubleLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[96765, 3677, 287, 9, 14, 27, 0, "StyleData", "ThinLine", "All",
  StyleMenuListing->None],
Cell[97055, 3688, 39, 0, 70, 39, 0, "StyleData", "ThinLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[97131, 3693, 287, 9, 16, 29, 0, "StyleData", "MediumLine", "All",
  StyleMenuListing->None],
Cell[97421, 3704, 41, 0, 70, 41, 0, "StyleData", "MediumLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[97499, 3709, 286, 9, 17, 28, 0, "StyleData", "ThickLine", "All",
  StyleMenuListing->None],
Cell[97788, 3720, 40, 0, 70, 40, 0, "StyleData", "ThickLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[97865, 3725, 100, 2, 40, 25, 0, "StyleData", "Spacer", "All",
  StyleMenuListing->None],
Cell[97968, 3729, 37, 0, 70, 37, 0, "StyleData", "Spacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[98042, 3734, 55, 1, 40, 29, 0, "StyleData", "TextSpacer", "All",
  StyleMenuListing->None],
Cell[98100, 3737, 41, 0, 70, 41, 0, "StyleData", "TextSpacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[98178, 3742, 58, 1, 40, 32, 0, "StyleData", "SectionSpacer", "All",
  StyleMenuListing->None],
Cell[98239, 3745, 44, 0, 70, 44, 0, "StyleData", "SectionSpacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[98320, 3750, 59, 1, 40, 33, 0, "StyleData", "GraphicsSpacer", "All",
  StyleMenuListing->None],
Cell[98382, 3753, 45, 0, 70, 45, 0, "StyleData", "GraphicsSpacer", \
"Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[98476, 3759, 29, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[98530, 3763, 494, 12, 70, 27, 0, "StyleData", "Outline1", "All",
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}},
  StyleMenuListing->None],
Cell[99027, 3777, 127, 3, 70, 43, 0, "StyleData", "Outline1", \
"Presentation"],
Cell[99157, 3782, 88, 2, 70, 39, 0, "StyleData", "Outline1", "Printout"],
Cell[99248, 3786, 39, 0, 70, 39, 0, "StyleData", "Outline1", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[99324, 3791, 133, 4, 70, 32, 0, "StyleData", "Outline1Label", "All",
  StyleMenuListing->None],
Cell[99460, 3797, 77, 1, 70, 48, 0, "StyleData", "Outline1Label", \
"Presentation"],
Cell[99540, 3800, 73, 1, 70, 44, 0, "StyleData", "Outline1Label", \
"Printout"],
Cell[99616, 3803, 44, 0, 70, 44, 0, "StyleData", "Outline1Label", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[99697, 3808, 520, 13, 70, 27, 0, "StyleData", "Outline2", "All",
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}},
  StyleMenuListing->None],
Cell[100220, 3823, 96, 2, 70, 43, 0, "StyleData", "Outline2", \
"Presentation"],
Cell[100319, 3827, 89, 2, 70, 39, 0, "StyleData", "Outline2", "Printout"],
Cell[100411, 3831, 39, 0, 70, 39, 0, "StyleData", "Outline2", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[100487, 3836, 133, 4, 70, 32, 0, "StyleData", "Outline2Label", "All",
  StyleMenuListing->None],
Cell[100623, 3842, 77, 1, 70, 48, 0, "StyleData", "Outline2Label", \
"Presentation"],
Cell[100703, 3845, 73, 1, 70, 44, 0, "StyleData", "Outline2Label", \
"Printout"],
Cell[100779, 3848, 44, 0, 70, 44, 0, "StyleData", "Outline2Label", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[100860, 3853, 461, 11, 70, 27, 0, "StyleData", "Outline3", "All",
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}},
  StyleMenuListing->None],
Cell[101324, 3866, 96, 2, 70, 43, 0, "StyleData", "Outline3", \
"Presentation"],
Cell[101423, 3870, 89, 2, 70, 39, 0, "StyleData", "Outline3", "Printout"],
Cell[101515, 3874, 39, 0, 70, 39, 0, "StyleData", "Outline3", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[101591, 3879, 133, 4, 70, 32, 0, "StyleData", "Outline3Label", "All",
  StyleMenuListing->None],
Cell[101727, 3885, 77, 1, 70, 48, 0, "StyleData", "Outline3Label", \
"Presentation"],
Cell[101807, 3888, 73, 1, 70, 44, 0, "StyleData", "Outline3Label", \
"Printout"],
Cell[101883, 3891, 44, 0, 70, 44, 0, "StyleData", "Outline3Label", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[101964, 3896, 457, 11, 70, 27, 0, "StyleData", "Outline4", "All",
  CounterIncrements->"Outline4",
  StyleMenuListing->None],
Cell[102424, 3909, 97, 2, 70, 43, 0, "StyleData", "Outline4", \
"Presentation"],
Cell[102524, 3913, 89, 2, 70, 39, 0, "StyleData", "Outline4", "Printout"],
Cell[102616, 3917, 39, 0, 70, 39, 0, "StyleData", "Outline4", "Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[102692, 3922, 133, 4, 70, 32, 0, "StyleData", "Outline4Label", "All",
  StyleMenuListing->None],
Cell[102828, 3928, 77, 1, 70, 48, 0, "StyleData", "Outline4Label", \
"Presentation"],
Cell[102908, 3931, 73, 1, 70, 44, 0, "StyleData", "Outline4Label", \
"Printout"],
Cell[102984, 3934, 44, 0, 70, 44, 0, "StyleData", "Outline4Label", \
"Preprint"]
}, Closed]],

Cell[CellGroupData[{
Cell[103065, 3939, 283, 8, 70, 30, 0, "StyleData", "OutlineText", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[103351, 3949, 98, 2, 70, 46, 0, "StyleData", "OutlineText", \
"Presentation"],
Cell[103452, 3953, 139, 4, 70, 42, 0, "StyleData", "OutlineText", \
"Printout"],
Cell[103594, 3959, 42, 0, 70, 42, 0, "StyleData", "OutlineText", "Preprint"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[103685, 3965, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[103742, 3969, 811, 24, 70, 41, 0, "StyleData", "SlideShowNavigationBar", \
"All",
  CounterIncrements->"SlideShowNavigationBar",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[104556, 3995, 198, 5, 70, 53, 0, "StyleData", "SlideShowNavigationBar", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[104791, 4005, 322, 10, 70, 33, 0, "StyleData", "SlideHyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[105116, 4017, 49, 0, 70, 49, 0, "StyleData", "SlideHyperlink", \
"Presentation"],
Cell[105168, 4019, 45, 0, 70, 45, 0, "StyleData", "SlideHyperlink", \
"Printout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[105274, 4026, 32, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[105331, 4030, 71, 1, 70, "Subsection"],
Cell[105405, 4033, 92, 3, 70, 21, 0, "StyleData", "RM", "All",
  StyleMenuListing->None],
Cell[105500, 4038, 119, 3, 70, 21, 0, "StyleData", "BF", "All",
  StyleMenuListing->None],
Cell[105622, 4043, 159, 4, 70, 21, 0, "StyleData", "IT", "All",
  StyleMenuListing->None],
Cell[105784, 4049, 190, 4, 70, 28, 0, "StyleData", "SmallCaps", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[106011, 4058, 77, 1, 70, "Subsection"],
Cell[106091, 4061, 115, 4, 70, 21, 0, "StyleData", "TR", "All",
  StyleMenuListing->None],
Cell[106209, 4067, 205, 6, 70, 21, 0, "StyleData", "TI", "All",
  StyleMenuListing->None],
Cell[106417, 4075, 203, 6, 70, 21, 0, "StyleData", "TB", "All",
  StyleMenuListing->None],
Cell[106623, 4083, 215, 6, 70, 22, 0, "StyleData", "TBI", "All",
  StyleMenuListing->None],
Cell[106841, 4091, 294, 8, 70, 21, 0, "StyleData", "MR", "All",
  StyleMenuListing->None],
Cell[107138, 4101, 305, 8, 70, 21, 0, "StyleData", "MO", "All",
  StyleMenuListing->None],
Cell[107446, 4111, 303, 8, 70, 21, 0, "StyleData", "MB", "All",
  StyleMenuListing->None],
Cell[107752, 4121, 315, 8, 70, 22, 0, "StyleData", "MBO", "All",
  StyleMenuListing->None],
Cell[108070, 4131, 208, 6, 70, 21, 0, "StyleData", "SR", "All",
  StyleMenuListing->None],
Cell[108281, 4139, 219, 6, 70, 21, 0, "StyleData", "SO", "All",
  StyleMenuListing->None],
Cell[108503, 4147, 217, 6, 70, 21, 0, "StyleData", "SB", "All",
  StyleMenuListing->None],
Cell[108723, 4155, 229, 6, 70, 22, 0, "StyleData", "SBO", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[108989, 4166, 32, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[109046, 4170, 386, 10, 70, 28, 0, "StyleData", "Hyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[109435, 4182, 123, 3, 70, 40, 0, "StyleData", "Hyperlink", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[109595, 4190, 289, 8, 70, 29, 0, "StyleData", "XMLWebLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[109887, 4200, 108, 2, 70, 41, 0, "StyleData", "XMLWebLink", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[110032, 4207, 50, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[110107, 4211, 313, 8, 70, 32, 0, "StyleData", "UserGuideLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[110423, 4221, 111, 2, 70, 44, 0, "StyleData", "UserGuideLink", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[110571, 4228, 313, 8, 70, 32, 0, "StyleData", "ReferenceLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[110887, 4238, 111, 2, 70, 44, 0, "StyleData", "ReferenceLink", \
"Printout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[111071, 4248, 25, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[111121, 4252, 65, 1, 70, "Subsection"],
Cell[111189, 4255, 304, 7, 70, "Text"],
Cell[111496, 4264, 314, 10, 70, 33, 0, "StyleData", "CellExpression", "All",
  StyleMenuListing->None],
Cell[111813, 4276, 106, 3, 70, 28, 0, "StyleData", "InputForm", "All",
  StyleMenuListing->None],
Cell[111922, 4281, 151, 5, 70, 29, 0, "StyleData", "OutputForm", "All",
  StyleMenuListing->None],
Cell[112076, 4288, 108, 3, 70, 31, 0, "StyleData", "StandardForm", "All",
  StyleMenuListing->None],
Cell[112187, 4293, 179, 5, 70, 34, 0, "StyleData", "TraditionalForm", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[112403, 4303, 53, 0, 70, "Subsection"],
Cell[112459, 4305, 122, 3, 70, 36, 0, "StyleData", "ReferenceTemplate", "All",
  
  StyleMenuListing->None],
Cell[112584, 4310, 136, 3, 70, 50, 0, "StyleData", \
"AuthorFormCustomizationTemplate", "All",
  StyleMenuListing->None],
Cell[112723, 4315, 119, 3, 70, 33, 0, "StyleData", "CSSDefinitions", "All",
  StyleMenuListing->None],
Cell[112845, 4320, 118, 3, 70, 32, 0, "StyleData", "LaTeXPreamble", "All",
  StyleMenuListing->None],
Cell[112966, 4325, 118, 3, 70, 32, 0, "StyleData", "DOCTYPEFormat", "All",
  StyleMenuListing->None],
Cell[113087, 4330, 122, 3, 70, 36, 0, "StyleData", "ValidationSetting", "All",
  
  StyleMenuListing->None],
Cell[113212, 4335, 124, 3, 70, 38, 0, "StyleData", "XRefPaletteSettings", \
"All",
  StyleMenuListing->None],
Cell[113339, 4340, 117, 3, 70, 31, 0, "StyleData", "MiscSettings", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[113493, 4348, 60, 1, 70, "Subsection"],
Cell[113556, 4351, 116, 5, 70, "Text"],
Cell[113675, 4358, 110, 3, 70, 29, 0, "StyleData", "InlineCell", "All",
  StyleMenuListing->None],
Cell[113788, 4363, 116, 2, 70, 36, 0, "StyleData", "InlineCellEditing", "All",
  
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[113941, 4370, 55, 1, 70, "Subsection"],
Cell[113999, 4373, 122, 5, 70, "Text"],
Cell[114124, 4380, 226, 5, 70, 24, 0, "StyleData", "Paste", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[114353, 4387, 183, 4, 70, 29, 0, "StyleData", "StyleApply", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[114539, 4393, 257, 6, 70, 45, 0, "StyleData", \
"StyleApplyWithVerification", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[114799, 4401, 296, 7, 70, 35, 0, "StyleData", "ConvertCharacter", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic]
}, Closed]],

Cell[CellGroupData[{
Cell[115132, 4413, 57, 1, 70, "Subsection"],
Cell[115192, 4416, 330, 9, 70, "Text"],
Cell[115525, 4427, 109, 2, 70, 35, 0, "StyleData", "UnmatchedBracket", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[115671, 4434, 61, 1, 70, "Subsection"],
Cell[115735, 4437, 189, 5, 70, 55, 0, "StyleData", \
"DialogStyleSheetMisapplicationEscape", "All",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[115973, 4448, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[116028, 4452, 60, 1, 70, "Subsection"],
Cell[116091, 4455, 364, 6, 70, "Text"],

Cell[CellGroupData[{
Cell[116480, 4465, 681, 20, 70, 24, 0, "StyleData", "Input", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],
Cell[117164, 4487, 130, 3, 70, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[117331, 4495, 900, 26, 70, 32, 0, "StyleData", "InputNumbered", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],
Cell[118234, 4523, 138, 3, 70, 44, 0, "StyleData", "InputNumbered", \
"Printout"]
}, Closed]],
Cell[118387, 4529, 325, 11, 70, 28, 0, "StyleData", "InputOnly", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[118737, 4544, 622, 18, 70, 25, 0, "StyleData", "Output", "All",
  CounterIncrements->"Output",
  StyleMenuListing->None],
Cell[119362, 4564, 86, 2, 70, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[119485, 4571, 516, 15, 70, 26, 0, "StyleData", "Message", "All",
  CounterIncrements->"Message",
  StyleMenuListing->None],
Cell[120004, 4588, 138, 3, 70, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[120179, 4596, 480, 14, 70, 24, 0, "StyleData", "Print", "All",
  CounterIncrements->"Print",
  StyleMenuListing->None],
Cell[120662, 4612, 109, 2, 70, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[120786, 4617, 280, 7, 70, "Text"],

Cell[CellGroupData[{
Cell[121091, 4628, 519, 17, 70, 27, 0, "StyleData", "Graphics", "All",
  CounterIncrements->"Graphics",
  StyleMenuListing->None],
Cell[121613, 4647, 144, 4, 70, 39, 0, "StyleData", "Graphics", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[121794, 4656, 154, 5, 70, 28, 0, "StyleData", "CellLabel", "All",
  StyleMenuListing->None],
Cell[121951, 4663, 130, 4, 70, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[122130, 4673, 67, 1, 70, "Subsection"],

Cell[CellGroupData[{
Cell[122222, 4678, 56, 1, 70, 30, 0, "StyleData", "MathCaption", "All",
  StyleMenuListing->None],
Cell[122281, 4681, 68, 1, 70, 42, 0, "StyleData", "MathCaption", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[122386, 4687, 53, 1, 70, 27, 0, "StyleData", "UserTips", "All",
  StyleMenuListing->None],
Cell[122442, 4690, 65, 1, 70, 39, 0, "StyleData", "UserTips", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[122544, 4696, 57, 1, 70, 31, 0, "StyleData", "UserTipsList", "All",
  StyleMenuListing->None],
Cell[122604, 4699, 69, 1, 70, 43, 0, "StyleData", "UserTipsList", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[122710, 4705, 57, 1, 70, 31, 0, "StyleData", "IndentedText", "All",
  StyleMenuListing->None],
Cell[122770, 4708, 69, 1, 70, 43, 0, "StyleData", "IndentedText", "Printout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[122888, 4715, 45, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[122958, 4719, 527, 14, 70, 35, 0, "StyleData", "Item1NumberedNew", "All",
  
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[123488, 4735, 194, 6, 70, 47, 0, "StyleData", "Item1NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[123719, 4746, 511, 13, 70, 35, 0, "StyleData", "Item2NumberedNew", "All",
  
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item2Numbered", 0}},
  StyleMenuListing->None],
Cell[124233, 4761, 195, 6, 70, 47, 0, "StyleData", "Item2NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[124465, 4772, 511, 13, 70, 35, 0, "StyleData", "Item3NumberedNew", "All",
  
  CounterIncrements->"Item3Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[124979, 4787, 195, 6, 70, 47, 0, "StyleData", "Item3NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

