(************** Content-type: application/mathematica **************
                       CreatedBy='Publicon 1.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[      8355,        374]*)
(*NotebookOutlinePosition[    173603,       6397]*)
(*  CellTagsIndexPosition[    173311,       6384]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Title...", "Title"],

Cell["Subtitle...", "Subtitle"],

Cell[TextData[{
  Cell[TextData[{
    ButtonBox["AuthorName",
      ButtonData:>"AuthorFirstName1",
      ButtonStyle->"AuthorFirstName"],
    " ",
    ButtonBox["",
      ButtonData:>"AuthorLastName1",
      ButtonStyle->"AuthorLastName"]
  }], "Author"],
  StyleBox["", "Nil"]
}], "AuthorGroup"],

Cell["Abstract...", "Abstract"],

Cell[CellGroupData[{

Cell[TextData[{
  Cell[TextData[{
    
    CounterBox["Section"],
    " "
  }], "SectionLabel",
    TaggingRules:>{"CellLabel" -> True}],
  "Section"
}], "Section"],

Cell[TextData[{
  "Wskldjflkjs dflkjs fkljsflkwoifjlksdjflkjweiojwef ",
  StyleBox["\[InvisibleSpace]", "RefSep"],
  ButtonBox["Parl (1980)",
    ButtonData:>"Parl",
    ButtonStyle->"Citation",
    ButtonNote->"Parl"]
}], "Text",
  CellTags->":bib:Parl"],

Cell[TextData[{
  "Your text begins here. ksdjl ksjdfkl sjfklj sdklj sdfjkl ",
  StyleBox["\[InvisibleSpace]", "RefSep"],
  ButtonBox["Diaconis (1988)",
    ButtonData:>"Diacon",
    ButtonStyle->"Citation",
    ButtonNote->"Diacon"],
  " sdfjlskfj lsjflskfj lskjf lskjf lskjflksjf lksjf lksjf lksjflksj flksjf \
lksjflk sdflksjdfowiufoiwf wkjlwkejfoiw ufoiwu fowjfklwejfio \
wfjwlekjflwkejf."
}], "Text",
  CellTags->":bib:Diacon"],

Cell[TextData[{
  "Wlskdjfl jsfjoifjwjflksd,mf,smfiwjlwkmf,.sdmfnskjvh iox cvxcm,vnjkshfkl \
sjdfiowowef ,msdn,fmnsdm,fn wioefoweufoisdkfsdn, mxncm,vn skjfsdjfiowf ",
  StyleBox["\[InvisibleSpace]", "RefSep"],
  ButtonBox["Kasman and Rothstein (1997)",
    ButtonData:>"Kasman97",
    ButtonStyle->"Citation",
    ButtonNote->"Kasman97"],
  " sdljlskjflskfjl sdjflskdfj lksjflksj."
}], "Text",
  CellTags->":bib:Kasman97"],

Cell[TextData[{
  "lksjdflksj dfkljsfkljsdfjoiwejfwklefk,sdj fksdflksdjf iowjfklsdjf ",
  StyleBox["\[InvisibleSpace]", "RefSep"],
  ButtonBox["Tymczak, Japaridze, Handy and Wang (1998)",
    ButtonData:>"Tymczak",
    ButtonStyle->"Citation",
    ButtonNote->"Tymczak"],
  " lskdjflskj flksj flksdjf lsjd flkjsdflkjsdfkl"
}], "Text",
  CellTags->":bib:Tymczak"]
}, Open  ]],

Cell[CellGroupData[{

Cell["References", "ReferenceSection"],

Cell[CellGroupData[{

Cell[TextData[{
  ButtonBox["\[CapitalCCedilla]",
    ButtonData:>":bib:Diacon",
    ButtonStyle->"RefReturnPointer"],
  " ",
  Cell[TextData[{
    StyleBox["Diaconis", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["P", "RefAuthorFN"],
    "."
  }], "RefAuthorGroup"],
  " ",
  "(",
  StyleBox["1988", "RefYear"],
  ")",
  ".",
  " ",
  StyleBox["Group Representations in Probability and Statistics", 
    "RefTitle"],
  ".",
  " ",
  "I",
  "n",
  " ",
  Cell[TextData[{
    StyleBox["H", "RefEditorFN"],
    ".",
    " ",
    StyleBox["S", "RefEditorMN"],
    ".",
    " ",
    StyleBox["Thompson", "RefEditorLN"]
  }], "RefEditorGroup"],
  " ",
  "(",
  "E",
  "d",
  ".",
  ")",
  ",",
  " ",
  StyleBox["Inst. Math. Stat.", "RefBookTitle"],
  " ",
  "(",
  "p",
  "p",
  ".",
  " ",
  StyleBox["198", "RefFirstPage"],
  "\[Dash]",
  StyleBox["198", "RefLastPage"],
  ")",
  ".",
  " ",
  StyleBox["Hayward", "RefCity"],
  ":",
  " ",
  StyleBox["Inst. Math. Stat.", "RefPublisher"],
  "."
}], "Reference",
  TaggingRules:>{"RefType" -> "InBook"},
  CellTags->"Diacon"],

Cell[TextData[{
  ButtonBox["\[CapitalCCedilla]",
    ButtonData:>":bib:Kasman97",
    ButtonStyle->"RefReturnPointer"],
  " ",
  Cell[TextData[{
    StyleBox["Kasman", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["A", "RefAuthorFN"],
    "."
  }], "RefAuthorGroup"],
  ", & ",
  Cell[TextData[{
    StyleBox["Rothstein", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["M", "RefAuthorFN"],
    "."
  }], "RefAuthorGroup"],
  " ",
  "(",
  StyleBox["1997", "RefYear"],
  ")",
  ".",
  " ",
  StyleBox["Bispectral Darboux transformations: the generalized Airy case", 
    "RefTitle"],
  ".",
  " ",
  StyleBox["Phys. D", "RefJournalTitle"],
  ",",
  " ",
  StyleBox["102", "RefJournalVolume"],
  "(",
  StyleBox["3\[Dash]4", "RefJournalNumber"],
  ")",
  ",",
  " ",
  StyleBox["159", "RefFirstPage"],
  "\[Dash]",
  StyleBox["176", "RefLastPage"],
  "."
}], "Reference",
  TaggingRules:>{"RefType" -> "Article"},
  CellTags->"Kasman97"],

Cell[TextData[{
  ButtonBox["\[CapitalCCedilla]",
    ButtonData:>":bib:Parl",
    ButtonStyle->"RefReturnPointer"],
  " ",
  Cell[TextData[{
    StyleBox["Parl", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["S", "RefAuthorFN"],
    "."
  }], "RefAuthorGroup"],
  " ",
  "(",
  StyleBox["1980", "RefYear"],
  ",",
  " ",
  StyleBox["Jan", "RefMonth"],
  " ",
  StyleBox["14", "RefDay"],
  ")",
  ".",
  " ",
  StyleBox["A New Method of Calculating the Generalized Q Function", 
    "RefTitle"],
  ".",
  " ",
  StyleBox["IEEE Trans. Info. Th.", "RefJournalTitle"],
  ",",
  " ",
  StyleBox["26", "RefJournalVolume"],
  "(",
  StyleBox["3", "RefJournalNumber"],
  ")",
  ",",
  " ",
  StyleBox["121", "RefFirstPage"],
  "\[Dash]",
  StyleBox["124", "RefLastPage"],
  "."
}], "Reference",
  TaggingRules:>{"RefType" -> "Article"},
  CellTags->"Parl"],

Cell[TextData[{
  ButtonBox["\[CapitalCCedilla]",
    ButtonData:>":bib:Tymczak",
    ButtonStyle->"RefReturnPointer"],
  " ",
  Cell[TextData[{
    StyleBox["Tymczak", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["C", "RefAuthorFN"],
    ".",
    " ",
    StyleBox["J", "RefAuthorMN"],
    "."
  }], "RefAuthorGroup"],
  ", ",
  Cell[TextData[{
    StyleBox["Japaridze", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["G", "RefAuthorFN"],
    ".",
    " ",
    StyleBox["S", "RefAuthorMN"],
    "."
  }], "RefAuthorGroup"],
  ", ",
  Cell[TextData[{
    StyleBox["Handy", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["C", "RefAuthorFN"],
    ".",
    " ",
    StyleBox["R", "RefAuthorMN"],
    "."
  }], "RefAuthorGroup"],
  ", & ",
  Cell[TextData[{
    StyleBox["Wang", "RefAuthorLN"],
    ",",
    " ",
    StyleBox["X", "RefAuthorFN"],
    ".",
    " ",
    StyleBox["Q", "RefAuthorMN"],
    "."
  }], "RefAuthorGroup"],
  " ",
  "(",
  StyleBox["1998", "RefYear"],
  ",",
  " ",
  StyleBox["March", "RefMonth"],
  " ",
  StyleBox["14", "RefDay"],
  ")",
  ".",
  " ",
  StyleBox["New perspective on inner product quantization", "RefTitle"],
  ".",
  " ",
  StyleBox["Phys. Rev. Lett.", "RefJournalTitle"],
  ",",
  " ",
  StyleBox["80", "RefJournalVolume"],
  "(",
  StyleBox["17", "RefJournalNumber"],
  ")",
  ",",
  " ",
  StyleBox["3673", "RefFirstPage"],
  "\[Dash]",
  StyleBox["3677", "RefLastPage"],
  "."
}], "Reference",
  TaggingRules:>{"RefType" -> "Article"},
  CellTags->"Tymczak"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 795}},
WindowSize->{520, 673},
WindowMargins->{{8, Automatic}, {Automatic, 8}},
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["Article1.nb Style Definitions", "Title"],
  
  Cell["\<\
Modify the definitions below to change the default appearance of \
all cells in a given style.  Make modifications to any definition using \
commands in the Format menu.\
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell["CSS", "Section"],
  
  Cell["\<\
<style type=\"text/css\">
/* global */
body { margin: 10pt }

p.NoSpace { margin: 0pt }

img { vertical-align: middle;  } 

/* Frontmatter*/

.Title { margin: 36pt 2pt 4pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 32pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.Subtitle { margin: 2pt 2pt 4pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 18pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: center;
\tcolor: #000000;
\t}

a.AuthorData { text-decoration:none; }

.AuthorDataSup { font-size: 80% }

.AuthorGroup { margin: 24pt 54pt 2pt 54pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.Institution { margin: 0pt 54pt 0pt 54pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000080;
\t}

.Abstract { margin: 24pt 54pt 3pt 54pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: justify;
\tcolor: #000080;
\t}

/* mainmatter */

h3 { margin: 24pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 18pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

h4 { margin: 12pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 15pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

h5 { margin: 6pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.Subsubsubsection { margin: 6pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000000;
\t}

.Text, .TextContinuation, .TextNoIndent { margin: 5pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: justify;
\tcolor: #000000;
\t}

/* Itemized Lists */

li { margin: 2pt 12pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size:10pt;
\t}

ol ol { list-style: lower-alpha; }

ol ol ol{ list-style: lower-roman; }

.Item1Paragraph, .Item2Paragraph, .Item3Paragraph 
{ margin-top: 3pt; margin-bottom: 3pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* Illustrations */

.Figure, .Picture, .Graphics { margin: 6pt 2pt 8pt 2pt; text-align: center; }

.FigureCaption, .PictureCaption, .ProgramCaption, .Caption { margin: 2pt 42pt \
6pt 42pt;
\tfont-family: Helvetica;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.Program { margin: 5pt 2pt 2pt 2pt;
\tfont-family: \"Courier New\", Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

table { margin: 1pt 2pt 1pt 28pt; }

table.TableMasterGrid { width:100%; 
\tmargin: 3pt 2pt 7pt 2pt;
\tborder-bottom: 1pt solid #000000;
\tborder-top: 2pt solid #000000;
\t}

table.TableMasterGrid td.TableLineElement {
\tborder-bottom: solid 1pt #000000;
\tfont-size: 1pt;
\tline-height: 0pt;
\t}

.TableTitle { margin: 7pt 2pt 2pt 28pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.TableTitleLabel { font-weight: bold; }

.TableNote { margin: -3pt 2pt 7pt 28pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #4C4C4C;
\t}

.TableColumnHead, .TableSpanHead { 
\tfont-family: Times New Roman, Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic; 
\tcolor: #000000;
\t}

.TableText, .TableSpanText {
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal; 
\tcolor: #000000;
\t}

/* mathematics */

.Equation, .EquationWide, 
.EquationNumbered, .EquationWideNumbered, 
.AppendixEquation,
.EquationGroupAlignedNumbered, .EquationGroupAligned,
.EquationGroupNumbered, .EquationGroup {
\tmargin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal; 
\ttext-align: center; 
\tfont-style: normal; 
\tcolor: #000000;
\t}

table.EquationNumbered {
\twidth: 100%;
\t}

table.AppendixEquation {
\twidth: 100%;
\t}

table.AppendixEquation td.AppendixEquationLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationNumbered td.EquationNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationGroup,
table.EquationGroupNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

p.EquationGroup {
\tpadding-left: 4.5%;
\t}

table.EquationGroupNumbered td.EquationGroupNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

.EquationGroupAligned table {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tpadding-left: 4.5%;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

.EquationGroupAligned table td,
.EquationGroupAligned table th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

table.EquationGroupAlignedNumbered td,
table.EquationGroupAlignedNumbered th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered td.EquationGroupAlignedNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

/* Cross-References */

.XRef { color: #000000; text-decoration:none }
.DkBlue { color: #000080; }

/* Backmatter */

.Reference, .Endnote { margin: 1pt 2pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

td.EndnoteLabel { width: 32px; }
td.ReferenceLabel { width: 72px; }

/* miscellaneous */

.PageBreak { page-break-before:always; }

/* Common Inline */

.RM  { font-style: normal; font-weight: normal }
.BF  { font-style: normal; font-weight: bold }
.IT  { font-style: italic; font-weight: normal }
.TR  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: normal }
.TI  { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: normal }
.TB  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: bold }
.TBI { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: bold }
.MR  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MO  { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: normal }
.MB  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MBO { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: bold }
.SR  { font-family: Helvetica, Arial; font-style: normal; font-weight: normal \
}
.SO  { font-family: Helvetica, Arial; font-style: italic; font-weight: normal \
}
.SB  { font-family: Helvetica, Arial; font-style: normal; font-weight: bold }
.SBO { font-family: Helvetica, Arial; font-style: italic; font-weight: bold }

/* conformance */

.Input { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.Output { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.CellLabel { margin: 7pt 2pt 2pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #0000ff;
\t}

</style>\
\>", "Text",
    CellTags->"CSSDefinitions"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Style Environment Names", "Section"],
  
  Cell[StyleData[All, "Screen"],
    PageWidth->WindowWidth,
    LineSpacing->{1, 3},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "FlushLeft"],
    PageWidth->WindowWidth,
    LineSpacing->{1, 3},
    ScriptMinSize->9],
  
  Cell[StyleData[All, "Presentation"],
    PageWidth->WindowWidth,
    ScrollingOptions->{"PagewiseDisplay"->True},
    ShowCellBracket->False,
    ShowGroupOpenCloseIcon->True,
    CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
    ScriptMinSize->12],
  
  Cell[StyleData[All, "Printout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    Hyphenation->True,
    LineSpacing->{1, 2},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "FlushLeftPrintout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    Hyphenation->True,
    LineSpacing->{1, 2},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}],
  
  Cell[StyleData[All, "DoubleSpacedPrintout"],
    PageWidth->PaperWidth,
    ShowCellBracket->False,
    Hyphenation->True,
    LineSpacing->{2, 1},
    ScriptMinSize->5,
    PrivateFontOptions->{"FontType"->"Outline"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Notebook Options", "Section"],
  
  Cell["\<\
The options defined for the style below will be used at the \
Notebook level.\
\>", "Text"],
  
  Cell[StyleData["Notebook"],
    PageHeaders->{{
      None, Cell[ "Author Name", "Header"], None}, {
        None, Cell[ "Article Title", "Header"], None}},
    PageFooters->{{None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None}, {None, Cell[ 
            TextData[ {
              CounterBox[ "Page"]}], "PageNumber"], None}},
    PageHeaderLines->{False, False},
    PageFooterLines->{False, False},
    PrintingOptions->{"PrintingMargins"->{{18, 18}, {36, 36}},
    "PageSize"->{504, 720},
    "PageHeaderMargins"->{18, 18},
    "FirstPageHeader"->False,
    "FirstPageFooter"->True,
    "FacingPages"->True},
    CellElementSpacings->{"ClosedCellHeight"->9},
    CellFrameLabelMargins->6,
    DefaultNewCellStyle->"Text",
    InputAutoReplacements->{"TeX"->FormBox[ 
            StyleBox[ 
              RowBox[ {"T", 
                AdjustmentBox[ 
                "E", BoxMargins -> {{-0.29999999999999999, 0}, {0, 0}}, 
                  BoxBaselineShift -> 0.5], "X"}], SingleLetterItalics -> 
              False], TraditionalForm], "LaTeX"->FormBox[ 
            StyleBox[ 
              RowBox[ {"L", 
                StyleBox[ 
                  AdjustmentBox[ 
                  "A", BoxMargins -> {{-0.5, -0.29999999999999999}, {0, 0}}, 
                    BoxBaselineShift -> -0.40000000000000002], FontSize -> 
                  Smaller], "T", 
                AdjustmentBox[ 
                "E", BoxMargins -> {{-0.29999999999999999, 0}, {0, 0}}, 
                  BoxBaselineShift -> 0.5], "X"}], SingleLetterItalics -> 
              False], TraditionalForm], "mma"->"Mathematica", 
        "Mma"->"Mathematica", "MMA"->"Mathematica", "--"->"\[Dash]", 
        "---"->"\[LongDash]", " \""->" \[OpenCurlyDoubleQuote]", 
        "\"'"->"\[OpenCurlyDoubleQuote]\[OpenCurlyQuote]", 
        "'\""->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        ".\""->".\[CloseCurlyDoubleQuote]", 
        ",\""->",\[CloseCurlyDoubleQuote]", 
        "?\""->"?\[CloseCurlyDoubleQuote]", 
        ";\""->";\[CloseCurlyDoubleQuote]", 
        ":\""->":\[CloseCurlyDoubleQuote]", 
        "!\""->"!\[CloseCurlyDoubleQuote]", " '"->" \[OpenCurlyQuote]", 
        "',"->"\[CloseCurlyQuote],", "'."->"\[CloseCurlyQuote].", 
        "';"->"\[CloseCurlyQuote];", "':"->"\[CloseCurlyQuote]:", 
        "'!"->"\[CloseCurlyQuote]!", ",\""->",\[CloseCurlyQuote]", 
        ".'"->".\[CloseCurlyQuote]", "?'"->"?\[CloseCurlyQuote]", 
        ";'"->";\[CloseCurlyQuote]", ":'"->":\[CloseCurlyQuote]", 
        "!'"->"!\[CloseCurlyQuote]", ". '"->". \[OpenCurlyQuote]", 
        ", '"->", \[OpenCurlyQuote]", "? '"->"? \[OpenCurlyQuote]", 
        "; '"->"; \[OpenCurlyQuote]", ": '"->": \[OpenCurlyQuote]", 
        "! '"->"! \[OpenCurlyQuote]", ", \""->", \[OpenCurlyDoubleQuote]", 
        ". \""->". \[OpenCurlyDoubleQuote]", 
        "? \""->"? \[OpenCurlyDoubleQuote]", 
        "; \""->"; \[OpenCurlyDoubleQuote]", 
        ": \""->": \[OpenCurlyDoubleQuote]", 
        "! \""->"! \[OpenCurlyDoubleQuote]", 
        "\","->"\[CloseCurlyDoubleQuote],", 
        "\"."->"\[CloseCurlyDoubleQuote].", 
        "\";"->"\[CloseCurlyDoubleQuote];", 
        "\":"->"\[CloseCurlyDoubleQuote]:", 
        "\"!"->"\[CloseCurlyDoubleQuote]!", "'a "->"\[CloseCurlyQuote]a ", 
        "'d "->"\[CloseCurlyQuote]d ", "'l "->"\[CloseCurlyQuote]l ", 
        "'ll "->"\[CloseCurlyQuote]ll ", "'m "->"\[CloseCurlyQuote]m ", 
        "'o "->"\[CloseCurlyQuote]o ", "'ol "->"\[CloseCurlyQuote]ol ", 
        "'Ol "->"\[CloseCurlyQuote]Ol ", "'r "->"\[CloseCurlyQuote]r ", 
        "'s "->"\[CloseCurlyQuote]s ", "'t "->"\[CloseCurlyQuote]t ", 
        "'ve "->"\[CloseCurlyQuote]ve ", "'er "->"\[CloseCurlyQuote]er ", 
        "'re "->"\[CloseCurlyQuote]re ", "'y "->"\[CloseCurlyQuote]y ", 
        "'z "->"\[CloseCurlyQuote]z ", "'x "->"\[CloseCurlyQuote]x ", 
        "\" "->"\[CloseCurlyDoubleQuote] ", "\"\""->"\[OpenCurlyDoubleQuote]",
         "''"->"\[OpenCurlyQuote]", "'tis "->"\[CloseCurlyQuote]tis ", 
        "'ts "->"\[CloseCurlyQuote]ts ", "' "->"\[CloseCurlyQuote] ", 
        "'am "->"\[CloseCurlyQuote]am ", 
        ",'\" "->",\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        ".'\""->".\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        "?'\""->"?\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        ";'\""->";\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        ":'\""->":\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        "!'\""->"!\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
        "'\","->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote],", 
        "'\"."->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote].", 
        "'\"?"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]?", 
        "'\";"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote];", 
        "'\":"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]:", 
        "'\"!"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]!"},
    StyleMenuListing->None],
  
  Cell["\"AllowsIndexedHeadersFooters\"->False", "MiscSettings"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Frontmatter", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Title", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Title"],
    CellMargins->{{12, 12}, {4, 36}},
    CellGroupingRules->{"TitleGrouping", 10},
    PageBreakBelow->False,
    TextAlignment->Center,
    LineSpacing->{1, 2},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->32,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "FlushLeft"],
    CellFrame->{{0, 0}, {2, 0}},
    CellMargins->{{12, 12}, {4, 36}},
    CellFrameMargins->{{0, 0}, {2, 8}},
    TextAlignment->Left,
    LineSpacing->{1, 2},
    FontSize->32,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "Presentation"],
    CellFrame->False,
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{12, 12}, {6, 54}},
    FontSize->48,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "Printout"],
    CellMargins->{{2, 2}, {3, 32}},
    FontSize->28],
  
  Cell[StyleData["Title", "FlushLeftPrintout"],
    CellFrame->{{0, 0}, {1.5, 0}},
    CellMargins->{{2, 2}, {3, 32}},
    TextAlignment->Left,
    FontSize->28,
    FontWeight->"Bold"],
  
  Cell[StyleData["Title", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {3, 32}},
    FontSize->28]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subtitle"],
    CellMargins->{{12, 12}, {4, 2}},
    CellGroupingRules->{"TitleGrouping", 20},
    PageBreakBelow->False,
    TextAlignment->Center,
    LineSpacing->{1, 0},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subtitle", "FlushLeft"],
    CellMargins->{{12, 12}, {4, 2}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->20,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subtitle", "Presentation"],
    CellMargins->{{12, 12}, {6, 3}},
    FontSize->30,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subtitle", "Printout"],
    CellMargins->{{2, 2}, {3, 1}},
    FontSize->18,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subtitle", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {3, 1}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->18,
    FontSlant->"Italic"],
  
  Cell[StyleData["Subtitle", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {3, 1}},
    FontSize->18,
    FontWeight->"Plain",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Date", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Day"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
    ButtonEvaluator->Automatic,
    ButtonData:>"Day",
    Active->True}],
  
  Cell[StyleData["Day", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Month"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
    ButtonEvaluator->Automatic,
    ButtonData:>"Month",
    Active->True}],
  
  Cell[StyleData["Month", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Year"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
    ButtonEvaluator->Automatic,
    ButtonData:>"Year",
    Active->True}],
  
  Cell[StyleData["Year", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Date"],
    CellMargins->{{54, 54}, {6, 12}},
    CellGroupingRules->"NormalGrouping",
    TextAlignment->Center,
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Date", "FlushLeft"],
    CellMargins->{{54, 54}, {6, 12}},
    TextAlignment->Left],
  
  Cell[StyleData["Date", "Presentation"],
    CellMargins->{{54, 54}, {9, 18}},
    CellGroupingRules->"NormalGrouping",
    TextAlignment->Center,
    ParagraphSpacing->{0, 8},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->15,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Date", "Printout"],
    CellMargins->{{48, 48}, {5, 10}},
    LineSpacing->{1, 1},
    FontSize->7,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Date", "FlushLeftPrintout"],
    CellMargins->{{48, 48}, {5, 10}},
    TextAlignment->Left,
    LineSpacing->{1, 1},
    FontSize->7,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Date", "DoubleSpacedPrintout"],
    CellMargins->{{48, 48}, {5, 10}},
    LineSpacing->{1, 1},
    FontSize->7,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Author", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Author"],
    Selectable->False,
    CellMargins->{{36, 54}, {1, 18}},
    CellGroupingRules->{"SectionGrouping", 50},
    TextAlignment->Left,
    ParagraphSpacing->{0, 0},
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Author", "Printout"],
    CellMargins->{{21, 10}, {0, 18}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AuthorData"],
    Selectable->False,
    ConversionRules:>{"HTML" -> {"<sup class=\"AuthorDataSup\">", 
      GetAuthorData[ ], "</sup>"}},
    ScriptMinSize->10,
    StyleMenuListing->None],
  
  Cell[StyleData["AuthorData", "Printout"],
    Selectable->False,
    ScriptMinSize->8],
  
  Cell[StyleData["AuthorData", "FlushLeftPrintout"],
    Selectable->False,
    ScriptMinSize->8],
  
  Cell[StyleData["AuthorData", "DoubleSpacedPrintout"],
    Selectable->False,
    ScriptMinSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AuthorGroup"],
    Editable->False,
    CellMargins->{{54, 54}, {2, 24}},
    CellGroupingRules->"InputGrouping",
    TextAlignment->Center,
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->14,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["AuthorGroup", "FlushLeft"],
    Editable->False,
    CellMargins->{{54, 54}, {2, 24}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->14],
  
  Cell[StyleData["AuthorGroup", "Presentation"],
    Editable->False,
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{54, 54}, {3, 36}},
    FontSize->21],
  
  Cell[StyleData["AuthorGroup", "Printout"],
    CellMargins->{{48, 48}, {1, 20}},
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["AuthorGroup", "FlushLeftPrintout"],
    Editable->False,
    CellMargins->{{48, 48}, {1, 21}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["AuthorGroup", "DoubleSpacedPrintout"],
    CellMargins->{{48, 48}, {1, 20}},
    FontSize->12,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[StyleData["AuthorFirstName"],
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["AuthorMiddleName"],
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["AuthorLastName"],
    Editable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["AuthorNameSuffix"],
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["AuthorAffiliation"],
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AuthorEmail"],
    SingleLetterItalics->False,
    StyleMenuListing->None,
    FontSize->18,
    FontWeight->"Plain",
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None",
    ButtonNote->ButtonData}],
  
  Cell[StyleData["AuthorEmail", "FlushLeft"]],
  
  Cell[StyleData["AuthorEmail", "Presentation"],
    FontSize->26],
  
  Cell[StyleData["AuthorEmail", "Printout"],
    FontSize->1,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["AuthorEmail", "FlushLeftPrintout"],
    FontSize->1,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["AuthorEmail", "DoubleSpacedPrintout"],
    FontSize->1,
    FontColor->GrayLevel[1]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Institution", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Institution"],
    Editable->False,
    CellMargins->{{54, 54}, {0, 0}},
    CellGroupingRules->"OutputGrouping",
    TextAlignment->Center,
    CounterIncrements->"Institution",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Institution", "FlushLeft"],
    Editable->False,
    CellMargins->{{54, 54}, {0, 0}},
    TextAlignment->Left,
    ParagraphIndent->-18,
    FontFamily->"Times",
    FontSize->12,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Institution", "Presentation"],
    Editable->False,
    CellMargins->{{54, 54}, {1, 1}},
    FontSize->18],
  
  Cell[StyleData["Institution", "Printout"],
    CellMargins->{{48, 48}, {0, 0}},
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Institution", "FlushLeftPrintout"],
    Editable->False,
    CellMargins->{{48, 48}, {0, 0}},
    TextAlignment->Left,
    ParagraphIndent->-16,
    FontFamily->"Times",
    FontSize->10,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Institution", "DoubleSpacedPrintout"],
    CellMargins->{{48, 48}, {0, 0}},
    FontSize->10,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InstitutionNumber"],
    Editable->False,
    TextAlignment->Left,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["InstitutionNumber", "FlushLeft"],
    Editable->False,
    CellSize->{18, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["InstitutionNumber", "FlushLeftPrintout"],
    Editable->False,
    CellSize->{16, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}]
  }, Closed]],
  
  Cell[StyleData["InstitutionName"],
    Editable->False,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
    ButtonEvaluator->Automatic,
    Active->True}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Abstract", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Abstract"],
    CellMargins->{{54, 54}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 50},
    CellFrameMargins->5,
    TextAlignment->Left,
    TextJustification->1,
    LineSpacing->{1, 1},
    StyleMenuListing->None,
    FontSize->12,
    FontColor->RGBColor[0, 0, 0.500008]],
  
  Cell[StyleData["Abstract", "FlushLeft"]],
  
  Cell[StyleData["Abstract", "Presentation"],
    CellMargins->{{54, 54}, {5, 36}},
    FontSize->17],
  
  Cell[StyleData["Abstract", "Printout"],
    CellMargins->{{48, 48}, {2, 14}},
    CellFrameMargins->3,
    FontSize->10],
  
  Cell[StyleData["Abstract", "FlushLeftPrintout"],
    CellMargins->{{48, 48}, {2, 14}},
    CellFrameMargins->3,
    FontSize->10],
  
  Cell[StyleData["Abstract", "DoubleSpacedPrintout"],
    CellMargins->{{48, 48}, {2, 14}},
    CellFrameMargins->3,
    FontSize->10]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Mainmatter", "Section"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Section"],
    CellMargins->{{12, 12}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "Cell", 
      "XRefPrefix" -> "Section"}, "StyleSheetApplicability" -> False},
    PageBreakBelow->False,
    TextAlignment->Center,
    TabSpacings->2.1,
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
        "Subsubsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["Section", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 24}},
    TextAlignment->Left,
    ParagraphIndent->-32,
    TabSpacings->2.1,
    CounterIncrements->"Section",
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["Section", "Presentation"],
    CellMargins->{{12, 12}, {5, 36}},
    ParagraphIndent->-48,
    FontSize->30],
  
  Cell[StyleData["Section", "Printout"],
    CellMargins->{{2, 2}, {2, 21}},
    ParagraphIndent->-29,
    FontSize->18,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Section", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 21}},
    TextAlignment->Left,
    ParagraphIndent->0,
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["Section", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 21}},
    ParagraphIndent->-29,
    FontSize->18,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsection"],
    CellDingbat->None,
    CellMargins->{{12, 12}, {3, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    CellGroupingRules->{"SectionGrouping", 40},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
      "Subsection"}, "CounterTarget" -> "Cell", "XRefPrefix" -> "Section"}, 
      "StyleSheetApplicability" -> False},
    PageBreakBelow->False,
    TextAlignment->Center,
    TabSpacings->1.7,
    CounterIncrements->"Subsection",
    CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->17,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    TextAlignment->Left,
    ParagraphIndent->-50,
    TabSpacings->1.7,
    FontFamily->"Times",
    FontSize->17,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "Presentation"],
    CellMargins->{{12, 12}, {5, 18}},
    ParagraphIndent->-75,
    FontSize->25],
  
  Cell[StyleData["Subsection", "Printout"],
    CellMargins->{{2, 2}, {2, 10}},
    ParagraphIndent->-43,
    FontSize->15,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 10}},
    TextAlignment->Left,
    ParagraphIndent->0,
    FontSize->15,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 10}},
    ParagraphIndent->-43,
    FontSize->15,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsection"],
    CellMargins->{{12, 12}, {3, 6}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    CellGroupingRules->{"SectionGrouping", 50},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
      "Subsection", ".", "Subsubsection"}, "CounterTarget" -> "Cell", 
      "XRefPrefix" -> "Section"}, "StyleSheetApplicability" -> False},
    PageBreakBelow->False,
    TextAlignment->Center,
    CounterIncrements->"Subsubsection",
    CounterAssignments->{{"Subsubsubsection", 0}},
    StyleMenuListing->None,
    FontSize->14,
    FontWeight->"Bold",
    FontColor->GrayLevel[0.333333],
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Subsubsection", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 6}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    TextAlignment->Left,
    ParagraphIndent->-60,
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["Subsubsection", "Presentation"],
    CellMargins->{{12, 12}, {5, 9}},
    ParagraphIndent->-90,
    FontSize->21],
  
  Cell[StyleData["Subsubsection", "Printout"],
    CellMargins->{{2, 2}, {2, 5}},
    ParagraphIndent->-50,
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextAlignment->Left,
    ParagraphIndent->0,
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 5}},
    ParagraphIndent->-50,
    FontSize->12,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Subsubsubsection"],
    CellMargins->{{12, 12}, {3, 6}},
    CellGroupingRules->{"SectionGrouping", 60},
    ConversionRules:>{"HTML" -> {"<h6 class=\"Subsubsubsection\">", "</h6>"}},
    
    CounterIncrements->"Subsubsubsection",
    StyleMenuListing->None,
    FontSize->14,
    FontWeight->"Bold",
    FontSlant->"Italic",
    FontColor->GrayLevel[0.333333]],
  
  Cell[StyleData["Subsubsubsection", "FlushLeft"]],
  
  Cell[StyleData["Subsubsubsection", "Presentation"],
    CellMargins->{{23, 12}, {5, 9}},
    FontSize->21],
  
  Cell[StyleData["Subsubsubsection", "Printout"],
    CellMargins->{{2, 2}, {2, 5}},
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsubsection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 5}},
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Subsubsubsection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 5}},
    FontSize->12,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Section Heading Inline Cells", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionLabel"],
    Editable->False,
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    CellSize->{32, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["SectionLabel", "FlushLeft"],
    CellSize->{32, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SectionLabel", "Presentation"],
    CellSize->{48, Inherited}],
  
  Cell[StyleData["SectionLabel", "Printout"],
    CellSize->{29, Inherited}],
  
  Cell[StyleData["SectionLabel", "FlushLeftPrintout"],
    CellSize->{29, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SectionLabel", "DoubleSpacedPrintout"],
    CellSize->{29, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionLabel"],
    Editable->False,
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    CellSize->{50, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["SubsectionLabel", "FlushLeft"],
    CellSize->{50, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SubsectionLabel", "Presentation"],
    CellSize->{75, Inherited}],
  
  Cell[StyleData["SubsectionLabel", "Printout"],
    CellSize->{43, Inherited}],
  
  Cell[StyleData["SubsectionLabel", "FlushLeftPrintout"],
    CellSize->{43, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SubsectionLabel", "DoubleSpacedPrintout"],
    CellSize->{43, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionLabel"],
    Editable->False,
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    CellSize->{60, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["SubsubsectionLabel", "FlushLeft"],
    CellSize->{60, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SubsubsectionLabel", "Presentation"],
    CellSize->{90, Inherited}],
  
  Cell[StyleData["SubsubsectionLabel", "Printout"],
    CellSize->{50, Inherited}],
  
  Cell[StyleData["SubsubsectionLabel", "FlushLeftPrintout"],
    CellSize->{50, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["SubsubsectionLabel", "DoubleSpacedPrintout"],
    CellSize->{50, Inherited}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Alternate Headings", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionAlt"],
    CellMargins->{{12, 12}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    PageBreakBelow->False,
    TextAlignment->Center,
    TabSpacings->2.1,
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["SectionAlt", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 24}},
    TextAlignment->Left,
    TabSpacings->2.1,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["SectionAlt", "Presentation"],
    CellMargins->{{12, 12}, {5, 36}},
    FontSize->30],
  
  Cell[StyleData["SectionAlt", "Printout"],
    CellMargins->{{2, 12}, {3, 18}},
    FontSize->18,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SectionAlt", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 21}},
    TextAlignment->Left,
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["SectionAlt", "DoubleSpacedPrintout"],
    CellMargins->{{2, 12}, {3, 18}},
    FontSize->18,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsectionAlt"],
    CellDingbat->None,
    CellMargins->{{12, 12}, {3, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    CellGroupingRules->{"SectionGrouping", 40},
    PageBreakBelow->False,
    TextAlignment->Center,
    TabSpacings->1.7,
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->17,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsectionAlt", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 12}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    TextAlignment->Left,
    TabSpacings->1.7,
    FontFamily->"Times",
    FontSize->17,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsectionAlt", "Presentation"],
    CellMargins->{{12, 12}, {5, 18}},
    FontSize->25],
  
  Cell[StyleData["SubsectionAlt", "Printout"],
    CellMargins->{{2, 12}, {2, 5}},
    FontSize->15,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsectionAlt", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 10}},
    TextAlignment->Left,
    FontSize->15,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsectionAlt", "DoubleSpacedPrintout"],
    CellMargins->{{2, 12}, {2, 5}},
    FontSize->15,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SubsubsectionAlt"],
    CellMargins->{{12, 12}, {3, 6}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    CellGroupingRules->{"SectionGrouping", 50},
    PageBreakBelow->False,
    TextAlignment->Center,
    StyleMenuListing->None,
    FontSize->14,
    FontWeight->"Bold",
    FontColor->GrayLevel[0.333333],
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["SubsubsectionAlt", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 6}},
    CellElementSpacings->{"ClosedGroupTopMargin"->12},
    TextAlignment->Left,
    FontSize->14,
    FontWeight->"Bold"],
  
  Cell[StyleData["SubsubsectionAlt", "Presentation"],
    CellMargins->{{12, 12}, {5, 9}},
    FontSize->21],
  
  Cell[StyleData["SubsubsectionAlt", "Printout"],
    CellMargins->{{2, 12}, {1, 4}},
    FontSize->12,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsubsectionAlt", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextAlignment->Left,
    FontSize->12,
    FontWeight->"Bold",
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["SubsubsectionAlt", "DoubleSpacedPrintout"],
    CellMargins->{{2, 12}, {1, 4}},
    FontSize->12,
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Body Text", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Text"],
    CellMargins->{{12, 10}, {3, 5}},
    TextAlignment->Left,
    TextJustification->1,
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    CounterAssignments->{{"Item1Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["Text", "FlushLeft"]],
  
  Cell[StyleData["Text", "Presentation"],
    CellMargins->{{23, 10}, {5, 8}},
    FontSize->17],
  
  Cell[StyleData["Text", "Printout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["Text", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["Text", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{2, 1},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextNoIndent"],
    CellMargins->{{12, 10}, {3, 5}},
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
    TextAlignment->Left,
    TextJustification->1,
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    CounterAssignments->{{"Item1Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TextNoIndent", "FlushLeft"]],
  
  Cell[StyleData["TextNoIndent", "Presentation"],
    CellMargins->{{23, 10}, {5, 8}},
    FontSize->17],
  
  Cell[StyleData["TextNoIndent", "Printout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["TextNoIndent", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["TextNoIndent", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{2, 1},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextContinuation"],
    CellMargins->{{12, 10}, {3, 5}},
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n", Automatic, ""}}},
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
    TextAlignment->Left,
    TextJustification->1,
    LineSpacing->{1, 3},
    CounterIncrements->"TextContinuation",
    CounterAssignments->{{"Item1Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["TextContinuation", "FlushLeft"]],
  
  Cell[StyleData["TextContinuation", "Presentation"],
    CellMargins->{{23, 10}, {5, 8}},
    FontSize->17],
  
  Cell[StyleData["TextContinuation", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["TextContinuation", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{2, 1},
    FontSize->10]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Itemized Lists", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Bulleted Lists", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1"],
    CellMargins->{{12, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      30}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
      "CellGroupEnvironment" -> "ul"}}},
    CellFrameLabels->{{
      Cell[ "\[FilledSmallCircle]", "Item1Label", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item1",
    StyleMenuListing->None],
  
  Cell[StyleData["Item1", "FlushLeft"]],
  
  Cell[StyleData["Item1", "Presentation"],
    CellMargins->{{21, 12}, {2, 3}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item1", "Printout"],
    CellMargins->{{2, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2"],
    CellMargins->{{36, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      40}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
      "CellGroupEnvironment" -> "ul"}}},
    CellFrameLabels->{{
      Cell[ "\[FilledSmallCircle]", "Item2Label", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item2",
    StyleMenuListing->None],
  
  Cell[StyleData["Item2", "FlushLeft"]],
  
  Cell[StyleData["Item2", "Presentation"],
    CellMargins->{{59, 12}, {2, 3}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item2", "Printout"],
    CellMargins->{{20, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2", "FlushLeftPrintout"],
    CellMargins->{{20, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2", "DoubleSpacedPrintout"],
    CellMargins->{{20, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3"],
    CellMargins->{{60, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      50}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
      "CellGroupEnvironment" -> "ul"}}},
    CellFrameLabels->{{
      Cell[ "\[FilledSmallCircle]", "Item3Label", CellBaseline -> Baseline], 
          Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item3",
    StyleMenuListing->None],
  
  Cell[StyleData["Item3", "FlushLeft"]],
  
  Cell[StyleData["Item3", "Presentation"],
    CellMargins->{{95, 12}, {2, 3}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item3", "Printout"],
    CellMargins->{{40, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3", "FlushLeftPrintout"],
    CellMargins->{{40, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3", "DoubleSpacedPrintout"],
    CellMargins->{{40, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1Label"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"", 
      NoOutput[ ], ""}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Plain"],
  
  Cell[StyleData["Item1Label", "FlushLeft"]],
  
  Cell[StyleData["Item1Label", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item1Label", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Label", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Label", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2Label"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"", 
      NoOutput[ ], ""}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Label", "FlushLeft"]],
  
  Cell[StyleData["Item2Label", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item2Label", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Label", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Label", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3Label"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"", 
      NoOutput[ ], ""}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Label", "FlushLeft"]],
  
  Cell[StyleData["Item3Label", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item3Label", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Label", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Label", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Numbered Lists", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1Numbered"],
    CellMargins->{{12, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      30}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
      "CellGroupEnvironment" -> "ol"}}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item1Numbered"], "."}], "Item1NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item1Numbered",
    CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
    StyleMenuListing->None],
  
  Cell[StyleData["Item1Numbered", "FlushLeft"]],
  
  Cell[StyleData["Item1Numbered", "Presentation"],
    CellMargins->{{23, 12}, {2, 3}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item1Numbered", "Printout"],
    CellMargins->{{2, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Numbered", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Numbered", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2Numbered"],
    CellMargins->{{36, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      40}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
      "CellGroupEnvironment" -> "ol"}}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item2Numbered"], "."}], "Item2NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item2Numbered",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Item2Numbered", "FlushLeft"]],
  
  Cell[StyleData["Item2Numbered", "Presentation"],
    CellMargins->{{59, 12}, {2, 2}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item2Numbered", "Printout"],
    CellMargins->{{20, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2Numbered", "FlushLeftPrintout"],
    CellMargins->{{20, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2Numbered", "DoubleSpacedPrintout"],
    CellMargins->{{20, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3Numbered"],
    CellMargins->{{60, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      50}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
      "CellGroupEnvironment" -> "ol"}}},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item3Numbered"], "."}], "Item3NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    CounterIncrements->"Item3Numbered",
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>RomanNumeral}],
  
  Cell[StyleData["Item3Numbered", "FlushLeft"]],
  
  Cell[StyleData["Item3Numbered", "Presentation"],
    CellMargins->{{95, 12}, {2, 3}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item3Numbered", "Printout"],
    CellMargins->{{40, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3Numbered", "FlushLeftPrintout"],
    CellMargins->{{40, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3Numbered", "DoubleSpacedPrintout"],
    CellMargins->{{40, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1NumberedLabel"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Item1NumberedLabel", "FlushLeft"]],
  
  Cell[StyleData["Item1NumberedLabel", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item1NumberedLabel", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1NumberedLabel", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1NumberedLabel", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2NumberedLabel"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Item2NumberedLabel", "FlushLeft"]],
  
  Cell[StyleData["Item2NumberedLabel", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item2NumberedLabel", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item2NumberedLabel", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item2NumberedLabel", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3NumberedLabel"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Item3NumberedLabel", "FlushLeft"]],
  
  Cell[StyleData["Item3NumberedLabel", "Presentation"],
    CellSize->{36, Inherited},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item3NumberedLabel", "Printout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item3NumberedLabel", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None],
  
  Cell[StyleData["Item3NumberedLabel", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["List Paragraphs", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1Paragraph"],
    CellMargins->{{40, 12}, {1, 1}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, 
      ""}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
      False}}},
    StyleMenuListing->None],
  
  Cell[StyleData["Item1Paragraph", "FlushLeft"]],
  
  Cell[StyleData["Item1Paragraph", "Presentation"],
    CellMargins->{{63, 12}, {2, 2}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item1Paragraph", "Printout"],
    CellMargins->{{24, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Paragraph", "FlushLeftPrintout"],
    CellMargins->{{24, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item1Paragraph", "DoubleSpacedPrintout"],
    CellMargins->{{24, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2Paragraph"],
    CellMargins->{{64, 12}, {1, 1}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, 
      ""}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
      False}}},
    StyleMenuListing->None],
  
  Cell[StyleData["Item2Paragraph", "FlushLeft"]],
  
  Cell[StyleData["Item2Paragraph", "Presentation"],
    CellMargins->{{99, 12}, {2, 2}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item2Paragraph", "Printout"],
    CellMargins->{{42, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2Paragraph", "FlushLeftPrintout"],
    CellMargins->{{42, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item2Paragraph", "DoubleSpacedPrintout"],
    CellMargins->{{42, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3Paragraph"],
    CellMargins->{{88, 12}, {1, 1}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, 
      ""}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"RestartList" -> 
      False}}},
    StyleMenuListing->None],
  
  Cell[StyleData["Item3Paragraph", "FlushLeft"]],
  
  Cell[StyleData["Item3Paragraph", "Presentation"],
    CellMargins->{{135, 12}, {2, 2}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["Item3Paragraph", "Printout"],
    CellMargins->{{62, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3Paragraph", "FlushLeftPrintout"],
    CellMargins->{{62, 2}, {1, 1}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Item3Paragraph", "DoubleSpacedPrintout"],
    CellMargins->{{62, 2}, {1, 1}},
    LineSpacing->{2, 1},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Illustrations and Examples", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Figure", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Figure"],
    Editable->False,
    CellMargins->{{12, 12}, {8, 6}},
    CellGroupingRules->"InputGrouping",
    ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
      ExtractFigure[ ], "\n\\end{center}"}},
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
      "Style:FigureCaption"}, "ExtraConversionRules" -> {"General" -> {
      "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
      "CellGroupEnvironment" -> {"figure", "[h]"}}}},
    PageBreakAbove->False,
    TextAlignment->Center,
    Hyphenation->True,
    CounterIncrements->"Figure",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Figure", "FlushLeft"],
    TextAlignment->Left],
  
  Cell[StyleData["Figure", "Presentation"],
    CellMargins->{{12, Inherited}, {12, 9}},
    FontSize->13,
    Magnification->1.5],
  
  Cell[StyleData["Figure", "Printout"],
    CellMargins->{{2, Inherited}, {6, 4}},
    Magnification->0.8],
  
  Cell[StyleData["Figure", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {6, 4}},
    TextAlignment->Left,
    Magnification->0.8],
  
  Cell[StyleData["Figure", "DoubleSpacedPrintout"],
    CellMargins->{{2, Inherited}, {6, 4}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FigureCaption"],
    CellMargins->{{48, 48}, {6, 2}},
    CellGroupingRules->"OutputGrouping",
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", 
      "}\n"}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Figure"}, 
      "CounterTarget" -> "Cell", "XRefPrefix" -> "Figure"}, 
      "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, 
      "TeX" -> {"CellGroupEnvironment" -> {"figure", "[h]"}}}},
    PageBreakAbove->False,
    TextAlignment->Center,
    Hyphenation->True,
    CounterIncrements->"FigureCaption",
    CounterAssignments->{{"Nil", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["FigureCaption", "FlushLeft"],
    CellMargins->{{12, 12}, {6, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["FigureCaption", "Presentation"],
    CellMargins->{{48, 48}, {9, 3}},
    FontSize->13],
  
  Cell[StyleData["FigureCaption", "Printout"],
    CellMargins->{{42, 42}, {4, 1}},
    FontSize->7],
  
  Cell[StyleData["FigureCaption", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {4, 1}},
    TextAlignment->Left,
    FontSize->7],
  
  Cell[StyleData["FigureCaption", "DoubleSpacedPrintout"],
    CellMargins->{{42, 42}, {4, 1}},
    LineSpacing->{2, 1},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["FigureCaptionLabel"],
    TextAlignment->Left,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["FigureCaptionLabel", "Printout"],
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Picture", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Picture"],
    Editable->False,
    CellMargins->{{12, 12}, {8, 6}},
    CellGroupingRules->"InputGrouping",
    ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
      ExtractFigure[ ], "\n\\end{center}"}},
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
      "Style:PictureCaption"}, "ExtraConversionRules" -> {"General" -> {
      "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
      "CellGroupEnvironment" -> {"figure", "[h]"}}}},
    TextAlignment->Center,
    CounterIncrements->"Picture",
    StyleMenuListing->None],
  
  Cell[StyleData["Picture", "FlushLeft"],
    TextAlignment->Left],
  
  Cell[StyleData["Picture", "Presentation"],
    CellMargins->{{12, Inherited}, {12, 9}},
    Magnification->1.5],
  
  Cell[StyleData["Picture", "Printout"],
    CellMargins->{{2, Inherited}, {6, 4}},
    Magnification->0.8],
  
  Cell[StyleData["Picture", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {6, 4}},
    TextAlignment->Left,
    Magnification->0.8],
  
  Cell[StyleData["Picture", "DoubleSpacedPrintout"],
    CellMargins->{{2, Inherited}, {6, 4}},
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureCaption"],
    CellMargins->{{48, 48}, {6, 2}},
    CellGroupingRules->"OutputGrouping",
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", 
      "}\n"}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Picture"}, 
      "CounterTarget" -> "Cell", "XRefPrefix" -> "Picture"}, 
      "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, 
      "TeX" -> {"CellGroupEnvironment" -> {"figure", "[h]"}}}},
    PageBreakAbove->False,
    TextAlignment->Center,
    Hyphenation->True,
    CounterIncrements->"PictureCaption",
    CounterAssignments->{{"Nil", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["PictureCaption", "FlushLeft"],
    CellMargins->{{12, 12}, {6, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["PictureCaption", "Presentation"],
    CellMargins->{{48, 48}, {9, 3}},
    FontSize->13],
  
  Cell[StyleData["PictureCaption", "Printout"],
    CellMargins->{{42, 42}, {4, 1}},
    FontSize->7],
  
  Cell[StyleData["PictureCaption", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {4, 1}},
    TextAlignment->Left,
    FontSize->7],
  
  Cell[StyleData["PictureCaption", "DoubleSpacedPrintout"],
    CellMargins->{{42, 42}, {4, 1}},
    LineSpacing->{2, 1},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PictureCaptionLabel"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["PictureCaptionLabel", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Program/Script", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Program"],
    CellMargins->{{12, 10}, {2, 5}},
    CellGroupingRules->"InputGrouping",
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
      "CounterTarget" -> "Cell", "XRefPrefix" -> "Program"}},
    CounterIncrements->"Program",
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["Program", "FlushLeft"]],
  
  Cell[StyleData["Program", "Presentation"],
    CellMargins->{{23, 10}, {3, 8}},
    FontSize->19],
  
  Cell[StyleData["Program", "Printout"],
    CellMargins->{{2, 2}, {1, 4}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Program", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {1, 4}},
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Program", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {1, 4}},
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramCaption"],
    CellMargins->{{48, 48}, {6, 2}},
    CellGroupingRules->"OutputGrouping",
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
      "CounterTarget" -> "CellGroup"}},
    PageBreakAbove->False,
    Hyphenation->True,
    CounterIncrements->"ProgramCaption",
    CounterAssignments->{{"Nil", 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["ProgramCaption", "FlushLeft"]],
  
  Cell[StyleData["ProgramCaption", "Presentation"],
    CellMargins->{{48, 48}, {9, 3}},
    FontSize->14],
  
  Cell[StyleData["ProgramCaption", "Printout"],
    CellMargins->{{42, 42}, {2, 4}},
    FontSize->7],
  
  Cell[StyleData["ProgramCaption", "FlushLeftPrintout"],
    CellMargins->{{2, 12}, {2, 4}},
    FontSize->7],
  
  Cell[StyleData["ProgramCaption", "DoubleSpacedPrintout"],
    CellMargins->{{42, 42}, {2, 4}},
    FontSize->7]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramCaptionLabel"],
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["ProgramCaptionLabel", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ProgramText"],
    CellMargins->{{26, 10}, {12, 0}},
    CellGroupingRules->"OutputGrouping",
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
      "CounterTarget" -> "CellGroup"}},
    PageBreakAbove->False,
    TextJustification->1,
    Hyphenation->True,
    CounterIncrements->"ProgramText",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->9],
  
  Cell[StyleData["ProgramText", "FlushLeft"]],
  
  Cell[StyleData["ProgramText", "Presentation"],
    CellMargins->{{26, 10}, {18, 0}},
    FontSize->14],
  
  Cell[StyleData["ProgramText", "Printout"],
    CellMargins->{{22, 2}, {12, 0}},
    FontSize->7],
  
  Cell[StyleData["ProgramText", "FlushLeftPrintout"],
    CellMargins->{{22, 2}, {12, 0}},
    FontSize->7],
  
  Cell[StyleData["ProgramText", "DoubleSpacedPrintout"],
    CellMargins->{{22, 2}, {12, 0}},
    FontSize->7]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Tables", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableTitle"],
    PageWidth->WindowWidth,
    CellMargins->{{12, 10}, {1, 7}},
    CellGroupingRules->"InputGrouping",
    ConversionRules:>{"TeX" -> {"\n\\caption{", Automatic, "} "}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      90, "AlwaysStartEnvironment" -> True}, "TeX" -> {"CellGroupEnvironment" -> 
      "table"}}, "CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
      "CounterTarget" -> "Cell", "XRefPrefix" -> "Table"}},
    LineSpacing->{1, 2},
    CounterIncrements->"TableTitle",
    CounterAssignments->{{"Nil", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    GridBoxOptions->{ColumnWidths->40,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TableTitle", "FlushLeft"]],
  
  Cell[StyleData["TableTitle", "Presentation"],
    CellMargins->{{23, 10}, {2, 11}},
    FontSize->17],
  
  Cell[StyleData["TableTitle", "Printout"],
    CellMargins->{{2, 10}, {1, 5}},
    FontSize->10],
  
  Cell[StyleData["TableTitle", "FlushLeftPrintout"],
    CellMargins->{{2, 10}, {1, 5}},
    FontSize->10],
  
  Cell[StyleData["TableTitle", "DoubleSpacedPrintout"],
    CellMargins->{{2, 10}, {1, 5}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableTitleLabel"],
    LineSpacing->{1, 2},
    CounterIncrements->"TableTitleLabel",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    GridBoxOptions->{ColumnWidths->40,
    ColumnAlignments->{Left}}],
  
  Cell[StyleData["TableTitleLabel", "Printout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Table"],
    Editable->False,
    PageWidth->WindowWidth,
    CellMargins->{{12, 10}, {4, 1}},
    CellGroupingRules->"OutputGrouping",
    ConversionRules:>{"TeX" -> {"\n\\begin{tabular}\n", Automatic, 
      "\n\\end{tabular}"}, "HTML" -> {{"", Automatic, ""}, {"", Automatic, 
      ""}}},
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      90}, "TeX" -> {"CellGroupEnvironment" -> "table"}}, 
      "CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
      "CounterTarget" -> "CellGroup"}},
    CellHorizontalScrolling->True,
    CounterIncrements->"Table",
    CounterAssignments->{{"TableNote", 0}},
    StyleMenuListing->None,
    GridBoxOptions->{ColumnWidths->0.503,
    RowAlignments->Center,
    ColumnAlignments->{Left},
    GridFrame->{{0, 0}, {0.5, 2}},
    GridDefaultElement:>Cell[ "Data", "TableText"]}],
  
  Cell[StyleData["Table", "FlushLeft"]],
  
  Cell[StyleData["Table", "Presentation"],
    CellMargins->{{23, 10}, {6, 2}},
    FontSize->17],
  
  Cell[StyleData["Table", "Printout"],
    PageWidth->PaperWidth,
    CellMargins->{{2, 10}, {3, 1}},
    FontSize->10],
  
  Cell[StyleData["Table", "FlushLeftPrintout"],
    PageWidth->PaperWidth,
    CellMargins->{{2, 10}, {3, 1}},
    FontSize->10],
  
  Cell[StyleData["Table", "DoubleSpacedPrintout"],
    PageWidth->PaperWidth,
    CellMargins->{{2, 10}, {3, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableNote"],
    Editable->False,
    PageWidth->WindowWidth,
    CellMargins->{{12, 10}, {7, -3}},
    CellGroupingRules->"OutputGrouping",
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Table"}, 
      "CounterTarget" -> "CellGroup"}},
    LineSpacing->{1, 1},
    ParagraphSpacing->{0.3, 0},
    CounterIncrements->"TableNote",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->10,
    FontColor->GrayLevel[0.300008]],
  
  Cell[StyleData["TableNote", "FlushLeft"]],
  
  Cell[StyleData["TableNote", "Presentation"],
    Editable->False,
    CellMargins->{{23, 10}, {11, -5}},
    FontSize->15],
  
  Cell[StyleData["TableNote", "Printout"],
    CellMargins->{{2, 10}, {5, -2}},
    FontSize->9],
  
  Cell[StyleData["TableNote", "FlushLeftPrintout"],
    CellMargins->{{2, 10}, {5, -2}},
    FontSize->9],
  
  Cell[StyleData["TableNote", "DoubleSpacedPrintout"],
    CellMargins->{{2, 10}, {5, -2}},
    LineSpacing->{2, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Table Styles", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableColumnHead"],
    Editable->True,
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSlant->"Italic",
    GridBoxOptions->{GridBaseline->Axis,
    RowSpacings->1,
    ColumnSpacings->0.8,
    ColumnWidths->Automatic,
    RowAlignments->Baseline,
    ColumnAlignments->{Center},
    GridFrame->False,
    GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
    RowLines->False,
    ColumnLines->False,
    RowMinHeight->1,
    RowsEqual->False,
    ColumnsEqual->False,
    GridDefaultElement:>"\[Placeholder]"}],
  
  Cell[StyleData["TableColumnHead", "FlushLeft"]],
  
  Cell[StyleData["TableColumnHead", "Presentation"],
    FontSize->17],
  
  Cell[StyleData["TableColumnHead", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TableColumnHead", "FlushLeftPrintout"],
    FontSize->10],
  
  Cell[StyleData["TableColumnHead", "DoubleSpacedPrintout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableSpanHead"],
    Editable->True,
    TextAlignment->Center,
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSlant->"Italic",
    GridBoxOptions->{GridBaseline->Axis,
    RowSpacings->1,
    ColumnSpacings->0.8,
    ColumnWidths->Automatic,
    RowAlignments->Baseline,
    ColumnAlignments->{Center},
    GridFrame->False,
    GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
    RowLines->False,
    ColumnLines->False,
    RowMinHeight->1,
    RowsEqual->False,
    ColumnsEqual->False,
    GridDefaultElement:>"\[Placeholder]"}],
  
  Cell[StyleData["TableSpanHead", "FlushLeft"]],
  
  Cell[StyleData["TableSpanHead", "Presentation"],
    FontSize->17],
  
  Cell[StyleData["TableSpanHead", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TableSpanHead", "FlushLeftPrintout"],
    FontSize->10],
  
  Cell[StyleData["TableSpanHead", "DoubleSpacedPrintout"],
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableText"],
    Editable->True,
    TextAlignment->Left,
    LineSpacing->{1, 1},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    GridBoxOptions->{GridBaseline->Axis,
    RowSpacings->1,
    ColumnSpacings->0.8,
    ColumnWidths->Automatic,
    RowAlignments->Baseline,
    ColumnAlignments->{Center},
    GridFrame->False,
    GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
    RowLines->False,
    ColumnLines->False,
    RowMinHeight->1,
    RowsEqual->False,
    ColumnsEqual->False,
    GridDefaultElement:>"\[Placeholder]"}],
  
  Cell[StyleData["TableText", "FlushLeft"]],
  
  Cell[StyleData["TableText", "Presentation"],
    FontSize->17],
  
  Cell[StyleData["TableText", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TableText", "FlushLeftPrintout"],
    FontSize->10],
  
  Cell[StyleData["TableText", "DoubleSpacedPrintout"],
    LineSpacing->{2, 1},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableSpanText"],
    Editable->True,
    TextAlignment->Center,
    LineSpacing->{1, 1},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12,
    GridBoxOptions->{ColumnSpacings->0,
    ColumnAlignments->{Center},
    GridFrame->False,
    RowLines->False}],
  
  Cell[StyleData["TableSpanText", "FlushLeft"]],
  
  Cell[StyleData["TableSpanText", "Presentation"],
    FontSize->17],
  
  Cell[StyleData["TableSpanText", "Printout"],
    FontSize->10],
  
  Cell[StyleData["TableSpanText", "FlushLeftPrintout"],
    FontSize->10],
  
  Cell[StyleData["TableSpanText", "DoubleSpacedPrintout"],
    FontSize->10]
  }, Closed]],
  
  Cell[StyleData["TableSubGrid"],
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->0.7,
    ColumnSpacings->0.8,
    ColumnAlignments->{Left, Center},
    GridFrame->False,
    RowLines->False,
    RowMinHeight->0.1,
    GridDefaultElement:>Cell[ "Data", "TableText"]}],
  
  Cell[StyleData["TableMasterGrid"],
    StyleMenuListing->None,
    GridBoxOptions->{RowSpacings->0.01,
    ColumnWidths->0.999}],
  
  Cell[StyleData["TableLineElement"],
    Editable->False,
    CellFrame->{{0, 0}, {0.5, 0}},
    CellElementSpacings->{"CellMinHeight"->1},
    ConversionRules:>{"HTML" -> {{"&nbsp;", 
      NoOutput[ ], ""}, {"", Automatic, ""}}},
    CellSize->{Inherited, 1.25},
    TabFilling->" ",
    TabSpacings->1000,
    StyleMenuListing->None,
    FontSize->1],
  
  Cell[StyleData["TableBlankElement"],
    Editable->False,
    CellElementSpacings->{"CellMinHeight"->1},
    CellSize->{Inherited, 1.25},
    StyleMenuListing->None,
    FontSize->1],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SpanLeft"],
    Editable->False,
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SpanLeft", "FlushLeft"]],
  
  Cell[StyleData["SpanLeft", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SpanLeft", "Printout"],
    FontSize->14],
  
  Cell[StyleData["SpanLeft", "FlushLeftPrintout"],
    FontSize->14],
  
  Cell[StyleData["SpanLeft", "DoubleSpacedPrintout"],
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SpanCenter"],
    Editable->False,
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SpanCenter", "FlushLeft"]],
  
  Cell[StyleData["SpanCenter", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SpanCenter", "Printout"],
    FontSize->14],
  
  Cell[StyleData["SpanCenter", "FlushLeftPrintout"],
    FontSize->14],
  
  Cell[StyleData["SpanCenter", "DoubleSpacedPrintout"],
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SpanRight"],
    Editable->False,
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SpanRight", "FlushLeft"]],
  
  Cell[StyleData["SpanRight", "Presentation"],
    FontSize->24],
  
  Cell[StyleData["SpanRight", "Printout"],
    FontSize->14],
  
  Cell[StyleData["SpanRight", "FlushLeftPrintout"],
    FontSize->14],
  
  Cell[StyleData["SpanRight", "DoubleSpacedPrintout"],
    FontSize->14]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Caption", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Caption"],
    CellMargins->{{48, 48}, {6, 2}},
    CellGroupingRules->"OutputGrouping",
    TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
    PageBreakAbove->False,
    Hyphenation->True,
    CounterIncrements->"Caption",
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9],
  
  Cell[StyleData["Caption", "FlushLeft"],
    CellMargins->{{12, 12}, {6, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["Caption", "Presentation"],
    CellMargins->{{48, 48}, {9, 3}},
    FontSize->13],
  
  Cell[StyleData["Caption", "Printout"],
    CellMargins->{{42, 42}, {4, 1}},
    FontSize->7],
  
  Cell[StyleData["Caption", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {4, 1}},
    TextAlignment->Left,
    FontSize->7],
  
  Cell[StyleData["Caption", "DoubleSpacedPrintout"],
    CellMargins->{{42, 42}, {4, 1}},
    LineSpacing->{2, 1},
    FontSize->7]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Mathematics", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Equations", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Equation"],
    CellMargins->{{12, 42}, {7, 7}},
    ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"Equation\">", 
      "</p>"}}},
    CellHorizontalScrolling->True,
    DefaultFormatType->DefaultInputFormatType,
    InputAutoReplacements->{},
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    TextAlignment->Center,
    CounterIncrements->"Equation",
    StyleMenuListing->None],
  
  Cell[StyleData["Equation", "FlushLeft"],
    CellMargins->{{36, 10}, {7, 7}},
    TextAlignment->Left],
  
  Cell[StyleData["Equation", "Presentation"],
    CellMargins->{{12, 55}, {11, 11}},
    FontSize->19],
  
  Cell[StyleData["Equation", "Printout"],
    CellMargins->{{2, 28}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["Equation", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {5, 5}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["Equation", "DoubleSpacedPrintout"],
    CellMargins->{{2, 28}, {5, 5}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationGroup"],
    CellMargins->{{12, 42}, {0, 2}},
    CellGroupingRules->"GraphicsGrouping",
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      1, "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> 
      "gather*"}}},
    DefaultFormatType->DefaultInputFormatType,
    TextAlignment->Center,
    StyleMenuListing->None],
  
  Cell[StyleData["EquationGroup", "FlushLeft"],
    CellMargins->{{36, 10}, {0, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["EquationGroup", "Presentation"],
    CellMargins->{{12, 55}, {0, 3}},
    FontSize->19],
  
  Cell[StyleData["EquationGroup", "Printout"],
    CellMargins->{{2, 28}, {0, 1}},
    FontSize->10],
  
  Cell[StyleData["EquationGroup", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {0, 1}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["EquationGroup", "DoubleSpacedPrintout"],
    CellMargins->{{2, 28}, {0, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationGroupAligned"],
    CellMargins->{{12, 42}, {0, 2}},
    CellGroupingRules->"GraphicsGrouping",
    TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
      1, "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> 
      "align*"}}},
    DefaultFormatType->DefaultInputFormatType,
    TextAlignment->Center,
    SpanMinSize->2,
    StyleMenuListing->None,
    UnderoverscriptBoxOptions->{LimitsPositioning->False},
    UnderscriptBoxOptions->{LimitsPositioning->False},
    OverscriptBoxOptions->{LimitsPositioning->False},
    GridBoxOptions->{AllowScriptLevelChange->False}],
  
  Cell[StyleData["EquationGroupAligned", "FlushLeft"],
    CellMargins->{{36, 42}, {0, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["EquationGroupAligned", "Presentation"],
    CellMargins->{{12, 55}, {0, 3}},
    FontSize->19],
  
  Cell[StyleData["EquationGroupAligned", "Printout"],
    CellMargins->{{2, 28}, {0, 1}},
    FontSize->10],
  
  Cell[StyleData["EquationGroupAligned", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {0, 1}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["EquationGroupAligned", "DoubleSpacedPrintout"],
    CellMargins->{{2, 28}, {0, 1}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Numbered Equations", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationNumbered"],
    CellMargins->{{12, 12}, {7, 7}},
    ConversionRules:>{"HTML" -> {{"", ""}, {
      "<table class='EquationNumbered'><tr><td>", Automatic, 
      IncludeCount[ 
      "</td><td class='EquationNumberedLabel'>(`1`)</td></tr></table>", 
        "EquationNumbered"]}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
      "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
      "Equation"}},
    CellHorizontalScrolling->True,
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
        None, None}},
    DefaultFormatType->DefaultInputFormatType,
    InputAutoReplacements->{},
    AutoStyleOptions->{"UnmatchedBracketStyle"->None},
    TextAlignment->Center,
    CounterIncrements->"EquationNumbered",
    StyleMenuListing->None],
  
  Cell[StyleData["EquationNumbered", "FlushLeft"],
    CellMargins->{{36, 6}, {7, 7}},
    TextAlignment->Left],
  
  Cell[StyleData["EquationNumbered", "Presentation"],
    CellMargins->{{12, 12}, {11, 11}},
    FontSize->19],
  
  Cell[StyleData["EquationNumbered", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["EquationNumbered", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {5, 5}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["EquationNumbered", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationGroupNumbered"],
    CellMargins->{{12, 6}, {0, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{"HTML" -> {{"", ""}, {
      "<table class='EquationGroupNumbered'><tr><td>", Automatic, 
      IncludeCount[ 
      "</td><td class='EquationGroupNumberedLabel'>(`1`)</td></tr></table>", 
        "EquationNumbered"]}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
      "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
      "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> 
      True}, "TeX" -> {"CellGroupEnvironment" -> "gather"}}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
        None, None}},
    DefaultFormatType->DefaultInputFormatType,
    TextAlignment->Center,
    CounterIncrements->"EquationNumbered",
    StyleMenuListing->None],
  
  Cell[StyleData["EquationGroupNumbered", "FlushLeft"],
    CellMargins->{{36, 6}, {0, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["EquationGroupNumbered", "Presentation"],
    CellMargins->{{12, 6}, {0, 3}},
    FontSize->19],
  
  Cell[StyleData["EquationGroupNumbered", "Printout"],
    CellMargins->{{2, 2}, {0, 1}},
    FontSize->10],
  
  Cell[StyleData["EquationGroupNumbered", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {0, 1}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["EquationGroupNumbered", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {0, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationGroupAlignedNumbered"],
    CellMargins->{{12, 6}, {0, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{"HTML" -> {{"", ""}, {
      "<table class='EquationGroupAlignedNumbered'><tr><td>", Automatic, 
      IncludeCount[ 
      "</td><td \
class='EquationGroupAlignedNumberedLabel'>(`1`)</td></tr></table>", 
        "EquationNumbered"]}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
      "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
      "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> 
      True}, "TeX" -> {"CellGroupEnvironment" -> "align"}}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
        None, None}},
    DefaultFormatType->DefaultInputFormatType,
    TextAlignment->Center,
    SpanMinSize->2,
    CounterIncrements->"EquationNumbered",
    StyleMenuListing->None,
    UnderoverscriptBoxOptions->{LimitsPositioning->False},
    UnderscriptBoxOptions->{LimitsPositioning->False},
    OverscriptBoxOptions->{LimitsPositioning->False},
    GridBoxOptions->{AllowScriptLevelChange->False}],
  
  Cell[StyleData["EquationGroupAlignedNumbered", "FlushLeft"],
    CellMargins->{{36, 12}, {0, 2}},
    TextAlignment->Left],
  
  Cell[StyleData["EquationGroupAlignedNumbered", "Presentation"],
    CellMargins->{{12, 6}, {0, 3}},
    FontSize->19],
  
  Cell[StyleData["EquationGroupAlignedNumbered", "Printout"],
    CellMargins->{{2, 2}, {0, 1}},
    FontSize->10],
  
  Cell[StyleData["EquationGroupAlignedNumbered", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {0, 1}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["EquationGroupAlignedNumbered", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {0, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EquationNumber"],
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None],
  
  Cell[StyleData["EquationNumber", "FlushLeft"],
    CellSize->{24, Inherited}],
  
  Cell[StyleData["EquationNumber", "Presentation"],
    CellSize->{36, Inherited}],
  
  Cell[StyleData["EquationNumber", "Printout"],
    CellSize->{20, Inherited}],
  
  Cell[StyleData["EquationNumber", "FlushLeftPrintout"],
    CellSize->{20, Inherited}],
  
  Cell[StyleData["EquationNumber", "DoubleSpacedPrintout"],
    CellSize->{20, Inherited}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Equation Grid Tag Styles", "Subsection"],
  
  Cell[StyleData["EquationGrid"],
    StyleMenuListing->None],
  
  Cell[StyleData["SplitEquation"],
    StyleMenuListing->None],
  
  Cell[StyleData["Piecewise"],
    StyleMenuListing->None],
  
  Cell[StyleData["Matrix"],
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Cross-References", "Section",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["XRef"],
    ConversionRules:>{"HTML" -> {"", XRefToHtmlHyperlink, ""}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Times",
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["XRef", "FlushLeft"]],
  
  Cell[StyleData["XRef", "Presentation"]],
  
  Cell[StyleData["XRef", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["XRef", "FlushLeftPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["XRef", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[StyleData["PageRef"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Backmatter", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Appendix", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AppendixSection"],
    CellMargins->{{12, 12}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    ConversionRules:>{"TeX" -> {"\\section{", "}\n"}},
    PageBreakBelow->False,
    TextAlignment->Center,
    CounterIncrements->"AppendixSection",
    CounterAssignments->{{"AppendixEquation", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["AppendixSection", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 24}},
    TextAlignment->Left],
  
  Cell[StyleData["AppendixSection", "Presentation"],
    CellMargins->{{12, 12}, {5, 36}},
    FontSize->30],
  
  Cell[StyleData["AppendixSection", "Printout"],
    CellMargins->{{2, 2}, {3, 18}},
    FontSize->17],
  
  Cell[StyleData["AppendixSection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {3, 18}},
    TextAlignment->Left,
    FontSize->17],
  
  Cell[StyleData["AppendixSection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {3, 18}},
    FontSize->17]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AppendixSectionLabel"],
    Editable->False,
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    CellSize->{32, Inherited},
    TextAlignment->Left,
    StyleMenuListing->None],
  
  Cell[StyleData["AppendixSectionLabel", "FlushLeft"],
    CellSize->{32, Inherited}],
  
  Cell[StyleData["AppendixSectionLabel", "Presentation"],
    CellSize->{48, Inherited}],
  
  Cell[StyleData["AppendixSectionLabel", "Printout"],
    CellSize->{29, Inherited}],
  
  Cell[StyleData["AppendixSectionLabel", "FlushLeftPrintout"],
    CellSize->{29, Inherited}],
  
  Cell[StyleData["AppendixSectionLabel", "DoubleSpacedPrintout"],
    CellSize->{29, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["AppendixEquation"],
    CellMargins->{{12, 12}, {7, 7}},
    ConversionRules:>{"HTML" -> {{"", ""}, {
      "<table class='AppendixEquation'><tr><td>", Automatic, 
      IncludeCount[ 
      "</td><td class='AppendixEquationLabel'>(`1`.`2`)</td></tr></table>", 
        "AppendixSection", "AppendixEquation"]}}},
    TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
      "AppendixSection", ".", "AppendixEquation"}, "CounterTarget" -> "Cell", 
      "XRefPrefix" -> "Equation"}},
    CellFrameLabels->{{None, Cell[ 
            TextData[ {"(", 
              CounterBox[ "AppendixSection"], ".", 
              CounterBox[ "AppendixEquation"], ")"}]]}, {None, None}},
    DefaultFormatType->DefaultInputFormatType,
    TextAlignment->Center,
    CounterIncrements->"AppendixEquation",
    StyleMenuListing->None],
  
  Cell[StyleData["AppendixEquation", "FlushLeft"],
    CellMargins->{{36, 6}, {7, 7}},
    TextAlignment->Left],
  
  Cell[StyleData["AppendixEquation", "Presentation"],
    CellMargins->{{12, 12}, {11, 11}},
    FontSize->19],
  
  Cell[StyleData["AppendixEquation", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["AppendixEquation", "FlushLeftPrintout"],
    CellMargins->{{21, 6}, {5, 5}},
    TextAlignment->Left,
    FontSize->10],
  
  Cell[StyleData["AppendixEquation", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Endnotes", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EndnoteSection"],
    CellMargins->{{12, 12}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<h3 class=\"EndnoteSection\">", 
      "</h3>"}}},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    TextAlignment->Center,
    LineSpacing->{1, 7},
    LanguageCategory->"NaturalLanguage",
    CounterIncrements->"Section",
    CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
        "Endnote", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["EndnoteSection", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 24}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["EndnoteSection", "Presentation"],
    CellMargins->{{12, 12}, {5, 36}},
    FontSize->30],
  
  Cell[StyleData["EndnoteSection", "Printout"],
    CellMargins->{{2, 2}, {3, 18}},
    FontSize->17],
  
  Cell[StyleData["EndnoteSection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 21}},
    TextAlignment->Left,
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["EndnoteSection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {3, 18}},
    FontSize->17]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Endnote"],
    CellMargins->{{12, 8}, {0, 0}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"", ""}}, {"HTML" -> {
      "<table class=\"Endnote\"><tr valign=\"top\">", "</td></tr></table>"}}},
    
    LineSpacing->{1, 2},
    ParagraphSpacing->{0, 0},
    ParagraphIndent->-36,
    TabSpacings->5.5,
    CounterIncrements->"Endnote",
    StyleMenuListing->None],
  
  Cell[StyleData["Endnote", "FlushLeft"]],
  
  Cell[StyleData["Endnote", "Presentation"],
    CellMargins->{{23, 8}, {0, 0}},
    ParagraphIndent->-54,
    FontSize->17],
  
  Cell[StyleData["Endnote", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    FontSize->10],
  
  Cell[StyleData["Endnote", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    TextJustification->0.5,
    FontSize->10],
  
  Cell[StyleData["Endnote", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    LineSpacing->{2, 1},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EndnoteLabel"],
    ConversionRules:>{"HTML" -> {"<td class=\"EndnoteLabel\" align=\"left\">",
       "&nbsp;</td><td>"}},
    CellSize->{36, Inherited},
    TextAlignment->Right,
    SpanMaxSize->1,
    CounterIncrements->"EndnoteLabel",
    StyleMenuListing->None],
  
  Cell[StyleData["EndnoteLabel", "FlushLeft"]],
  
  Cell[StyleData["EndnoteLabel", "Presentation"],
    CellSize->{54, Inherited}],
  
  Cell[StyleData["EndnoteLabel", "Printout"],
    CellSize->{24, Inherited}],
  
  Cell[StyleData["EndnoteLabel", "FlushLeftPrintout"],
    CellSize->{24, Inherited}],
  
  Cell[StyleData["EndnoteLabel", "DoubleSpacedPrintout"],
    CellSize->{24, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EndnoteNumber"],
    CellSize->{36, Inherited},
    TextAlignment->Right,
    CounterIncrements->"EndnoteNumber",
    StyleMenuListing->None],
  
  Cell[StyleData["EndnoteNumber", "FlushLeft"]],
  
  Cell[StyleData["EndnoteNumber", "Presentation"]],
  
  Cell[StyleData["EndnoteNumber", "Printout"]],
  
  Cell[StyleData["EndnoteNumber", "FlushLeftPrintout"]],
  
  Cell[StyleData["EndnoteNumber", "DoubleSpacedPrintout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["NoteKey"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(EditNote[ #]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["NoteKey", "FlushLeft"]],
  
  Cell[StyleData["NoteKey", "Presentation"]],
  
  Cell[StyleData["NoteKey", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["NoteKey", "FlushLeftPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["NoteKey", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["EndnoteReturnLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["EndnoteReturnLink", "FlushLeft"]],
  
  Cell[StyleData["EndnoteReturnLink", "Presentation"]],
  
  Cell[StyleData["EndnoteReturnLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["EndnoteReturnLink", "FlushLeftPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}],
  
  Cell[StyleData["EndnoteReturnLink", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TableNoteKey"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(EditTableNote[ #, #2]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonSource->ButtonContents,
    ButtonFrame->"None"}],
  
  Cell[StyleData["TableNoteKey", "FlushLeft"]],
  
  Cell[StyleData["TableNoteKey", "Presentation"]],
  
  Cell[StyleData["TableNoteKey", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["TableNoteKey", "FlushLeftPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["TableNoteKey", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["PageRef", "FlushLeft"],
    StyleMenuListing->None],
  
  Cell[StyleData["PageRef", "Presentation"],
    StyleMenuListing->None],
  
  Cell[StyleData["PageRef", "Printout"],
    StyleMenuListing->None],
  
  Cell[StyleData["PageRef", "FlushLeftPrintout"],
    StyleMenuListing->None],
  
  Cell[StyleData["PageRef", "DoubleSpacedPrintout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Note"],
    Editable->False,
    Deletable->False,
    ConversionRules:>{"TeX" -> {{"\\footnote{", Convert[ 
        ExtractElement[ ][ 
          ExtractButtonData[ ][ #]]]&, "}"}, {"", Automatic, ""}}},
    ScriptMinSize->10,
    SpanMaxSize->1,
    StyleMenuListing->None,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Note", "FlushLeft"]],
  
  Cell[StyleData["Note", "Presentation"]],
  
  Cell[StyleData["Note", "Printout"],
    ScriptMinSize->8],
  
  Cell[StyleData["Note", "FlushLeftPrintout"],
    ScriptMinSize->8],
  
  Cell[StyleData["Note", "DoubleSpacedPrintout"],
    ScriptMinSize->8]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["References", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceSection"],
    CellMargins->{{12, 12}, {3, 24}},
    CellGroupingRules->{"SectionGrouping", 30},
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<h3 class=\"ReferenceSection\">", 
      "</h3>"}}},
    PageBreakBelow->False,
    DefaultNewInlineCellStyle->"None",
    TextAlignment->Center,
    LineSpacing->{1, 7},
    LanguageCategory->"NaturalLanguage",
    CounterAssignments->{{"Reference", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["ReferenceSection", "FlushLeft"],
    CellMargins->{{12, 12}, {3, 24}},
    TextAlignment->Left,
    FontFamily->"Times",
    FontSize->20,
    FontWeight->"Bold"],
  
  Cell[StyleData["ReferenceSection", "Presentation"],
    CellMargins->{{12, 12}, {5, 36}},
    FontSize->30],
  
  Cell[StyleData["ReferenceSection", "Printout"],
    CellMargins->{{2, 12}, {3, 18}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["ReferenceSection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 21}},
    TextAlignment->Left,
    FontSize->18,
    FontWeight->"Bold"],
  
  Cell[StyleData["ReferenceSection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 12}, {3, 18}},
    StyleMenuListing->None,
    FontSize->17]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Reference"],
    CellMargins->{{12, 10}, {2, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\n\n", 
      ConvertAsNatbib[ ], ""}}, {"HTML" -> {
      "<table class=\"Reference\"><tr valign=\"top\">", 
      "</td></tr></table>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
      "CellGroupEnvironment" -> {"thebibliography", "{000}"}}}},
    Hyphenation->True,
    LineSpacing->{1, 2},
    ParagraphIndent->-8,
    CounterIncrements->"Reference",
    StyleMenuListing->None],
  
  Cell[StyleData["Reference", "FlushLeft"]],
  
  Cell[StyleData["Reference", "Presentation"],
    CellMargins->{{23, 10}, {3, 3}},
    ParagraphIndent->-12,
    FontSize->17],
  
  Cell[StyleData["Reference", "Printout"],
    CellMargins->{{2, 2}, {1, 1}},
    ParagraphIndent->-5,
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Reference", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    ParagraphIndent->-60,
    StyleMenuListing->None,
    FontSize->10],
  
  Cell[StyleData["Reference", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    LineSpacing->{2, 1},
    ParagraphIndent->-60,
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceLabel"],
    ConversionRules:>{"HTML" -> {
      "<td class=\"ReferenceLabel\" align=\"left\">", "&nbsp;</td><td>"}},
    CellSize->{72, Inherited},
    TextAlignment->Left,
    SpanMaxSize->1,
    CounterIncrements->"ReferenceLabel",
    StyleMenuListing->None],
  
  Cell[StyleData["ReferenceLabel", "FlushLeft"],
    TextAlignment->Left],
  
  Cell[StyleData["ReferenceLabel", "Presentation"],
    CellSize->{108, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["ReferenceLabel", "Printout"],
    CellSize->{60, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["ReferenceLabel", "FlushLeftPrintout"],
    CellSize->{60, Inherited},
    TextAlignment->Left],
  
  Cell[StyleData["ReferenceLabel", "DoubleSpacedPrintout"],
    CellSize->{60, Inherited},
    TextAlignment->Left]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefSep"],
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}},
    StyleMenuListing->None],
  
  Cell[StyleData["RefSep", "FlushLeft"]],
  
  Cell[StyleData["RefSep", "Presentation"]],
  
  Cell[StyleData["RefSep", "Printout"]],
  
  Cell[StyleData["RefSep", "FlushLeftPrintout"]],
  
  Cell[StyleData["RefSep", "DoubleSpacedPrintout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefReturnLink"],
    ConversionRules:>{"TeX" -> {"\n\\bibitem{", DeleteCharacter[ 5][ 
        ExtractButtonData[ ][ #]]&, "}"}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Times",
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefReturnLink", "FlushLeft"]],
  
  Cell[StyleData["RefReturnLink", "Presentation"]],
  
  Cell[StyleData["RefReturnLink", "Printout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefReturnLink", "FlushLeftPrintout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefReturnLink", "DoubleSpacedPrintout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefReturnPointer"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {
      "<table class=\"Reference\"><tr valign=\"top\">", 
      "</td></tr></table>"}}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Mathematica4",
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefReturnPointer", "FlushLeft"]],
  
  Cell[StyleData["RefReturnPointer", "Presentation"]],
  
  Cell[StyleData["RefReturnPointer", "Printout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefReturnPointer", "FlushLeftPrintout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefReturnPointer", "DoubleSpacedPrintout"],
    StyleMenuListing->None,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceSourceLink"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Mathematica4",
    FontSize->1,
    FontColor->GrayLevel[1],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["ReferenceSourceLink", "Printout"],
    FontColor->GrayLevel[1]]
  }, Closed]],
  
  Cell[StyleData["ReferenceSourceURL"],
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Citation"],
    ConversionRules:>{"TeX" -> {"\\cite{", 
      ExtractButtonData[ ], "}"}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(ListDataLink[ #2]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["Citation", "FlushLeft"]],
  
  Cell[StyleData["Citation", "Presentation"]],
  
  Cell[StyleData["Citation", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Citation", "FlushLeftPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["Citation", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["RefKey"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 0.500008],
    ButtonBoxOptions->{ButtonFunction:>(EditRef[ #]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["RefKey", "FlushLeft"]],
  
  Cell[StyleData["RefKey", "Presentation"]],
  
  Cell[StyleData["RefKey", "Printout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefKey", "FlushLeftPrintout"],
    FontColor->GrayLevel[0]],
  
  Cell[StyleData["RefKey", "DoubleSpacedPrintout"],
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["References Templates", "Subsubsection",
    StyleMenuListing->None],
  
  Cell["FirstAuthor:<Last>, <FirstInitial>. <MiddleInitial>.", 
    "ReferenceTemplate"],
  
  Cell["OtherAuthors:, <Last>, <FirstInitial>. <MiddleInitial>.", 
    "ReferenceTemplate"],
  
  Cell["LastAuthor:, & <Last>, <FirstInitial>. <MiddleInitial>.", 
    "ReferenceTemplate"],
  
  Cell["FirstEditor:<FirstInitial>. <MiddleInitial>. <Last>", 
    "ReferenceTemplate"],
  
  Cell["OtherEditors:, <FirstInitial>. <MiddleInitial>. <Last>", 
    "ReferenceTemplate"],
  
  Cell["LastEditor: & <FirstInitial>. <MiddleInitial>. <Last>", 
    "ReferenceTemplate"],
  
  Cell["Sorting:Author", "ReferenceTemplate"],
  
  Cell["ReferenceAuthorMax:4", "ReferenceTemplate"],
  
  Cell["ReferenceEditorMax:4", "ReferenceTemplate"],
  
  Cell["ReferenceAuthorMin:1", "ReferenceTemplate"],
  
  Cell["ReferenceEditorMin:1", "ReferenceTemplate"],
  
  Cell["AbbreviatedAuthors:, et al.", "ReferenceTemplate"],
  
  Cell["AbbreviatedEditors:, et al.", "ReferenceTemplate"],
  
  Cell[CellGroupData[{
  
  Cell["Article Templates", "Subsubsubsection"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>(<JournalNumber>), <PageRange>. Retrieved \
<RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>(<JournalNumber>), <PageRange>.\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> \
from <URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>, <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>, <PageRange>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>. Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>. Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>. Retrieved <RetrievalDate> from <URL>\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>. \
\>", "ReferenceTemplate"],
  
  Cell["\<\
(The following template is the default template for \"Article\" \
references that don't match any of the above templates.)\
\>", "Text"],
  
  Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. \
<JournalTitle>, <JournalVolume>(<JournalNumber>), <PageRange>.\
\>", 
    "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["In Book Templates", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \"InBook\" \
references.)\
\>", "Text"],
  
  Cell["\<\
InBook:<Author> (<Year>). <Title>. In <Editor> (Ed.), <BookTitle> \
(pp. <PageRange>). <City>: <Publisher>.\
\>", "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Whole Book Templates", "Subsubsubsection"],
  
  Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>. \
Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: \
<Publisher>.\
\>", "ReferenceTemplate"],
  
  Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. Retrieved \
<RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],
  
  Cell["\<\
(The following template is the default template for \"Book\" \
references that don't match any of the above templates.)\
\>", "Text"],
  
  Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: \
<Publisher>.\
\>", "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Thesis Templates", "Subsubsubsection"],
  
  Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, \
<School>, <City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", 
    "ReferenceTemplate"],
  
  Cell["\<\
PhdThesis:<Author> (<Year>). <BookTitle>. Unpublished doctoral \
dissertation, <School>, <City>.\
\>", "ReferenceTemplate"],
  
  Cell["\<\
(The following template is the default template for \"PhdThesis\" \
references that don't match any of the above templates.)\
\>", "Text"],
  
  Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, \
<School>, <City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", 
    "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Technical Report Templates", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \
\"TechReport\" references.)\
\>", "Text"],
  
  Cell["\<\
TechReport:<Author> (<Year>). <Title>. <School>, <City>. \
<ReportNumber>, <Submittedby>\
\>", "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Online Source Templates", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \
\"OnlineSource\" references.)\
\>", "Text"],
  
  Cell["\<\
OnlineSource:<Author>, <Title>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Preprint Templates", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \"Preprint\" \
references.)\
\>", "Text"],
  
  Cell["Preprint:<Author> (<Year>). <Title>. <PublicationStatus>", 
    "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Plain Insertion Template", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \
\[OpenCurlyDoubleQuote]PlainInsert\" references.)\
\>", "Text"],
  
  Cell["PlainInsert:<InsertedBibText>", "ReferenceTemplate"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Note Templates", "Subsubsubsection"],
  
  Cell["\<\
(The following template is the default template for \"Note\" \
references.)\
\>", "Text"],
  
  Cell["Note:<NoteText>", "ReferenceTemplate"]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Common Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefTitle"],
    ConversionRules:>{"TeX" -> {"\\textit{", "}"}},
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["RefType"],
    CellSize->{0, 12},
    StyleMenuListing->None],
  
  Cell[StyleData["RefURL"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefRetrievalDate"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefSourceOfAbstract"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefInsertedBibText"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefNote"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Book Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefBookTitle"],
    ConversionRules:>{"TeX" -> {"\\textit{", "}"}},
    StyleMenuListing->None,
    FontSlant->"Italic"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Journal Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefJournalTitle"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefJournalVolume"],
    ConversionRules:>{"TeX" -> {"\\textbf{", "}"}},
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["RefJournalNumber"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Publisher Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefPublisher"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefCity"],
    ParagraphIndent->0,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Author Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefAuthorGroup"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefAuthorFN"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefAuthorLN"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefAuthorMN"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Editor Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefEditorGroup"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefEditorFN"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefEditorMN"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefEditorLN"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["School Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefSchool"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Publication Date Data Field Styles", "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefDay"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefMonth"],
    StyleMenuListing->None],
  
  Cell[StyleData["RefYear"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Page Data Field Styles: Auto Generated and Contiguous Pages", 
    "Subsubsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RefFirstPage"],
    ParagraphIndent->0,
    StyleMenuListing->None],
  
  Cell[StyleData["RefLastPage"],
    ParagraphIndent->0,
    StyleMenuListing->None]
  }, Closed]]
  }, Open  ]]
  }, Open  ]],
  
  Cell[CellGroupData[{
  
  Cell["Headers and Footers", "Section"],
  
  Cell[StyleData["Header"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontSize->10,
    FontSlant->"Italic"],
  
  Cell[StyleData["Footer"],
    CellMargins->{{0, 0}, {0, 4}},
    StyleMenuListing->None,
    FontSize->9,
    FontSlant->"Italic"],
  
  Cell[StyleData["PageNumber"],
    CellMargins->{{0, 0}, {4, 1}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Miscellaneous", "Section"],
  
  Cell[StyleData["TextSuperscript"],
    ConversionRules:>(Times[ {"TeX" -> {{"", 
        ConvertTextSuperscriptToLaTeX[ ], ""}, {"", Automatic, ""}}}, 
        SingleLetterItalics] -> False),
    ScriptMinSize->10,
    StyleMenuListing->None],
  
  Cell[StyleData["TextSubscript"],
    ScriptMinSize->10,
    SingleLetterItalics->False,
    StyleMenuListing->None],
  
  Cell[StyleData["Nil"],
    StyleMenuListing->None],
  
  Cell[StyleData["Verbatim"],
    StyleMenuListing->None,
    FontSize->12],
  
  Cell[StyleData["TeXName"],
    ConversionRules:>{"TeX" -> {"\\TeX\\", 
      NoOutput[ ], ""}},
    StyleMenuListing->None],
  
  Cell[StyleData["LaTeXName"],
    ConversionRules:>{"TeX" -> {"\\LaTeX\\", 
      NoOutput[ ], ""}},
    StyleMenuListing->None],
  
  Cell[StyleData["LaTeXeName"],
    ConversionRules:>{"TeX" -> {"\\LaTeXe\\", 
      NoOutput[ ], ""}},
    StyleMenuListing->None],
  
  Cell[StyleData["ChemicalElement"],
    SingleLetterItalics->False,
    ZeroWidthTimes->True,
    StyleMenuListing->None],
  
  Cell[StyleData["CustomCharacter"],
    SingleLetterItalics->False,
    StyleMenuListing->None],
  
  Cell[StyleData["Palette"],
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["PageBreak"],
    Editable->False,
    CellMargins->{{0, 0}, {1, 1}},
    CellBracketOptions->{"Thickness"->1,
    "Color"->RGBColor[0.500008, 0.500008, 1],
    "Margins"->{Inherited, 3},
    "Widths"->{5, 5}},
    CellElementSpacings->{"CellMinHeight"->1},
    ConversionRules:>{"TeX" -> {"\n\n\\pagebreak", 
      NoOutput[ ], ""}, "HTML" -> {"<br class=\"PageBreak\">", 
      NoOutput[ ], ""}},
    PageBreakAbove->True,
    CellSize->{Inherited, 6},
    TabFilling->"- ",
    TabSpacings->1000,
    StyleMenuListing->None,
    FontSize->6,
    FontColor->GrayLevel[0.700008]],
  
  Cell[StyleData["PageBreak", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    CellSize->{Inherited, 2},
    TabFilling->""]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CreationDate"],
    CellFrame->0.5,
    CellMargins->{{10, 10}, {4, 4}},
    TextAlignment->Center,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10],
  
  Cell[StyleData["CreationDate", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    LineSpacing->{1, 1},
    FontSize->8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Lines and Spacers", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SingleLine"],
    CellMargins->{{2, 10}, {1, 1}},
    CellGroupingRules->{"GraphicsGrouping", 0},
    StyleMenuListing->None,
    FontSize->2],
  
  Cell[StyleData["SingleLine", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    CellGroupingRules->{"GraphicsGrouping", 0},
    FontSize->2]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["DoubleLine"],
    Editable->False,
    PageWidth->400,
    CellFrame->{{0, 0}, {0.25, 0.25}},
    CellMargins->{{12, 10}, {1, 1}},
    CellElementSpacings->{"CellMinHeight"->0},
    CellFrameMargins->{{2, 10}, {0, 0}},
    StyleMenuListing->None,
    FontSize->4],
  
  Cell[StyleData["DoubleLine", "Printout"],
    CellMargins->{{2, 10}, {1, 1}},
    FontSize->2]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ThinLine"],
    Editable->False,
    Selectable->False,
    CellFrame->{{0, 0}, {0, 0.5}},
    ShowCellBracket->False,
    CellMargins->{{12, 10}, {2, 2}},
    CellElementSpacings->{"CellMinHeight"->1},
    CellFrameMargins->False,
    CellSize->{Inherited, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["ThinLine", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MediumLine"],
    Editable->False,
    Selectable->False,
    CellFrame->{{0, 0}, {0, 2}},
    ShowCellBracket->False,
    CellMargins->{{12, 10}, {2, 2}},
    CellElementSpacings->{"CellMinHeight"->1},
    CellFrameMargins->False,
    CellSize->{Inherited, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["MediumLine", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ThickLine"],
    Editable->False,
    Selectable->False,
    CellFrame->{{0, 0}, {0, 3}},
    ShowCellBracket->False,
    CellMargins->{{12, 10}, {2, 2}},
    CellElementSpacings->{"CellMinHeight"->1},
    CellFrameMargins->False,
    CellSize->{Inherited, 8},
    StyleMenuListing->None],
  
  Cell[StyleData["ThickLine", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Spacer"],
    CellMargins->{{Inherited, Inherited}, {4, 4}},
    StyleMenuListing->None],
  
  Cell[StyleData["Spacer", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["TextSpacer"],
    StyleMenuListing->None],
  
  Cell[StyleData["TextSpacer", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SectionSpacer"],
    StyleMenuListing->None],
  
  Cell[StyleData["SectionSpacer", "Printout"]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["GraphicsSpacer"],
    StyleMenuListing->None],
  
  Cell[StyleData["GraphicsSpacer", "Printout"]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Vita", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaGroup"],
    CellMargins->{{12, 12}, {7, 24}},
    CellGroupingRules->{"SectionGrouping", 1},
    ConversionRules:>{"TeX" -> {"", 
      NoOutput[ ], ""}, "HTML" -> {"", 
      NoOutput[ ], ""}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->GrayLevel[0.500008]],
  
  Cell[StyleData["VitaGroup", "FlushLeft"]],
  
  Cell[StyleData["VitaGroup", "Presentation"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->1,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["VitaGroup", "Printout"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->1,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["VitaGroup", "FlushLeftPrintout"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->1,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["VitaGroup", "DoubleSpacedPrintout"],
    CellMargins->{{0, 0}, {0, 0}},
    FontSize->1,
    FontColor->GrayLevel[1]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaAuthor"],
    CellMargins->{{12, 12}, {7, 7}},
    StyleMenuListing->None],
  
  Cell[StyleData["VitaAuthor", "FlushLeft"]],
  
  Cell[StyleData["VitaAuthor", "Presentation"],
    CellMargins->{{23, 12}, {11, 11}},
    StyleMenuListing->None,
    FontSize->17],
  
  Cell[StyleData["VitaAuthor", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["VitaAuthor", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["VitaAuthor", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaContactInformation"],
    CellMargins->{{12, 12}, {7, 7}},
    StyleMenuListing->None],
  
  Cell[StyleData["VitaContactInformation", "FlushLeft"]],
  
  Cell[StyleData["VitaContactInformation", "Presentation"],
    CellMargins->{{23, 12}, {7, 7}},
    FontSize->17],
  
  Cell[StyleData["VitaContactInformation", "Printout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["VitaContactInformation", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10],
  
  Cell[StyleData["VitaContactInformation", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {5, 5}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaSection"],
    CellMargins->{{12, 12}, {24, 4}},
    CellGroupingRules->{"SectionGrouping", 7},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->24,
    FontWeight->"Bold"],
  
  Cell[StyleData["VitaSection", "FlushLeft"]],
  
  Cell[StyleData["VitaSection", "Presentation"],
    CellMargins->{{23, 12}, {36, 6}},
    FontSize->36],
  
  Cell[StyleData["VitaSection", "Printout"],
    CellMargins->{{2, 2}, {21, 3}},
    FontSize->21],
  
  Cell[StyleData["VitaSection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {21, 3}},
    FontSize->21],
  
  Cell[StyleData["VitaSection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {21, 3}},
    FontSize->21]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaSubsection"],
    CellFrame->{{0, 0}, {0.5, 0}},
    CellMargins->{{12, 12}, {4, 24}},
    CellGroupingRules->{"SectionGrouping", 10},
    CellFrameMargins->{{0, 0}, {3, 0}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->16,
    FontWeight->"Bold"],
  
  Cell[StyleData["VitaSubsection", "FlushLeft"]],
  
  Cell[StyleData["VitaSubsection", "Presentation"],
    CellFrame->{{0, 0}, {2, 0}},
    CellMargins->{{23, 12}, {6, 36}},
    CellFrameMargins->{{0, 0}, {5, 0}},
    FontSize->24],
  
  Cell[StyleData["VitaSubsection", "Printout"],
    CellMargins->{{2, 2}, {3, 21}},
    FontSize->14],
  
  Cell[StyleData["VitaSubsection", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {3, 21}},
    FontSize->14],
  
  Cell[StyleData["VitaSubsection", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {3, 21}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaItem"],
    CellMargins->{{12, 12}, {1, 2}},
    CellGroupingRules->"GraphicsGrouping",
    ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
      "</li>"}}},
    TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
      "CellGroupEnvironment" -> "itemize"}, "HTML" -> {"NestingLevel" -> 1, 
      "CellGroupEnvironment" -> "ul"}}},
    CellFrameLabels->{{
      Cell[ "\[FilledSmallCircle]", "VitaItemLabel", CellBaseline -> 
            Baseline], Inherited}, {Inherited, Inherited}},
    CellFrameLabelMargins->4,
    StyleMenuListing->None],
  
  Cell[StyleData["VitaItem", "FlushLeft"]],
  
  Cell[StyleData["VitaItem", "Presentation"],
    CellMargins->{{23, 12}, {2, 3}},
    CellFrameLabelMargins->6,
    FontSize->17],
  
  Cell[StyleData["VitaItem", "Printout"],
    CellMargins->{{2, 2}, {1, 1}},
    FontSize->10],
  
  Cell[StyleData["VitaItem", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    FontSize->10],
  
  Cell[StyleData["VitaItem", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaItemLabel"],
    ConversionRules:>{{"TeX" -> {"", 
      NoOutput[ ], ""}}, {"HTML" -> {"", 
      NoOutput[ ], ""}}},
    CellSize->{24, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["VitaItemLabel", "FlushLeft"]],
  
  Cell[StyleData["VitaItemLabel", "Presentation"]],
  
  Cell[StyleData["VitaItemLabel", "Printout"],
    CellSize->{18, Inherited},
    FontSize->10],
  
  Cell[StyleData["VitaItemLabel", "FlushLeftPrintout"],
    CellSize->{18, Inherited},
    FontSize->10],
  
  Cell[StyleData["VitaItemLabel", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["VitaItemParagraph"],
    CellMargins->{{40, 12}, {1, 1}},
    CellGroupingRules->"GraphicsGrouping",
    TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
      "CellGroupEnvironment" -> "enumerate"}}},
    CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
    StyleMenuListing->None],
  
  Cell[StyleData["VitaItemParagraph", "FlushLeft"]],
  
  Cell[StyleData["VitaItemParagraph", "Presentation"],
    CellMargins->{{54, 12}, {2, 2}},
    FontSize->17],
  
  Cell[StyleData["VitaItemParagraph", "Printout"],
    CellMargins->{{24, 2}, {1, 1}},
    FontSize->10],
  
  Cell[StyleData["VitaItemParagraph", "FlushLeftPrintout"],
    CellMargins->{{24, 2}, {1, 1}},
    FontSize->10],
  
  Cell[StyleData["VitaItemParagraph", "DoubleSpacedPrintout"],
    CellMargins->{{24, 2}, {1, 1}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Vita"],
    CellMargins->{{12, 12}, {3, 5}},
    StyleMenuListing->None],
  
  Cell[StyleData["Vita", "FlushLeft"]],
  
  Cell[StyleData["Vita", "Presentation"],
    CellMargins->{{23, 12}, {5, 8}},
    FontSize->17],
  
  Cell[StyleData["Vita", "Printout"],
    CellMargins->{{2, 2}, {2, 4}}],
  
  Cell[StyleData["Vita", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {2, 4}}],
  
  Cell[StyleData["Vita", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {2, 4}}]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Outline", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1"],
    CellMargins->{{12, 12}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 30},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Outline1"], ". "}], "Outline1Label", CellBaseline -> 
            Baseline], Inherited}, {Inherited, Inherited}},
    CounterIncrements->"Outline1",
    CounterAssignments->{{"Outline2", 0}},
    StyleMenuListing->None,
    FontSize->18,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],
  
  Cell[StyleData["Outline1", "FlushLeft"]],
  
  Cell[StyleData["Outline1", "Presentation"],
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{12, 12}, {7, 7}},
    FontSize->27],
  
  Cell[StyleData["Outline1", "Printout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->16],
  
  Cell[StyleData["Outline1", "FlushLeftPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->16],
  
  Cell[StyleData["Outline1", "DoubleSpacedPrintout"],
    CellMargins->{{2, 2}, {6, 6}},
    FontSize->16]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline1Label"],
    CellSize->{40, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Outline1Label", "FlushLeft"]],
  
  Cell[StyleData["Outline1Label", "Presentation"],
    CellSize->{60, Inherited}],
  
  Cell[StyleData["Outline1Label", "Printout"],
    CellSize->{36, Inherited}],
  
  Cell[StyleData["Outline1Label", "FlushLeftPrintout"],
    CellSize->{36, Inherited}],
  
  Cell[StyleData["Outline1Label", "DoubleSpacedPrintout"],
    CellSize->{36, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2"],
    CellMargins->{{32, 12}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 40},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Outline2"], ". "}], "Outline2Label", CellBaseline -> 
            Baseline], Inherited}, {Inherited, Inherited}},
    CounterIncrements->"Outline2",
    CounterAssignments->{{"Outline3", 0}},
    StyleMenuListing->None,
    FontSize->16,
    FontWeight->"Bold",
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "A", "Z"], #]&)}],
  
  Cell[StyleData["Outline2", "FlushLeft"]],
  
  Cell[StyleData["Outline2", "Presentation"],
    CellMargins->{{52, 12}, {11, 11}},
    FontSize->24],
  
  Cell[StyleData["Outline2", "Printout"],
    CellMargins->{{22, 2}, {6, 6}},
    FontSize->14],
  
  Cell[StyleData["Outline2", "FlushLeftPrintout"],
    CellMargins->{{22, 2}, {6, 6}},
    FontSize->14],
  
  Cell[StyleData["Outline2", "DoubleSpacedPrintout"],
    CellMargins->{{22, 2}, {6, 6}},
    FontSize->14]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline2Label"],
    CellSize->{30, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Outline2Label", "FlushLeft"]],
  
  Cell[StyleData["Outline2Label", "Presentation"],
    CellSize->{45, Inherited}],
  
  Cell[StyleData["Outline2Label", "Printout"],
    CellSize->{27, Inherited}],
  
  Cell[StyleData["Outline2Label", "FlushLeftPrintout"],
    CellSize->{27, Inherited}],
  
  Cell[StyleData["Outline2Label", "DoubleSpacedPrintout"],
    CellSize->{27, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3"],
    CellMargins->{{52, 12}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 50},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Outline3"], ". "}], "Outline3Label", CellBaseline -> 
            Baseline], Inherited}, {Inherited, Inherited}},
    CounterIncrements->"Outline3",
    CounterAssignments->{{"Outline4", 0}},
    StyleMenuListing->None,
    FontSize->14,
    CounterBoxOptions->{CounterFunction:>Identity}],
  
  Cell[StyleData["Outline3", "FlushLeft"]],
  
  Cell[StyleData["Outline3", "Presentation"],
    CellMargins->{{92, 12}, {11, 11}},
    FontSize->21],
  
  Cell[StyleData["Outline3", "Printout"],
    CellMargins->{{42, 2}, {6, 6}},
    FontSize->12],
  
  Cell[StyleData["Outline3", "FlushLeftPrintout"],
    CellMargins->{{42, 2}, {6, 6}},
    FontSize->12],
  
  Cell[StyleData["Outline3", "DoubleSpacedPrintout"],
    CellMargins->{{42, 2}, {6, 6}},
    FontSize->12]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline3Label"],
    CellSize->{21, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Outline3Label", "FlushLeft"]],
  
  Cell[StyleData["Outline3Label", "Presentation"],
    CellSize->{32, Inherited}],
  
  Cell[StyleData["Outline3Label", "Printout"],
    CellSize->{18, Inherited}],
  
  Cell[StyleData["Outline3Label", "FlushLeftPrintout"],
    CellSize->{18, Inherited}],
  
  Cell[StyleData["Outline3Label", "DoubleSpacedPrintout"],
    CellSize->{18, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4"],
    CellMargins->{{67, 12}, {7, 7}},
    CellGroupingRules->{"SectionGrouping", 60},
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Outline4"], ". "}], "Outline4Label", CellBaseline -> 
            Baseline], Inherited}, {Inherited, Inherited}},
    CounterIncrements->"Outline4",
    StyleMenuListing->None,
    FontSize->12,
    CounterBoxOptions->{CounterFunction:>(Part[ 
        CharacterRange[ "a", "z"], #]&)}],
  
  Cell[StyleData["Outline4", "FlushLeft"]],
  
  Cell[StyleData["Outline4", "Presentation"],
    CellMargins->{{122, 12}, {11, 11}},
    FontSize->17],
  
  Cell[StyleData["Outline4", "Printout"],
    CellMargins->{{57, 2}, {6, 6}},
    FontSize->10],
  
  Cell[StyleData["Outline4", "FlushLeftPrintout"],
    CellMargins->{{57, 2}, {6, 6}},
    FontSize->10],
  
  Cell[StyleData["Outline4", "DoubleSpacedPrintout"],
    CellMargins->{{57, 2}, {6, 6}},
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Outline4Label"],
    CellSize->{18, Inherited},
    TextAlignment->Right,
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Outline4Label", "FlushLeft"]],
  
  Cell[StyleData["Outline4Label", "Presentation"],
    CellSize->{27, Inherited}],
  
  Cell[StyleData["Outline4Label", "Printout"],
    CellSize->{16, Inherited}],
  
  Cell[StyleData["Outline4Label", "FlushLeftPrintout"],
    CellSize->{16, Inherited}],
  
  Cell[StyleData["Outline4Label", "DoubleSpacedPrintout"],
    CellSize->{16, Inherited}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["OutlineText"],
    CellMargins->{{91, 12}, {3, 5}},
    ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, 
      ""}}},
    TextAlignment->Left,
    LineSpacing->{1, 3},
    CounterIncrements->"Text",
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["OutlineText", "FlushLeft"]],
  
  Cell[StyleData["OutlineText", "Presentation"],
    CellMargins->{{155, 12}, {5, 8}},
    FontSize->17],
  
  Cell[StyleData["OutlineText", "Printout"],
    CellMargins->{{79, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["OutlineText", "FlushLeftPrintout"],
    CellMargins->{{79, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10],
  
  Cell[StyleData["OutlineText", "DoubleSpacedPrintout"],
    CellMargins->{{79, 2}, {2, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    FontSize->10]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Slide Show", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideShowNavigationBar"],
    Editable->False,
    CellFrame->True,
    ShowGroupOpenCloseIcon->False,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"CellMinHeight"->0.8125},
    CellGroupingRules->{"TitleGrouping", 1},
    PageBreakAbove->True,
    CellFrameMargins->False,
    CellFrameColor->GrayLevel[0.8],
    CellFrameLabelMargins->False,
    TextAlignment->Center,
    CounterIncrements->"SlideShowNavigationBar",
    CounterAssignments->{{"Item1Numbered", 0}},
    StyleMenuListing->None,
    FontSize->10,
    Background->GrayLevel[0.8],
    Magnification->1,
    GridBoxOptions->{GridBaseline->Center,
    RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
    RowAlignments->Baseline,
    ColumnAlignments->{
      Center, Center, Center, Center, Center, Center, Right, Center}}],
  
  Cell[StyleData["SlideShowNavigationBar", "Printout"],
    Deletable->False,
    ShowCellBracket->False,
    CellMargins->{{-1, -1}, {-1, -1}},
    PageBreakAbove->True,
    CellFrameMargins->{{1, 1}, {0, 0}}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["SlideHyperlink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontSize->26,
    FontColor->GrayLevel[0.400015],
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonMinHeight->0.85,
    ButtonMargins->0.5,
    ButtonNote->None}],
  
  Cell[StyleData["SlideHyperlink", "Presentation"]],
  
  Cell[StyleData["SlideHyperlink", "Printout"]]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Common Inline", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["General Text Attributes", "Subsection",
    StyleMenuListing->None],
  
  Cell[StyleData["RM"],
    StyleMenuListing->None,
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["BF"],
    ConversionRules:>{"TeX" -> {"\\textbf{", "}"}},
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["IT"],
    ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic,
       ""}}},
    StyleMenuListing->None,
    FontSlant->"Italic"],
  
  Cell[StyleData["SmallCaps"],
    ConversionRules:>{"TeX" -> {{"", ChangeCase[ "Lower"][ 
        ExtractWord[ ][ #]]&, ""}, {"", Automatic, ""}}},
    StyleMenuListing->None,
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Font Specific Text Attributes", "Subsection",
    StyleMenuListing->None],
  
  Cell[StyleData["TR"],
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["TI"],
    ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic,
       ""}}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["TB"],
    ConversionRules:>{"TeX" -> {{"\\textbf{", Automatic, "}"}, {"", Automatic,
       ""}}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["TBI"],
    ConversionRules:>{"TeX" -> {{"\\textbf{\\textit{", Automatic, "}}"}, {"", 
      Automatic, ""}}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["MR"],
    ConversionRules:>{"TeX" -> {{"\\texttt{", Automatic, "}"}, {"", Automatic,
       ""}}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["MO"],
    ConversionRules:>{"TeX" -> {{"\\texttt{\\textit{", Automatic, "}}"}, {"", 
      Automatic, ""}}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["MB"],
    ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{", Automatic, "}}"}, {"", 
      Automatic, ""}}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["MBO"],
    ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{\\textit{", Automatic, 
      "}}}"}, {"", Automatic, ""}}},
    Hyphenation->True,
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontWeight->"Bold",
    FontSlant->"Italic"],
  
  Cell[StyleData["SR"],
    ConversionRules:>{"TeX" -> {{"\\textsf{", Automatic, "}"}, {"", Automatic,
       ""}}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Plain"],
  
  Cell[StyleData["SO"],
    ConversionRules:>{"TeX" -> {{"\\textsf{\\textit{", Automatic, "}}"}, {"", 
      Automatic, ""}}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Plain",
    FontSlant->"Italic"],
  
  Cell[StyleData["SB"],
    ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{", Automatic, "}}"}, {"", 
      Automatic, ""}}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Plain"],
  
  Cell[StyleData["SBO"],
    ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{\\textit{", Automatic, 
      "}}}"}, {"", Automatic, ""}}},
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontSlant->"Italic"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Hyperlinks", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Hyperlink"],
    ConversionRules:>{"TeX" -> {{"", 
      ExportAsHyperRef[ ], ""}, {"", Automatic, ""}}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookLocate[ #2]}]&),
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["Hyperlink", "Printout"],
    FontSize->10,
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["XMLWebLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(OpenAllTypes[ #]&),
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonNote->ButtonData}],
  
  Cell[StyleData["XMLWebLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["On-line Help System Links", "Subsubsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserGuideLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "UserGuide", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["UserGuideLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["ReferenceLink"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1],
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "Reference", #]}]&),
    Active->True,
    ButtonFrame->"None"}],
  
  Cell[StyleData["ReferenceLink", "Printout"],
    FontColor->GrayLevel[0],
    FontVariations->{"Underline"->False}]
  }, Closed]]
  }, Closed]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["System", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Format Type Style", "Subsection",
    StyleMenuListing->None],
  
  Cell["\<\

The cells below define styles that are mixed in with the styles of 
most cells.  If a cell's FormatType matches the name of one of the styles 
defined below, then that style is applied between the cell's style and its 
own options. This is particularly true of Input and Output.
\
\>", "Text"],
  
  Cell[StyleData["CellExpression"],
    PageWidth->Infinity,
    CellMargins->{{6, Inherited}, {Inherited, Inherited}},
    ShowCellLabel->False,
    ShowSpecialCharacters->False,
    AllowInlineCells->False,
    AutoItalicWords->{},
    StyleMenuListing->None,
    FontFamily->"Courier",
    FontSize->12,
    Background->GrayLevel[1]],
  
  Cell[StyleData["InputForm"],
    AllowInlineCells->False,
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["OutputForm"],
    PageWidth->Infinity,
    TextAlignment->Left,
    LineSpacing->{0.6, 1},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["StandardForm"],
    LineSpacing->{1.25, 0},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["TraditionalForm"],
    LineSpacing->{1.25, 0},
    SingleLetterItalics->True,
    TraditionalFunctionNotation->True,
    DelimiterMatching->None,
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Document Settings and Templates", "Subsection"],
  
  Cell[StyleData["ReferenceTemplate"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["AuthorFormCustomizationTemplate"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["CSSDefinitions"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["LaTeXPreamble"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["DOCTYPEFormat"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["ValidationSetting"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["XRefPaletteSettings"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"],
  
  Cell[StyleData["MiscSettings"],
    CellMargins->{{12, 10}, {7, 7}},
    StyleMenuListing->None,
    FontFamily->"Courier"]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Inline Cells", "Subsection",
    StyleMenuListing->None],
  
  Cell["\<\

The style defined below is mixed in to any cell that is in an 
inline cell within another.
\
\>", "Text"],
  
  Cell[StyleData["InlineCell"],
    InputAutoReplacements->{"-"->"-"},
    ScriptLevel->1,
    StyleMenuListing->None],
  
  Cell[StyleData["InlineCellEditing"],
    StyleMenuListing->None,
    Background->RGBColor[0.880003, 0.899992, 0.959991]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Palette", "Subsection",
    StyleMenuListing->None],
  
  Cell["\<\

The cells below define styles that define standard ButtonFunctions, 
for use in palette buttons.
\
\>", "Text"],
  
  Cell[StyleData["Paste"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`NotebookApply[ 
          FrontEnd`InputNotebook[ ], #, After]}]&)}],
  
  Cell[StyleData["StyleApply"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(CellWriteStyle[ #]&),
    ButtonEvaluator->Automatic}],
  
  Cell[StyleData["StyleApplyWithVerification"],
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic}],
  
  Cell[StyleData["ConvertCharacter"],
    ConversionRules:>{"TeX" -> {"", 
      ExtractButtonData[ "TeX"], ""}, "HTML" :> {"", 
      ExtractButtonData[ "HTML"], ""}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->Automatic,
    ButtonBoxOptions->{ButtonEvaluator->Automatic,
    ButtonFrame->"None"}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Automatic", "Subsection",
    StyleMenuListing->None],
  
  Cell["\<\

The cells below define styles that are used to affect the display 
of certain types of objects in typeset expressions.  For example, 
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and 
parenthesis characters are displayed (typically by coloring them to make them \

stand out).
\
\>", "Text"],
  
  Cell[StyleData["UnmatchedBracket"],
    StyleMenuListing->None,
    FontColor->RGBColor[0.760006, 0.330007, 0.8]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["DialogEffects", "Subsection",
    StyleMenuListing->None],
  
  Cell[StyleData["DialogStyleSheetMisapplicationEscape"],
    ShowCellBracket->False,
    CellMargins->{{12, 12}, {2000, 40}},
    CellOpen->True,
    TextAlignment->Center,
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Conformance", "Section"],
  
  Cell[CellGroupData[{
  
  Cell["Input/Output", "Subsection",
    StyleMenuListing->None],
  
  Cell["\<\
The cells in this section define styles used for input and output \
to the kernel.  Be careful when modifying, renaming, or removing these \
styles, because the front end associates special meanings with these style \
names. Some attributes for these styles are actually set in FormatType Styles \
(in the last section of this stylesheet). \
\>", "Text"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Input"],
    CellMargins->{{72, 72}, {6, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->StandardForm,
    InputAutoReplacements->{},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    SpanMaxSize->Automatic,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["Input", "Printout"],
    CellMargins->{{21, 6}, {3, 6}},
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["InputNumbered"],
    CellMargins->{{72, 6}, {6, 8}},
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    CellFrameLabels->{{None, Cell[ 
            BoxData[ 
              StyleBox[ 
                RowBox[ {"(", 
                  CounterBox[ "Input"], ")"}], FontWeight -> "Plain", 
                FontFamily -> "Times"]]]}, {None, None}},
    CellFrameLabelMargins->{{0, 42}, {0, 0}},
    DefaultFormatType->StandardForm,
    InputAutoReplacements->{},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    SpanMaxSize->Automatic,
    LinebreakAdjustments->{0.85, 2, 10, 0, 1},
    CounterIncrements->"Input",
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[StyleData["InputNumbered", "Printout"],
    CellMargins->{{21, 6}, {3, 6}},
    LinebreakAdjustments->{0.85, 2, 10, 1, 1},
    FontSize->9]
  }, Closed]],
  
  Cell[StyleData["InputOnly"],
    Evaluatable->True,
    CellGroupingRules->"InputGrouping",
    DefaultFormatType->StandardForm,
    AutoItalicWords->{},
    FormatType->InputForm,
    ShowStringCharacters->True,
    NumberMarks->True,
    SpanMaxSize->Automatic,
    CounterIncrements->"Input",
    StyleMenuListing->None,
    FontWeight->"Bold"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Output"],
    CellMargins->{{72, 72}, {7, 5}},
    CellEditDuplicate->True,
    CellGroupingRules->"OutputGrouping",
    CellHorizontalScrolling->True,
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->StandardForm,
    InputAutoReplacements->{},
    HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
    AutoItalicWords->{},
    LanguageCategory->"Formula",
    FormatType->InputForm,
    SpanMaxSize->Automatic,
    CounterIncrements->"Output",
    StyleMenuListing->None],
  
  Cell[StyleData["Output", "Printout"],
    CellMargins->{{21, 0}, {6, 3}},
    FontSize->9]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Message"],
    CellMargins->{{45, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->StandardForm,
    AutoItalicWords->{},
    FormatType->InputForm,
    SpanMaxSize->Automatic,
    CounterIncrements->"Message",
    StyleMenuListing->None,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["Message", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->8,
    FontColor->GrayLevel[0]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Print"],
    CellMargins->{{45, Inherited}, {Inherited, Inherited}},
    CellGroupingRules->"OutputGrouping",
    PageBreakWithin->False,
    GroupPageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
    DefaultFormatType->StandardForm,
    AutoItalicWords->{},
    FormatType->InputForm,
    SpanMaxSize->Automatic,
    CounterIncrements->"Print",
    StyleMenuListing->None],
  
  Cell[StyleData["Print", "Printout"],
    CellMargins->{{39, Inherited}, {Inherited, Inherited}},
    FontSize->8]
  }, Closed]],
  
  Cell["\<\
Do not remove TextAlignment->Left from \"Graphics\" style \
definitions or else graphics may behave badly as inline cells:\
\>", "Text",
    CellMargins->{{72, Inherited}, {Inherited, Inherited}},
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->GrayLevel[0.500008]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Graphics"],
    Editable->True,
    CellMargins->{{36, Inherited}, {0, 7}},
    CellGroupingRules->"GraphicsGrouping",
    CellHorizontalScrolling->False,
    PageBreakWithin->False,
    GeneratedCell->True,
    CellAutoOverwrite->True,
    ShowCellLabel->False,
    DefaultFormatType->StandardForm,
    InputAutoReplacements->{},
    TextAlignment->Left,
    LanguageCategory->None,
    FormatType->InputForm,
    SpanMaxSize->Automatic,
    CounterIncrements->"Graphics",
    ImageMargins->{{0, 0}, {0, 0}},
    StyleMenuListing->None],
  
  Cell[StyleData["Graphics", "Printout"],
    CellMargins->{{27, 0}, {6, 3}},
    ImageMargins->{{0, 0}, {0, 0}},
    FontSize->9,
    Magnification->0.8]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["CellLabel"],
    SpanMaxSize->Automatic,
    StyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0, 0, 1]],
  
  Cell[StyleData["CellLabel", "Printout"],
    FontFamily->"Courier",
    FontSize->8,
    FontSlant->"Italic",
    FontColor->GrayLevel[0]]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Help Browser Styles", "Subsection",
    StyleMenuListing->None],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["MathCaption"],
    StyleMenuListing->None],
  
  Cell[StyleData["MathCaption", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserTips"],
    StyleMenuListing->None],
  
  Cell[StyleData["UserTips", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["UserTipsList"],
    StyleMenuListing->None],
  
  Cell[StyleData["UserTipsList", "Printout"],
    StyleMenuListing->None]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["IndentedText"],
    StyleMenuListing->None],
  
  Cell[StyleData["IndentedText", "Printout"],
    StyleMenuListing->None]
  }, Closed]]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Alternative Item Styles", "Subsection"],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item1NumberedNew"],
    CellMargins->{{12, 10}, {3, 5}},
    CellGroupingRules->"GraphicsGrouping",
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item1Numbered"], ". "}], "Item1NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    TextAlignment->Left,
    LineSpacing->{1, 3},
    ParagraphIndent->-24,
    CounterIncrements->"Item1Numbered",
    CounterAssignments->{{"Item1Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times",
    FontSize->12],
  
  Cell[StyleData["Item1NumberedNew", "Printout"],
    CellMargins->{{0, 12}, {1, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    ParagraphIndent->-18,
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item2NumberedNew"],
    CellMargins->{{24, 10}, {3, 5}},
    CellGroupingRules->"GraphicsGrouping",
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item2Numbered"], ". "}], "Item2NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    TextAlignment->Left,
    LineSpacing->{1, 3},
    ParagraphIndent->-24,
    CounterIncrements->"Item2Numbered",
    CounterAssignments->{{"Item2Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Item2NumberedNew", "Printout"],
    CellMargins->{{12, 12}, {1, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    ParagraphIndent->-18,
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell[StyleData["Item3NumberedNew"],
    CellMargins->{{36, 10}, {3, 5}},
    CellGroupingRules->"GraphicsGrouping",
    CellFrameLabels->{{Cell[ 
            TextData[ {
              CounterBox[ "Item3Numbered"], ". "}], "Item3NumberedLabel", 
            CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
    TextAlignment->Left,
    LineSpacing->{1, 3},
    ParagraphIndent->-24,
    CounterIncrements->"Item3Numbered",
    CounterAssignments->{{"Item3Numbered", 0}},
    StyleMenuListing->None,
    FontFamily->"Times"],
  
  Cell[StyleData["Item3NumberedNew", "Printout"],
    CellMargins->{{24, 12}, {1, 4}},
    TextJustification->1,
    LineSpacing->{1, 2},
    ParagraphIndent->-18,
    StyleMenuListing->None,
    FontSize->10]
  }, Closed]]
  }, Closed]]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  ":bib:Parl"->{
    Cell[2360, 84, 255, 8, 26, "Text",
      CellTags->":bib:Parl"]},
  ":bib:Diacon"->{
    Cell[2618, 94, 432, 11, 62, "Text",
      CellTags->":bib:Diacon"]},
  ":bib:Kasman97"->{
    Cell[3053, 107, 422, 10, 62, "Text",
      CellTags->":bib:Kasman97"]},
  ":bib:Tymczak"->{
    Cell[3478, 119, 362, 9, 44, "Text",
      CellTags->":bib:Tymczak"]},
  "Diacon"->{
    Cell[3940, 137, 1074, 62, 40, "Reference",
      CellTags->"Diacon"]},
  "Kasman97"->{
    Cell[5017, 201, 937, 45, 38, "Reference",
      CellTags->"Kasman97"]},
  "Parl"->{
    Cell[5957, 248, 850, 42, 38, "Reference",
      CellTags->"Parl"]},
  "Tymczak"->{
    Cell[6810, 292, 1505, 77, 38, "Reference",
      CellTags->"Tymczak"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {":bib:Parl", 172577, 6356},
  {":bib:Diacon", 172666, 6359},
  {":bib:Kasman97", 172760, 6362},
  {":bib:Tymczak", 172856, 6365},
  {"Diacon", 172944, 6368},
  {"Kasman97", 173035, 6371},
  {"Parl", 173123, 6374},
  {"Tymczak", 173210, 6377}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1775, 53, 25, 0, 74, "Title"],
Cell[1803, 55, 31, 0, 26, "Subtitle"],
Cell[1837, 57, 297, 11, 46, "AuthorGroup"],
Cell[2137, 70, 31, 0, 43, "Abstract"],

Cell[CellGroupData[{
Cell[2193, 74, 164, 8, 51, "Section"],
Cell[2360, 84, 255, 8, 26, "Text",
  CellTags->":bib:Parl"],
Cell[2618, 94, 432, 11, 62, "Text",
  CellTags->":bib:Diacon"],
Cell[3053, 107, 422, 10, 62, "Text",
  CellTags->":bib:Kasman97"],
Cell[3478, 119, 362, 9, 44, "Text",
  CellTags->":bib:Tymczak"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3877, 133, 38, 0, 55, "ReferenceSection"],

Cell[CellGroupData[{
Cell[3940, 137, 1074, 62, 40, "Reference",
  CellTags->"Diacon"],
Cell[5017, 201, 937, 45, 38, "Reference",
  CellTags->"Kasman97"],
Cell[5957, 248, 850, 42, 38, "Reference",
  CellTags->"Parl"],
Cell[6810, 292, 1505, 77, 38, "Reference",
  CellTags->"Tymczak"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

