(************** Content-type: application/mathematica **************
                       CreatedBy='Publicon 1.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     11355,        329]*)
(*NotebookOutlinePosition[     27746,        862]*)
(*  CellTagsIndexPosition[     27596,        853]*)
(*WindowFrame->Palette*)



Notebook[{
Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[
              AdjustmentBox["?",
                BoxMargins->{{0.0181818, -0.0181818}, {-0.214288, 0.214288}},
                BoxBaselineShift->0.214288],
              ButtonData:>"New Utilities",
              ButtonStyle->"DialogHelp",
              ButtonNote->"Help"], 
            ButtonBox["s",
              ButtonData:>{"XtraUtilities", "DefaultSampleNew.nb"},
              ButtonStyle->"SampleDoc"], 
            ButtonBox[
              AdjustmentBox["\[LeftPointer]\[LeftPointer]",
                BoxMargins->{{0.1, -0.1}, {3.27*^-7, -3.27826*^-7}}],
              ButtonStyle->"FullLeft"], 
            ButtonBox["\[LeftPointer]",
              ButtonStyle->"InLeft"], 
            ButtonBox[
              AdjustmentBox["\[RightPointer]",
                BoxMargins->{{0.1, -0.1}, {3.27826*^-7, -3.27826*^-7}}],
              ButtonStyle->"InRight"], 
            ButtonBox[
              AdjustmentBox["\[RightPointer]\[RightPointer]",
                BoxMargins->{{0.109091, -0.109091}, {
                3.27824*^-7, -3.27826*^-7}}],
              ButtonStyle->"FullRight"], 
            ButtonBox[
              
              AdjustmentBox[\(\[SkeletonIndicator]\[NegativeThinSpace]\
\[SkeletonIndicator]\[NegativeThinSpace]\[SkeletonIndicator]\),
                BoxMargins->{{0, 0}, {-0.333333, 0.333333}},
                BoxBaselineShift->0.333333],
              ButtonData:>"Default",
              ButtonStyle->"Iconify"]}
          }], TraditionalForm]], "NavButtonRow",
  SingleLetterItalics->False],

Cell[BoxData[GridBox[{
        {
          ButtonBox[
            AdjustmentBox[\(New\ Document\),
              BoxMargins->{{0, 0}, {0.333334, -0.333334}},
              BoxBaselineShift->-0.333334],
            ButtonData:>{"PubliconDefaultNew.nb", {
              Cell[ "F R O N T M A T T E R", "FrontmatterGroup"], 
              Cell[ "Title...", "Title"], 
              Cell[ "Subtitle...", "Subtitle"], 
              Cell[ 
                CellGroupData[ {
                  Cell[ "AuthorName", "Author"], 
                  Cell[ "AuthorTitle", "AuthorTitle"], 
                  Cell[ "Institution", "Institution"], 
                  Cell[ 
                    TextData[ 
                      ButtonBox[ "Email"]], "AuthorEmail"]}, Open]], 
              Cell[ 
                CellGroupData[ {
                  Cell[ "Abstract", "AbstractSection"], 
                  Cell[ "Abstract...", "Abstract"], 
                  Cell[ "Date...", "Date"]}, Open]], 
              Cell[ "B O D Y", "MainmatterGroup"], 
              Cell[ 
                CellGroupData[ {
                  Cell[ "Section", "Section"], 
                  Cell[ "Your text begins here....", "Text"]}, Open]], 
              Cell[ "B A C K M A T T E R", "BackmatterGroup"], 
              Cell[ "Appendix Head...", "AppendixSection"]}, {2, All}},
            ButtonStyle->"NewDocButton",
            ButtonNote->"Begin New Document"]}
        }]], "NewDocButton"],

Cell[CellGroupData[{

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[" ",
              ButtonFunction:>GeneratePalette[ "TearOff", "TOC"],
              ButtonEvaluator->Automatic,
              ButtonNote->"Tear-off Button Group"], 
            ButtonBox[GridBox[{
                  {" ", \(Table\ of\ Contents\), 
                    StyleBox[
                      AdjustmentBox["\[DownPointer]",
                        BoxMargins->{{0, 0}, {-0.25, 0.25}},
                        BoxBaselineShift->0.25],
                      "Pointer"]}
                  },
                ColumnWidths->{0.02, 0.71, 0.1}],
              ButtonNote->"TOC"]}
          },
        ColumnWidths->{0.07, 0.95}], TraditionalForm]], "TopGroupButton"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox["Article",
              ButtonData:>"Article",
              ButtonStyle->"RadioButtonOn",
              ButtonNote->"TOC for Article"]},
          {
            ButtonBox["Book",
              ButtonData:>"Book",
              ButtonStyle->"RadioButtonOff",
              ButtonNote->"TOC of File for Book"]}
          }], TraditionalForm]], "RadioButtonCell",
  CellTags->"TOC"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox["Primary",
              ButtonData:>"Contents",
              ButtonStyle->"RadioButtonOn",
              ButtonNote->"List of Primary Content"]},
          {
            ButtonBox["Figures",
              ButtonData:>"Figures",
              ButtonStyle->"RadioButtonOff",
              ButtonNote->"List of Figures/Illustrations"]},
          {
            ButtonBox["Tables",
              ButtonData:>"Tables",
              ButtonStyle->"RadioButtonOff",
              ButtonNote->"List of Tables"]}
          }], TraditionalForm]], "RadioButtonCell",
  CellTags->"TOC"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox["Pages",
              ButtonData:>"Pages",
              ButtonStyle->"RadioButtonOn",
              ButtonNote->"Supply Page Numbers"]},
          {
            ButtonBox["Outline",
              ButtonData:>"Outline",
              ButtonStyle->"RadioButtonOff",
              ButtonNote->"Supply Hyperlinks"]}
          }], TraditionalForm]], "RadioButtonCell",
  CellTags->"TOC"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[\(Create\ TOC\),
              ButtonFunction:>MakeTOC[ ],
              ButtonStyle->"DarkButton",
              ButtonNote->"Generate TOC"]}
          }], TraditionalFrom]], "ButtonCell",
  CellTags->"TOC"],

Cell[BoxData[
    \(\(RadioButtonInit[];\)\)], "Input",
  ShowCellBracket->False,
  CellMargins->{{2, 72}, {0, 0}},
  CellElementSpacings->{"ClosedCellHeight"->4},
  CellOpen->False,
  InitializationCell->True,
  CellTags->"TOC"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[" ",
              ButtonFunction:>GeneratePalette[ "TearOff", "Sort"],
              ButtonEvaluator->Automatic,
              ButtonNote->"Tear-off Button Group"], 
            ButtonBox[GridBox[{
                  {" ", "Sorting", 
                    StyleBox[
                      AdjustmentBox["\[DownPointer]",
                        BoxMargins->{{0, 0}, {-0.25, 0.25}},
                        BoxBaselineShift->0.25],
                      "Pointer"]}
                  },
                ColumnWidths->{0.02, 0.71, 0.1}],
              ButtonNote->"Sorting"]}
          },
        ColumnWidths->{0.07, 0.95}], TraditionalForm]], "GroupButton"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[\(By\ \ 1  st\ \ Word\),
              ButtonFunction:>CellSort[ ],
              ButtonNote->"Sort Cells on 1st Word"]},
          {
            ButtonBox[\(By\ \ 2  nd\ \ Word\),
              ButtonFunction:>CellSort[ "SkipWords" -> 1],
              ButtonNote->"Sort Cells on 2nd Word"]},
          {
            ButtonBox[\(Drop\ \ 1  st\ \ Word\),
              
              ButtonFunction:>CellSort[ 
                "SkipWords" -> 1, "TrimSkips" -> True],
              ButtonNote->"Drop 1st and Sort on 2nd"]}
          }], TraditionalForm]], "Button",
  CellMargins->{{0, 0}, {4, 0}},
  ZeroWidthTimes->True,
  CellTags->"Sort"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[" ",
              ButtonFunction:>GeneratePalette[ "TearOff", "Import"],
              ButtonEvaluator->Automatic,
              ButtonNote->"Tear-off Button Group"], 
            ButtonBox[GridBox[{
                  {" ", "EPS", 
                    StyleBox[
                      AdjustmentBox["\[DownPointer]",
                        BoxMargins->{{0, 0}, {-0.25, 0.25}},
                        BoxBaselineShift->0.25],
                      "Pointer"]}
                  },
                ColumnWidths->{0.02, 0.71, 0.1}],
              ButtonNote->"EPS Import"]}
          },
        ColumnWidths->{0.07, 0.95}], TraditionalForm]], "GroupButton"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox["Import",
              ButtonFunction:>ImportAsMPS[ ],
              ButtonNote->"Import EPS File"]}
          }], TraditionalForm]], "Button",
  CellMargins->{{0, 0}, {4, 0}},
  ZeroWidthTimes->True,
  CellTags->"Import"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[" ",
              ButtonFunction:>GeneratePalette[ "TearOff", "DocPalTools"],
              ButtonEvaluator->Automatic,
              ButtonNote->"Tear-off Button Group"], 
            ButtonBox[GridBox[{
                  {" ", \(Document\ Palette\), 
                    StyleBox[
                      AdjustmentBox["\[DownPointer]",
                        BoxMargins->{{0, 0}, {-0.25, 0.25}},
                        BoxBaselineShift->0.25],
                      "Pointer"]}
                  },
                ColumnWidths->{0.02, 0.71, 0.1}],
              ButtonNote->"Doc Palette Source Tools"]}
          },
        ColumnWidths->{0.07, 0.95}], TraditionalForm]], "GroupButton"],

Cell[BoxData[
    FormBox[GridBox[{
          {
            ButtonBox[\(New\ \ Doc\ \ Button\),
              ButtonFunction:>MakeNewDoc[ ],
              ButtonStyle->"Button",
              ButtonNote->"Make New Document button"]}
          }], TraditionalForm]], "Button",
  CellMargins->{{0, 0}, {4, 0}},
  ZeroWidthTimes->True,
  CellTags->"DocPalTools"]
}, Open  ]]
},
FrontEndVersion->"4.2 for Macintosh",
ScreenRectangle->{{0, 1152}, {0, 795}},
MessageOptions->{"KernelMessageAction"->{"Beep", "PrintToConsole"}},
ClosingAutoSave->True,
AutoGeneratedPackage->None,
Editable->False,
Selectable->False,
Deletable->False,
WindowSize->{130, 455},
WindowMargins->{{Automatic, 296}, {Automatic, 0}},
WindowFrame->"Palette",
WindowElements->"StatusArea",
WindowFrameElements->"CloseBox",
WindowClickSelect->False,
WindowTitle->"XtraUtils",
Visible->True,
ShowCellBracket->False,
Active->True,
TaggingRules:>{"DialogWritable" -> False},
Background->RGBColor[0.6, 0.700008, 0.8],
StyleDefinitions -> Notebook[{
  
  Cell[CellGroupData[{
  Cell["PubliconDefault.nb Document Palette Styles", "Title"],
  
  Cell[CellGroupData[{
  
  Cell["Style Buttons", "Section",
    CellMargins->{{Inherited, Inherited}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4}],
  
  Cell[StyleData["TopGroupButton"],
    Selectable->True,
    PageWidth->127,
    CellMargins->{{0, 0}, {-1, 5}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    CellGroupingRules->{"SectionGrouping", 10},
    SingleLetterItalics->False,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    ButtonBoxOptions->{ButtonFunction:>CompoundExpression[ 
        SelectionMove[ 
          ButtonNotebook[ ], All, ButtonCell], 
        FrontEndExecute[ 
          FrontEndToken[ 
            ButtonNotebook[ ], "OpenCloseGroup"]]],
    ButtonEvaluator->None,
    ButtonMargins->1,
    Background->RGBColor[0.6, 0.6, 0.700008]},
    GridBoxOptions->{ColumnSpacings->0,
    ColumnWidths->{0.14, 0.72, 0.13},
    ColumnAlignments->{Right, Center, Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["GroupButton"],
    Selectable->True,
    PageWidth->127,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4,
    "ClosedGroupTopMargin"->2},
    CellGroupingRules->{"SectionGrouping", 10},
    SingleLetterItalics->False,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    ButtonBoxOptions->{ButtonFunction:>CompoundExpression[ 
        SelectionMove[ 
          ButtonNotebook[ ], All, ButtonCell], 
        FrontEndToken[ 
          ButtonNotebook[ ], "OpenCloseGroup"]],
    ButtonEvaluator->None,
    ButtonMargins->1,
    Background->RGBColor[0.6, 0.6, 0.700008]},
    GridBoxOptions->{ColumnSpacings->0,
    ColumnWidths->{0.14, 0.72, 0.13},
    ColumnAlignments->{Left, Center, Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["SubGroupButton"],
    Selectable->True,
    PageWidth->129,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4,
    "ClosedGroupTopMargin"->0},
    CellGroupingRules->{"SectionGrouping", 20},
    SingleLetterItalics->False,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    ButtonBoxOptions->{ButtonFunction:>CompoundExpression[ 
        SelectionMove[ 
          ButtonNotebook[ ], All, ButtonCell], 
        FrontEndToken[ 
          ButtonNotebook[ ], "OpenCloseGroup"]],
    ButtonEvaluator->None,
    ButtonMargins->1,
    Background->RGBColor[0.500008, 0.6, 0.700008]},
    GridBoxOptions->{ColumnSpacings->0,
    ColumnWidths->{0.13, 0.72, 0.12},
    ColumnAlignments->{Right, Center, Left},
    RowMinHeight->1.2}],
  
  Cell[StyleData["Button"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->6,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["ButtonCell"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->RGBColor[0.549996, 0.650004, 0.749996],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->6,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["DarkButtonCell"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->RGBColor[0.6, 0.700008, 0.8],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->6,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["MediumButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->5,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["ThinButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->3,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["DarkButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->RGBColor[0.8, 0.900008, 1],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->6,
    Background->RGBColor[0.500008, 0.6, 0.700008]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["ThinDarkButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->11,
    FontColor->RGBColor[0.8, 0.900008, 1],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->2,
    Background->RGBColor[0.500008, 0.6, 0.700008]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["MakeDefaultButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4,
    "ClosedGroupTopMargin"->3},
    CellGroupingRules->{"SectionGrouping", 10},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->RGBColor[0.8, 0.900008, 1],
    ButtonBoxOptions->{ButtonFunction:>SetDefaultPalette[ ],
    ButtonEvaluator->Automatic,
    ButtonMargins->1,
    Background->RGBColor[0.500008, 0.6, 0.700008]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}],
  
  Cell[StyleData["SmallButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->10,
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonEvaluator->Automatic,
    ButtonMargins->2,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{ColumnWidths->0.99}],
  
  Cell[StyleData["HalfButton2"],
    Selectable->True,
    PageWidth->129,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontSize->9,
    FontColor->RGBColor[0.8, 0.900008, 1],
    ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
        CheckDocStyleMatch[ ], 
        CellWriteStyle[ #]]&),
    ButtonEvaluator->Automatic,
    ButtonMargins->3,
    Background->RGBColor[0.500008, 0.600015, 0.700008]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.5}],
  
  Cell[StyleData["RadioButtonCell"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {0, 0}},
    CellElementSpacings->{"ClosedCellHeight"->4},
    TabSpacings->0.65,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonEvaluator->Automatic,
    ButtonMargins->3,
    Background->RGBColor[0.6, 0.700008, 0.8]},
    GridBoxOptions->{RowSpacings->0,
    ColumnSpacings->0,
    ColumnWidths->0.99}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Utility Buttons", "Section"],
  
  Cell[StyleData["NewDocButton"],
    Selectable->True,
    PageWidth->131,
    CellMargins->{{0, 0}, {-1, -2}},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Arial",
    FontWeight->"Bold",
    FontColor->GrayLevel[0.900008],
    ButtonBoxOptions->{ButtonFunction:>(GenerateDocument[ #]&),
    ButtonEvaluator->Automatic,
    ButtonMinHeight->2,
    ButtonMargins->0,
    Background->RGBColor[0.4, 0.4, 0.6]},
    GridBoxOptions->{ColumnWidths->0.99}],
  
  Cell[StyleData["NavButtonRow"],
    Selectable->True,
    PageWidth->125,
    CellMargins->{{0, 0}, {0, 0}},
    TextAlignment->Left,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    FontColor->GrayLevel[0.700008],
    ButtonBoxOptions->{ButtonMargins->1,
    Background->RGBColor[0.100008, 0.2, 0.500008]},
    GridBoxOptions->{ColumnSpacings->0,
    ColumnWidths->{0.15, 0.15, 0.16, 0.13, 0.13, 0.16, 0.13}}],
  
  Cell[StyleData["Pointer"],
    Selectable->True,
    StyleMenuListing->None,
    FontSize->18],
  
  Cell[StyleData["BigPointer"],
    Selectable->True,
    StyleMenuListing->None,
    FontSize->24],
  
  Cell[StyleData["FullLeft"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>PalettePosition[ "FullLeft"],
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonNote->"Move Full Left"}],
  
  Cell[StyleData["InLeft"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(PalettePosition[ "InLeft"][ #2]&),
    ButtonEvaluator->Automatic,
    ButtonData:>{"Darwin" -> {165, 130}, "Other" -> {172, 138}},
    Active->True,
    ButtonNote->"Move Near Left"}],
  
  Cell[StyleData["InRight"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(PalettePosition[ "InRight"][ #2]&),
    ButtonEvaluator->Automatic,
    ButtonData:>{"Darwin" -> {165, 130}, "Other" -> {172, 138}},
    Active->True,
    ButtonNote->"Move Near Right"}],
  
  Cell[StyleData["FullRight"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>PalettePosition[ "FullRight"],
    ButtonEvaluator->Automatic,
    Active->True,
    ButtonNote->"Move Full Right"}],
  
  Cell[StyleData["DialogHelp"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
        FrontEnd`HelpBrowserLookup[ "UserGuide", #]}]&),
    ButtonNote->"Help"}],
  
  Cell[StyleData["SampleDoc"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(OpenSampleDocument[ #]&),
    ButtonEvaluator->Automatic,
    ButtonNote->"Sample Document"}],
  
  Cell[StyleData["Iconify"],
    Selectable->True,
    StyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(IconifyNotebook[ #]&),
    ButtonEvaluator->Automatic,
    ButtonNote->"Iconify"}],
  
  Cell[StyleData["SearchUp"],
    Selectable->True,
    StyleMenuListing->None,
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(NotebookFind[ 
        SelectedNotebook[ ], #, Previous, CellStyle]&),
    ButtonEvaluator->None}],
  
  Cell[StyleData["SearchDown"],
    Selectable->True,
    StyleMenuListing->None,
    FontColor->GrayLevel[0],
    ButtonBoxOptions->{ButtonFunction:>(NotebookFind[ 
        SelectedNotebook[ ], #, Next, CellStyle]&),
    ButtonEvaluator->None}],
  
  Cell[StyleData["GeneratePalette"],
    Selectable->False,
    CellMargins->{{0, Inherited}, {Inherited, 20}},
    CellElementSpacings->{"ClosedGroupTopMargin"->20},
    CellGroupingRules->{"SectionGrouping", 10},
    StyleMenuListing->None,
    ButtonStyleMenuListing->None,
    FontFamily->"Helvetica",
    FontWeight->"Bold",
    ButtonBoxOptions->{ButtonFunction:>GeneratePalette[ "DocumentPalette"],
    ButtonEvaluator->Automatic,
    Active->True}],
  
  Cell[StyleData["ScrollBar"],
    Selectable->True,
    ShowSelection->False,
    CellMargins->{{57, Inherited}, {Inherited, 24}},
    CellGroupingRules->{"SectionGrouping", 10},
    AutoIndent->False,
    LineSpacing->{0.4, 0},
    StyleMenuListing->None,
    FontSize->30,
    FontColor->RGBColor[0.549996, 0.650004, 0.749996],
    ButtonBoxOptions->{ButtonFunction:>ToggleScrollBar[ 
        ButtonNotebook[ ]],
    ButtonEvaluator->Automatic}]
  }, Closed]],
  
  Cell[CellGroupData[{
  
  Cell["Formatting", "Section"],
  
  Cell[StyleData["ColorTextDark"],
    Selectable->True,
    StyleMenuListing->None,
    FontColor->RGBColor[0.2, 0.300008, 0.4]],
  
  Cell[StyleData["ColorTextLight"],
    Selectable->True,
    StyleMenuListing->None,
    FontColor->RGBColor[0.4, 0.500008, 0.6]],
  
  Cell[StyleData["ReverseText"],
    Selectable->True,
    StyleMenuListing->None,
    FontColor->GrayLevel[1]],
  
  Cell[StyleData["RadioButtonOn"],
    ButtonStyleMenuListing->None,
    FontVariations->{"Underline"->True},
    ButtonBoxOptions->{ButtonFunction:>Null}],
  
  Cell[StyleData["RadioButtonOff"],
    ButtonStyleMenuListing->None,
    ButtonBoxOptions->{ButtonFunction:>(RadioButtonToggle[ #]&)}]
  }, Closed]]
  }, Open  ]]
  }]
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "TOC"->{
    Cell[5574, 146, 451, 13, 39, "RadioButtonCell",
      CellTags->"TOC"],
    Cell[6028, 161, 646, 18, 57, "RadioButtonCell",
      CellTags->"TOC"],
    Cell[6677, 181, 454, 13, 39, "RadioButtonCell",
      CellTags->"TOC"],
    Cell[7134, 196, 278, 8, 27, "ButtonCell",
      CellTags->"TOC"],
    Cell[7415, 206, 229, 7, 5, "Input",
      CellOpen->False,
      InitializationCell->True,
      CellTags->"TOC"]},
  "Sort"->{
    Cell[8409, 238, 711, 19, 79, "Button",
      CellTags->"Sort"]},
  "Import"->{
    Cell[9886, 282, 293, 9, 31, "Button",
      CellTags->"Import"]},
  "DocPalTools"->{
    Cell[10980, 316, 359, 10, 31, "Button",
      CellTags->"DocPalTools"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"TOC", 26892, 827},
  {"Sort", 27322, 840},
  {"Import", 27405, 843},
  {"DocPalTools", 27494, 846}
  }
*)

(*NotebookFileOutline
Notebook[{
Cell[1754, 51, 1601, 37, 17, "NavButtonRow"],
Cell[3358, 90, 1451, 32, 22, "NewDocButton"],

Cell[CellGroupData[{
Cell[4834, 126, 737, 18, 21, "TopGroupButton"],
Cell[5574, 146, 451, 13, 39, "RadioButtonCell",
  CellTags->"TOC"],
Cell[6028, 161, 646, 18, 57, "RadioButtonCell",
  CellTags->"TOC"],
Cell[6677, 181, 454, 13, 39, "RadioButtonCell",
  CellTags->"TOC"],
Cell[7134, 196, 278, 8, 27, "ButtonCell",
  CellTags->"TOC"],
Cell[7415, 206, 229, 7, 5, "Input",
  CellOpen->False,
  InitializationCell->True,
  CellTags->"TOC"]
}, Open  ]],

Cell[CellGroupData[{
Cell[7681, 218, 725, 18, 17, "GroupButton"],
Cell[8409, 238, 711, 19, 79, "Button",
  CellTags->"Sort"]
}, Open  ]],

Cell[CellGroupData[{
Cell[9157, 262, 726, 18, 17, "GroupButton"],
Cell[9886, 282, 293, 9, 31, "Button",
  CellTags->"Import"]
}, Open  ]],

Cell[CellGroupData[{
Cell[10216, 296, 761, 18, 17, "GroupButton"],
Cell[10980, 316, 359, 10, 31, "Button",
  CellTags->"DocPalTools"]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

