(************** Content-type: application/mathematica **************
                       CreatedBy='Publicon 1.0'

                    Mathematica-Compatible Notebook

This notebook can be used with any Mathematica-compatible
application, such as Mathematica, MathReader or Publicon. The data
for the notebook starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do
one of the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the
  application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing
the word CacheID, otherwise Mathematica-compatible applications may
try to use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
*******************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    334172,      12950]*)
(*NotebookOutlinePosition[    335090,      12982]*)
(*  CellTagsIndexPosition[    334973,      12975]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["PubliconDefault.nb Style Definitions", "Title"],

Cell[CellGroupData[{

Cell["CSS", "Section"],

Cell["\<\

<style type=\"text/css\">
/* global */
body { margin: 10pt; background-color: #FFFFFF; }

math { text-align: left; }

p.NoSpace { margin: 0pt }

img { vertical-align: middle;  } 

/* Frontmatter */

.Title { margin: 36pt 2pt 4pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 24pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.Subtitle { margin: 6pt 2pt 4pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 16pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000080;
\t}

.Subsubtitle { margin: 6pt 2pt 2pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 13pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\t}

.Source,.DateReceived,.CopyrightYear
 { margin: 12pt 2pt 0pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 8pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.ISSN,.Volume,.Number,.FirstPage,.LastPage,.URL,
.DateRevisionRequested,.DateRevisionReceived,.DateAccepted,
.DatePublished, 
.CopyrightBy
 { margin: 0pt 2pt 0pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 8pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.Date { margin: 0pt 120pt 6pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\tborder-top: 1pt solid #000000;
\tpadding-top: 4pt;
\t}

.Author { margin: 24pt 2pt 0pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\t}

.AuthorTitle, .Institution { margin: 0pt 2pt 0pt 24pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\t}

.AuthorEmail { margin: 0pt 2pt 0pt 24pt;
\tfont-family: \"Courier New\", Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #0000FF;
\t}

.AbstractSection { margin: 18pt 120pt 0pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\tborder-bottom: 1pt solid #000000;
\tpadding-bottom: 4pt;
\t}

.AbstractSubsection { margin: 2pt 120pt 0pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000080;
\t}

.Abstract, .AbstractContinuation, .AbstractMath { margin: 4pt 120pt 4pt 24pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000080;
\t}

.AbstractShortSection { margin: 7pt 2pt 2pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.AbstractShort { margin: 3pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCTitle, .TOCIllustrations, .TOCTables, .LOASection,
.BookChapterTitle
\t{ margin: 36pt 2pt 24pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 21pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCFrontmatterTitle, .TOCBackmatterTitle, .TOCFrontBackTitle
\t{ margin: 1pt 2pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCSpacer { margin: 0pt 2pt 0pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCSection { margin: 1pt 2pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCSubsection, .TOCItem { margin: 1pt 2pt 1pt 24pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.TOCSubsubsection { margin: 1pt 2pt 1pt 48pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.LOAItem { margin: 4pt 2pt 4pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.LOAAbbreviation { font-weight: bold; }
\t
/* keyboard shortcuts styles */

h3 { margin: 24pt 2pt 4pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 14pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\tborder-bottom: 1pt solid #000000;
\tpadding-bottom: 4pt;
\t}

h4 { margin: 16pt 2pt 3pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

h5 { margin: 9pt 2pt 3pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #333333;
\t}

.Subsubsubsection { margin: 6pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #333333;
\t}

.SectionAlt { margin: 24pt 2pt 3pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 12pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\tborder: none;
\t}

.SubsectionAlt { margin: 12pt 2pt 3pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.SubsubsectionAlt { margin: 6pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #4C4C4C;
\t}

.SubsubsubsectionAlt { margin: 6pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #4C4C4C;
\t}

.Text, .TextContinuation, .TextNoIndent, .Acknowledgments, .Appendix 
\t{ margin: 5pt 2pt 3pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: justify;
\tcolor: #000000;
\t}

/* Itemized Lists */

li { margin: 2pt 12pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size:10pt;
\t}

ol ol { list-style: lower-alpha; }

ol ol ol { list-style: lower-roman; }

.Item1Paragraph, .Item2Paragraph, .Item3Paragraph 
{ margin-top: 3pt; margin-bottom: 3pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* Illustrations */

.Figure, .Picture, .Illustration, .Graphics 
\t{ margin: 7pt 2pt 0pt 2pt; text-align: left; }

.FigureCaption, .PictureCaption, .IllustrationCaption,
.ProgramCaption, .Caption 
\t{ margin: 2pt 2pt 6pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.FigureCaptionLabel, .PictureCaptionLabel, 
.IllustrationCaptionLabel,
.ProgramCaptionLabel, .CaptionLabel,
.FigureNumber, .PictureNumber, .IllustrationNumber,
.ProgramNumber, .CaptionNumber,
.TableTitleLabel, .TableNoteLabel
\t{ font-weight: bold; }

.FigureText, .PictureText, .IllustrationText, .ProgramText
\t{ margin: 0pt 2pt 12pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.Program { margin: 7pt 2pt 2pt 2pt;
\tfont-family: \"Courier New\", Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\tborder-bottom: 1pt solid #000000;
\tborder-top: 1pt solid #000000;
\tpadding-bottom: 4pt;
\tpadding-top: 4pt;
\t}

.SupplementalCaptionLabel { margin: 7pt 2pt 1pt 2pt;
\tborder-bottom: 1px solid black;
\tfont-family: Helvetica, Arial;
\tfont-size: 9pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.SupplementalCaption { margin: 4pt 2pt 8pt 2pt;
\tborder-bottom: 1px solid black;
\tfont-family: Helvetica, Arial;
\tfont-size: 9pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.SupplementalText { margin: 4pt 2pt 7pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.FigureFile, .Supplemental { margin: 2pt 2pt 7pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\tbackground-color:#C6C6EC;
\tpadding:3pt;
\t}

.TableTitle { margin: 7pt 2pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

table { margin: 1pt 2pt 1pt 2pt; }

table.TableMasterGrid { width:100%; 
\tmargin: 3pt 2pt 7pt 2pt;
\tborder-bottom: 1pt solid #000000;
\tborder-top: 2pt solid #000000;
\t}

table.TableMasterGrid td.TableLineElement {
\tborder-bottom: solid 1pt #000000;
\tfont-size: 1pt;
\tpadding: 0pt;
\tmargin:0pt;
\tline-height: 0pt;
\t}

.TableNote { margin: -3pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #4C4C4C;
\t}

.TableColumnHead, .TableSpanHead {
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic; 
\tcolor: #000000;
\t}

.TableText, .TableSpanText {
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal; 
\tcolor: #000000;
\t}

.Extract { margin: 8pt 12pt 8pt 24pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* mathematics */

.Equation, .EquationWide, 
.EquationNumbered, .EquationWideNumbered, 
.AppendixEquation,
.EquationGroupAlignedNumbered, .EquationGroupAligned,
.EquationGroupNumbered, .EquationGroup,
.SubequationNumbered, .SubequationAlignedNumbered, {
\tmargin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal; 
\ttext-align: left; 
\tfont-style: normal; 
\tcolor: #000000;
\t}

table.EquationNumbered {
\twidth: 100%;
\t}

table.AppendixEquation {
\twidth: 100%;
\t}

table.AppendixEquation td.AppendixEquationLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationNumbered td.EquationNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.EquationGroup,
table.EquationGroupNumbered,
table.SubequationNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

p.EquationGroup {
\tpadding-left: 4.5%;
\t}

table.EquationGroupNumbered td.EquationGroupNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.SubequationNumbered td.SubequationNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

.EquationGroupAligned table {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tpadding-left: 4.5%;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

.EquationGroupAligned table td,
.EquationGroupAligned table th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

table.SubequationAlignedNumbered {
\twidth: 100%;
\tpadding-top: 0pt;
\tpadding-bottom: 0pt;
\tmargin-top: 0pt;
\tmargin-bottom: 0pt;
\t}

table.EquationGroupAlignedNumbered td,
table.EquationGroupAlignedNumbered th,
table.SubequationAlignedNumbered td,
table.SubequationAlignedNumbered th {
\tpadding: 0pt;
\t}

table.EquationGroupAlignedNumbered td.EquationGroupAlignedNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

table.SubequationAlignedNumbered td.SubequationAlignedNumberedLabel {
\twidth: 4%;
\tfont-size: 10pt;
\tpadding: 0pt;
\t}

.Theorem,.Corollary,.Lemma,.Proposition,.Conjecture
\t{ margin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000000;
\ttext-align: justify;
\t}

.Definition,.Axiom,.Example,.Remark,.Proof
\t{ margin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\ttext-align: justify;
\t}

.TheoremLabel,.CorollaryLabel,.LemmaLabel,.PropositionLabel,
.ConjectureLabel,.DefinitionLabel,.AxiomLabel,.ExampleLabel
\t{
\tfont-weight: bold;
\tfont-style: normal;
\t}

.RemarkLabel,.ProofLabel, .CaseLabel, .ProblemsLabel
\t{
\tfont-weight: normal;
\tfont-style: italic;
\t}

.ProofSection, .CaseSection, .ProblemsSection
\t{ margin: 7pt 2pt 7pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* Cross-References */

.XRef { color: #000000; text-decoration:none }
.DkBlue { color: #000080; }

/* Backmatter */

.Reference, .Endnote { margin: 1pt 2pt 1pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

td.EndnoteLabel { width: 32px; }
td.ReferenceLabel { width: 32px; }

.RefReviewVolume, .RefJournalVolume
\t{ font-weight: bold; font-style: normal; }

.RefBookTitle, .RefJournalTitle, .RefSchoolDept
{ font-weight: normal; font-style: italic; }

.IndexEntry { 
\tmargin: 0pt 2pt 2pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.IndexSubentry { 
\tmargin: 0pt 2pt 2pt 18pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.IndexSubsubentry { 
\tmargin: 0pt 2pt 2pt 30pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.IndexNote { 
\tmargin: 0pt 2pt 2pt 2pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 9pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000000;
\t}

/* Book Elements */

.BookPartLabel { 
\tmargin: 7pt 48pt 7pt 48pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 24pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.BookPartTitle { 
\tmargin: 7pt 48pt 12pt 48pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 30pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.BookPartSubtitle { 
\tmargin: 7pt 48pt 12pt 48pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 21pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.BookPartSubsubtitle { 
\tmargin: 7pt 48pt 12pt 48pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 16pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.BookPartText { 
\tmargin: 7pt 60pt 7pt 60pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\ttext-indent: 10pt;
\tcolor: #000000;
\t}

.BookPartTextNoIndent { 
\tmargin: 7pt 60pt 7pt 60pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

.BookChapterLabel { 
\tmargin: 72pt 2pt 4pt 2pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 11pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

.BookChapterNumber { 
\tfont-family: Helvetica, Arial;
\tfont-size: 17pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: center;
\tcolor: #000000;
\t}

\t/* BookChapterTitle is in frontmatter 
\t   section, with TOCTitle */

.Epigraph { margin: 0pt 48pt 0pt 48pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: italic;
\ttext-align: left;
\tcolor: #000000;
\t}

.EpigraphAuthor { margin: 10pt 48pt 21pt 48pt;
\tfont-family: \"Times New Roman\", Times;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}

/* miscellaneous */

.PageBreak { page-break-before:always; }

/* Common Inline */

.RM  { font-style: normal; font-weight: normal }
.BF  { font-style: normal; font-weight: bold }
.IT  { font-style: italic; font-weight: normal }
.TR  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: normal }
.TI  { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: normal }
.TB  { font-family: \"Times New Roman\", Times; font-style: normal; \
font-weight: bold }
.TBI { font-family: \"Times New Roman\", Times; font-style: italic; \
font-weight: bold }
.MR  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MO  { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: normal }
.MB  { font-family: \"Courier New\", Courier; font-style: normal; \
font-weight: normal }
.MBO { font-family: \"Courier New\", Courier; font-style: italic; \
font-weight: bold }
.SR  { font-family: Helvetica, Arial; font-style: normal; font-weight: normal \
}
.SO  { font-family: Helvetica, Arial; font-style: italic; font-weight: normal \
}
.SB  { font-family: Helvetica, Arial; font-style: normal; font-weight: bold }
.SBO { font-family: Helvetica, Arial; font-style: italic; font-weight: bold }

/* conformance */

.Input { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: bold;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.Output { margin: 7pt 12pt 7pt 48pt;
\tfont-family: Courier New, Courier;
\tfont-size: 10pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #000000;
\t}
.CellLabel { margin: 7pt 2pt 2pt 24pt;
\tfont-family: Helvetica, Arial;
\tfont-size: 7pt;
\tfont-weight: normal;
\tfont-style: normal;
\ttext-align: left;
\tcolor: #0000ff;
\t}

</style>\
\>", "Text",
  CellTags->"CSSDefinitions"]
}, Closed]],

Cell[CellGroupData[{

Cell["TeX Configuration", "Section"],

Cell["\<\

\\documentclass{article}

\\usepackage{amssymb,amscd,amsmath,graphicx,verbatim}
\\usepackage[dvips]{hyperref}
\\usepackage[TS1,OT1,T1]{fontenc}
\
\>", "Text",
  ShowCellTags->True,
  CellTags->"TeXPreamble"]
}, Closed]],

Cell[CellGroupData[{

Cell["Style Environment Names", "Section"],

Cell[StyleData[All, "Screen"],
  PageWidth->WindowWidth,
  LineSpacing->{1, 3},
  ScriptMinSize->9],

Cell[StyleData[All, "NumberedHeads"],
  PageWidth->WindowWidth,
  LineSpacing->{1, 3},
  ScriptMinSize->9],

Cell[StyleData[All, "Presentation"],
  PageWidth->WindowWidth,
  ScrollingOptions->{"PagewiseDisplay"->True},
  ShowCellBracket->False,
  ShowGroupOpenCloseIcon->True,
  CellLabelMargins->{{24, Inherited}, {Inherited, Inherited}},
  ScriptMinSize->12],

Cell[StyleData[All, "Printout"],
  PageWidth->PaperWidth,
  ShowCellBracket->False,
  Hyphenation->True,
  LineSpacing->{1, 2},
  ScriptMinSize->5,
  PrivateFontOptions->{"FontType"->"Outline"}],

Cell[StyleData[All, "NumberedHeadsPrintout"],
  PageWidth->PaperWidth,
  ShowCellBracket->False,
  Hyphenation->True,
  LineSpacing->{1, 2},
  ScriptMinSize->5,
  PrivateFontOptions->{"FontType"->"Outline"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Notebook Options", "Section"],

Cell["\<\
The options defined for the style below will be used at the Notebook level.\
\>", "Text"],

Cell[StyleData["Notebook"],
  PageHeaders->{{Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"], None, Cell[ 
          TextData[ {
            OptionValueBox[ "FileName"]}], "Header"]}, {Cell[ 
          TextData[ {
            OptionValueBox[ "FileName"]}], "Header"], None, Cell[ 
          TextData[ {
            CounterBox[ "Page"]}], "PageNumber"]}},
  PrintingOptions->{"FirstPageHeader"->False,
  "FacingPages"->True},
  CellElementSpacings->{"ClosedCellHeight"->9},
  CellFrameLabelMargins->6,
  DefaultNewCellStyle->"Text",
  InputAutoReplacements->{"TeX"->FormBox[ 
          StyleBox[ 
            RowBox[ {"T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}], SingleLetterItalics -> False], TraditionalForm], 
      "LaTeX"->FormBox[ 
          StyleBox[ 
            RowBox[ {"L", 
              StyleBox[ 
                AdjustmentBox[ 
                "A", BoxMargins -> {{-0.5, -0.3}, {0, -0}}, 
                  BoxBaselineShift -> -0.4], FontSize -> Smaller], "T", 
              AdjustmentBox[ 
              "E", BoxMargins -> {{-0.3, 0}, {0, 0}}, BoxBaselineShift -> 
                0.5], "X"}], SingleLetterItalics -> False], TraditionalForm], 
      "mma"->"Mathematica", "Mma"->"Mathematica", "MMA"->"Mathematica", 
      "--"->"\[Dash]", "---"->"\[LongDash]", 
      " \""->" \[OpenCurlyDoubleQuote]", 
      "\"'"->"\[OpenCurlyDoubleQuote]\[OpenCurlyQuote]", 
      "'\""->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ".\""->".\[CloseCurlyDoubleQuote]", ",\""->",\[CloseCurlyDoubleQuote]", 
      "?\""->"?\[CloseCurlyDoubleQuote]", ";\""->";\[CloseCurlyDoubleQuote]", 
      ":\""->":\[CloseCurlyDoubleQuote]", "!\""->"!\[CloseCurlyDoubleQuote]", 
      " '"->" \[OpenCurlyQuote]", "',"->"\[CloseCurlyQuote],", 
      "'."->"\[CloseCurlyQuote].", "';"->"\[CloseCurlyQuote];", 
      "':"->"\[CloseCurlyQuote]:", "'!"->"\[CloseCurlyQuote]!", 
      ",\""->",\[CloseCurlyQuote]", ".'"->".\[CloseCurlyQuote]", 
      "?'"->"?\[CloseCurlyQuote]", ";'"->";\[CloseCurlyQuote]", 
      ":'"->":\[CloseCurlyQuote]", "!'"->"!\[CloseCurlyQuote]", 
      ". '"->". \[OpenCurlyQuote]", ", '"->", \[OpenCurlyQuote]", 
      "? '"->"? \[OpenCurlyQuote]", "; '"->"; \[OpenCurlyQuote]", 
      ": '"->": \[OpenCurlyQuote]", "! '"->"! \[OpenCurlyQuote]", 
      ", \""->", \[OpenCurlyDoubleQuote]", 
      ". \""->". \[OpenCurlyDoubleQuote]", 
      "? \""->"? \[OpenCurlyDoubleQuote]", 
      "; \""->"; \[OpenCurlyDoubleQuote]", 
      ": \""->": \[OpenCurlyDoubleQuote]", 
      "! \""->"! \[OpenCurlyDoubleQuote]", "\","->"\[CloseCurlyDoubleQuote],",
       "\"."->"\[CloseCurlyDoubleQuote].", "\";"->"\[CloseCurlyDoubleQuote];",
       "\":"->"\[CloseCurlyDoubleQuote]:", "\"!"->"\[CloseCurlyDoubleQuote]!",
       "'a "->"\[CloseCurlyQuote]a ", "'d "->"\[CloseCurlyQuote]d ", 
      "'l "->"\[CloseCurlyQuote]l ", "'ll "->"\[CloseCurlyQuote]ll ", 
      "'m "->"\[CloseCurlyQuote]m ", "'o "->"\[CloseCurlyQuote]o ", 
      "'ol "->"\[CloseCurlyQuote]ol ", "'Ol "->"\[CloseCurlyQuote]Ol ", 
      "'r "->"\[CloseCurlyQuote]r ", "'s "->"\[CloseCurlyQuote]s ", 
      "'t "->"\[CloseCurlyQuote]t ", "'ve "->"\[CloseCurlyQuote]ve ", 
      "'er "->"\[CloseCurlyQuote]er ", "'re "->"\[CloseCurlyQuote]re ", 
      "'y "->"\[CloseCurlyQuote]y ", "'z "->"\[CloseCurlyQuote]z ", 
      "'x "->"\[CloseCurlyQuote]x ", "\" "->"\[CloseCurlyDoubleQuote] ", 
      "\"\""->"\[OpenCurlyDoubleQuote]", "''"->"\[OpenCurlyQuote]", 
      "'tis "->"\[CloseCurlyQuote]tis ", "'ts "->"\[CloseCurlyQuote]ts ", 
      "' "->"\[CloseCurlyQuote] ", "'am "->"\[CloseCurlyQuote]am ", 
      ",'\" "->",\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ".'\""->".\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "?'\""->"?\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ";'\""->";\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      ":'\""->":\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "!'\""->"!\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]", 
      "'\","->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote],", 
      "'\"."->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote].", 
      "'\"?"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]?", 
      "'\";"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote];", 
      "'\":"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]:", 
      "'\"!"->"\[CloseCurlyQuote]\[CloseCurlyDoubleQuote]!"},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  SpanMaxSize->Infinity,
  SpanCharacterRounding->Round,
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Frontmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["FrontmatterGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["FrontmatterGroup", "NumberedHeads"]],

Cell[StyleData["FrontmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["FrontmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["FrontmatterGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell["Title", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Title"],
  CellMargins->{{12, 12}, {4, 36}},
  CellGroupingRules->{"TitleGrouping", 10},
  ConversionRules:>{"TeX" -> {"\n\\title{", "}"}},
  PageBreakBelow->False,
  LineSpacing->{1, 2},
  StyleMenuListing->None,
  FontSize->30,
  FontWeight->"Bold"],

Cell[StyleData["Title", "NumberedHeads"]],

Cell[StyleData["Title", "Presentation"],
  CellMargins->{{23, 12}, {6, 54}},
  FontSize->45],

Cell[StyleData["Title", "Printout"],
  CellMargins->{{2, 2}, {3, 30}},
  FontSize->24],

Cell[StyleData["Title", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 30}},
  FontSize->24]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subtitle"],
  CellMargins->{{12, 12}, {4, 6}},
  CellGroupingRules->{"TitleGrouping", 20},
  PageBreakBelow->False,
  LineSpacing->{1, 0},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->20,
  FontSlant->"Italic",
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Subtitle", "NumberedHeads"]],

Cell[StyleData["Subtitle", "Presentation"],
  CellMargins->{{23, 12}, {6, 9}},
  FontSize->30],

Cell[StyleData["Subtitle", "Printout"],
  CellMargins->{{2, 2}, {3, 5}},
  FontSize->16,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]],

Cell[StyleData["Subtitle", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 5}},
  FontSize->16,
  FontWeight->"Plain",
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubtitle"],
  CellMargins->{{12, 12}, {2, 6}},
  CellGroupingRules->{"TitleGrouping", 30},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->15,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Subsubtitle", "NumberedHeads"]],

Cell[StyleData["Subsubtitle", "Presentation"],
  CellMargins->{{23, 12}, {3, 9}},
  FontSize->23],

Cell[StyleData["Subsubtitle", "Printout"],
  CellMargins->{{2, 2}, {1, 5}},
  FontSize->13,
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsubtitle", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 5}},
  FontSize->13,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell["Title Inline Cells", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TitleLabel"],
  StyleMenuListing->None],

Cell[StyleData["TitleLabel", "NumberedHeads"]],

Cell[StyleData["TitleLabel", "Presentation"]],

Cell[StyleData["TitleLabel", "Printout"]],

Cell[StyleData["TitleLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubtitleLabel"],
  StyleMenuListing->None],

Cell[StyleData["SubtitleLabel", "NumberedHeads"]],

Cell[StyleData["SubtitleLabel", "Presentation"]],

Cell[StyleData["SubtitleLabel", "Printout"]],

Cell[StyleData["SubtitleLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubtitleLabel"],
  StyleMenuListing->None],

Cell[StyleData["SubsubtitleLabel", "NumberedHeads"]],

Cell[StyleData["SubsubtitleLabel", "Presentation"]],

Cell[StyleData["SubsubtitleLabel", "Printout"]],

Cell[StyleData["SubsubtitleLabel", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Copyrights", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["CopyrightLine"],
  StyleMenuListing->None],

Cell[StyleData["CopyrightLine", "NumberedHeads"]],

Cell[StyleData["CopyrightLine", "Presentation"]],

Cell[StyleData["CopyrightLine", "Printout"]],

Cell[StyleData["CopyrightLine", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CopyrightYear"],
  CellMargins->{{36, 10}, {0, 12}},
  CellGroupingRules->{"SectionGrouping", 20},
  ConversionRules:>{"HTML" -> {
    "<p class=\"CopyrightYear\"><span class=\"DkBlue\">Copyright:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Copyright: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["CopyrightYear", "NumberedHeads"]],

Cell[StyleData["CopyrightYear", "Presentation"],
  CellMargins->{{47, 10}, {0, 18}},
  FontSize->14],

Cell[StyleData["CopyrightYear", "Printout"],
  CellMargins->{{24, 2}, {0, 10}},
  FontSize->8],

Cell[StyleData["CopyrightYear", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 10}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CopyrightBy"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"CopyrightBy\"><span class=\"DkBlue\">...by:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "...by: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["CopyrightBy", "NumberedHeads"]],

Cell[StyleData["CopyrightBy", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["CopyrightBy", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["CopyrightBy", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Date", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["Day"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
  ButtonEvaluator->Automatic,
  ButtonData:>"Day",
  Active->True}],

Cell[StyleData["Month"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
  ButtonEvaluator->Automatic,
  ButtonData:>"Month",
  Active->True}],

Cell[StyleData["Year"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(EditDate[ #]&),
  ButtonEvaluator->Automatic,
  ButtonData:>"Year",
  Active->True}],

Cell[CellGroupData[{

Cell[StyleData["Date"],
  CellFrame->{{0, 0}, {0, 0.5}},
  CellMargins->{{36, 144}, {6, 0}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\\date{\\today}"}},
  CellFrameMargins->3,
  ParagraphSpacing->{0, 8},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Date", "NumberedHeads"]],

Cell[StyleData["Date", "Presentation"],
  CellMargins->{{47, 144}, {9, 0}},
  FontSize->14],

Cell[StyleData["Date", "Printout"],
  CellMargins->{{24, 120}, {5, 0}},
  LineSpacing->{1, 1},
  FontSize->7,
  FontColor->GrayLevel[0]],

Cell[StyleData["Date", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {5, 0}},
  LineSpacing->{1, 1},
  FontSize->7,
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Author", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Author"],
  CellMargins->{{36, 144}, {0, 24}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\author{", "}"}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Author", "NumberedHeads"]],

Cell[StyleData["Author", "Presentation"],
  CellMargins->{{47, 144}, {0, 36}},
  FontSize->18],

Cell[StyleData["Author", "Printout"],
  CellMargins->{{24, 120}, {0, 20}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["Author", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 20}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["AuthorData"],
  Selectable->False,
  ScriptMinSize->8,
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["AuthorGroup"],
  StyleMenuListing->None],

Cell[StyleData["AuthorGroup", "NumberedHeads"]],

Cell[StyleData["AuthorGroup", "Presentation"]],

Cell[StyleData["AuthorGroup", "Printout"]],

Cell[StyleData["AuthorGroup", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[StyleData["AuthorFirstName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorMiddleName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorLastName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorNameSuffix"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["AuthorAffiliation"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[CellGroupData[{

Cell[StyleData["AuthorTitle"],
  CellMargins->{{36, 144}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  SingleLetterItalics->False,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None",
  ButtonNote->ButtonData}],

Cell[StyleData["AuthorTitle", "NumberedHeads"]],

Cell[StyleData["AuthorTitle", "Presentation"],
  CellMargins->{{47, 144}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  FontSize->17],

Cell[StyleData["AuthorTitle", "Printout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AuthorTitle", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorEmail"],
  CellMargins->{{36, 144}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"HTML" -> {"<p class=\"AuthorEmail\"><a href=\"mailto:", 
    JoinWords[ 
      ExtractElement[ 1, 1, 1][ #], "\">", 
      ExtractElement[ 1, 1, 1][ #]]&, "</a></p>"}},
  SingleLetterItalics->False,
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  FontColor->RGBColor[0, 0, 1],
  ButtonBoxOptions->{ButtonFunction:>LinkToEmail[ ],
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None",
  ButtonNote->"Email link"}],

Cell[StyleData["AuthorEmail", "NumberedHeads"]],

Cell[StyleData["AuthorEmail", "Presentation"],
  CellMargins->{{47, 144}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  FontSize->17],

Cell[StyleData["AuthorEmail", "Printout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AuthorEmail", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorPhone"],
  StyleMenuListing->None],

Cell[StyleData["AuthorPhone", "NumberedHeads"]],

Cell[StyleData["AuthorPhone", "Presentation"]],

Cell[StyleData["AuthorPhone", "Printout"]],

Cell[StyleData["AuthorPhone", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorAddress"],
  CellMargins->{{12, 12}, {0, 3}},
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->GrayLevel[0.2]],

Cell[StyleData["AuthorAddress", "NumberedHeads"],
  CellMargins->{{12, 12}, {0, 3}},
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->GrayLevel[0.2]],

Cell[StyleData["AuthorAddress", "Presentation"],
  CellMargins->{{12, 12}, {0, 3}},
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->GrayLevel[0.2]],

Cell[StyleData["AuthorAddress", "Printout"],
  CellMargins->{{2, 2}, {0, 2}},
  FontSize->10],

Cell[StyleData["AuthorAddress", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 2}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorCurrentAddress"],
  StyleMenuListing->None],

Cell[StyleData["AuthorCurrentAddress", "NumberedHeads"]],

Cell[StyleData["AuthorCurrentAddress", "Presentation"]],

Cell[StyleData["AuthorCurrentAddress", "Printout"]],

Cell[StyleData["AuthorCurrentAddress", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorThanks"],
  StyleMenuListing->None],

Cell[StyleData["AuthorThanks", "NumberedHeads"]],

Cell[StyleData["AuthorThanks", "Presentation"]],

Cell[StyleData["AuthorThanks", "Printout"]],

Cell[StyleData["AuthorThanks", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorHomepage"],
  StyleMenuListing->None],

Cell[StyleData["AuthorHomepage", "NumberedHeads"]],

Cell[StyleData["AuthorHomepage", "Presentation"]],

Cell[StyleData["AuthorHomepage", "Printout"]],

Cell[StyleData["AuthorHomepage", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AuthorPACS"],
  StyleMenuListing->None],

Cell[StyleData["AuthorPACS", "NumberedHeads"]],

Cell[StyleData["AuthorPACS", "Presentation"]],

Cell[StyleData["AuthorPACS", "Printout"]],

Cell[StyleData["AuthorPACS", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Institution", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Institution"],
  CellMargins->{{36, 144}, {0, 0}},
  CellGroupingRules->"OutputGrouping",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Institution", "NumberedHeads"]],

Cell[StyleData["Institution", "Presentation"],
  CellMargins->{{47, 144}, {0, 0}},
  FontSize->17],

Cell[StyleData["Institution", "Printout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["Institution", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 0}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[StyleData["InstitutionNumber"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[StyleData["InstitutionName"],
  StyleMenuListing->None,
  ButtonBoxOptions->{ButtonFunction:>(FillInAuthorForm[ #]&),
  ButtonEvaluator->Automatic,
  Active->True}],

Cell[CellGroupData[{

Cell[StyleData["AltInstitution"],
  Editable->False,
  StyleMenuListing->None],

Cell[StyleData["AltInstitution", "NumberedHeads"]],

Cell[StyleData["AltInstitution", "Presentation"]],

Cell[StyleData["AltInstitution", "Printout"]],

Cell[StyleData["AltInstitution", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Abstract", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["AbstractSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{36, 144}, {0, 18}},
  CellGroupingRules->{"SectionGrouping", 30},
  CellFrameMargins->3,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold",
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["AbstractSection", "NumberedHeads"]],

Cell[StyleData["AbstractSection", "Presentation"],
  CellMargins->{{47, 144}, {0, 27}},
  FontSize->21],

Cell[StyleData["AbstractSection", "Printout"],
  CellMargins->{{24, 120}, {0, 16}},
  StyleMenuListing->None,
  FontSize->12,
  FontColor->GrayLevel[0]],

Cell[StyleData["AbstractSection", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 16}},
  StyleMenuListing->None,
  FontSize->12,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AbstractSubsection"],
  CellMargins->{{36, 144}, {0, 3}},
  CellGroupingRules->{"SectionGrouping", 40},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontSlant->"Italic",
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["AbstractSubsection", "NumberedHeads"]],

Cell[StyleData["AbstractSubsection", "Presentation"],
  CellMargins->{{47, 144}, {0, 5}},
  FontSize->18],

Cell[StyleData["AbstractSubsection", "Printout"],
  CellMargins->{{24, 120}, {0, 2}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AbstractSubsection", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {0, 2}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Abstract"],
  CellMargins->{{36, 144}, {4, 4}},
  TextAlignment->Left,
  TextJustification->0.5,
  LineSpacing->{1, 2},
  StyleMenuListing->None,
  FontSize->12,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["Abstract", "NumberedHeads"],
  StyleMenuListing->None],

Cell[StyleData["Abstract", "Presentation"],
  CellMargins->{{47, 144}, {5, 5}},
  StyleMenuListing->None,
  FontSize->18],

Cell[StyleData["Abstract", "Printout"],
  CellMargins->{{24, 120}, {2, 2}},
  StyleMenuListing->None,
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["Abstract", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {2, 2}},
  StyleMenuListing->None,
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AbstractContinuation"],
  CellMargins->{{36, 144}, {4, 4}},
  TextAlignment->Left,
  TextJustification->0.5,
  LineSpacing->{1, 2},
  StyleMenuListing->None,
  FontSize->12,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["AbstractContinuation", "NumberedHeads"],
  StyleMenuListing->None],

Cell[StyleData["AbstractContinuation", "Presentation"],
  CellMargins->{{47, 144}, {5, 5}},
  StyleMenuListing->None,
  FontSize->18],

Cell[StyleData["AbstractContinuation", "Printout"],
  CellMargins->{{24, 120}, {2, 2}},
  StyleMenuListing->None,
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AbstractContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {2, 2}},
  StyleMenuListing->None,
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AbstractMath"],
  CellMargins->{{36, 144}, {5, 5}},
  ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"AbstractMath\">", 
    "</p>"}}},
  CellHorizontalScrolling->True,
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  CounterIncrements->"Equation",
  StyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008]],

Cell[StyleData["AbstractMath", "NumberedHeads"]],

Cell[StyleData["AbstractMath", "Presentation"],
  CellMargins->{{47, 144}, {8, 8}},
  FontSize->19],

Cell[StyleData["AbstractMath", "Printout"],
  CellMargins->{{24, 120}, {4, 4}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["AbstractMath", "NumberedHeadsPrintout"],
  CellMargins->{{24, 120}, {4, 4}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Short Abstract", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["AbstractShortSection"],
  CellMargins->{{12, 12}, {2, 7}},
  CellGroupingRules->{"SectionGrouping", 30},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold"],

Cell[StyleData["AbstractShortSection", "NumberedHeads"]],

Cell[StyleData["AbstractShortSection", "Presentation"],
  CellMargins->{{23, 12}, {3, 11}},
  FontSize->18],

Cell[StyleData["AbstractShortSection", "Printout"],
  CellMargins->{{2, 2}, {1, 5}},
  FontSize->10],

Cell[StyleData["AbstractShortSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AbstractShort"],
  CellMargins->{{12, 12}, {4, 4}},
  StyleMenuListing->None],

Cell[StyleData["AbstractShort", "NumberedHeads"]],

Cell[StyleData["AbstractShort", "Presentation"],
  CellMargins->{{23, 12}, {6, 6}},
  FontSize->17],

Cell[StyleData["AbstractShort", "Printout"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->10],

Cell[StyleData["AbstractShort", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 3}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Cataloging Information", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["UniqueIdentifier"],
  StyleMenuListing->None],

Cell[StyleData["UniqueIdentifier", "NumberedHeads"]],

Cell[StyleData["UniqueIdentifier", "Presentation"]],

Cell[StyleData["UniqueIdentifier", "Printout"]],

Cell[StyleData["UniqueIdentifier", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DocumentLabel"],
  StyleMenuListing->None],

Cell[StyleData["DocumentLabel", "NumberedHeads"]],

Cell[StyleData["DocumentLabel", "Presentation"]],

Cell[StyleData["DocumentLabel", "Printout"]],

Cell[StyleData["DocumentLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Source"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"Source\"><span class=\"DkBlue\">Source:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "Source: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["Source", "NumberedHeads"]],

Cell[StyleData["Source", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["Source", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["Source", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ISSN"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"ISSN\"><span class=\"DkBlue\">ISSN:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "ISSN: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["ISSN", "NumberedHeads"]],

Cell[StyleData["ISSN", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["ISSN", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["ISSN", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Volume"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"Volume\"><span class=\"DkBlue\">Volume:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "Volume: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["Volume", "NumberedHeads"]],

Cell[StyleData["Volume", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["Volume", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["Volume", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Number"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"Number\"><span class=\"DkBlue\">Number:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "Issue: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["Number", "NumberedHeads"]],

Cell[StyleData["Number", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["Number", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["Number", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FirstPage"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"FirstPage\"><span class=\"DkBlue\">First page:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "First page: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["FirstPage", "NumberedHeads"]],

Cell[StyleData["FirstPage", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["FirstPage", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["FirstPage", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LastPage"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"LastPage\"><span class=\"DkBlue\">Last page:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Last page: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["LastPage", "NumberedHeads"]],

Cell[StyleData["LastPage", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["LastPage", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["LastPage", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["URL"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"URL\"><span class=\"DkBlue\">URL:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "URL: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["URL", "NumberedHeads"]],

Cell[StyleData["URL", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["URL", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["URL", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DateReceived"],
  CellMargins->{{36, 10}, {0, 12}},
  CellGroupingRules->{"SectionGrouping", 20},
  ConversionRules:>{"HTML" -> {
    "<p class=\"DateReceived\"><span class=\"DkBlue\">Received:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Received: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DateReceived", "NumberedHeads"],
  CellMargins->{{54, 10}, {0, 12}},
  CellGroupingRules->{"SectionGrouping", 20},
  ConversionRules:>{"HTML" -> {"<p class=\"DateReceived\">Received: ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Received: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DateReceived", "Presentation"],
  CellMargins->{{47, 10}, {0, 18}},
  FontSize->14],

Cell[StyleData["DateReceived", "Printout"],
  CellMargins->{{24, 2}, {0, 10}},
  FontSize->8],

Cell[StyleData["DateReceived", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 10}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DateRevisionRequested"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"DateRevisionRequested\"><span class=\"DkBlue\">Revisions \
requested:</span> ", "</p>"}},
  CellFrameLabels->{{
    Cell[ "Revisions requested: ", FontColor -> RGBColor[ .2, .3, .5]], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DateRevisionRequested", "NumberedHeads"]],

Cell[StyleData["DateRevisionRequested", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["DateRevisionRequested", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["DateRevisionRequested", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DateRevisionReceived"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"DateRevisionReceived\"><span class=\"DkBlue\">Revised:</span> \
", "</p>"}},
  CellFrameLabels->{{
    Cell[ "Revised: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DateRevisionReceived", "NumberedHeads"]],

Cell[StyleData["DateRevisionReceived", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["DateRevisionReceived", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["DateRevisionReceived", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DateAccepted"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"DateAccepted\"><span class=\"DkBlue\">Accepted:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Accepted: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DateAccepted", "NumberedHeads"]],

Cell[StyleData["DateAccepted", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["DateAccepted", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["DateAccepted", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DatePublished"],
  CellMargins->{{36, 10}, {0, 0}},
  ConversionRules:>{"HTML" -> {
    "<p class=\"DatePublished\"><span class=\"DkBlue\">Published:</span> ", 
    "</p>"}},
  CellFrameLabels->{{
    Cell[ "Published: ", FontColor -> RGBColor[ .2, .3, .5]], Inherited}, {
      Inherited, Inherited}},
  CellFrameLabelMargins->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["DatePublished", "NumberedHeads"]],

Cell[StyleData["DatePublished", "Presentation"],
  CellMargins->{{47, 10}, {0, 0}},
  FontSize->14],

Cell[StyleData["DatePublished", "Printout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8],

Cell[StyleData["DatePublished", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {0, 0}},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubjectClassification"],
  StyleMenuListing->None],

Cell[StyleData["SubjectClassification", "NumberedHeads"]],

Cell[StyleData["SubjectClassification", "Presentation"]],

Cell[StyleData["SubjectClassification", "Printout"]],

Cell[StyleData["SubjectClassification", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["KeywordGroup"],
  StyleMenuListing->None],

Cell[StyleData["KeywordGroup", "NumberedHeads"]],

Cell[StyleData["KeywordGroup", "Presentation"]],

Cell[StyleData["KeywordGroup", "Printout"]],

Cell[StyleData["KeywordGroup", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Keywords"],
  StyleMenuListing->None],

Cell[StyleData["Keywords", "NumberedHeads"]],

Cell[StyleData["Keywords", "Presentation"]],

Cell[StyleData["Keywords", "Printout"]],

Cell[StyleData["Keywords", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PreprintID"],
  StyleMenuListing->None],

Cell[StyleData["PreprintID", "NumberedHeads"]],

Cell[StyleData["PreprintID", "Presentation"]],

Cell[StyleData["PreprintID", "Printout"]],

Cell[StyleData["PreprintID", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Dedication", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Dedication"],
  CellMargins->{{12, 12}, {3, 5}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Dedication", "NumberedHeads"]],

Cell[StyleData["Dedication", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["Dedication", "Printout"],
  CellMargins->{{2, 2}, {1, 4}},
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["Dedication", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 4}},
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Table of Contents", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell["Article", "Subsubsection"],

Cell[CellGroupData[{

Cell["Title Headings", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCHeading"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  LineSpacing->{1, 2},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["TOCHeading", "NumberedHeads"]],

Cell[StyleData["TOCHeading", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14],

Cell[StyleData["TOCHeading", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCIllustrations"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  LineSpacing->{1, 2},
  CounterAssignments->{{"TOCItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["TOCIllustrations", "NumberedHeads"]],

Cell[StyleData["TOCIllustrations", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14],

Cell[StyleData["TOCIllustrations", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTables"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  LineSpacing->{1, 2},
  CounterAssignments->{{"TOCItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["TOCTables", "NumberedHeads"]],

Cell[StyleData["TOCTables", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14],

Cell[StyleData["TOCTables", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Contents Headings", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCFrontmatterHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCFrontmatterHeading", "NumberedHeads"]],

Cell[StyleData["TOCFrontmatterHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCFrontmatterHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBackmatterHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCBackmatterHeading", "NumberedHeads"]],

Cell[StyleData["TOCBackmatterHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCBackmatterHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCFrontBackHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCFrontBackHeading", "NumberedHeads"]],

Cell[StyleData["TOCFrontBackHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCFrontBackHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSection"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCSection"]}], "TOCSectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->54,
  CounterIncrements->"TOCSection",
  CounterAssignments->{{"TOCSubsection", 0}},
  StyleMenuListing->None,
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCSection", "NumberedHeads"]],

Cell[StyleData["TOCSection", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsection"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 50},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCSection"], ".", 
            CounterBox[ "TOCSubsection"]}], "TOCSubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->49.87,
  CounterIncrements->"TOCSubsection",
  CounterAssignments->{{"TOCSubsubsection", 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCSubsection", "NumberedHeads"]],

Cell[StyleData["TOCSubsection", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->55.8,
  FontSize->10],

Cell[StyleData["TOCSubsection", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->55.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsection"],
  CellMargins->{{60, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 60},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCSection"], ".", 
            CounterBox[ "TOCSubsection"], ".", 
            CounterBox[ "TOCSubsubsection"]}], "TOCSubsubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->45.8,
  CounterIncrements->"TOCSubsubsection",
  StyleMenuListing->None],

Cell[StyleData["TOCSubsubsection", "NumberedHeads"]],

Cell[StyleData["TOCSubsubsection", "Printout"],
  CellMargins->{{48, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->50.7,
  FontSize->10],

Cell[StyleData["TOCSubsubsection", "NumberedHeadsPrintout"],
  CellMargins->{{48, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->50.7,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCFigure"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Fig. ", 
            CounterBox[ "TOCFigure"], "."}], "TOCFigureLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCFigure",
  StyleMenuListing->None],

Cell[StyleData["TOCFigure", "NumberedHeads"]],

Cell[StyleData["TOCFigure", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCFigure", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSupplemental"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Supp. ", 
            CounterBox[ "TOCSupplemental"], "."}], "TOCSupplementalLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCSupplemental",
  StyleMenuListing->None],

Cell[StyleData["TOCSupplemental", "NumberedHeads"]],

Cell[StyleData["TOCSupplemental", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCSupplemental", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPicture"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Pict. ", 
            CounterBox[ "TOCPicture"], "."}], "TOCPictureLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCPicture",
  StyleMenuListing->None],

Cell[StyleData["TOCPicture", "NumberedHeads"]],

Cell[StyleData["TOCPicture", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCPicture", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCIllustration"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Illus. ", 
            CounterBox[ "TOCIllustration"], "."}], "TOCIllustrationLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCIllustration",
  StyleMenuListing->None],

Cell[StyleData["TOCIllustration", "NumberedHeads"]],

Cell[StyleData["TOCIllustration", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCIllustration", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCProgram"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Pgm. ", 
            CounterBox[ "TOCProgram"], "."}], "TOCProgramLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCProgram",
  StyleMenuListing->None],

Cell[StyleData["TOCProgram", "NumberedHeads"]],

Cell[StyleData["TOCProgram", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCProgram", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTable"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Table ", 
            CounterBox[ "TOCTable"], "."}], "TOCTableLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->50.2,
  CounterIncrements->"TOCTable",
  StyleMenuListing->None],

Cell[StyleData["TOCTable", "NumberedHeads"]],

Cell[StyleData["TOCTable", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10],

Cell[StyleData["TOCTable", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->56.3,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCItem"],
  CellMargins->{{36, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCItem"]}], "TOCItemLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->51.4,
  CounterIncrements->"TOCItem",
  StyleMenuListing->None],

Cell[StyleData["TOCItem", "NumberedHeads"]],

Cell[StyleData["TOCItem", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  TabSpacings->57.1,
  FontSize->10],

Cell[StyleData["TOCItem", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  TabSpacings->57.1,
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Labels and misc", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCSpacer"],
  CellMargins->{{12, 12}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCSpacer", "NumberedHeads"],
  CellMargins->{{12, 12}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCSpacer", "Printout"],
  CellMargins->{{2, 2}, {0, 0}}],

Cell[StyleData["TOCSpacer", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCSectionLabel", "NumberedHeads"]],

Cell[StyleData["TOCSectionLabel", "Printout"],
  CellSize->{14, Inherited}],

Cell[StyleData["TOCSectionLabel", "NumberedHeadsPrintout"],
  CellSize->{14, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{32, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCSubsectionLabel", "NumberedHeads"]],

Cell[StyleData["TOCSubsectionLabel", "Printout"],
  CellSize->{24, Inherited}],

Cell[StyleData["TOCSubsectionLabel", "NumberedHeadsPrintout"],
  CellSize->{24, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSubsubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{44, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCSubsubsectionLabel", "NumberedHeads"]],

Cell[StyleData["TOCSubsubsectionLabel", "Printout"],
  CellSize->{38, Inherited}],

Cell[StyleData["TOCSubsubsectionLabel", "NumberedHeadsPrintout"],
  CellSize->{38, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCFigureLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCFigureLabel", "NumberedHeads"]],

Cell[StyleData["TOCFigureLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCFigureLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCSupplementalLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCSupplementalLabel", "NumberedHeads"]],

Cell[StyleData["TOCSupplementalLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCSupplementalLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPictureLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCPictureLabel", "NumberedHeads"]],

Cell[StyleData["TOCPictureLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCPictureLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCIllustrationLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCIllustrationLabel", "NumberedHeads"]],

Cell[StyleData["TOCIllustrationLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCIllustrationLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCProgramLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCProgramLabel", "NumberedHeads"]],

Cell[StyleData["TOCProgramLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCProgramLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCTableLabel"],
  CellSize->{53, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCTableLabel", "NumberedHeads"]],

Cell[StyleData["TOCTableLabel", "Printout"],
  CellSize->{42, Inherited}],

Cell[StyleData["TOCTableLabel", "NumberedHeadsPrintout"],
  CellSize->{42, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCItemNumber"],
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCItemNumber", "NumberedHeads"]],

Cell[StyleData["TOCItemNumber", "Printout"],
  CellSize->{14, Inherited}],

Cell[StyleData["TOCItemNumber", "NumberedHeadsPrintout"],
  CellSize->{14, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCItemLabel"],
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCItemLabel", "NumberedHeads"]],

Cell[StyleData["TOCItemLabel", "Printout"],
  CellSize->{14, Inherited}],

Cell[StyleData["TOCItemLabel", "NumberedHeadsPrintout"],
  CellSize->{14, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCLeader"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  TabFilling->". ",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontWeight->"Plain"],

Cell[StyleData["TOCLeader", "NumberedHeads"]],

Cell[StyleData["TOCLeader", "Printout"],
  FontSize->10],

Cell[StyleData["TOCLeader", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCPageNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["TOCPageNumber", "NumberedHeads"]],

Cell[StyleData["TOCPageNumber", "Printout"],
  CellSize->{21, Inherited}],

Cell[StyleData["TOCPageNumber", "NumberedHeadsPrintout"],
  CellSize->{21, Inherited}]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book", "Subsubsection"],

Cell[CellGroupData[{

Cell["Title Headings", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCBookHeading"],
  CellMargins->{{12, 12}, {24, 36}},
  CellGroupingRules->{"SectionGrouping", 20},
  PageBreakBelow->False,
  LineSpacing->{1, 2},
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookHeading", "NumberedHeads"]],

Cell[StyleData["TOCHeading", "Printout"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21],

Cell[StyleData["TOCBookHeading", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookIllustrations"],
  CellMargins->{{12, 12}, {24, 36}},
  CellGroupingRules->{"SectionGrouping", 20},
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookIllustrations", "NumberedHeads"]],

Cell[StyleData["TOCIllustrations", "Printout"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21],

Cell[RawData["\<\
Cell[StyleData[\"TOCBookIllustrations\", \"NumberedHeadsPrintout\"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21]\
\>"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookTables"],
  CellMargins->{{12, 12}, {24, 36}},
  CellGroupingRules->{"SectionGrouping", 20},
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookTables", "NumberedHeads"]],

Cell[StyleData["TOCBookTables", "Printout"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21],

Cell[StyleData["TOCBookTables", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {21, 30}},
  FontSize->21]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Contents Headings", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCBookFrontmatterHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  CounterIncrements->"TOCBookFrontmatterHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookFrontmatterHeading", "NumberedHeads"]],

Cell[StyleData["TOCBookFrontmatterHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCBookFrontmatterHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookBackmatterHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  CounterIncrements->"TOCBookBackmatterHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookBackmatterHeading", "NumberedHeads"]],

Cell[StyleData["TOCBookBackmatterHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCBookBackmatterHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookFrontBackHeading"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  TabSpacings->54,
  CounterIncrements->"TOCBookFrontBackHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookFrontBackHeading", "NumberedHeads"]],

Cell[StyleData["TOCBookFrontBackHeading", "Printout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCBookFrontBackHeading", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 0}},
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookPartTitle"],
  CellMargins->{{36, 12}, {1, 12}},
  CellGroupingRules->{"SectionGrouping", 30},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Part ", 
            CounterBox[ "TOCBookPartTitle"]}], "TOCBookPartTitleLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"TOCBookPartTitle",
  CounterAssignments->{{"TOCBookChapterTitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookPartTitle", "NumberedHeads"]],

Cell[StyleData["TOCBookPartTitle", "Printout"],
  CellMargins->{{22, 2}, {0, 10}},
  FontSize->14],

Cell[StyleData["TOCBookPartTitle", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {0, 10}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookChapterTitle"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 40},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCBookChapterTitle"]}], "TOCBookChapterTitleLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->54,
  CounterIncrements->"TOCBookChapterTitle",
  CounterAssignments->{{"TOCBookSection", 0}},
  StyleMenuListing->None,
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["TOCBookChapterTitle", "NumberedHeads"]],

Cell[StyleData["TOCBookChapterTitle", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->60,
  FontSize->12],

Cell[StyleData["TOCBookChapterTitle", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->60,
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSection"],
  CellMargins->{{36, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 50},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCBookChapterTitle"], ".", 
            CounterBox[ "TOCBookSection"]}], "TOCBookSectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->49.87,
  CounterIncrements->"TOCBookSection",
  CounterAssignments->{{"TOCBookSubsection", 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCBookSection", "NumberedHeads"]],

Cell[StyleData["TOCBookSection", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->55.8,
  FontSize->10],

Cell[StyleData["TOCBookSection", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->55.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSubsection"],
  CellMargins->{{60, 12}, {1, 1}},
  CellGroupingRules->{"SectionGrouping", 60},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCBookChapterTitle"], ".", 
            CounterBox[ "TOCBookSection"], ".", 
            CounterBox[ "TOCBookSubsection"]}], "TOCBookSubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->45.8,
  CounterIncrements->"TOCBookSubsection",
  StyleMenuListing->None],

Cell[StyleData["TOCBookSubsection", "NumberedHeads"]],

Cell[StyleData["TOCBookSubsection", "Printout"],
  CellMargins->{{48, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->50.7,
  FontSize->10],

Cell[StyleData["TOCBookSubsection", "NumberedHeadsPrintout"],
  CellMargins->{{48, 2}, {1, 1}},
  PageBreakBelow->False,
  TabSpacings->50.7,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookFigure"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Fig. ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookFigure"], "."}], "TOCBookFigureLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookFigure",
  StyleMenuListing->None],

Cell[StyleData["TOCBookFigure", "NumberedHeads"]],

Cell[StyleData["TOCBookFigure", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookFigure", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSupplemental"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Supp. ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookSupplemental"], "."}], 
          "TOCBookSupplementalLabel", CellBaseline -> Baseline], Inherited}, {
      Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookSupplemental",
  StyleMenuListing->None],

Cell[StyleData["TOCBookSupplemental", "NumberedHeads"]],

Cell[StyleData["TOCBookSupplemental", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookSupplemental", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookPicture"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Pict. ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookPicture"], "."}], "TOCBookPictureLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookPicture",
  StyleMenuListing->None],

Cell[StyleData["TOCBookPicture", "NumberedHeads"]],

Cell[StyleData["TOCBookPicture", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookPicture", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookIllustration"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Illus. ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookIllustration"], "."}], 
          "TOCBookIllustrationLabel", CellBaseline -> Baseline], Inherited}, {
      Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookIllustration",
  StyleMenuListing->None],

Cell[StyleData["TOCBookIllustration", "NumberedHeads"]],

Cell[StyleData["TOCBookIllustration", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookIllustration", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookProgram"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Pgm. ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookProgram"], "."}], "TOCBookProgramLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookProgram",
  StyleMenuListing->None],

Cell[StyleData["TOCBookProgram", "NumberedHeads"]],

Cell[StyleData["TOCBookProgram", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookProgram", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookTable"],
  CellMargins->{{12, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"Table ", 
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookTable"], "."}], "TOCBookTableLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->48.5,
  CounterIncrements->"TOCBookTable",
  StyleMenuListing->None],

Cell[StyleData["TOCBookTable", "NumberedHeads"]],

Cell[StyleData["TOCBookTable", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10],

Cell[StyleData["TOCBookTable", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TabSpacings->54.8,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookItem"],
  CellMargins->{{36, 12}, {1, 1}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "TOCBookFrontBackHeading"], ".", 
            CounterBox[ "TOCBookItem"], "."}], "TOCBookItemLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TabSpacings->49.8,
  CounterIncrements->"TOCBookItem",
  StyleMenuListing->None],

Cell[StyleData["TOCBookItem", "NumberedHeads"]],

Cell[StyleData["TOCBookItem", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  TabSpacings->55.75,
  FontSize->10],

Cell[StyleData["TOCBookItem", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  TabSpacings->55.75,
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Labels and misc", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSpacer"],
  CellMargins->{{12, 12}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCBookSpacer", "NumberedHeads"],
  CellMargins->{{12, 12}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["TOCBookSpacer", "Printout"],
  CellMargins->{{2, 2}, {0, 0}}],

Cell[StyleData["TOCBookSpacer", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookPartTitleLabel"],
  CellSize->{42, Inherited},
  StyleMenuListing->None],

Cell[StyleData["TOCBookPartTitleLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookPartTitleLabel", "Printout"],
  CellSize->{38, Inherited}],

Cell[StyleData["TOCBookPartTitleLabel", "NumberedHeadsPrintout"],
  CellSize->{38, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookChapterTitleLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookChapterTitleLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookChapterTitleLabel", "Printout"],
  CellSize->{14, Inherited}],

Cell[StyleData["TOCBookChapterTitleLabel", "NumberedHeadsPrintout"],
  CellSize->{14, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{32, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookSectionLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookSectionLabel", "Printout"],
  CellSize->{24, Inherited}],

Cell[StyleData["TOCBookSectionLabel", "NumberedHeadsPrintout"],
  CellSize->{24, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{44, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookSubsectionLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookSubsectionLabel", "Printout"],
  CellSize->{38, Inherited}],

Cell[StyleData["TOCBookSubsectionLabel", "NumberedHeadsPrintout"],
  CellSize->{38, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookFigureLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookFigureLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookFigureLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookFigureLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookSupplementalLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookSupplementalLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookSupplementalLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookSupplementalLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookPictureLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookPictureLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookPictureLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookPictureLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookIllustrationLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookIllustrationLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookIllustrationLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookIllustrationLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookProgramLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookProgramLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookProgramLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookProgramLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookTableLabel"],
  CellSize->{68, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookTableLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookTableLabel", "Printout"],
  CellSize->{53, Inherited}],

Cell[StyleData["TOCBookTableLabel", "NumberedHeadsPrintout"],
  CellSize->{53, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookItemNumber"],
  CellSize->{32, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookItemNumber", "NumberedHeads"]],

Cell[StyleData["TOCBookItemNumber", "Printout"],
  CellSize->{24, Inherited}],

Cell[StyleData["TOCBookItemNumber", "NumberedHeadsPrintout"],
  CellSize->{24, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookItemLabel"],
  CellSize->{32, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["TOCBookItemLabel", "NumberedHeads"]],

Cell[StyleData["TOCBookItemLabel", "Printout"],
  CellSize->{24, Inherited}],

Cell[StyleData["TOCBookItemLabel", "NumberedHeadsPrintout"],
  CellSize->{24, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookLeader"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  TabFilling->". ",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontWeight->"Plain"],

Cell[StyleData["TOCBookLeader", "NumberedHeads"]],

Cell[StyleData["TOCBookLeader", "Printout"],
  FontSize->10],

Cell[StyleData["TOCBookLeader", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TOCBookPageNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], "\n\n"}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["TOCBookPageNumber", "NumberedHeads"]],

Cell[StyleData["TOCBookPageNumber", "Printout"],
  CellSize->{21, Inherited}],

Cell[StyleData["TOCBookPageNumber", "NumberedHeadsPrintout"],
  CellSize->{21, Inherited}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["List of Abbreviations", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["LOASection"],
  CellMargins->{{12, 12}, {24, 36}},
  CellGroupingRules->{"SectionGrouping", 20},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["LOASection", "NumberedHeads"]],

Cell[StyleData["LOASection", "Printout"],
  CellMargins->{{2, 2}, {21, 30}},
  StyleMenuListing->None,
  FontSize->21],

Cell[StyleData["LOASection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {21, 30}},
  StyleMenuListing->None,
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LOAItem"],
  CellMargins->{{12, 12}, {4, 4}},
  CounterIncrements->"LOAItem",
  StyleMenuListing->None,
  FontFamily->"Helvetica"],

Cell[StyleData["LOAItem", "NumberedHeads"]],

Cell[StyleData["LOAItem", "Printout"],
  CellMargins->{{2, 2}, {3, 3}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["LOAItem", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 3}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LOAAbbreviation"],
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold"],

Cell[StyleData["LOAAbbreviation", "NumberedHeads"]],

Cell[StyleData["LOAAbbreviation", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["LOAAbbreviation", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LOADefinition"],
  StyleMenuListing->None,
  FontFamily->"Helvetica"],

Cell[StyleData["LOADefinition", "NumberedHeads"]],

Cell[StyleData["LOADefinition", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["LOADefinition", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LOAItemNumber"],
  StyleMenuListing->None],

Cell[StyleData["LOAItemNumber", "NumberedHeads"]],

Cell[StyleData["LOAItemNumber", "Printout"]],

Cell[StyleData["LOAItemNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LOAItemLabel"],
  StyleMenuListing->None],

Cell[StyleData["LOAItemLabel", "NumberedHeads"]],

Cell[StyleData["LOAItemLabel", "Printout"]],

Cell[StyleData["LOAItemLabel", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Thesis Title Page", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["TitleGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["TitleGroup", "NumberedHeads"]],

Cell[StyleData["TitleGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["TitleGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CopyrightGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 5},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["CopyrightGroup", "NumberedHeads"]],

Cell[StyleData["CopyrightGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["CopyrightGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PhDThesisTitle"],
  StyleMenuListing->None],

Cell[StyleData["PhDThesisTitle", "NumberedHeads"]],

Cell[StyleData["PhDThesisTitle", "Printout"]],

Cell[StyleData["PhDThesisTitle", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MSThesisTitle"],
  StyleMenuListing->None],

Cell[StyleData["MSThesisTitle", "NumberedHeads"]],

Cell[StyleData["MSThesisTitle", "Printout"]],

Cell[StyleData["MSThesisTitle", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisSchools"],
  StyleMenuListing->None],

Cell[StyleData["ThesisSchools", "NumberedHeads"]],

Cell[StyleData["ThesisSchools", "Printout"]],

Cell[StyleData["ThesisSchools", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisAuthorField"],
  StyleMenuListing->None],

Cell[StyleData["ThesisAuthorField", "NumberedHeads"]],

Cell[StyleData["ThesisAuthorField", "Printout"]],

Cell[StyleData["ThesisAuthorField", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisDepartmentField"],
  StyleMenuListing->None],

Cell[StyleData["ThesisDepartmentField", "NumberedHeads"]],

Cell[StyleData["ThesisDepartmentField", "Printout"]],

Cell[StyleData["ThesisDepartmentField", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisCollegeField"],
  StyleMenuListing->None],

Cell[StyleData["ThesisCollegeField", "NumberedHeads"]],

Cell[StyleData["ThesisCollegeField", "Printout"]],

Cell[StyleData["ThesisCollegeField", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisDegreeYearFieldNoExport"],
  StyleMenuListing->None],

Cell[StyleData["ThesisDegreeYearFieldNoExport", "NumberedHeads"]],

Cell[StyleData["ThesisDegreeYearFieldNoExport", "Printout"]],

Cell[StyleData["ThesisDegreeYearFieldNoExport", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisDegreeYearField"],
  StyleMenuListing->None],

Cell[StyleData["ThesisDegreeYearField", "NumberedHeads"]],

Cell[StyleData["ThesisDegreeYearField", "Printout"]],

Cell[StyleData["ThesisDegreeYearField", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisAbbreviation"],
  StyleMenuListing->None],

Cell[StyleData["ThesisAbbreviation", "NumberedHeads"]],

Cell[StyleData["ThesisAbbreviation", "Printout"]],

Cell[StyleData["ThesisAbbreviation", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThesisAbbreviationDescription"],
  StyleMenuListing->None],

Cell[StyleData["ThesisAbbreviationDescription", "NumberedHeads"]],

Cell[StyleData["ThesisAbbreviationDescription", "Printout"]],

Cell[StyleData["ThesisAbbreviationDescription", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mainmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["MainmatterGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 1},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["MainmatterGroup", "NumberedHeads"]],

Cell[StyleData["MainmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["MainmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["MainmatterGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Section"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\n\\section{", "}"}, "HTML" -> {
    "<h3 class=\"Section\">", "</h3>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "Cell", 
    "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  TabSpacings->2.1,
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Subsubsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["Section", "NumberedHeads"],
  CellFrame->False,
  CellFrameLabels->{{Cell[ 
          TextData[ 
            CounterBox[ "Section"], "."], "SectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Section", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["Section", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14,
  FontColor->GrayLevel[0]],

Cell[StyleData["Section", "NumberedHeadsPrintout"],
  CellFrame->False,
  CellMargins->{{2, 2}, {3, 18}},
  CellFrameLabels->{{Cell[ 
          TextData[ 
            CounterBox[ "Section"], "."], "SectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  FontSize->14,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsection"],
  CellDingbat->None,
  CellMargins->{{12, 12}, {3, 16}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 40},
  ConversionRules:>{"TeX" -> {"\n\n\\subsection{", "}"}, "HTML" -> {
    "<h4 class=\"Subsection\">", "</h4>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection"}, "CounterTarget" -> "Cell", "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CellFrameLabelMargins->6,
  TabSpacings->1.7,
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["Subsection", "NumberedHeads"],
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"], "."}], "SubsectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Subsection", "Presentation"],
  CellMargins->{{23, 12}, {5, 24}},
  FontSize->21],

Cell[StyleData["Subsection", "Printout"],
  CellMargins->{{2, 2}, {2, 14}},
  FontSize->12,
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 14}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"], "."}], "SubsectionLabel", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  FontSize->12,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsection"],
  CellMargins->{{12, 12}, {3, 9}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 50},
  ConversionRules:>{"TeX" -> {"\n\n\\subsubsection{", "}"}, "HTML" -> {
    "<h5 class=\"Subsubsection\">", "</h5>"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection", ".", "Subsubsection"}, "CounterTarget" -> "Cell", 
    "XRefPrefix" -> "Section"}},
  PageBreakBelow->False,
  CounterIncrements->"Subsubsection",
  CounterAssignments->{{"Subsubsubsection", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0.200015],
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Subsubsection", "NumberedHeads"],
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"], ".", 
            CounterBox[ "Subsubsection"], "."}], "SubsubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}}],

Cell[StyleData["Subsubsection", "Presentation"],
  CellMargins->{{23, 12}, {5, 14}},
  FontSize->18],

Cell[StyleData["Subsubsection", "Printout"],
  CellMargins->{{2, 2}, {2, 7}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsubsection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 7}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Section"], ".", 
            CounterBox[ "Subsection"], ".", 
            CounterBox[ "Subsubsection"], "."}], "SubsubsectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Subsubsubsection"],
  CellMargins->{{12, 12}, {3, 6}},
  CellGroupingRules->{"SectionGrouping", 60},
  ConversionRules:>{{"TeX" -> {"\n\n\\paragraph{", "}"}}, {"HTML" -> {
    "<h6 class=\"Subsubsubsection\">", "</h6>"}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Subsection", ".", "Subsubsection", ".", "Subsubsubsection"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Section"}},
  CounterIncrements->"Subsubsubsection",
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0.300008]],

Cell[StyleData["Subsubsubsection", "NumberedHeads"]],

Cell[StyleData["Subsubsubsection", "Presentation"],
  CellMargins->{{23, 12}, {5, 9}},
  FontSize->18],

Cell[StyleData["Subsubsubsection", "Printout"],
  CellMargins->{{2, 2}, {2, 5}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["Subsubsubsection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 5}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell["Section Heading Inline Cells", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["SectionLabel", "NumberedHeads"]],

Cell[StyleData["SectionLabel", "Presentation"]],

Cell[StyleData["SectionLabel", "Printout"]],

Cell[StyleData["SectionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TextAlignment->Left,
  StyleMenuListing->None],

Cell[StyleData["SubsectionLabel", "NumberedHeads"]],

Cell[StyleData["SubsectionLabel", "Presentation"]],

Cell[StyleData["SubsectionLabel", "Printout"]],

Cell[StyleData["SubsectionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SubsubsectionLabel", "NumberedHeads"]],

Cell[StyleData["SubsubsectionLabel", "Presentation"]],

Cell[StyleData["SubsubsectionLabel", "Printout"]],

Cell[StyleData["SubsubsectionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SubsubsubsectionLabel", "NumberedHeads"]],

Cell[StyleData["SubsubsubsectionLabel", "Presentation"]],

Cell[StyleData["SubsubsubsectionLabel", "Printout"]],

Cell[StyleData["SubsubsubsectionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SectionNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SectionNumber", "NumberedHeads"]],

Cell[StyleData["SectionNumber", "Presentation"]],

Cell[StyleData["SectionNumber", "Printout"]],

Cell[StyleData["SectionNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SubsectionNumber", "NumberedHeads"]],

Cell[StyleData["SubsectionNumber", "Presentation"]],

Cell[StyleData["SubsectionNumber", "Printout"]],

Cell[StyleData["SubsectionNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SubsubsectionNumber", "NumberedHeads"]],

Cell[StyleData["SubsubsectionNumber", "Presentation"]],

Cell[StyleData["SubsubsectionNumber", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["SubsubsectionNumber", "NumberedHeadsPrintout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["SubsubsubsectionNumber", "NumberedHeads"]],

Cell[StyleData["SubsubsubsectionNumber", "Presentation"]],

Cell[StyleData["SubsubsubsectionNumber", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["SubsubsubsectionNumber", "NumberedHeadsPrintout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionText"],
  StyleMenuListing->None],

Cell[StyleData["SubsectionText", "NumberedHeads"]],

Cell[StyleData["SubsectionText", "Presentation"],
  CellMargins->{{23, 10}, {2, 6}},
  FontSize->17],

Cell[StyleData["SubsectionText", "Printout"],
  CellMargins->{{2, 2}, {1, 3}},
  FontSize->10],

Cell[StyleData["SubsectionText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 3}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionText"],
  StyleMenuListing->None],

Cell[StyleData["SubsubsectionText", "NumberedHeads"]],

Cell[StyleData["SubsubsectionText", "Presentation"],
  CellMargins->{{23, 10}, {2, 6}},
  FontSize->17],

Cell[StyleData["SubsubsectionText", "Printout"],
  CellMargins->{{2, 2}, {1, 2}},
  FontSize->10],

Cell[StyleData["SubsubsectionText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 2}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionText"],
  StyleMenuListing->None],

Cell[StyleData["SubsubsubsectionText", "NumberedHeads"]],

Cell[StyleData["SubsubsubsectionText", "Presentation"],
  CellMargins->{{23, 10}, {2, 6}},
  FontSize->17],

Cell[StyleData["SubsubsubsectionText", "Printout"],
  CellMargins->{{2, 2}, {1, 2}},
  FontSize->10],

Cell[StyleData["SubsubsubsectionText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 2}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Alternate Headings", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SectionAlt"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\n\\section*{", "}"}, "HTML" -> {
    "<h3 class=\"SectionAlt\">", "</h3>"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  ParagraphIndent->-25,
  TabSpacings->2.1,
  CounterIncrements->"SectionAlt",
  CounterAssignments->{{"SubsectionAlt", 0}, {"SubsubsectionAlt", 0}, {
      "SubsubsubsectionAlt", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["SectionAlt", "NumberedHeads"]],

Cell[StyleData["SectionAlt", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["SectionAlt", "Printout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14,
  FontColor->GrayLevel[0]],

Cell[StyleData["SectionAlt", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 18}},
  FontSize->14,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsectionAlt"],
  CellDingbat->None,
  CellMargins->{{12, 12}, {3, 16}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 40},
  ConversionRules:>{"TeX" -> {"\n\n\\subsection*{", "}"}, "HTML" -> {
    "<h4 class=\"SubsectionAlt\">", "</h4>"}},
  PageBreakBelow->False,
  CellFrameLabelMargins->6,
  ParagraphIndent->-18,
  TabSpacings->1.7,
  CounterIncrements->"Subsection",
  CounterAssignments->{{"SubsubsectionAlt", 0}, {"SubsubsubsectionAlt", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->14,
  FontWeight->"Bold"],

Cell[StyleData["SubsectionAlt", "NumberedHeads"]],

Cell[StyleData["SubsectionAlt", "Presentation"],
  CellMargins->{{23, 12}, {5, 24}},
  FontSize->21],

Cell[StyleData["SubsectionAlt", "Printout"],
  CellMargins->{{2, 2}, {2, 14}},
  FontSize->12,
  FontColor->GrayLevel[0]],

Cell[StyleData["SubsectionAlt", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 14}},
  FontSize->12,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsectionAlt"],
  CellMargins->{{12, 12}, {3, 9}},
  CellElementSpacings->{"ClosedGroupTopMargin"->12},
  CellGroupingRules->{"SectionGrouping", 50},
  ConversionRules:>{"TeX" -> {"\n\n\\subsubsection*{", "}"}, "HTML" -> {
    "<h5 class=\"SubsubsectionAlt\">", "</h5>"}},
  PageBreakBelow->False,
  CounterIncrements->"SubsubsectionAlt",
  CounterAssignments->{{"SubsubsubsectionAlt", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0.200015],
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["SubsubsectionAlt", "NumberedHeads"]],

Cell[StyleData["SubsubsectionAlt", "Presentation"],
  CellMargins->{{23, 12}, {5, 14}},
  FontSize->18],

Cell[StyleData["SubsubsectionAlt", "Printout"],
  CellMargins->{{2, 2}, {2, 7}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["SubsubsectionAlt", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 7}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubsubsubsectionAlt"],
  CellMargins->{{12, 12}, {3, 6}},
  CellGroupingRules->{"SectionGrouping", 60},
  CounterIncrements->"SubsubsubsectionAlt",
  StyleMenuListing->None,
  FontSize->12,
  FontWeight->"Bold",
  FontColor->GrayLevel[0.300008]],

Cell[StyleData["SubsubsubsectionAlt", "NumberedHeads"]],

Cell[StyleData["SubsubsubsectionAlt", "Presentation"],
  CellMargins->{{23, 12}, {5, 9}},
  FontSize->18],

Cell[StyleData["SubsubsubsectionAlt", "Printout"],
  CellMargins->{{2, 2}, {2, 5}},
  FontSize->10,
  FontColor->GrayLevel[0]],

Cell[StyleData["SubsubsubsectionAlt", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 5}},
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Body Text", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Text"],
  CellMargins->{{12, 12}, {3, 5}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Text", "NumberedHeads"]],

Cell[StyleData["Text", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["Text", "Printout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["Text", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextNoIndent"],
  CellMargins->{{12, 12}, {3, 5}},
  ConversionRules:>{"TeX" -> {{"\\noindent ", Automatic, ""}, {
    "\n\n\\noindent ", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"TextNoIndent",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["TextNoIndent", "NumberedHeads"]],

Cell[StyleData["TextNoIndent", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["TextNoIndent", "Printout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["TextNoIndent", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextContinuation"],
  CellMargins->{{12, 12}, {3, 5}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"TextNoIndent",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["TextContinuation", "NumberedHeads"]],

Cell[StyleData["TextContinuation", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["TextContinuation", "Printout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["TextContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Itemized Lists", "Section"],

Cell[CellGroupData[{

Cell["Bulleted Lists", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item1Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1", "NumberedHeads"]],

Cell[StyleData["Item1", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item2Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item2", "NumberedHeads"]],

Cell[StyleData["Item2", "Presentation"],
  CellMargins->{{59, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2", "Printout"],
  CellMargins->{{20, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2", "NumberedHeadsPrintout"],
  CellMargins->{{20, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item3Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3",
  StyleMenuListing->None],

Cell[StyleData["Item3", "NumberedHeads"]],

Cell[StyleData["Item3", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3", "NumberedHeadsPrintout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item1Label", "NumberedHeads"]],

Cell[StyleData["Item1Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item2Label", "NumberedHeads"]],

Cell[StyleData["Item2Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item2Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item3Label", "NumberedHeads"]],

Cell[StyleData["Item3Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item3Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numbered Lists", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1Numbered"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item1Numbered"], "."}], "Item1NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1Numbered", "NumberedHeads"]],

Cell[StyleData["Item1Numbered", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Numbered", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Numbered"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"(", 
            CounterBox[ "Item2Numbered"], ")"}], "Item2NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["Item2Numbered", "NumberedHeads"]],

Cell[StyleData["Item2Numbered", "Presentation"],
  CellMargins->{{59, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Numbered", "Printout"],
  CellMargins->{{20, 2}, {1, 2}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{20, 2}, {1, 2}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Numbered"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item3Numbered"], "."}], "Item3NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>RomanNumeral}],

Cell[StyleData["Item3Numbered", "NumberedHeads"]],

Cell[StyleData["Item3Numbered", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Numbered", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item1NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item1NumberedLabel", "NumberedHeads"]],

Cell[StyleData["Item1NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item2NumberedLabel", "NumberedHeads"]],

Cell[StyleData["Item2NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item2NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Item3NumberedLabel", "NumberedHeads"]],

Cell[StyleData["Item3NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["Item3NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["List Paragraphs", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Item1Paragraph"],
  CellMargins->{{40, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "enumerate"}}},
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item1Paragraph", "NumberedHeads"]],

Cell[StyleData["Item1Paragraph", "Presentation"],
  CellMargins->{{63, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item1Paragraph", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item1Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2Paragraph"],
  CellMargins->{{64, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 2, 
    "CellGroupEnvironment" -> "enumerate"}}},
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["Item2Paragraph", "NumberedHeads"]],

Cell[StyleData["Item2Paragraph", "Presentation"],
  CellMargins->{{99, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item2Paragraph", "Printout"],
  CellMargins->{{42, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item2Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{42, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3Paragraph"],
  CellMargins->{{88, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 3, 
    "CellGroupEnvironment" -> "enumerate"}}},
  StyleMenuListing->None],

Cell[StyleData["Item3Paragraph", "NumberedHeads"]],

Cell[StyleData["Item3Paragraph", "Presentation"],
  CellMargins->{{135, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["Item3Paragraph", "Printout"],
  CellMargins->{{62, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Item3Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{62, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Illustrations and Examples", "Section"],

Cell[CellGroupData[{

Cell["Figure", "Subsection"],

Cell["\<\
When changing settings that affect rendering of \"Figure\", apply the same \
settings to \"Graphics\" in the conformance group to avoid jumpiness on \
import:\
\>", "Text",
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["Figure"],
  Editable->False,
  CellMargins->{{12, Inherited}, {0, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
    ExtractFigure[ ], "\n\\end{center}"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
    "Style:FigureCaption"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  CounterIncrements->"Figure",
  StyleMenuListing->None],

Cell[StyleData["Figure", "NumberedHeads"]],

Cell[StyleData["Figure", "Presentation"],
  CellMargins->{{12, Inherited}, {0, 11}},
  FontSize->18,
  Magnification->1.5],

Cell[StyleData["Figure", "Printout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8],

Cell[StyleData["Figure", "NumberedHeadsPrintout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureCaption"],
  CellMargins->{{12, 10}, {6, 2}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", "}\n"}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Figure"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Figure"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"FigureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["FigureCaption", "NumberedHeads"]],

Cell[StyleData["FigureCaption", "Presentation"],
  CellMargins->{{23, 10}, {9, 3}},
  FontSize->14],

Cell[StyleData["FigureCaption", "Printout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7],

Cell[StyleData["FigureCaption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureCaptionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["FigureCaptionLabel", "NumberedHeads"]],

Cell[StyleData["FigureCaptionLabel", "Presentation"]],

Cell[StyleData["FigureCaptionLabel", "Printout"]],

Cell[StyleData["FigureCaptionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureNumber"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["FigureNumber", "NumberedHeads"]],

Cell[StyleData["FigureNumber", "Presentation"]],

Cell[StyleData["FigureNumber", "Printout"]],

Cell[StyleData["FigureNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureText"],
  CellMargins->{{12, 10}, {12, 0}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Figure"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"FigureText",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->9],

Cell[StyleData["FigureText", "NumberedHeads"]],

Cell[StyleData["FigureText", "Presentation"],
  CellMargins->{{23, 10}, {18, 0}},
  FontSize->14],

Cell[StyleData["FigureText", "Printout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7],

Cell[StyleData["FigureText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureFile"],
  Deletable->False,
  CellMargins->{{12, 10}, {7, 2}},
  CellGroupingRules->"OutputGrouping",
  StyleMenuListing->None,
  Background->RGBColor[0.776471, 0.776471, 0.92549]],

Cell[StyleData["FigureFile", "NumberedHeads"]],

Cell[StyleData["FigureFile", "Presentation"],
  CellMargins->{{23, 10}, {11, 3}},
  FontSize->17],

Cell[StyleData["FigureFile", "Printout"],
  CellMargins->{{2, 2}, {6, 1}},
  FontSize->10,
  Background->GrayLevel[0.8]],

Cell[StyleData["FigureFile", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 1}},
  FontSize->10,
  Background->GrayLevel[0.8]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Supplemental Material", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SupplementalCaptionLabel"],
  Deletable->False,
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 10}, {1, 7}},
  CellGroupingRules->"InputGrouping",
  TaggingRules:>{"CellGroupDeletable" -> True, "CounterSettings" -> {
    "CounterFormat" -> {"Supplemental"}, "CounterTarget" -> "CellGroup", 
    "XRefPrefix" -> "Supplemental File"}},
  PageBreakBelow->False,
  CellFrameMargins->2,
  CounterIncrements->"SupplementalCaptionLabel",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->11,
  FontWeight->"Bold"],

Cell[StyleData["SupplementalCaptionLabel", "NumberedHeads"]],

Cell[StyleData["SupplementalCaptionLabel", "Presentation"],
  CellMargins->{{23, 10}, {2, 11}},
  FontSize->17],

Cell[StyleData["SupplementalCaptionLabel", "Printout"],
  CellMargins->{{2, 2}, {0, 6}},
  FontSize->9],

Cell[StyleData["SupplementalCaptionLabel", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 6}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SupplementalCaption"],
  Deletable->False,
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 10}, {8, 4}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Supplemental"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakBelow->False,
  CellFrameMargins->2,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->11,
  FontWeight->"Bold"],

Cell[StyleData["SupplementalCaption", "NumberedHeads"]],

Cell[StyleData["SupplementalCaption", "Presentation"],
  CellMargins->{{23, 10}, {12, 6}},
  FontSize->17],

Cell[StyleData["SupplementalCaption", "Printout"],
  CellMargins->{{2, 2}, {6, 3}},
  FontSize->9],

Cell[StyleData["SupplementalCaption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 3}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SupplementalText"],
  Deletable->False,
  CellMargins->{{12, 10}, {7, 4}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Supplemental"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakBelow->False,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->11],

Cell[StyleData["SupplementalText", "NumberedHeads"]],

Cell[StyleData["SupplementalText", "Presentation"],
  CellMargins->{{23, 10}, {11, 6}},
  FontSize->17],

Cell[StyleData["SupplementalText", "Printout"],
  CellMargins->{{2, 2}, {6, 3}},
  FontSize->9],

Cell[StyleData["SupplementalText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 3}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Supplemental"],
  Deletable->False,
  CellMargins->{{12, 10}, {7, 2}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Supplemental"}, 
    "CounterTarget" -> "CellGroup"}, "AllowedToFollow" -> {"Text"}},
  TextAlignment->Center,
  CounterIncrements->"Supplemental",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->11,
  Background->RGBColor[0.776471, 0.776471, 0.92549]],

Cell[StyleData["Supplemental", "NumberedHeads"]],

Cell[StyleData["Supplemental", "Presentation"],
  CellMargins->{{23, 10}, {11, 3}},
  FontSize->17],

Cell[StyleData["Supplemental", "Printout"],
  CellMargins->{{2, 2}, {6, 1}},
  FontSize->9,
  Background->GrayLevel[0.8]],

Cell[StyleData["Supplemental", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 1}},
  FontSize->9,
  Background->GrayLevel[0.8]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Picture", "Subsection"],

Cell["\<\
When changing settings that affect rendering of \"Picture\", apply the same \
settings to \"Graphics\" in the conformance group to avoid jumpiness on \
import:\
\>", "Text",
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["Picture"],
  Editable->False,
  CellMargins->{{12, Inherited}, {0, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
    ExtractFigure[ ], "\n\\end{center}"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
    "Style:PictureCaption"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  CounterIncrements->"Picture",
  StyleMenuListing->None],

Cell[StyleData["Picture", "NumberedHeads"]],

Cell[StyleData["Picture", "Presentation"],
  CellMargins->{{12, Inherited}, {0, 11}},
  Magnification->1.5],

Cell[StyleData["Picture", "Printout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8],

Cell[StyleData["Picture", "NumberedHeadsPrintout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureCaption"],
  CellMargins->{{12, 10}, {6, 2}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", "}\n"}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Picture"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Picture"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"PictureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["PictureCaption", "NumberedHeads"]],

Cell[StyleData["PictureCaption", "Presentation"],
  CellMargins->{{23, 10}, {9, 3}},
  FontSize->14],

Cell[StyleData["PictureCaption", "Printout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7],

Cell[StyleData["PictureCaption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureCaptionLabel"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["PictureCaptionLabel", "NumberedHeads"]],

Cell[StyleData["PictureCaptionLabel", "Presentation"]],

Cell[StyleData["PictureCaptionLabel", "Printout"]],

Cell[StyleData["PictureCaptionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureNumber"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["PictureNumber", "NumberedHeads"]],

Cell[StyleData["PictureNumber", "Presentation"]],

Cell[StyleData["PictureNumber", "Printout"]],

Cell[StyleData["PictureNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PictureText"],
  CellMargins->{{12, 10}, {12, 0}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Picture"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"PictureText",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->9],

Cell[StyleData["PictureText", "NumberedHeads"]],

Cell[StyleData["PictureText", "Presentation"],
  CellMargins->{{23, 10}, {18, 0}},
  FontSize->14],

Cell[StyleData["PictureText", "Printout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7],

Cell[StyleData["PictureText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Illustration", "Subsection"],

Cell["\<\
When changing settings that affect rendering of \"Illustration\", apply the \
same settings to \"Graphics\" in the conformance group to avoid jumpiness on \
import:\
\>", "Text",
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["Illustration"],
  Editable->False,
  CellMargins->{{12, Inherited}, {0, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{center}", 
    ExtractFigure[ ], "\n\\end{center}"}},
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> 
    "Style:IllustrationCaption"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90, "AlwaysStartEnvironment" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  CounterIncrements->"Illustration",
  StyleMenuListing->None],

Cell[StyleData["Illustration", "NumberedHeads"]],

Cell[StyleData["Illustration", "Presentation"],
  CellMargins->{{12, Inherited}, {0, 11}},
  Magnification->1.5],

Cell[StyleData["Illustration", "Printout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8],

Cell[StyleData["Illustration", "NumberedHeadsPrintout"],
  CellMargins->{{2, Inherited}, {0, 5}},
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IllustrationCaption"],
  CellMargins->{{12, 10}, {6, 2}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\\caption{", "}\n"}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Illustration"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Illustration"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90}, "TeX" -> {
    "CellGroupEnvironment" -> {"figure", "[h]"}}}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"IllustrationCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["IllustrationCaption", "NumberedHeads"]],

Cell[StyleData["IllustrationCaption", "Presentation"],
  CellMargins->{{23, 10}, {9, 3}},
  FontSize->14],

Cell[StyleData["IllustrationCaption", "Printout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7],

Cell[StyleData["IllustrationCaption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IllustrationCaptionLabel"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["IllustrationCaptionLabel", "NumberedHeads"]],

Cell[StyleData["IllustrationCaptionLabel", "Presentation"]],

Cell[StyleData["IllustrationCaptionLabel", "Printout"]],

Cell[StyleData["IllustrationCaptionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IllustrationNumber"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["IllustrationNumber", "NumberedHeads"]],

Cell[StyleData["IllustrationNumber", "Presentation"]],

Cell[StyleData["IllustrationNumber", "Printout"]],

Cell[StyleData["IllustrationNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IllustrationText"],
  CellMargins->{{12, 10}, {12, 0}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Illustration"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"IllustrationText",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->9],

Cell[StyleData["IllustrationText", "NumberedHeads"]],

Cell[StyleData["IllustrationText", "Presentation"],
  CellMargins->{{12, 10}, {18, 0}},
  FontSize->14],

Cell[StyleData["IllustrationText", "Printout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7],

Cell[StyleData["IllustrationText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Program/Script", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Program"],
  CellFrame->{{0, 0}, {1, 1}},
  CellMargins->{{12, 0}, {2, 7}},
  CellGroupingRules->"InputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Program"}},
  CellFrameMargins->{{12, 10}, {7, 5}},
  CounterIncrements->"Program",
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["Program", "NumberedHeads"]],

Cell[StyleData["Program", "Presentation"],
  CellMargins->{{23, 0}, {3, 11}},
  FontSize->18],

Cell[StyleData["Program", "Printout"],
  CellMargins->{{2, 0}, {5, 5}},
  StyleMenuListing->None,
  FontSize->9.5],

Cell[StyleData["Program", "NumberedHeadsPrintout"],
  CellMargins->{{2, 0}, {5, 5}},
  StyleMenuListing->None,
  FontSize->9.5]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramCaption"],
  CellMargins->{{12, 10}, {6, 2}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"ProgramCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["ProgramCaption", "NumberedHeads"]],

Cell[StyleData["ProgramCaption", "Presentation"],
  CellMargins->{{23, 10}, {9, 3}},
  FontSize->14],

Cell[StyleData["ProgramCaption", "Printout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7],

Cell[StyleData["ProgramCaption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramCaptionLabel"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["ProgramCaptionLabel", "NumberedHeads"]],

Cell[StyleData["ProgramCaptionLabel", "Presentation"]],

Cell[StyleData["ProgramCaptionLabel", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["ProgramCaptionLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramNumber"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["ProgramNumber", "NumberedHeads"]],

Cell[StyleData["ProgramNumber", "Presentation"]],

Cell[StyleData["ProgramNumber", "Printout"]],

Cell[StyleData["ProgramNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProgramText"],
  CellMargins->{{12, 10}, {12, 0}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Program"}, 
    "CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"ProgramText",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->9],

Cell[StyleData["ProgramText", "NumberedHeads"]],

Cell[StyleData["ProgramText", "Presentation"],
  CellMargins->{{23, 10}, {18, 0}},
  FontSize->14],

Cell[StyleData["ProgramText", "Printout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7],

Cell[StyleData["ProgramText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Tables", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["TableTitle"],
  PageWidth->WindowWidth,
  CellMargins->{{12, 10}, {1, 7}},
  CellGroupingRules->"InputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\caption{", Automatic, "}"}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
    "CounterTarget" -> "Cell", "XRefPrefix" -> "Table"}, 
    "ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 90, 
    "AlwaysStartEnvironment" -> True}, "TeX" -> {"CellGroupEnvironment" -> 
    "table"}}},
  LineSpacing->{1, 2},
  CounterIncrements->"TableTitle",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  GridBoxOptions->{ColumnWidths->40,
  ColumnAlignments->{Left}}],

Cell[StyleData["TableTitle", "NumberedHeads"]],

Cell[StyleData["TableTitle", "Presentation"],
  CellMargins->{{23, 10}, {2, 11}},
  FontSize->17],

Cell[StyleData["TableTitle", "Printout"],
  CellMargins->{{2, 10}, {1, 5}},
  FontSize->10],

Cell[StyleData["TableTitle", "NumberedHeadsPrintout"],
  CellMargins->{{2, 10}, {1, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableTitleLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  LineSpacing->{1, 2},
  CounterIncrements->"TableTitleLabel",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  GridBoxOptions->{ColumnWidths->40,
  ColumnAlignments->{Left}}],

Cell[StyleData["TableTitleLabel", "NumberedHeads"]],

Cell[StyleData["TableTitleLabel", "Presentation"]],

Cell[StyleData["TableTitleLabel", "Printout"],
  FontSize->10],

Cell[StyleData["TableTitleLabel", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Table"],
  Editable->False,
  PageWidth->WindowWidth,
  CellMargins->{{12, 10}, {4, 1}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {"\n\\begin{center}", Automatic, 
    "\n\\end{center}"}, "HTML" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"TableTitle"}, 
    "CounterTarget" -> "CellGroup"}, "ExtraConversionRules" -> {"General" -> {
    "NestingLevel" -> 90}, "TeX" -> {"CellGroupEnvironment" -> "table"}}},
  CellHorizontalScrolling->True,
  CounterIncrements->"Table",
  CounterAssignments->{{"TableNote", 0}},
  StyleMenuListing->None,
  GridBoxOptions->{ColumnWidths->0.503,
  RowAlignments->Center,
  ColumnAlignments->{Left},
  GridFrame->{{0, 0}, {0.5, 2}},
  GridDefaultElement:>Cell[ "Data", "TableText"]}],

Cell[StyleData["Table", "NumberedHeads"]],

Cell[StyleData["Table", "Presentation"],
  CellMargins->{{23, 10}, {6, 2}},
  FontSize->17],

Cell[StyleData["Table", "Printout"],
  PageWidth->PaperWidth,
  CellMargins->{{2, 10}, {3, 1}},
  FontSize->10],

Cell[StyleData["Table", "NumberedHeadsPrintout"],
  PageWidth->PaperWidth,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableNumber"],
  StyleMenuListing->None],

Cell[StyleData["TableNumber", "NumberedHeads"]],

Cell[StyleData["TableNumber", "Presentation"]],

Cell[StyleData["TableNumber", "Printout"]],

Cell[StyleData["TableNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableNote"],
  Editable->False,
  PageWidth->WindowWidth,
  CellMargins->{{12, 10}, {7, -3}},
  CellGroupingRules->"OutputGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Table"}, 
    "CounterTarget" -> "CellGroup"}},
  LineSpacing->{1, 1},
  ParagraphSpacing->{0.3, 0},
  CounterIncrements->"TableNote",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->10,
  FontColor->GrayLevel[0.300008]],

Cell[StyleData["TableNote", "NumberedHeads"]],

Cell[StyleData["TableNote", "Presentation"],
  CellMargins->{{23, 10}, {11, -5}},
  FontSize->15],

Cell[StyleData["TableNote", "Printout"],
  CellMargins->{{2, 10}, {5, -2}},
  FontSize->9],

Cell[StyleData["TableNote", "NumberedHeadsPrintout"],
  CellMargins->{{2, 10}, {5, -2}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableNoteLabel"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["TableNoteLabel", "NumberedHeads"]],

Cell[StyleData["TableNoteLabel", "Presentation"]],

Cell[StyleData["TableNoteLabel", "Printout"]],

Cell[StyleData["TableNoteLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableSpacer"],
  StyleMenuListing->None],

Cell[StyleData["TableSpacer", "NumberedHeads"]],

Cell[StyleData["TableSpacer", "Presentation"]],

Cell[StyleData["TableSpacer", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["TableSpacer", "NumberedHeadsPrintout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Table Styles", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TableColumnHead"],
  Editable->True,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSlant->"Italic",
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableColumnHead", "NumberedHeads"]],

Cell[StyleData["TableColumnHead", "Presentation"],
  FontSize->17],

Cell[StyleData["TableColumnHead", "Printout"],
  FontSize->10],

Cell[StyleData["TableColumnHead", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableSpanHead"],
  Editable->True,
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSlant->"Italic",
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableSpanHead", "NumberedHeads"]],

Cell[StyleData["TableSpanHead", "Presentation"],
  FontSize->17],

Cell[StyleData["TableSpanHead", "Printout"],
  FontSize->10],

Cell[StyleData["TableSpanHead", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableText"],
  Editable->True,
  TextAlignment->Left,
  LineSpacing->{1, 1},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  GridBoxOptions->{GridBaseline->Axis,
  RowSpacings->1,
  ColumnSpacings->0.8,
  ColumnWidths->Automatic,
  RowAlignments->Baseline,
  ColumnAlignments->{Center},
  GridFrame->False,
  GridFrameMargins->{{0.4, 0.4}, {0.5, 0.5}},
  RowLines->False,
  ColumnLines->False,
  RowMinHeight->1,
  RowsEqual->False,
  ColumnsEqual->False,
  GridDefaultElement:>"\[Placeholder]"}],

Cell[StyleData["TableText", "NumberedHeads"]],

Cell[StyleData["TableText", "Presentation"],
  FontSize->17],

Cell[StyleData["TableText", "Printout"],
  FontSize->10],

Cell[StyleData["TableText", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableSpanText"],
  Editable->True,
  TextAlignment->Left,
  LineSpacing->{1, 1},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  GridBoxOptions->{ColumnSpacings->0,
  ColumnAlignments->{Left},
  GridFrame->False,
  RowLines->False}],

Cell[StyleData["TableSpanText", "NumberedHeads"]],

Cell[StyleData["TableSpanText", "Presentation"],
  FontSize->17],

Cell[StyleData["TableSpanText", "Printout"],
  FontSize->10],

Cell[StyleData["TableSpanText", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[StyleData["TableSubGrid"],
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->0.7,
  ColumnSpacings->0.8,
  ColumnAlignments->{Left, Center},
  GridFrame->False,
  RowLines->False,
  RowMinHeight->0.1,
  GridDefaultElement:>Cell[ "Data", "TableText"]}],

Cell[StyleData["TableMasterGrid"],
  StyleMenuListing->None,
  GridBoxOptions->{RowSpacings->0.01,
  ColumnWidths->0.999}],

Cell[StyleData["TableLineElement"],
  Editable->False,
  CellFrame->{{0, 0}, {0.5, 0}},
  CellElementSpacings->{"CellMinHeight"->1},
  ConversionRules:>{"HTML" -> {{"&nbsp;", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  CellSize->{Inherited, 1.25},
  TabFilling->" ",
  TabSpacings->1000,
  StyleMenuListing->None,
  FontSize->1],

Cell[StyleData["TableBlankElement"],
  Editable->False,
  CellElementSpacings->{"CellMinHeight"->1},
  CellSize->{Inherited, 1.25},
  StyleMenuListing->None,
  FontSize->1],

Cell[CellGroupData[{

Cell[StyleData["SpanLeft"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanLeft", "NumberedHeads"]],

Cell[StyleData["SpanLeft", "Printout"],
  FontSize->14],

Cell[StyleData["SpanLeft", "Presentation"]],

Cell[StyleData["SpanLeft", "NumberedHeadsPrintout"],
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SpanCenter"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanCenter", "NumberedHeads"]],

Cell[StyleData["SpanCenter", "Presentation"]],

Cell[StyleData["SpanCenter", "Printout"],
  FontSize->14],

Cell[StyleData["SpanCenter", "NumberedHeadsPrintout"],
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SpanRight"],
  Editable->False,
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SpanRight", "NumberedHeads"]],

Cell[StyleData["SpanRight", "Presentation"]],

Cell[StyleData["SpanRight", "Printout"],
  FontSize->14],

Cell[StyleData["SpanRight", "NumberedHeadsPrintout"],
  FontSize->14]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Caption", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Caption"],
  CellMargins->{{12, 10}, {6, 2}},
  CellGroupingRules->"OutputGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterTarget" -> "CellGroup"}},
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"Caption",
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9],

Cell[StyleData["Caption", "NumberedHeads"]],

Cell[StyleData["Caption", "Presentation"],
  CellMargins->{{23, 10}, {9, 3}},
  FontSize->14],

Cell[StyleData["Caption", "Printout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7],

Cell[StyleData["Caption", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {2, 4}},
  FontSize->7]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaptionLabel"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["CaptionLabel", "NumberedHeads"]],

Cell[StyleData["CaptionLabel", "Presentation"]],

Cell[StyleData["CaptionLabel", "Printout"],
  StyleMenuListing->None],

Cell[StyleData["CaptionLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaptionNumber"],
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["CaptionNumber", "NumberedHeads"]],

Cell[StyleData["CaptionNumber", "Presentation"]],

Cell[StyleData["CaptionNumber", "Printout"]],

Cell[StyleData["CaptionNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaptionText"],
  CellMargins->{{12, 10}, {12, 0}},
  CellGroupingRules->"OutputGrouping",
  PageBreakAbove->False,
  Hyphenation->True,
  CounterIncrements->"CaptionText",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->9],

Cell[StyleData["CaptionText", "NumberedHeads"]],

Cell[StyleData["CaptionText", "Presentation"],
  CellMargins->{{23, 10}, {18, 0}},
  FontSize->14],

Cell[StyleData["CaptionText", "Printout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7],

Cell[StyleData["CaptionText", "NumberedHeadsPrintout"],
  CellMargins->{{2, 12}, {12, 0}},
  TextJustification->1,
  FontSize->7]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Text Extract", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Extract"],
  CellMargins->{{24, 22}, {8, 8}},
  LineSpacing->{1, 2},
  StyleMenuListing->None,
  FontSize->11],

Cell[StyleData["Extract", "NumberedHeads"]],

Cell[StyleData["Extract", "Presentation"],
  CellMargins->{{35, 22}, {12, 12}},
  FontSize->17],

Cell[StyleData["Extract", "Printout"],
  CellMargins->{{12, 24}, {4, 4}},
  TextJustification->1,
  FontSize->9],

Cell[StyleData["Extract", "NumberedHeadsPrintout"],
  CellMargins->{{12, 24}, {4, 4}},
  TextJustification->1,
  FontSize->9]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Mathematics", "Section"],

Cell[CellGroupData[{

Cell["Equations", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Equation"],
  CellMargins->{{12, 32}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"Equation\">", "</p>"}}},
  
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90}}},
  CellHorizontalScrolling->True,
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  CounterIncrements->"Equation",
  StyleMenuListing->None],

Cell[StyleData["Equation", "NumberedHeads"]],

Cell[StyleData["Equation", "Presentation"],
  CellMargins->{{23, 32}, {11, 11}},
  FontSize->19],

Cell[StyleData["Equation", "Printout"],
  CellMargins->{{2, 20}, {5, 5}},
  FontSize->10],

Cell[StyleData["Equation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 20}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationWide"],
  CellMargins->{{12, 32}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {"<p class=\"EquationWide\">", 
    "</p>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90}}},
  CellHorizontalScrolling->True,
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  CounterIncrements->"Equation",
  StyleMenuListing->None],

Cell[StyleData["EquationWide", "NumberedHeads"]],

Cell[StyleData["EquationWide", "Presentation"],
  CellMargins->{{23, 32}, {11, 11}},
  FontSize->19],

Cell[StyleData["EquationWide", "Printout"],
  CellMargins->{{2, 20}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationWide", "NumberedHeadsPrintout"],
  CellMargins->{{2, 20}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroup"],
  CellMargins->{{12, 32}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90, "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> 
    "gather*"}}},
  DefaultFormatType->DefaultInputFormatType,
  StyleMenuListing->None],

Cell[StyleData["EquationGroup", "NumberedHeads"]],

Cell[StyleData["EquationGroup", "Presentation"],
  CellMargins->{{23, 32}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroup", "Printout"],
  CellMargins->{{2, 20}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroup", "NumberedHeadsPrintout"],
  CellMargins->{{2, 20}, {0, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupAligned"],
  CellMargins->{{12, 42}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    90, "Numbered" -> False}, "TeX" -> {"CellGroupEnvironment" -> "align*"}}},
  
  DefaultFormatType->DefaultInputFormatType,
  StyleMenuListing->None,
  UnderoverscriptBoxOptions->{LimitsPositioning->False},
  UnderscriptBoxOptions->{LimitsPositioning->False},
  OverscriptBoxOptions->{LimitsPositioning->False},
  GridBoxOptions->{AllowScriptLevelChange->False}],

Cell[StyleData["EquationGroupAligned", "NumberedHeads"]],

Cell[StyleData["EquationGroupAligned", "Presentation"],
  CellMargins->{{23, 55}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupAligned", "Printout"],
  CellMargins->{{2, 28}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupAligned", "NumberedHeadsPrintout"],
  CellMargins->{{2, 28}, {0, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numbered Equations", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["EquationNumbered"],
  CellMargins->{{12, 12}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='EquationNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90}}},
  CellHorizontalScrolling->True,
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}]]}, {None, None}},
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationNumbered", "NumberedHeads"]],

Cell[StyleData["EquationNumbered", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->19],

Cell[StyleData["EquationNumbered", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationWideNumbered"],
  CellMargins->{{12, 12}, {7, 7}},
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationGroupNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='EquationGroupNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90}}},
  CellHorizontalScrolling->True,
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}]]}, {None, None}},
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  AutoStyleOptions->{"UnmatchedBracketStyle"->None},
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationWideNumbered", "NumberedHeads"]],

Cell[StyleData["EquationWideNumbered", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->19],

Cell[StyleData["EquationWideNumbered", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["EquationWideNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationGroupNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='EquationGroupNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90}, "TeX" -> {"CellGroupEnvironment" -> "gather"}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],

Cell[StyleData["EquationGroupNumbered", "NumberedHeads"]],

Cell[StyleData["EquationGroupNumbered", "Presentation"],
  CellMargins->{{23, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationGroupAlignedNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='EquationGroupAlignedNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td \
class='EquationGroupAlignedNumberedLabel'>(`1`)</td></tr></table>", 
      "EquationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {
    "EquationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90}, "TeX" -> {"CellGroupEnvironment" -> "align"}}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered"], ")"}], "EquationNumber"]}, {
      None, None}},
  DefaultFormatType->DefaultInputFormatType,
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None,
  UnderoverscriptBoxOptions->{LimitsPositioning->False},
  UnderscriptBoxOptions->{LimitsPositioning->False},
  OverscriptBoxOptions->{LimitsPositioning->False},
  GridBoxOptions->{AllowScriptLevelChange->False}],

Cell[StyleData["EquationGroupAlignedNumbered", "NumberedHeads"]],

Cell[StyleData["EquationGroupAlignedNumbered", "Presentation"],
  CellMargins->{{23, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["EquationGroupAlignedNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10],

Cell[StyleData["EquationGroupAlignedNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubequationNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='SubequationNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='SubequationNumberedLabel'>(`1``2`)</td></tr></table>", 
      "EquationNumbered", "SubequationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"EquationNumbered",
     "", "SubequationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90, "Subequation" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> "gather"}}},
  CellFrameLabels->{{Inherited, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered", CounterFunction :> Identity], 
            CounterBox[ "SubequationNumbered"], ")"}], 
          "SubequationNumber"]}, {Inherited, Inherited}},
  CounterIncrements->"SubequationNumbered",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["SubequationNumbered", "NumberedHeads"]],

Cell[StyleData["SubequationNumbered", "Presentation"],
  CellMargins->{{23, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["SubequationNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["SubequationNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubequationAlignedNumbered"],
  CellMargins->{{12, 6}, {0, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='SubequationAlignedNumbered'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td \
class='SubequationAlignedNumberedLabel'>(`1``2`)</td></tr></table>", 
      "EquationNumbered", "SubequationNumbered"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"EquationNumbered",
     "", "SubequationNumbered"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}, "ExtraConversionRules" -> {"General" -> {"Numbered" -> True, 
    "NestingLevel" -> 90, "Subequation" -> True}, "TeX" -> {
    "CellGroupEnvironment" -> "align"}}},
  CellFrameLabels->{{Inherited, Cell[ 
          TextData[ {"(", 
            CounterBox[ "EquationNumbered", CounterFunction :> Identity], 
            CounterBox[ "SubequationNumbered"], ")"}], 
          "SubequationNumber"]}, {Inherited, Inherited}},
  CounterIncrements->"SubequationNumbered",
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)},
  UnderoverscriptBoxOptions->{LimitsPositioning->False},
  UnderscriptBoxOptions->{LimitsPositioning->False},
  OverscriptBoxOptions->{LimitsPositioning->False},
  GridBoxOptions->{AllowScriptLevelChange->False}],

Cell[StyleData["SubequationAlignedNumbered", "NumberedHeads"]],

Cell[StyleData["SubequationAlignedNumbered", "Presentation"],
  CellMargins->{{24, 6}, {0, 3}},
  FontSize->19],

Cell[StyleData["SubequationAlignedNumbered", "Printout"],
  CellMargins->{{2, 2}, {0, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["SubequationAlignedNumbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {0, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EquationNumber"],
  CellSize->{30, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["EquationNumber", "NumberedHeads"]],

Cell[StyleData["EquationNumber", "Presentation"],
  CellSize->{45, Inherited}],

Cell[StyleData["EquationNumber", "Printout"],
  CellSize->{27, Inherited}],

Cell[StyleData["EquationNumber", "NumberedHeadsPrintout"],
  CellSize->{27, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SubequationNumber"],
  CellSize->{30, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["SubequationNumber", "NumberedHeads"]],

Cell[StyleData["SubequationNumber", "Presentation"],
  CellSize->{45, Inherited}],

Cell[StyleData["SubequationNumber", "Printout"],
  CellSize->{27, Inherited}],

Cell[StyleData["SubequationNumber", "NumberedHeadsPrintout"],
  CellSize->{27, Inherited}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Equation Grid Tag Styles", "Subsection"],

Cell[StyleData["EquationGrid"],
  StyleMenuListing->None],

Cell[StyleData["SplitEquation"],
  StyleMenuListing->None],

Cell[StyleData["Piecewise"],
  StyleMenuListing->None],

Cell[StyleData["Matrix"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Enunciations", "Subsection"],

Cell[CellGroupData[{

Cell["Theorem", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Theorem"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Theorem"}, "CounterTarget" -> "Cell"}, "ExtraConversionRules" -> {
    "TeX" -> {"NestingLevel" -> 10, "CellGroupEnvironment" -> "theorem"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Theorem", "NumberedHeads"]],

Cell[StyleData["Theorem", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Theorem", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Theorem", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TheoremLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["TheoremLabel", "NumberedHeads"]],

Cell[StyleData["TheoremLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["TheoremLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["TheoremLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TheoremContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "theorem"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"TheoremContinuation",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["TheoremContinuation", "NumberedHeads"]],

Cell[StyleData["TheoremContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["TheoremContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["TheoremContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Corollary", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Corollary"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "corollary"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Corollary", "NumberedHeads"]],

Cell[StyleData["Corollary", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Corollary", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Corollary", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CorollaryLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["CorollaryLabel", "NumberedHeads"]],

Cell[StyleData["CorollaryLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["CorollaryLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["CorollaryLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CorollaryContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "corollary"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"CorollaryContinuation",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["CorollaryContinuation", "NumberedHeads"]],

Cell[StyleData["CorollaryContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["CorollaryContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["CorollaryContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Lemma", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Lemma"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "lemma"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Lemma", "NumberedHeads"]],

Cell[StyleData["Lemma", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Lemma", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Lemma", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LemmaLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["LemmaLabel", "NumberedHeads"]],

Cell[StyleData["LemmaLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["LemmaLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["LemmaLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LemmaContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "lemma"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"LemmaContinuation",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["LemmaContinuation", "NumberedHeads"]],

Cell[StyleData["LemmaContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["LemmaContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["LemmaContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Proposition", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Proposition"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "proposition"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Proposition", "NumberedHeads"]],

Cell[StyleData["Proposition", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Proposition", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Proposition", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PropositionLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["PropositionLabel", "NumberedHeads"]],

Cell[StyleData["PropositionLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["PropositionLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["PropositionLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PropositionContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "proposition"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"PropositionContinuation",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["PropositionContinuation", "NumberedHeads"]],

Cell[StyleData["PropositionContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["PropositionContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["PropositionContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conjecture", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Conjecture"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "conjecture"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Conjecture", "NumberedHeads"]],

Cell[StyleData["Conjecture", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Conjecture", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Conjecture", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ConjectureLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["ConjectureLabel", "NumberedHeads"]],

Cell[StyleData["ConjectureLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["ConjectureLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ConjectureLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ConjectureContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "conjecture"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"ConjectureContinuation",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["ConjectureContinuation", "NumberedHeads"]],

Cell[StyleData["ConjectureContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["ConjectureContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["ConjectureContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Definition", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Definition"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "definition"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Definition", "NumberedHeads"]],

Cell[StyleData["Definition", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Definition", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Definition", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["DefinitionLabel", "NumberedHeads"]],

Cell[StyleData["DefinitionLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["DefinitionLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["DefinitionLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DefinitionContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "definition"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"DefinitionContinuation",
  StyleMenuListing->None],

Cell[StyleData["DefinitionContinuation", "NumberedHeads"]],

Cell[StyleData["DefinitionContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["DefinitionContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["DefinitionContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Axiom", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Axiom"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "axiom"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Axiom", "NumberedHeads"]],

Cell[StyleData["Axiom", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Axiom", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Axiom", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AxiomLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["AxiomLabel", "NumberedHeads"]],

Cell[StyleData["AxiomLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["AxiomLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["AxiomLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AxiomContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "axiom"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"AxiomContinuation",
  StyleMenuListing->None],

Cell[StyleData["AxiomContinuation", "NumberedHeads"]],

Cell[StyleData["AxiomContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["AxiomContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["AxiomContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Example", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Example"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "example"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Example", "NumberedHeads"]],

Cell[StyleData["Example", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Example", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Example", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["ExampleLabel", "NumberedHeads"]],

Cell[StyleData["ExampleLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["ExampleLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ExampleLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ExampleContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "example"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"ExampleContinuation",
  StyleMenuListing->None],

Cell[StyleData["ExampleContinuation", "NumberedHeads"]],

Cell[StyleData["ExampleContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["ExampleContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["ExampleContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Remark", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Remark"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "remark"}}, "CounterSettings" -> {
    "CounterFormat" -> {"Section", ".", "Theorem"}, "CounterTarget" -> 
    "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Remark", "NumberedHeads"]],

Cell[StyleData["Remark", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Remark", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Remark", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RemarkLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["RemarkLabel", "NumberedHeads"]],

Cell[StyleData["RemarkLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["RemarkLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["RemarkLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RemarkContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "remark"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"RemarkContinuation",
  StyleMenuListing->None],

Cell[StyleData["RemarkContinuation", "NumberedHeads"]],

Cell[StyleData["RemarkContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["RemarkContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["RemarkContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Proof", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Proof"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "proof"}}, "CounterSettings" -> {
    "CounterTarget" -> "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Proof", "NumberedHeads"]],

Cell[StyleData["Proof", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Proof", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Proof", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProofLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["ProofLabel", "NumberedHeads"]],

Cell[StyleData["ProofLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["ProofLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ProofLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProofContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "proof"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"ProofContinuation",
  StyleMenuListing->None],

Cell[StyleData["ProofContinuation", "NumberedHeads"]],

Cell[StyleData["ProofContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["ProofContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["ProofContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProofSection"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["ProofSection", "NumberedHeads"]],

Cell[StyleData["ProofSection", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->17],

Cell[StyleData["ProofSection", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ProofSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[StyleData["QED"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Case", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Case"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Theorem"}, 
    "CounterTarget" -> "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Case", "NumberedHeads"]],

Cell[StyleData["Case", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Case", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Case", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaseLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["CaseLabel", "NumberedHeads"]],

Cell[StyleData["CaseLabel", "Presentation"]],

Cell[StyleData["CaseLabel", "Printout"],
  FontSize->10],

Cell[StyleData["CaseLabel", "NumberedHeadsPrintout"],
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaseContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "case"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"CaseContinuation",
  StyleMenuListing->None],

Cell[StyleData["CaseContinuation", "NumberedHeads"]],

Cell[StyleData["CaseContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["CaseContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["CaseContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CaseSection"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["CaseSection", "NumberedHeads"]],

Cell[StyleData["CaseSection", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->17],

Cell[StyleData["CaseSection", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["CaseSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Problems", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Problems"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Theorem"}, 
    "CounterTarget" -> "Cell"}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None,
  FontSlant->"Plain"],

Cell[StyleData["Problems", "NumberedHeads"]],

Cell[StyleData["Problems", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Problems", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Problems", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProblemsLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["ProblemsLabel", "NumberedHeads"]],

Cell[StyleData["ProblemsLabel", "Presentation"]],

Cell[StyleData["ProblemsLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ProblemsLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProblemsContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "problems"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"ProblemsContinuation",
  StyleMenuListing->None],

Cell[StyleData["ProblemsContinuation", "NumberedHeads"]],

Cell[StyleData["ProblemsContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["ProblemsContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["ProblemsContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ProblemsSection"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["ProblemsSection", "NumberedHeads"]],

Cell[StyleData["ProblemsSection", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->17],

Cell[StyleData["ProblemsSection", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["ProblemsSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Question", "Subsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Question"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"Section", ".", 
    "Theorem"}, "CounterTarget" -> "Cell"}, "ExtraConversionRules" -> {
    "TeX" -> {"NestingLevel" -> 10, "CellGroupEnvironment" -> "question"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->14,
  CounterIncrements->"Theorem",
  StyleMenuListing->None],

Cell[StyleData["Question", "NumberedHeads"]],

Cell[StyleData["Question", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  ParagraphIndent->21,
  FontSize->17],

Cell[StyleData["Question", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10],

Cell[StyleData["Question", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  ParagraphIndent->10,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["QuestionLabel"],
  ConversionRules:>{"TeX" -> {{"", 
    NoOutput[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["QuestionLabel", "NumberedHeads"]],

Cell[StyleData["QuestionLabel", "Presentation"],
  FontSize->17],

Cell[StyleData["QuestionLabel", "Printout"],
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["QuestionLabel", "NumberedHeadsPrintout"],
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["QuestionContinuation"],
  CellMargins->{{12, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 10, 
    "CellGroupEnvironment" -> "question"}}},
  Hyphenation->True,
  LineSpacing->{1, 3},
  ParagraphIndent->0,
  CounterIncrements->"QuestionContinuation",
  StyleMenuListing->None],

Cell[StyleData["QuestionContinuation", "NumberedHeads"]],

Cell[StyleData["QuestionContinuation", "Presentation"],
  CellMargins->{{23, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["QuestionContinuation", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["QuestionContinuation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Enunciation-Specific Itemized Lists", "Subsubsection"],

Cell[CellGroupData[{

Cell["Bulleted Lists", "Subsubsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem1"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {Null, 
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item1Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem1", "NumberedHeads"]],

Cell[StyleData["EnunciationItem1", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem1", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem1", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem2"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item2Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem2", "NumberedHeads"]],

Cell[StyleData["EnunciationItem2", "Presentation"],
  CellMargins->{{59, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem2", "Printout"],
  CellMargins->{{20, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem2", "NumberedHeadsPrintout"],
  CellMargins->{{20, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem3"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "itemize"}, "HTML" -> {
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "Item3Label", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem3", "NumberedHeads"]],

Cell[StyleData["EnunciationItem3", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem3", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem3", "NumberedHeadsPrintout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem1Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem1Label", "NumberedHeads"]],

Cell[StyleData["EnunciationItem1Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem1Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem1Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem2Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem2Label", "NumberedHeads"]],

Cell[StyleData["EnunciationItem2Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem2Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["EnunciationItem2Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem3Label"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem3Label", "NumberedHeads"]],

Cell[StyleData["EnunciationItem3Label", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem3Label", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["EnunciationItem3Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Numbered Lists", "Subsubsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem1Numbered"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    30}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item1Numbered"], "."}], "Item1NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem1Numbered", "NumberedHeads"]],

Cell[StyleData["EnunciationItem1Numbered", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem1Numbered", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem1Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem2Numbered"],
  CellMargins->{{36, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    40}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {"(", 
            CounterBox[ "Item2Numbered"], ")"}], "Item2NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["EnunciationItem2Numbered", "NumberedHeads"]],

Cell[StyleData["EnunciationItem2Numbered", "Presentation"],
  CellMargins->{{59, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem2Numbered", "Printout"],
  CellMargins->{{20, 2}, {1, 2}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem2Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{20, 2}, {1, 2}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem3Numbered"],
  CellMargins->{{60, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"\n\\item ", ""}, "HTML" -> {"<li>", "</li>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"General" -> {"NestingLevel" -> 
    50}, "TeX" -> {"CellGroupEnvironment" -> "enumerate"}, "HTML" -> {
    "CellGroupEnvironment" -> "ol"}}},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item3Numbered"], "."}], "Item3NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None,
  FontSlant->"Italic",
  CounterBoxOptions->{CounterFunction:>RomanNumeral}],

Cell[StyleData["EnunciationItem3Numbered", "NumberedHeads"]],

Cell[StyleData["EnunciationItem3Numbered", "Presentation"],
  CellMargins->{{95, 12}, {2, 3}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem3Numbered", "Printout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem3Numbered", "NumberedHeadsPrintout"],
  CellMargins->{{40, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem1NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem1NumberedLabel", "NumberedHeads"]],

Cell[StyleData["EnunciationItem1NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem1NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem1NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem2NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem2NumberedLabel", "NumberedHeads"]],

Cell[StyleData["EnunciationItem2NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem2NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["EnunciationItem2NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem3NumberedLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["EnunciationItem3NumberedLabel", "NumberedHeads"]],

Cell[StyleData["EnunciationItem3NumberedLabel", "Presentation"],
  CellSize->{36, Inherited},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem3NumberedLabel", "Printout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None],

Cell[StyleData["EnunciationItem3NumberedLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["List Paragraphs", "Subsubsubsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem1Paragraph"],
  CellMargins->{{40, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "enumerate"}}},
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem1Paragraph", "NumberedHeads"]],

Cell[StyleData["EnunciationItem1Paragraph", "Presentation"],
  CellMargins->{{63, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem1Paragraph", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem1Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem2Paragraph"],
  CellMargins->{{64, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 2, 
    "CellGroupEnvironment" -> "enumerate"}}},
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem2Paragraph", "NumberedHeads"]],

Cell[StyleData["EnunciationItem2Paragraph", "Presentation"],
  CellMargins->{{99, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem2Paragraph", "Printout"],
  CellMargins->{{42, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem2Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{42, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EnunciationItem3Paragraph"],
  CellMargins->{{88, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 3, 
    "CellGroupEnvironment" -> "enumerate"}}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["EnunciationItem3Paragraph", "NumberedHeads"]],

Cell[StyleData["EnunciationItem3Paragraph", "Presentation"],
  CellMargins->{{135, 12}, {2, 2}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["EnunciationItem3Paragraph", "Printout"],
  CellMargins->{{62, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["EnunciationItem3Paragraph", "NumberedHeadsPrintout"],
  CellMargins->{{62, 2}, {1, 1}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Cross-References", "Section",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["XRef"],
  ConversionRules:>{"TeX" -> {"\\ref{", 
    ExtractButtonData[ "CounterTag"], "}"}, "HTML" -> {"", 
    XRefToHtmlHyperlink, ""}},
  StyleMenuListing->None],

Cell[StyleData["XRef", "NumberedHeads"]],

Cell[StyleData["XRef", "Presentation"]],

Cell[StyleData["XRef", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["XRef", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableXRef"],
  StyleMenuListing->None],

Cell[StyleData["TableXRef", "NumberedHeads"]],

Cell[StyleData["TableXRef", "Presentation"]],

Cell[StyleData["TableXRef", "Printout"]],

Cell[StyleData["TableXRef", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FigureXRef"],
  StyleMenuListing->None],

Cell[StyleData["FigureXRef", "NumberedHeads"]],

Cell[StyleData["FigureXRef", "Presentation"]],

Cell[StyleData["FigureXRef", "Printout"]],

Cell[StyleData["FigureXRef", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageRef"],
  StyleMenuListing->None],

Cell[StyleData["PageRef", "NumberedHeads"]],

Cell[StyleData["PageRef", "Presentation"]],

Cell[StyleData["PageRef", "Printout"]],

Cell[StyleData["PageRef", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Backmatter", "Section"],

Cell[CellGroupData[{

Cell[StyleData["BackmatterGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 1},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["BackmatterGroup", "NumberedHeads"]],

Cell[StyleData["BackmatterGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["BackmatterGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["BackmatterGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell["Acknowledgments", "Subsection",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["AcknowledgmentsSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\n\\section{", Automatic, "}"}, "HTML" -> {
    "<h3 class=\"AcknowledgmentsSection\">", "</h3>"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["AcknowledgmentsSection", "NumberedHeads"]],

Cell[StyleData["AcknowledgmentsSection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["AcknowledgmentsSection", "Printout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->12],

Cell[StyleData["AcknowledgmentsSection", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Acknowledgments"],
  CellMargins->{{12, 10}, {3, 5}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Acknowledgments", "NumberedHeads"]],

Cell[StyleData["Acknowledgments", "Presentation"],
  CellMargins->{{23, 10}, {5, 8}},
  FontSize->17],

Cell[StyleData["Acknowledgments", "Printout"],
  CellMargins->{{0, 12}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["Acknowledgments", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Appendix", "Subsection",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["AppendixGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 1},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["AppendixGroup", "NumberedHeads"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 1},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["AppendixGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["AppendixGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["AppendixGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AppendixSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"\n\n\\section{", "}"}, "HTML" -> {
    "<h3 class=\"AppendixSection\">", "</h3>"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  CounterIncrements->"AppendixSection",
  CounterAssignments->{{"AppendixEquation", 0}, {"Appendix", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[StyleData["AppendixSection", "NumberedHeads"],
  CellFrame->False,
  CellFrameLabels->{{Cell[ 
          TextData[ 
            CounterBox[ "AppendixSection"], "."], "SectionLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}}],

Cell[StyleData["AppendixSection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["AppendixSection", "Printout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->12],

Cell[StyleData["AppendixSection", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AppendixSectionLabel"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[StyleData["AppendixSectionLabel", "NumberedHeads"]],

Cell[StyleData["AppendixSectionLabel", "Presentation"]],

Cell[StyleData["AppendixSectionLabel", "Printout"]],

Cell[StyleData["AppendixSectionLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AppendixSectionNumber"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[StyleData["AppendixSectionNumber", "NumberedHeads"]],

Cell[StyleData["AppendixSectionNumber", "Presentation"]],

Cell[StyleData["AppendixSectionNumber", "Printout"]],

Cell[StyleData["AppendixSectionNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AppendixEquation"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"HTML" -> {{"", ""}, {
    "<table class='AppendixEquation'><tr><td>", Automatic, 
    IncludeCount[ 
    "</td><td class='AppendixEquationLabel'>(`1`.`2`)</td></tr></table>", 
      "AppendixSection", "AppendixEquation"]}}},
  TaggingRules:>{"CounterSettings" -> {"CounterFormat" -> {"AppendixSection", 
    ".", "AppendixEquation"}, "CounterTarget" -> "Cell", "XRefPrefix" -> 
    "Equation"}},
  CellFrameLabels->{{None, Cell[ 
          TextData[ {"(", 
            CounterBox[ "AppendixSection"], ".", 
            CounterBox[ "AppendixEquation"], ")"}]]}, {None, None}},
  DefaultFormatType->DefaultInputFormatType,
  InputAutoReplacements->{},
  CounterIncrements->"AppendixEquation",
  StyleMenuListing->None],

Cell[StyleData["AppendixEquation", "NumberedHeads"]],

Cell[StyleData["AppendixEquation", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  FontSize->19],

Cell[StyleData["AppendixEquation", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["AppendixEquation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Appendix"],
  CellMargins->{{12, 12}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[StyleData["Appendix", "NumberedHeads"]],

Cell[StyleData["Appendix", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["Appendix", "Printout"],
  CellMargins->{{2, 2}, {2, 4}},
  FontSize->10],

Cell[StyleData["Appendix", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 4}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Endnotes", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["EndnoteSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<h3 class=\"EndnoteSection\">", "</h3>"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  DefaultNewInlineCellStyle->"None",
  LanguageCategory->"NaturalLanguage",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Endnote", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["EndnoteSection", "NumberedHeads"]],

Cell[StyleData["EndnoteSection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["EndnoteSection", "Printout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->14],

Cell[StyleData["EndnoteSection", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {3, 18}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Endnote"],
  CellMargins->{{12, 12}, {2, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {
    "<table class=\"Endnote\"><tr valign=\"top\">", "</td></tr></table>"}},
  LineSpacing->{1, 2},
  ParagraphSpacing->{0, 0},
  ParagraphIndent->-36,
  TabSpacings->5.5,
  CounterIncrements->"Endnote",
  StyleMenuListing->None],

Cell[StyleData["Endnote", "NumberedHeads"]],

Cell[StyleData["Endnote", "Presentation"],
  CellMargins->{{23, 12}, {3, 3}},
  ParagraphIndent->-54,
  FontSize->17],

Cell[StyleData["Endnote", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  TextJustification->0.5,
  FontSize->10],

Cell[StyleData["Endnote", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  TextJustification->0.5,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteLabel"],
  ConversionRules:>{"HTML" -> {"<td class=\"EndnoteLabel\" align=\"right\">", 
    "&nbsp;</td><td>"}},
  CellSize->{36, Inherited},
  TextAlignment->Right,
  CounterIncrements->"EndnoteLabel",
  StyleMenuListing->None],

Cell[StyleData["EndnoteLabel", "NumberedHeads"]],

Cell[StyleData["EndnoteLabel", "Presentation"],
  CellSize->{54, Inherited}],

Cell[StyleData["EndnoteLabel", "Printout"]],

Cell[StyleData["EndnoteLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteNumber"],
  CellSize->{36, Inherited},
  TextAlignment->Right,
  CounterIncrements->"EndnoteNumber",
  StyleMenuListing->None],

Cell[StyleData["EndnoteNumber", "NumberedHeads"]],

Cell[StyleData["EndnoteNumber", "Presentation"],
  CellSize->{54, Inherited}],

Cell[StyleData["EndnoteNumber", "Printout"]],

Cell[StyleData["EndnoteNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["NoteKey"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(EditNote[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["NoteKey", "NumberedHeads"]],

Cell[StyleData["NoteKey", "Presentation"]],

Cell[StyleData["NoteKey", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["NoteKey", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EndnoteReturnLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["EndnoteReturnLink", "NumberedHeads"]],

Cell[StyleData["EndnoteReturnLink", "Presentation"]],

Cell[StyleData["EndnoteReturnLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}],

Cell[StyleData["EndnoteReturnLink", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TableNoteKey"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(EditTableNote[ #, #2]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonSource->ButtonContents,
  ButtonFrame->"None"}],

Cell[StyleData["TableNoteKey", "NumberedHeads"]],

Cell[StyleData["TableNoteKey", "Presentation"]],

Cell[StyleData["TableNoteKey", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["TableNoteKey", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Note"],
  Editable->False,
  Deletable->False,
  ConversionRules:>{"TeX" -> {{"\\footnote{", Convert[ 
      ExtractElement[ ][ 
        ExtractButtonData[ ][ #]]]&, "}"}, {"", Automatic, ""}}},
  ScriptMinSize->10,
  StyleMenuListing->None,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Note", "NumberedHeads"]],

Cell[StyleData["Note", "Presentation"]],

Cell[StyleData["Note", "Printout"],
  ScriptMinSize->8],

Cell[StyleData["Note", "NumberedHeadsPrintout"],
  ScriptMinSize->8]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["References", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<h3 class=\"ReferenceSection\">", "</h3>"}},
  
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> {"thebibliography", "{000}"}}}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  DefaultNewInlineCellStyle->"None",
  LanguageCategory->"NaturalLanguage",
  CounterAssignments->{{"Reference", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["ReferenceSection", "NumberedHeads"]],

Cell[StyleData["ReferenceSection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["ReferenceSection", "Printout"],
  CellMargins->{{0, 12}, {3, 18}},
  StyleMenuListing->None,
  FontSize->14],

Cell[StyleData["ReferenceSection", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {3, 18}},
  StyleMenuListing->None,
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Reference"],
  CellMargins->{{12, 12}, {2, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{"TeX" -> {"", ""}, "HTML" -> {
    "<table class=\"Reference\"><tr valign=\"top\">", "</td></tr></table>"}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> {"thebibliography", "{000}"}}}},
  Hyphenation->True,
  LineSpacing->{1, 2},
  ParagraphIndent->-36,
  CounterIncrements->"Reference",
  StyleMenuListing->None],

Cell[StyleData["Reference", "NumberedHeads"]],

Cell[StyleData["Reference", "Presentation"],
  CellMargins->{{23, 12}, {3, 3}},
  ParagraphIndent->-54,
  FontSize->17],

Cell[StyleData["Reference", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["Reference", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceLabel"],
  ConversionRules:>{"HTML" -> {
    "<td class=\"ReferenceLabel\" align=\"right\">", "&nbsp;</td><td>"}},
  CellSize->{36, Inherited},
  TextAlignment->Right,
  CounterIncrements->"ReferenceLabel",
  StyleMenuListing->None],

Cell[StyleData["ReferenceLabel", "NumberedHeads"]],

Cell[StyleData["ReferenceLabel", "Presentation"],
  CellSize->{54, Inherited}],

Cell[StyleData["ReferenceLabel", "Printout"]],

Cell[StyleData["ReferenceLabel", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceNumber"],
  StyleMenuListing->None],

Cell[StyleData["ReferenceNumber", "NumberedHeads"]],

Cell[StyleData["ReferenceNumber", "Presentation"]],

Cell[StyleData["ReferenceNumber", "Printout"]],

Cell[StyleData["ReferenceNumber", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefSep"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["RefSep", "NumberedHeads"]],

Cell[StyleData["RefSep", "Presentation"]],

Cell[StyleData["RefSep", "Printout"]],

Cell[StyleData["RefSep", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefReturnLink"],
  ConversionRules:>{"TeX" -> {"\n\\bibitem{", DeleteCharacter[ 5][ 
      ExtractButtonData[ ][ #]]&, "}"}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Times",
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefReturnLink", "NumberedHeads"]],

Cell[StyleData["RefReturnLink", "Presentation"]],

Cell[StyleData["RefReturnLink", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["RefReturnLink", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefReturnPointer"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Mathematica4",
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefReturnPointer", "NumberedHeads"]],

Cell[StyleData["RefReturnPointer", "Presentation"]],

Cell[StyleData["RefReturnPointer", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["RefReturnPointer", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceSourceLink"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"<!--", "-->"}}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Mathematica4",
  FontSize->1,
  FontColor->GrayLevel[1],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["ReferenceSourceLink", "NumberedHeads"]],

Cell[StyleData["ReferenceSourceLink", "Presentation"]],

Cell[StyleData["ReferenceSourceLink", "Printout"],
  FontColor->GrayLevel[1]],

Cell[StyleData["ReferenceSourceLink", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[StyleData["ReferenceSourceURL"],
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Citation"],
  ConversionRules:>{"TeX" -> {"\\cite{", 
    ExtractButtonData[ ], "}"}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(ListDataLink[ #2]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["Citation", "NumberedHeads"]],

Cell[StyleData["Citation", "Presentation"]],

Cell[StyleData["Citation", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["Citation", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["RefKey"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 0.500008],
  ButtonBoxOptions->{ButtonFunction:>(EditRef[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["RefKey", "NumberedHeads"]],

Cell[StyleData["RefKey", "Presentation"]],

Cell[StyleData["RefKey", "Printout"],
  FontColor->GrayLevel[0]],

Cell[StyleData["RefKey", "NumberedHeadsPrintout"],
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell["References Templates", "Subsubsection",
  StyleMenuListing->None],

Cell["FirstAuthor:<Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["OtherAuthors:, <Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["LastAuthor:, & <Last>, <FirstInitial>. <MiddleInitial>.", \
"ReferenceTemplate"],

Cell["FirstEditor:<FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["OtherEditors:, <FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["LastEditor: & <FirstInitial>. <MiddleInitial>. <Last>", \
"ReferenceTemplate"],

Cell["Sorting:None", "ReferenceTemplate"],

Cell["ReferenceAuthorMax:4", "ReferenceTemplate"],

Cell["ReferenceEditorMax:4", "ReferenceTemplate"],

Cell["ReferenceAuthorMin:1", "ReferenceTemplate"],

Cell["ReferenceEditorMin:1", "ReferenceTemplate"],

Cell["AbbreviatedAuthors:, et al.", "ReferenceTemplate"],

Cell["AbbreviatedEditors:, et al.", "ReferenceTemplate"],

Cell[CellGroupData[{

Cell["Article Templates", "Subsubsubsection"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>, <PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>. \
Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>, <Month>). <Title>. <JournalTitle>, <JournalVolume>. \
\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).  Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>).\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>, \
<PageRange>. \
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>. \
Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
Article:<Author> (<Year>). <Title>. <JournalTitle>, <JournalVolume>. \
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"Article\" references \
that don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
Article:<Author> (<Year>, <Month> <Day>). <Title>. <JournalTitle>, \
<JournalVolume>(<JournalNumber>), <PageRange>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["In Book Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"InBook\" references.)\
\>", "Text"],

Cell["\<\
InBook:<Author> (<Year>). <Title>. In <Editor> (Ed.), <BookTitle> (pp. \
<PageRange>). <City>: <Publisher>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Whole Book Templates", "Subsubsubsection"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>. Retrieved \
<RetrievalDate> from <URL>\
\>", "ReferenceTemplate"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>.\
\>", "ReferenceTemplate"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. Retrieved <RetrievalDate> from \
<URL>\
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"Book\" references that \
don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
WholeBook:<Author> (<Year>). <BookTitle>. <City>: <Publisher>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Thesis Templates", "Subsubsubsection"],

Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, <School>, \
<City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", "ReferenceTemplate"],

Cell["\<\
PhdThesis:<Author> (<Year>). <BookTitle>. Unpublished doctoral dissertation, \
<School>, <City>.\
\>", "ReferenceTemplate"],

Cell["\<\
(The following template is the default template for \"PhdThesis\" references \
that don't match any of the above templates.)\
\>", "Text"],

Cell["\<\
PhdThesis:<Author> (<Year>). <Title> (Doctoral Dissertation, <School>, \
<City>). <SourceOfAbstract>, <JournalVolume>, <PageRange>.\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Technical Report Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"TechReport\" \
references.)\
\>", "Text"],

Cell["\<\
TechReport:<Author> (<Year>). <Title>. <School>, <City>. <ReportNumber>, \
<Submittedby>\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Online Source Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"OnlineSource\" \
references.)\
\>", "Text"],

Cell["\<\
OnlineSource:<Author>, <Title>. Retrieved <RetrievalDate> from <URL>\
\>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Preprint Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"Preprint\" references.)\
\
\>", "Text"],

Cell["Preprint:<Author> (<Year>). <Title>. <PublicationStatus>", \
"ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Plain Insertion Template", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \
\[OpenCurlyDoubleQuote]PlainInsert\" references.)\
\>", "Text"],

Cell["PlainInsert:<InsertedBibText>", "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{

Cell["Note Templates", "Subsubsubsection"],

Cell["\<\
(The following template is the default template for \"Note\" references.)\
\>", "Text"],

Cell["Note:<NoteText>", "ReferenceTemplate"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Common Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefTitle"],
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["RefType"],
  CellSize->{0, 12},
  StyleMenuListing->None],

Cell[StyleData["RefURL"],
  StyleMenuListing->None],

Cell[StyleData["RefRetrievalDate"],
  StyleMenuListing->None],

Cell[StyleData["RefSourceOfAbstract"],
  StyleMenuListing->None],

Cell[StyleData["RefInsertedBibText"],
  StyleMenuListing->None],

Cell[StyleData["RefNote"],
  StyleMenuListing->None],

Cell[StyleData["RefReviewVolume"],
  ConversionRules:>{"TeX" -> {"\\textbf{", "}"}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["RefReviewNumber"],
  StyleMenuListing->None],

Cell[StyleData["RefDatabase"],
  StyleMenuListing->None],

Cell[StyleData["RefVolume"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefBookTitle"],
  ConversionRules:>{"TeX" -> {"\\textit{", "}"}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["RefBookSubTitle"],
  StyleMenuListing->None],

Cell[StyleData["RefBookSubsubTitle"],
  StyleMenuListing->None],

Cell[StyleData["RefBookEdition"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Journal Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefJournalTitle"],
  ConversionRules:>{"TeX" -> {"\\textit{", "}"}},
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["RefJournalVolume"],
  ConversionRules:>{"TeX" -> {"\\textbf{", #&, "}"}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["RefJournalNumber"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Publisher Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefPublisher"],
  StyleMenuListing->None],

Cell[StyleData["RefAddress"],
  StyleMenuListing->None],

Cell[StyleData["RefCity"],
  StyleMenuListing->None],

Cell[StyleData["RefState"],
  StyleMenuListing->None],

Cell[StyleData["RefCountry"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Author Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefAuthorGroup"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorFN"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorLN"],
  StyleMenuListing->None],

Cell[StyleData["RefAuthorMN"],
  StyleMenuListing->None],

Cell[StyleData["RefInstitution"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Editor Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefEditorGroup"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorFN"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorMN"],
  StyleMenuListing->None],

Cell[StyleData["RefEditorLN"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["School Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefSchool"],
  StyleMenuListing->None],

Cell[StyleData["RefSchoolDept"],
  ConversionRules:>{"TeX" -> {"\\textit{", "}"}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["RefSchoolAddress"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Publication Date Data Field Styles", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefDay"],
  StyleMenuListing->None],

Cell[StyleData["RefMonth"],
  StyleMenuListing->None],

Cell[StyleData["RefYear"],
  StyleMenuListing->None],

Cell[StyleData["RefPublicationStatus"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Data Field Styles: Auto Generated and Contiguous Pages", \
"Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefPageRange"],
  StyleMenuListing->None],

Cell[StyleData["RefFirstPage"],
  StyleMenuListing->None],

Cell[StyleData["RefLastPage"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Page Data Field Styles: Noncontiguous Pages", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefDiscretePageList"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["In Note RefType", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefNoteText"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["In TechReport RefType", "Subsubsection",
  StyleMenuListing->None],

Cell[StyleData["RefReportNumber"],
  StyleMenuListing->None],

Cell[StyleData["RefSubmittedby"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Index", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["IndexSection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 30},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"<h3 class=\"IndexSection\">", "</h3>"}},
  PageBreakBelow->False,
  CellFrameMargins->{{0, 0}, {3, 0}},
  DefaultNewInlineCellStyle->"None",
  LineSpacing->{1, 7},
  LanguageCategory->"NaturalLanguage",
  CounterAssignments->{{"IndexEntry", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["IndexSection", "NumberedHeads"]],

Cell[StyleData["IndexSection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["IndexSection", "Printout"],
  CellMargins->{{0, 12}, {3, 18}},
  StyleMenuListing->None,
  FontSize->14],

Cell[StyleData["IndexSection", "NumberedHeadsPrintout"],
  CellMargins->{{0, 12}, {3, 18}},
  StyleMenuListing->None,
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexEntry"],
  CellMargins->{{12, 12}, {2, 0}},
  CellGroupingRules->"GraphicsGrouping",
  ParagraphIndent->-24,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->11],

Cell[StyleData["IndexEntry", "NumberedHeads"]],

Cell[StyleData["IndexEntry", "Presentation"],
  CellMargins->{{23, 12}, {3, 0}},
  ParagraphIndent->-36,
  FontSize->17],

Cell[StyleData["IndexEntry", "Printout"],
  CellMargins->{{2, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9],

Cell[StyleData["IndexEntry", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexSubentry"],
  CellMargins->{{24, 12}, {2, 0}},
  CellGroupingRules->"GraphicsGrouping",
  ParagraphIndent->-12,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->11],

Cell[StyleData["IndexSubentry", "NumberedHeads"]],

Cell[StyleData["IndexSubentry", "Presentation"],
  CellMargins->{{35, 12}, {3, 0}},
  ParagraphIndent->-18,
  FontSize->17],

Cell[StyleData["IndexSubentry", "Printout"],
  CellMargins->{{18, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9],

Cell[StyleData["IndexSubentry", "NumberedHeadsPrintout"],
  CellMargins->{{18, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexSubsubentry"],
  CellMargins->{{36, 12}, {2, 0}},
  CellGroupingRules->"GraphicsGrouping",
  ParagraphIndent->-12,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->11],

Cell[StyleData["IndexSubsubentry", "NumberedHeads"]],

Cell[StyleData["IndexSubsubentry", "Presentation"],
  CellMargins->{{47, 12}, {3, 0}},
  ParagraphIndent->-18,
  FontSize->17],

Cell[StyleData["IndexSubsubentry", "Printout"],
  CellMargins->{{30, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9],

Cell[StyleData["IndexSubsubentry", "NumberedHeadsPrintout"],
  CellMargins->{{30, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexNote"],
  CellMargins->{{12, 12}, {2, 0}},
  CellGroupingRules->"GraphicsGrouping",
  TextAlignment->Left,
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->11,
  FontSlant->"Italic"],

Cell[StyleData["IndexNote", "NumberedHeads"]],

Cell[StyleData["IndexNote", "Presentation"],
  CellMargins->{{23, 12}, {3, 0}},
  FontSize->17],

Cell[StyleData["IndexNote", "Printout"],
  CellMargins->{{2, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9],

Cell[StyleData["IndexNote", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 0}},
  StyleMenuListing->None,
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndexSpacer"],
  StyleMenuListing->None],

Cell[StyleData["IndexSpacer", "NumberedHeads"]],

Cell[StyleData["IndexSpacer", "Presentation"]],

Cell[StyleData["IndexSpacer", "Printout"]],

Cell[StyleData["IndexSpacer", "Printout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Elements", "Section",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell["Book Frontmatter", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["FrontMatterTitle"],
  StyleMenuListing->None],

Cell[StyleData["FrontMatterTitle", "NumberedHeads"]],

Cell[StyleData["FrontMatterTitle", "Presentation"]],

Cell[StyleData["FrontMatterTitle", "Printout"]],

Cell[StyleData["FrontMatterTitle", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell["BookHalfTitle Page", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["HalfTitle"],
  StyleMenuListing->None],

Cell[StyleData["HalfTitle", "NumberedHeads"]],

Cell[StyleData["HalfTitle", "Presentation"]],

Cell[StyleData["HalfTitle", "Printout"]],

Cell[StyleData["HalfTitle", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Series Information", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Series"],
  StyleMenuListing->None],

Cell[StyleData["Series", "NumberedHeads"]],

Cell[StyleData["Series", "Presentation"]],

Cell[StyleData["Series", "Printout"]],

Cell[StyleData["Series", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SeriesVolume"],
  StyleMenuListing->None],

Cell[StyleData["SeriesVolume", "NumberedHeads"]],

Cell[StyleData["SeriesVolume", "Presentation"]],

Cell[StyleData["SeriesVolume", "Printout"]],

Cell[StyleData["SeriesVolume", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SeriesEditor"],
  StyleMenuListing->None],

Cell[StyleData["SeriesEditor", "NumberedHeads"]],

Cell[StyleData["SeriesEditor", "Presentation"]],

Cell[StyleData["SeriesEditor", "Printout"]],

Cell[StyleData["SeriesEditor", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Symposium Information", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Symposium"],
  StyleMenuListing->None],

Cell[StyleData["Symposium", "NumberedHeads"]],

Cell[StyleData["Symposium", "Presentation"]],

Cell[StyleData["Symposium", "Printout"]],

Cell[StyleData["Symposium", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SymposiumCity"],
  StyleMenuListing->None],

Cell[StyleData["SymposiumCity", "NumberedHeads"]],

Cell[StyleData["SymposiumCity", "Presentation"]],

Cell[StyleData["SymposiumCity", "Printout"]],

Cell[StyleData["SymposiumCity", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SymposiumDate"],
  StyleMenuListing->None],

Cell[StyleData["SymposiumDate", "NumberedHeads"]],

Cell[StyleData["SymposiumDate", "Presentation"]],

Cell[StyleData["SymposiumDate", "Printout"]],

Cell[StyleData["SymposiumDate", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SymposiumEditor"],
  StyleMenuListing->None],

Cell[StyleData["SymposiumEditor", "NumberedHeads"]],

Cell[StyleData["SymposiumEditor", "Presentation"]],

Cell[StyleData["SymposiumEditor", "Printout"]],

Cell[StyleData["SymposiumEditor", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SymposiumSponsor"],
  StyleMenuListing->None],

Cell[StyleData["SymposiumSponsor", "NumberedHeads"]],

Cell[StyleData["SymposiumSponsor", "Presentation"]],

Cell[StyleData["SymposiumSponsor", "Printout"]],

Cell[StyleData["SymposiumSponsor", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Author's Previous Publications", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["AuthorsPreviousPublications"],
  StyleMenuListing->None],

Cell[StyleData["AuthorsPreviousPublications", "NumberedHeads"]],

Cell[StyleData["AuthorsPreviousPublications", "Presentation"]],

Cell[StyleData["AuthorsPreviousPublications", "Printout"]],

Cell[StyleData["AuthorsPreviousPublications", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Title Page", "Subsubsection"],

Cell[CellGroupData[{

Cell["Book Editor", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["EditorFirstName"],
  StyleMenuListing->None],

Cell[StyleData["EditorFirstName", "NumberedHeads"]],

Cell[StyleData["EditorFirstName", "Presentation"]],

Cell[StyleData["EditorFirstName", "Printout"]],

Cell[StyleData["EditorFirstName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EditorMiddleName"],
  StyleMenuListing->None],

Cell[StyleData["EditorMiddleName", "NumberedHeads"]],

Cell[StyleData["EditorMiddleName", "Presentation"]],

Cell[StyleData["EditorMiddleName", "Printout"]],

Cell[StyleData["EditorMiddleName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EditorLastName"],
  StyleMenuListing->None],

Cell[StyleData["EditorLastName", "NumberedHeads"]],

Cell[StyleData["EditorLastName", "Presentation"]],

Cell[StyleData["EditorLastName", "Printout"]],

Cell[StyleData["EditorLastName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EditorNameSuffix"],
  StyleMenuListing->None],

Cell[StyleData["EditorNameSuffix", "NumberedHeads"]],

Cell[StyleData["EditorNameSuffix", "Presentation"]],

Cell[StyleData["EditorNameSuffix", "Printout"]],

Cell[StyleData["EditorNameSuffix", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EditorInstitution"],
  StyleMenuListing->None],

Cell[StyleData["EditorInstitution", "NumberedHeads"]],

Cell[StyleData["EditorInstitution", "Presentation"]],

Cell[StyleData["EditorInstitution", "Printout"]],

Cell[StyleData["EditorInstitution", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EditorAltInstitution"],
  StyleMenuListing->None],

Cell[StyleData["EditorAltInstitution", "NumberedHeads"]],

Cell[StyleData["EditorAltInstitution", "Presentation"]],

Cell[StyleData["EditorAltInstitution", "Printout"]],

Cell[StyleData["EditorAltInstitution", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Translator", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["TranslatorFirstName"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorFirstName", "NumberedHeads"]],

Cell[StyleData["TranslatorFirstName", "Presentation"]],

Cell[StyleData["TranslatorFirstName", "Printout"]],

Cell[StyleData["TranslatorFirstName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TranslatorMiddleName"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorMiddleName", "NumberedHeads"]],

Cell[StyleData["TranslatorMiddleName", "Presentation"]],

Cell[StyleData["TranslatorMiddleName", "Printout"]],

Cell[StyleData["TranslatorMiddleName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TranslatorLastName"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorLastName", "NumberedHeads"]],

Cell[StyleData["TranslatorLastName", "Presentation"]],

Cell[StyleData["TranslatorLastName", "Printout"]],

Cell[StyleData["TranslatorLastName", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TranslatorNameSuffix"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorNameSuffix", "NumberedHeads"]],

Cell[StyleData["TranslatorNameSuffix", "Presentation"]],

Cell[StyleData["TranslatorNameSuffix", "Printout"]],

Cell[StyleData["TranslatorNameSuffix", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TranslatorInstitution"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorInstitution", "NumberedHeads"]],

Cell[StyleData["TranslatorInstitution", "Presentation"]],

Cell[StyleData["TranslatorInstitution", "Printout"]],

Cell[StyleData["TranslatorInstitution", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TranslatorAltInstitution"],
  StyleMenuListing->None],

Cell[StyleData["TranslatorAltInstitution", "NumberedHeads"]],

Cell[StyleData["TranslatorAltInstitution", "Presentation"]],

Cell[StyleData["TranslatorAltInstitution", "Printout"]],

Cell[StyleData["TranslatorAltInstitution", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Publication Information", "Subsubsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Publisher"],
  StyleMenuListing->None],

Cell[StyleData["Publisher", "NumberedHeads"]],

Cell[StyleData["Publisher", "Presentation"]],

Cell[StyleData["Publisher", "Printout"]],

Cell[StyleData["Publisher", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PublisherCities"],
  StyleMenuListing->None],

Cell[StyleData["PublisherCities", "NumberedHeads"]],

Cell[StyleData["PublisherCities", "Presentation"]],

Cell[StyleData["PublisherCities", "Printout"]],

Cell[StyleData["PublisherCities", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PublisherURL"],
  StyleMenuListing->None],

Cell[StyleData["PublisherURL", "NumberedHeads"]],

Cell[StyleData["PublisherURL", "Presentation"]],

Cell[StyleData["PublisherURL", "Printout"]],

Cell[StyleData["PublisherURL", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PublicationYear"],
  StyleMenuListing->None],

Cell[StyleData["PublicationYear", "NumberedHeads"]],

Cell[StyleData["PublicationYear", "Presentation"]],

Cell[StyleData["PublicationYear", "Printout"]],

Cell[StyleData["PublicationYear", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Copyright Page", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["CopyrightNotice"],
  StyleMenuListing->None],

Cell[StyleData["CopyrightNotice", "NumberedHeads"]],

Cell[StyleData["CopyrightNotice", "Presentation"]],

Cell[StyleData["CopyrightNotice", "Printout"]],

Cell[StyleData["CopyrightNotice", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PublishingHistory"],
  StyleMenuListing->None],

Cell[StyleData["PublishingHistory", "NumberedHeads"]],

Cell[StyleData["PublishingHistory", "Presentation"]],

Cell[StyleData["PublishingHistory", "Printout"]],

Cell[StyleData["PublishingHistory", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CountryWherePrinted"],
  StyleMenuListing->None],

Cell[StyleData["CountryWherePrinted", "NumberedHeads"]],

Cell[StyleData["CountryWherePrinted", "Presentation"]],

Cell[StyleData["CountryWherePrinted", "Printout"]],

Cell[StyleData["CountryWherePrinted", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PublisherAddress"],
  StyleMenuListing->None],

Cell[StyleData["PublisherAddress", "NumberedHeads"]],

Cell[StyleData["PublisherAddress", "Presentation"]],

Cell[StyleData["PublisherAddress", "Printout"]],

Cell[StyleData["PublisherAddress", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LibraryofCongressCIPDataSection"],
  StyleMenuListing->None],

Cell[StyleData["LibraryofCongressCIPDataSection", "NumberedHeads"]],

Cell[StyleData["LibraryofCongressCIPDataSection", "Presentation"]],

Cell[StyleData["LibraryofCongressCIPDataSection", "Printout"]],

Cell[StyleData["LibraryofCongressCIPDataSection", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["LibraryofCongressCIPData"],
  StyleMenuListing->None],

Cell[StyleData["LibraryofCongressCIPData", "NumberedHeads"]],

Cell[StyleData["LibraryofCongressCIPData", "Presentation"]],

Cell[StyleData["LibraryofCongressCIPData", "Printout"]],

Cell[StyleData["LibraryofCongressCIPData", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ISBN"],
  StyleMenuListing->None],

Cell[StyleData["ISBN", "NumberedHeads"]],

Cell[StyleData["ISBN", "Presentation"]],

Cell[StyleData["ISBN", "Printout"]],

Cell[StyleData["ISBN", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrintingNumbers"],
  StyleMenuListing->None],

Cell[StyleData["PrintingNumbers", "NumberedHeads"]],

Cell[StyleData["PrintingNumbers", "Presentation"]],

Cell[StyleData["PrintingNumbers", "Printout"]],

Cell[StyleData["PrintingNumbers", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Frontmatter Epigraph", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["FrontMatterEpigraph"],
  StyleMenuListing->None],

Cell[StyleData["FrontMatterEpigraph", "NumberedHeads"]],

Cell[StyleData["FrontMatterEpigraph", "Presentation"]],

Cell[StyleData["FrontMatterEpigraph", "Printout"]],

Cell[StyleData["FrontMatterEpigraph", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FrontMatterEpigraphAuthor"],
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["FrontMatterEpigraphAuthor", "NumberedHeads"]],

Cell[StyleData["FrontMatterEpigraphAuthor", "Presentation"]],

Cell[StyleData["FrontMatterEpigraphAuthor", "Printout"]],

Cell[StyleData["FrontMatterEpigraphAuthor", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["FrontMatterEpigraphSource"],
  TextAlignment->Right,
  StyleMenuListing->None],

Cell[StyleData["FrontMatterEpigraphSource", "NumberedHeads"]],

Cell[StyleData["FrontMatterEpigraphSource", "Presentation"]],

Cell[StyleData["FrontMatterEpigraphSource", "Printout"]],

Cell[StyleData["FrontMatterEpigraphSource", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell["Book Table of Contents (MOVED to frontmatter/TOC/Book)", "Subsubsection"],

Cell[CellGroupData[{

Cell["Book Preface", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["PrefaceSection"],
  StyleMenuListing->None],

Cell[StyleData["PrefaceSection", "NumberedHeads"]],

Cell[StyleData["PrefaceSection", "Presentation"]],

Cell[StyleData["PrefaceSection", "Printout"]],

Cell[StyleData["PrefaceSection", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Preface"],
  StyleMenuListing->None],

Cell[StyleData["Preface", "NumberedHeads"]],

Cell[StyleData["Preface", "Presentation"]],

Cell[StyleData["Preface", "Printout"]],

Cell[StyleData["Preface", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PrefaceAuthor"],
  StyleMenuListing->None],

Cell[StyleData["PrefaceAuthor", "NumberedHeads"]],

Cell[StyleData["PrefaceAuthor", "Presentation"]],

Cell[StyleData["PrefaceAuthor", "Printout"]],

Cell[StyleData["PrefaceAuthor", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Foreword", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["Foreword"],
  StyleMenuListing->None],

Cell[StyleData["Foreword", "NumberedHeads"]],

Cell[StyleData["Foreword", "Presentation"]],

Cell[StyleData["Foreword", "Printout"]],

Cell[StyleData["Foreword", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ForewordAuthor"],
  StyleMenuListing->None],

Cell[StyleData["ForewordAuthor", "NumberedHeads"]],

Cell[StyleData["ForewordAuthor", "Presentation"]],

Cell[StyleData["ForewordAuthor", "Printout"]],

Cell[StyleData["ForewordAuthor", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Part", "Subsection",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["BookPartLabel"],
  CellMargins->{{54, 54}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 10},
  TextAlignment->Center,
  CounterIncrements->"Part",
  CounterAssignments->{{"Chapter", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->27,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],

Cell[StyleData["BookPartLabel", "NumberedHeads"]],

Cell[StyleData["BookPartLabel", "Presentation"],
  CellMargins->{{54, 54}, {11, 11}},
  FontSize->41],

Cell[StyleData["BookPartLabel", "Printout"],
  CellMargins->{{48, 48}, {6, 6}},
  StyleMenuListing->None,
  FontSize->24],

Cell[StyleData["BookPartLabel", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {6, 6}},
  StyleMenuListing->None,
  FontSize->24]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartNumber"],
  CellMargins->{{54, 54}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->27,
  FontWeight->"Bold"],

Cell[StyleData["BookPartNumber", "NumberedHeads"]],

Cell[StyleData["BookPartNumber", "Presentation"],
  CellMargins->{{54, 54}, {11, 11}},
  FontSize->41],

Cell[StyleData["BookPartNumber", "Printout"],
  CellMargins->{{48, 48}, {6, 6}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontSize->24],

Cell[StyleData["BookPartNumber", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {6, 6}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontSize->24]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartTitle"],
  CellMargins->{{54, 54}, {12, 7}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->36,
  FontWeight->"Bold"],

Cell[StyleData["BookPartTitle", "NumberedHeads"]],

Cell[StyleData["BookPartTitle", "Presentation"],
  CellMargins->{{54, 54}, {18, 11}},
  FontSize->54],

Cell[StyleData["BookPartTitle", "Printout"],
  CellMargins->{{48, 48}, {10, 6}},
  StyleMenuListing->None,
  FontSize->30],

Cell[StyleData["BookPartTitle", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {10, 6}},
  StyleMenuListing->None,
  FontSize->30]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartSubtitle"],
  CellMargins->{{54, 54}, {12, 7}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["BookPartSubtitle", "NumberedHeads"]],

Cell[StyleData["BookPartSubtitle", "Presentation"],
  CellMargins->{{54, 54}, {18, 11}},
  FontSize->36],

Cell[StyleData["BookPartSubtitle", "Printout"],
  CellMargins->{{48, 48}, {10, 6}},
  StyleMenuListing->None,
  FontSize->21],

Cell[StyleData["BookPartSubtitle", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {10, 6}},
  StyleMenuListing->None,
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartSubsubtitle"],
  CellMargins->{{54, 54}, {12, Inherited}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->18,
  FontWeight->"Plain"],

Cell[StyleData["BookPartSubsubtitle", "NumberedHeads"]],

Cell[StyleData["BookPartSubsubtitle", "Presentation"],
  CellMargins->{{54, 54}, {18, Inherited}},
  FontSize->27],

Cell[StyleData["BookPartSubsubtitle", "Printout"],
  CellMargins->{{48, 48}, {10, Inherited}},
  StyleMenuListing->None,
  FontSize->16],

Cell[StyleData["BookPartSubsubtitle", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {10, Inherited}},
  StyleMenuListing->None,
  FontSize->16]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartText"],
  CellMargins->{{72, 72}, {7, 7}},
  TextJustification->1,
  ParagraphIndent->12,
  StyleMenuListing->None],

Cell[StyleData["BookPartText", "NumberedHeads"]],

Cell[StyleData["BookPartText", "Presentation"],
  CellMargins->{{72, 72}, {11, 11}},
  ParagraphIndent->17,
  FontSize->17],

Cell[StyleData["BookPartText", "Printout"],
  CellMargins->{{60, 60}, {5, 5}},
  ParagraphIndent->10,
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["BookPartText", "NumberedHeadsPrintout"],
  CellMargins->{{60, 60}, {5, 5}},
  ParagraphIndent->10,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookPartTextNoIndent"],
  CellMargins->{{72, 72}, {7, 7}},
  TextJustification->1,
  StyleMenuListing->None],

Cell[StyleData["BookPartTextNoIndent", "NumberedHeads"]],

Cell[StyleData["BookPartTextNoIndent", "Presentation"],
  CellMargins->{{72, 72}, {11, 11}},
  FontSize->17],

Cell[StyleData["BookPartTextNoIndent", "Printout"],
  CellMargins->{{60, 60}, {5, 5}},
  StyleMenuListing->None,
  FontSize->10],

Cell[StyleData["BookPartTextNoIndent", "NumberedHeadsPrintout"],
  CellMargins->{{60, 60}, {5, 5}},
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Chapter", "Subsection",
  GeneratedCell->False,
  CellAutoOverwrite->False,
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["BookChapterLabel"],
  CellMargins->{{12, 12}, {4, 72}},
  CellGroupingRules->{"SectionGrouping", 20},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  PageBreakAbove->True,
  PageBreakBelow->False,
  CellFrameMargins->1,
  LineSpacing->{1, 2},
  CounterIncrements->"Chapter",
  CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
      "Subsubsection", 0}, {"EquationNumbered", 0}, {"FigureCaption", 0}, {
      "PictureCaption", 0}, {"ProgramCaption", 0}, {"TableTitle", 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->13,
  FontWeight->"Plain"],

Cell[StyleData["BookChapterLabel", "NumberedHeads"]],

Cell[StyleData["BookChapterLabel", "Presentation"],
  CellMargins->{{23, 12}, {6, 108}},
  PageBreakAbove->False,
  FontSize->20],

Cell[StyleData["BookChapterLabel", "Printout"],
  CellMargins->{{2, 2}, {3, 60}},
  FontSize->11],

Cell[StyleData["BookChapterLabel", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 60}},
  FontSize->11]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookChapterNumber"],
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->19,
  FontWeight->"Bold"],

Cell[StyleData["BookChapterNumber", "NumberedHeads"]],

Cell[StyleData["BookChapterNumber", "Presentation"],
  FontSize->29],

Cell[StyleData["BookChapterNumber", "Printout"],
  FontSize->17],

Cell[StyleData["BookChapterNumber", "NumberedHeadsPrintout"],
  FontSize->17]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookChapterTitle"],
  CellMargins->{{12, 12}, {24, 4}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["BookChapterTitle", "NumberedHeads"]],

Cell[StyleData["BookChapterTitle", "Presentation"],
  CellMargins->{{23, 12}, {36, 6}},
  FontSize->36],

Cell[StyleData["BookChapterTitle", "Printout"],
  CellMargins->{{2, 2}, {21, 3}},
  StyleMenuListing->None,
  FontSize->21],

Cell[StyleData["BookChapterTitle", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {21, 3}},
  StyleMenuListing->None,
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookChapterSubtitle"],
  StyleMenuListing->None],

Cell[StyleData["BookChapterSubtitle", "NumberedHeads"]],

Cell[StyleData["BookChapterSubtitle", "Presentation"]],

Cell[StyleData["BookChapterSubtitle", "Printout"]],

Cell[StyleData["BookChapterSubtitle", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["BookChapterSubsubtitle"],
  StyleMenuListing->None],

Cell[StyleData["BookChapterSubsubtitle", "NumberedHeads"]],

Cell[StyleData["BookChapterSubsubtitle", "Presentation"]],

Cell[StyleData["BookChapterSubsubtitle", "Printout"]],

Cell[StyleData["BookChapterSubsubtitle", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Epigraph", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["Epigraph"],
  CellMargins->{{54, 54}, {0, 0}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["Epigraph", "NumberedHeads"]],

Cell[StyleData["Epigraph", "Presentation"],
  FontSize->17],

Cell[StyleData["Epigraph", "Printout"],
  CellMargins->{{48, 48}, {0, 0}},
  FontSize->10],

Cell[StyleData["Epigraph", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {0, 0}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["EpigraphAuthor"],
  CellMargins->{{54, 54}, {24, 12}},
  CellGroupingRules->"GraphicsGrouping",
  StyleMenuListing->None],

Cell[StyleData["EpigraphAuthor", "NumberedHeads"]],

Cell[StyleData["EpigraphAuthor", "Presentation"],
  CellMargins->{{54, 54}, {36, 18}},
  FontSize->17],

Cell[StyleData["EpigraphAuthor", "Printout"],
  CellMargins->{{48, 48}, {21, 10}},
  FontSize->10],

Cell[StyleData["EpigraphAuthor", "NumberedHeadsPrintout"],
  CellMargins->{{48, 48}, {21, 10}},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Backmatter", "Subsection"],

Cell[CellGroupData[{

Cell["Glossary", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["GlossarySection"],
  StyleMenuListing->None],

Cell[StyleData["GlossarySection", "NumberedHeads"]],

Cell[StyleData["GlossarySection", "Presentation"]],

Cell[StyleData["GlossarySection", "Printout"]],

Cell[StyleData["GlossarySection", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GlossaryEntry"],
  StyleMenuListing->None],

Cell[StyleData["GlossaryEntry", "NumberedHeads"]],

Cell[StyleData["GlossaryEntry", "Presentation"]],

Cell[StyleData["GlossaryEntry", "Printout"]],

Cell[StyleData["GlossaryEntry", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Book Frontmatter or Backmatter", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Colophon"],
  StyleMenuListing->None],

Cell[StyleData["Colophon", "NumberedHeads"]],

Cell[StyleData["Colophon", "Presentation"]],

Cell[StyleData["Colophon", "Printout"]],

Cell[StyleData["Colophon", "NumberedHeadsPrintout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["AcknowledgmentsAuthor"],
  StyleMenuListing->None],

Cell[StyleData["AcknowledgmentsAuthor", "NumberedHeads"]],

Cell[StyleData["AcknowledgmentsAuthor", "Presentation"]],

Cell[StyleData["AcknowledgmentsAuthor", "Printout"]],

Cell[StyleData["AcknowledgmentsAuthor", "NumberedHeadsPrintout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Headers and Footers", "Section"],

Cell[StyleData["Header"],
  CellMargins->{{0, 0}, {4, 1}},
  StyleMenuListing->None,
  FontSize->10,
  FontSlant->"Italic"],

Cell[StyleData["Footer"],
  CellMargins->{{0, 0}, {0, 4}},
  StyleMenuListing->None,
  FontSize->9,
  FontSlant->"Italic"],

Cell[StyleData["PageNumber"],
  CellMargins->{{0, 0}, {4, 1}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell["Miscellaneous", "Section"],

Cell[StyleData["TextSuperscript"],
  ConversionRules:>{"TeX" -> {{"", 
    ConvertTextSuperscriptToLaTeX[ ], ""}, {"", Automatic, ""}}},
  ScriptMinSize->10,
  SingleLetterItalics->False,
  StyleMenuListing->None],

Cell[StyleData["TextSubscript"],
  ScriptMinSize->10,
  SingleLetterItalics->False,
  StyleMenuListing->None],

Cell[StyleData["Nil"],
  StyleMenuListing->None],

Cell[StyleData["Verbatim"],
  StyleMenuListing->None,
  FontSize->12],

Cell[StyleData["TeXName"],
  ConversionRules:>{"TeX" -> {"\\TeX\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["LaTeXName"],
  ConversionRules:>{"TeX" -> {"\\LaTeX\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["LaTeXeName"],
  ConversionRules:>{"TeX" -> {"\\LaTeXe\\", 
    NoOutput[ ], ""}},
  StyleMenuListing->None],

Cell[StyleData["ChemicalElement"],
  SingleLetterItalics->False,
  ZeroWidthTimes->True,
  StyleMenuListing->None],

Cell[StyleData["CustomCharacter"],
  SingleLetterItalics->False,
  StyleMenuListing->None],

Cell[StyleData["Palette"],
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["PageBreak"],
  Editable->False,
  CellMargins->{{0, 0}, {1, 1}},
  CellBracketOptions->{"Thickness"->1,
  "Color"->RGBColor[0.500008, 0.500008, 1],
  "Margins"->{Inherited, 3},
  "Widths"->{5, 5}},
  CellElementSpacings->{"CellMinHeight"->1},
  ConversionRules:>{"TeX" -> {"\n\n\\pagebreak", 
    NoOutput[ ], ""}, "HTML" -> {"<br class=\"PageBreak\">", 
    NoOutput[ ], ""}},
  PageBreakAbove->True,
  CellSize->{Inherited, 6},
  TabFilling->"- ",
  TabSpacings->1000,
  StyleMenuListing->None,
  FontSize->6,
  FontColor->GrayLevel[0.700008]],

Cell[StyleData["PageBreak", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  CellSize->{Inherited, 2},
  TabFilling->""]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CreationDate"],
  CellFrame->0.5,
  CellMargins->{{10, 10}, {4, 4}},
  TextAlignment->Center,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->10],

Cell[StyleData["CreationDate", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  LineSpacing->{1, 1},
  FontSize->8]
}, Closed]],

Cell[CellGroupData[{

Cell["Lines and Spacers", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SingleLine"],
  CellMargins->{{2, 10}, {1, 1}},
  CellGroupingRules->{"GraphicsGrouping", 0},
  StyleMenuListing->None,
  FontSize->2],

Cell[StyleData["SingleLine", "Printout"],
  CellMargins->{{2, 10}, {1, 1}},
  CellGroupingRules->{"GraphicsGrouping", 0},
  FontSize->2]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["DoubleLine"],
  Editable->False,
  PageWidth->400,
  CellFrame->{{0, 0}, {0.25, 0.25}},
  CellMargins->{{12, 10}, {1, 1}},
  CellElementSpacings->{"CellMinHeight"->0},
  CellFrameMargins->{{2, 10}, {0, 0}},
  StyleMenuListing->None,
  FontSize->4],

Cell[StyleData["DoubleLine", "Printout"],
  CellMargins->{{2, 10}, {1, 1}},
  FontSize->2]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThinLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 0.5}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["ThinLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["MediumLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 2}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["MediumLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ThickLine"],
  Editable->False,
  Selectable->False,
  CellFrame->{{0, 0}, {0, 3}},
  ShowCellBracket->False,
  CellMargins->{{12, 10}, {2, 2}},
  CellElementSpacings->{"CellMinHeight"->1},
  CellFrameMargins->False,
  CellSize->{Inherited, 8},
  StyleMenuListing->None],

Cell[StyleData["ThickLine", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Spacer"],
  CellMargins->{{Inherited, Inherited}, {4, 4}},
  StyleMenuListing->None],

Cell[StyleData["Spacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["TextSpacer"],
  StyleMenuListing->None],

Cell[StyleData["TextSpacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SectionSpacer"],
  StyleMenuListing->None],

Cell[StyleData["SectionSpacer", "Printout"]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["GraphicsSpacer"],
  StyleMenuListing->None],

Cell[StyleData["GraphicsSpacer", "Printout"]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Vita", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["VitaGroup"],
  CellMargins->{{12, 12}, {7, 24}},
  CellGroupingRules->{"SectionGrouping", 1},
  ConversionRules:>{"TeX" -> {"", 
    NoOutput[ ], ""}, "HTML" -> {"", 
    NoOutput[ ], ""}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[StyleData["VitaGroup", "NumberedHeads"]],

Cell[StyleData["VitaGroup", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["VitaGroup", "Printout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]],

Cell[StyleData["VitaGroup", "NumberedHeadsPrintout"],
  CellMargins->{{0, 0}, {0, 0}},
  FontSize->1,
  FontColor->GrayLevel[1]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaAuthor"],
  CellMargins->{{12, 12}, {7, 7}},
  StyleMenuListing->None],

Cell[StyleData["VitaAuthor", "NumberedHeads"]],

Cell[StyleData["VitaAuthor", "Presentation"],
  CellMargins->{{23, 12}, {11, 11}},
  StyleMenuListing->None,
  FontSize->17],

Cell[StyleData["VitaAuthor", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["VitaAuthor", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaContactInformation"],
  CellMargins->{{12, 12}, {7, 7}},
  StyleMenuListing->None],

Cell[StyleData["VitaContactInformation", "NumberedHeads"]],

Cell[StyleData["VitaContactInformation", "Presentation"],
  CellMargins->{{23, 12}, {7, 7}},
  FontSize->17],

Cell[StyleData["VitaContactInformation", "Printout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10],

Cell[StyleData["VitaContactInformation", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {5, 5}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaSection"],
  CellMargins->{{12, 12}, {24, 4}},
  CellGroupingRules->{"SectionGrouping", 7},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->24,
  FontWeight->"Bold"],

Cell[StyleData["VitaSection", "NumberedHeads"]],

Cell[StyleData["VitaSection", "Presentation"],
  CellMargins->{{23, 12}, {36, 6}},
  FontSize->36],

Cell[StyleData["VitaSection", "Printout"],
  CellMargins->{{2, 2}, {21, 3}},
  FontSize->21],

Cell[StyleData["VitaSection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {21, 3}},
  FontSize->21]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaSubsection"],
  CellFrame->{{0, 0}, {0.5, 0}},
  CellMargins->{{12, 12}, {4, 24}},
  CellGroupingRules->{"SectionGrouping", 10},
  CellFrameMargins->{{0, 0}, {3, 0}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->16,
  FontWeight->"Bold"],

Cell[StyleData["VitaSubsection", "NumberedHeads"]],

Cell[StyleData["VitaSubsection", "Presentation"],
  CellFrame->{{0, 0}, {2, 0}},
  CellMargins->{{23, 12}, {6, 36}},
  CellFrameMargins->{{0, 0}, {5, 0}},
  FontSize->24],

Cell[StyleData["VitaSubsection", "Printout"],
  CellMargins->{{2, 2}, {3, 21}},
  FontSize->14],

Cell[StyleData["VitaSubsection", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {3, 21}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaItem"],
  CellMargins->{{12, 12}, {1, 2}},
  CellGroupingRules->"GraphicsGrouping",
  ConversionRules:>{{"TeX" -> {"\\item ", ""}}, {"HTML" -> {"<li>", 
    "</li>"}}},
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "itemize"}, "HTML" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "ul"}}},
  CellFrameLabels->{{
    Cell[ "\[FilledSmallCircle]", "VitaItemLabel", CellBaseline -> Baseline], 
        Inherited}, {Inherited, Inherited}},
  CellFrameLabelMargins->4,
  StyleMenuListing->None],

Cell[StyleData["VitaItem", "NumberedHeads"]],

Cell[StyleData["VitaItem", "Presentation"],
  CellMargins->{{23, 12}, {2, 3}},
  CellFrameLabelMargins->6,
  FontSize->17],

Cell[StyleData["VitaItem", "Printout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["VitaItem", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {1, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaItemLabel"],
  ConversionRules:>{{"TeX" -> {"", 
    NoOutput[ ], ""}}, {"HTML" -> {"", 
    NoOutput[ ], ""}}},
  CellSize->{24, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["VitaItemLabel", "NumberedHeads"]],

Cell[StyleData["VitaItemLabel", "Presentation"]],

Cell[StyleData["VitaItemLabel", "Printout"],
  CellSize->{18, Inherited},
  FontSize->10],

Cell[StyleData["VitaItemLabel", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["VitaItemParagraph"],
  CellMargins->{{40, 12}, {1, 1}},
  CellGroupingRules->"GraphicsGrouping",
  TaggingRules:>{"ExtraConversionRules" -> {"TeX" -> {"NestingLevel" -> 1, 
    "CellGroupEnvironment" -> "enumerate"}}},
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],

Cell[StyleData["VitaItemParagraph", "NumberedHeads"]],

Cell[StyleData["VitaItemParagraph", "Presentation"],
  CellMargins->{{54, 12}, {2, 2}},
  FontSize->17],

Cell[StyleData["VitaItemParagraph", "Printout"],
  CellMargins->{{24, 2}, {1, 1}},
  FontSize->10],

Cell[StyleData["VitaItemParagraph", "NumberedHeadsPrintout"],
  CellMargins->{{24, 2}, {1, 1}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Vita"],
  CellMargins->{{12, 12}, {3, 5}},
  StyleMenuListing->None],

Cell[StyleData["Vita", "NumberedHeads"]],

Cell[StyleData["Vita", "Presentation"],
  CellMargins->{{23, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["Vita", "Printout"],
  CellMargins->{{2, 2}, {2, 4}}],

Cell[StyleData["Vita", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {2, 4}}]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Outline", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Outline1"],
  CellMargins->{{12, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 30},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline1"], ". "}], "Outline1Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}},
  StyleMenuListing->None,
  FontSize->18,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>CapitalRomanNumeral}],

Cell[StyleData["Outline1", "NumberedHeads"]],

Cell[StyleData["Outline1", "Presentation"],
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{12, 12}, {7, 7}},
  FontSize->27],

Cell[StyleData["Outline1", "Printout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->16],

Cell[StyleData["Outline1", "NumberedHeadsPrintout"],
  CellMargins->{{2, 2}, {6, 6}},
  FontSize->16]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline1Label"],
  CellSize->{40, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline1Label", "NumberedHeads"]],

Cell[StyleData["Outline1Label", "Presentation"],
  CellSize->{60, Inherited}],

Cell[StyleData["Outline1Label", "Printout"],
  CellSize->{36, Inherited}],

Cell[StyleData["Outline1Label", "NumberedHeadsPrintout"],
  CellSize->{36, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline2"],
  CellMargins->{{32, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 40},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline2"], ". "}], "Outline2Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}},
  StyleMenuListing->None,
  FontSize->16,
  FontWeight->"Bold",
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "A", "Z"], #]&)}],

Cell[StyleData["Outline2", "NumberedHeads"]],

Cell[StyleData["Outline2", "Presentation"],
  CellMargins->{{52, 12}, {11, 11}},
  FontSize->24],

Cell[StyleData["Outline2", "Printout"],
  CellMargins->{{22, 2}, {6, 6}},
  FontSize->14],

Cell[StyleData["Outline2", "NumberedHeadsPrintout"],
  CellMargins->{{22, 2}, {6, 6}},
  FontSize->14]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline2Label"],
  CellSize->{30, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline2Label", "NumberedHeads"]],

Cell[StyleData["Outline2Label", "Presentation"],
  CellSize->{45, Inherited}],

Cell[StyleData["Outline2Label", "Printout"],
  CellSize->{27, Inherited}],

Cell[StyleData["Outline2Label", "NumberedHeadsPrintout"],
  CellSize->{27, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline3"],
  CellMargins->{{52, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 50},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline3"], ". "}], "Outline3Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}},
  StyleMenuListing->None,
  FontSize->14,
  CounterBoxOptions->{CounterFunction:>Identity}],

Cell[StyleData["Outline3", "NumberedHeads"]],

Cell[StyleData["Outline3", "Presentation"],
  CellMargins->{{92, 12}, {11, 11}},
  FontSize->21],

Cell[StyleData["Outline3", "Printout"],
  CellMargins->{{42, 2}, {6, 6}},
  FontSize->12],

Cell[StyleData["Outline3", "NumberedHeadsPrintout"],
  CellMargins->{{42, 2}, {6, 6}},
  FontSize->12]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline3Label"],
  CellSize->{21, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline3Label", "NumberedHeads"]],

Cell[StyleData["Outline3Label", "Presentation"],
  CellSize->{32, Inherited}],

Cell[StyleData["Outline3Label", "Printout"],
  CellSize->{18, Inherited}],

Cell[StyleData["Outline3Label", "NumberedHeadsPrintout"],
  CellSize->{18, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline4"],
  CellMargins->{{67, 12}, {7, 7}},
  CellGroupingRules->{"SectionGrouping", 60},
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Outline4"], ". "}], "Outline4Label", CellBaseline -> 
          Baseline], Inherited}, {Inherited, Inherited}},
  CounterIncrements->"Outline4",
  StyleMenuListing->None,
  FontSize->12,
  CounterBoxOptions->{CounterFunction:>(Part[ 
      CharacterRange[ "a", "z"], #]&)}],

Cell[StyleData["Outline4", "NumberedHeads"]],

Cell[StyleData["Outline4", "Presentation"],
  CellMargins->{{122, 12}, {11, 11}},
  FontSize->17],

Cell[StyleData["Outline4", "Printout"],
  CellMargins->{{57, 2}, {6, 6}},
  FontSize->10],

Cell[StyleData["Outline4", "NumberedHeadsPrintout"],
  CellMargins->{{57, 2}, {6, 6}},
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Outline4Label"],
  CellSize->{18, Inherited},
  TextAlignment->Right,
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Outline4Label", "NumberedHeads"]],

Cell[StyleData["Outline4Label", "Presentation"],
  CellSize->{27, Inherited}],

Cell[StyleData["Outline4Label", "Printout"],
  CellSize->{16, Inherited}],

Cell[StyleData["Outline4Label", "NumberedHeadsPrintout"],
  CellSize->{16, Inherited}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["OutlineText"],
  CellMargins->{{91, 12}, {3, 5}},
  ConversionRules:>{"TeX" -> {{"", Automatic, ""}, {"\n\n", Automatic, ""}}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  CounterIncrements->"Text",
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["OutlineText", "NumberedHeads"]],

Cell[StyleData["OutlineText", "Presentation"],
  CellMargins->{{155, 12}, {5, 8}},
  FontSize->17],

Cell[StyleData["OutlineText", "Printout"],
  CellMargins->{{79, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10],

Cell[StyleData["OutlineText", "NumberedHeadsPrintout"],
  CellMargins->{{79, 2}, {2, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  FontSize->10]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Slide Show", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["SlideShowNavigationBar"],
  Editable->False,
  CellFrame->True,
  ShowGroupOpenCloseIcon->False,
  CellMargins->{{0, 0}, {0, 0}},
  CellElementSpacings->{"CellMinHeight"->0.8125},
  CellGroupingRules->{"TitleGrouping", 1},
  PageBreakAbove->True,
  CellFrameMargins->False,
  CellFrameColor->GrayLevel[0.8],
  CellFrameLabelMargins->False,
  TextAlignment->Center,
  CounterIncrements->"SlideShowNavigationBar",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontSize->10,
  Background->GrayLevel[0.8],
  Magnification->1,
  GridBoxOptions->{GridBaseline->Center,
  RowSpacings->0,
  ColumnSpacings->0,
  ColumnWidths->{3.5, 3.5, 3.5, 3.5, 13, 5, 4},
  RowAlignments->Baseline,
  ColumnAlignments->{
    Center, Center, Center, Center, Center, Center, Right, Center}}],

Cell[StyleData["SlideShowNavigationBar", "Printout"],
  Deletable->False,
  ShowCellBracket->False,
  CellMargins->{{-1, -1}, {-1, -1}},
  PageBreakAbove->True,
  CellFrameMargins->{{1, 1}, {0, 0}}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["SlideHyperlink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontSize->26,
  FontColor->GrayLevel[0.400015],
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonMinHeight->0.85,
  ButtonMargins->0.5,
  ButtonNote->None}],

Cell[StyleData["SlideHyperlink", "Presentation"]],

Cell[StyleData["SlideHyperlink", "Printout"]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Common Inline", "Section"],

Cell[CellGroupData[{

Cell["General Text Attributes", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["RM"],
  StyleMenuListing->None,
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["BF"],
  ConversionRules:>{"TeX" -> {"\\textbf{", "}"}},
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["IT"],
  ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontSlant->"Italic"],

Cell[StyleData["SmallCaps"],
  ConversionRules:>{"TeX" -> {{"", ChangeCase[ "Lower"][ 
      ExtractWord[ ][ #]]&, ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell["Font Specific Text Attributes", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["TR"],
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["TI"],
  ConversionRules:>{"TeX" -> {{"\\textit{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["TB"],
  ConversionRules:>{"TeX" -> {{"\\textbf{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["TBI"],
  ConversionRules:>{"TeX" -> {{"\\textbf{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["MR"],
  ConversionRules:>{"TeX" -> {{"\\texttt{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["MO"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["MB"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["MBO"],
  ConversionRules:>{"TeX" -> {{"\\texttt{\\textbf{\\textit{", Automatic, 
    "}}}"}, {"", Automatic, ""}}},
  Hyphenation->True,
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontWeight->"Bold",
  FontSlant->"Italic"],

Cell[StyleData["SR"],
  ConversionRules:>{"TeX" -> {{"\\textsf{", Automatic, "}"}, {"", Automatic, 
    ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Plain"],

Cell[StyleData["SO"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textit{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Plain",
  FontSlant->"Italic"],

Cell[StyleData["SB"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{", Automatic, "}}"}, {"", 
    Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Plain"],

Cell[StyleData["SBO"],
  ConversionRules:>{"TeX" -> {{"\\textsf{\\textbf{\\textit{", Automatic, 
    "}}}"}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontWeight->"Bold",
  FontSlant->"Italic"]
}, Closed]],

Cell[CellGroupData[{

Cell["Hyperlinks", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Hyperlink"],
  ConversionRules:>{"TeX" -> {{"", 
    ExportAsHyperRef[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["Hyperlink", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["XMLWebLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(OpenAllTypes[ #]&),
  ButtonEvaluator->Automatic,
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["XMLWebLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["PageLink"],
  ConversionRules:>{"TeX" -> {{"", 
    ExportAsHyperRef[ ], ""}, {"", Automatic, ""}}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->False},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookLocate[ #2]}]&),
  Active->True,
  ButtonNote->ButtonData}],

Cell[StyleData["PageLink", "Printout"],
  FontSize->10,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell["On-line Help System Links", "Subsubsection"],

Cell[CellGroupData[{

Cell[StyleData["UserGuideLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "UserGuide", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["UserGuideLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["ReferenceLink"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1],
  FontVariations->{"Underline"->True},
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`HelpBrowserLookup[ "Reference", #]}]&),
  Active->True,
  ButtonFrame->"None"}],

Cell[StyleData["ReferenceLink", "Printout"],
  FontColor->GrayLevel[0],
  FontVariations->{"Underline"->False}]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["System", "Section"],

Cell[CellGroupData[{

Cell["Format Type Style", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that are mixed in with the styles of 
most cells.  If a cell's FormatType matches the name of one of the styles 
defined below, then that style is applied between the cell's style and its 
own options. This is particularly true of Input and Output.
\
\>", "Text"],

Cell[StyleData["CellExpression"],
  PageWidth->Infinity,
  CellMargins->{{6, Inherited}, {Inherited, Inherited}},
  ShowCellLabel->False,
  ShowSpecialCharacters->False,
  AllowInlineCells->False,
  AutoItalicWords->{},
  StyleMenuListing->None,
  FontFamily->"Courier",
  FontSize->12,
  Background->GrayLevel[1]],

Cell[StyleData["InputForm"],
  AllowInlineCells->False,
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["OutputForm"],
  PageWidth->Infinity,
  TextAlignment->Left,
  LineSpacing->{0.6, 1},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["StandardForm"],
  InputAutoReplacements->{
    "->"->"\[Rule]", ":>"->"\[RuleDelayed]", "<="->"\[LessEqual]", 
      ">="->"\[GreaterEqual]", "!="->"\[NotEqual]", "=="->"\[Equal]", 
      Inherited},
  "TwoByteSyntaxCharacterAutoReplacement"->True,
  LineSpacing->{1.25, 0},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["TraditionalForm"],
  LineSpacing->{1.25, 0},
  SingleLetterItalics->True,
  TraditionalFunctionNotation->True,
  DelimiterMatching->None,
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell["Document Settings and Templates", "Subsection"],

Cell[StyleData["ReferenceTemplate"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["AuthorFormCustomizationTemplate"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["CSSDefinitions"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["LaTeXPreamble"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["DOCTYPEFormat"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["ValidationSetting"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["XRefPaletteSettings"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"],

Cell[StyleData["MiscSettings"],
  CellMargins->{{12, 10}, {7, 7}},
  StyleMenuListing->None,
  FontFamily->"Courier"]
}, Closed]],

Cell[CellGroupData[{

Cell["Inline Cells", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The style defined below is mixed in to any cell that is in an 
inline cell within another.
\
\>", "Text"],

Cell[StyleData["InlineCell"],
  InputAutoReplacements->{"-"->"-"},
  ScriptLevel->1,
  StyleMenuListing->None],

Cell[StyleData["InlineCellEditing"],
  StyleMenuListing->None,
  Background->RGBColor[0.880003, 0.899992, 0.959991]]
}, Closed]],

Cell[CellGroupData[{

Cell["Palette", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that define standard ButtonFunctions, 
for use in palette buttons.
\
\>", "Text"],

Cell[StyleData["Paste"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(FrontEndExecute[ {
      FrontEnd`NotebookApply[ 
        FrontEnd`InputNotebook[ ], #, After]}]&)}],

Cell[StyleData["StyleApply"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(CellWriteStyle[ #]&),
  ButtonEvaluator->Automatic}],

Cell[StyleData["StyleApplyWithVerification"],
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonFunction:>(CompoundExpression[ 
      CheckDocStyleMatch[ ], 
      CellWriteStyle[ #]]&),
  ButtonEvaluator->Automatic}],

Cell[StyleData["ConvertCharacter"],
  ConversionRules:>{"TeX" -> {"", 
    ExtractButtonData[ "TeX"], ""}, "HTML" :> {"", 
    ExtractButtonData[ "HTML"], ""}},
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic,
  ButtonBoxOptions->{ButtonEvaluator->Automatic,
  ButtonFrame->"None"}]
}, Closed]],

Cell[CellGroupData[{

Cell["Automatic", "Subsection",
  StyleMenuListing->None],

Cell["\<\

The cells below define styles that are used to affect the display 
of certain types of objects in typeset expressions.  For example, 
\"UnmatchedBracket\" style defines how unmatched bracket, curly bracket, and 
parenthesis characters are displayed (typically by coloring them to make them \

stand out).
\
\>", "Text"],

Cell[StyleData["UnmatchedBracket"],
  StyleMenuListing->None,
  FontColor->RGBColor[0.760006, 0.330007, 0.8]]
}, Closed]],

Cell[CellGroupData[{

Cell["DialogEffects", "Subsection",
  StyleMenuListing->None],

Cell[StyleData["DialogStyleSheetMisapplicationEscape"],
  ShowCellBracket->False,
  CellMargins->{{12, 12}, {2000, 40}},
  CellOpen->True,
  TextAlignment->Center,
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Conformance", "Section"],

Cell[CellGroupData[{

Cell["Input/Output", "Subsection",
  StyleMenuListing->None],

Cell["\<\
The cells in this section define styles used for input and output to the \
kernel.  Be careful when modifying, renaming, or removing these styles, \
because the front end associates special meanings with these style names. \
Some attributes for these styles are actually set in FormatType Styles (in \
the last section of this stylesheet). \
\>", "Text"],

Cell[CellGroupData[{

Cell[StyleData["Input"],
  CellMargins->{{72, 72}, {6, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  LinebreakAdjustments->{0.85, 2, 10, 0, 1},
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["Input", "Printout"],
  CellMargins->{{21, 6}, {3, 6}},
  LinebreakAdjustments->{0.85, 2, 10, 1, 1},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["InputNumbered"],
  CellMargins->{{72, 6}, {6, 8}},
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  CellFrameLabels->{{None, Cell[ 
          BoxData[ 
            StyleBox[ 
              RowBox[ {"(", 
                CounterBox[ "Input"], ")"}], FontWeight -> "Plain", 
              FontFamily -> "Times"]]]}, {None, None}},
  CellFrameLabelMargins->{{0, 42}, {0, 0}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  LinebreakAdjustments->{0.85, 2, 10, 0, 1},
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[StyleData["InputNumbered", "Printout"],
  CellMargins->{{21, 6}, {3, 6}},
  LinebreakAdjustments->{0.85, 2, 10, 1, 1},
  FontSize->9]
}, Closed]],

Cell[StyleData["InputOnly"],
  Evaluatable->True,
  CellGroupingRules->"InputGrouping",
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  ShowStringCharacters->True,
  NumberMarks->True,
  SpanMaxSize->Automatic,
  CounterIncrements->"Input",
  StyleMenuListing->None,
  FontWeight->"Bold"],

Cell[CellGroupData[{

Cell[StyleData["Output"],
  CellMargins->{{72, 72}, {7, 5}},
  CellEditDuplicate->True,
  CellGroupingRules->"OutputGrouping",
  CellHorizontalScrolling->True,
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  HyphenationOptions->{"HyphenationCharacter"->"\[Continuation]"},
  AutoItalicWords->{},
  LanguageCategory->"Formula",
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Output",
  StyleMenuListing->None],

Cell[StyleData["Output", "Printout"],
  CellMargins->{{21, 0}, {6, 3}},
  FontSize->9]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Message"],
  CellMargins->{{45, Inherited}, {Inherited, Inherited}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Message",
  StyleMenuListing->None,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["Message", "Printout"],
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontSize->8,
  FontColor->GrayLevel[0]]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Print"],
  CellMargins->{{45, Inherited}, {Inherited, Inherited}},
  CellGroupingRules->"OutputGrouping",
  PageBreakWithin->False,
  GroupPageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  CellLabelMargins->{{11, Inherited}, {Inherited, Inherited}},
  DefaultFormatType->StandardForm,
  AutoItalicWords->{},
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Print",
  StyleMenuListing->None],

Cell[StyleData["Print", "Printout"],
  CellMargins->{{39, Inherited}, {Inherited, Inherited}},
  FontSize->8]
}, Closed]],

Cell["\<\
Do not remove TextAlignment->Left from \"Graphics\" style definitions or else \
graphics may behave badly as inline cells:\
\>", "Text",
  CellMargins->{{72, Inherited}, {Inherited, Inherited}},
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->GrayLevel[0.500008]],

Cell[CellGroupData[{

Cell[StyleData["Graphics"],
  Editable->True,
  CellMargins->{{36, Inherited}, {0, 7}},
  CellGroupingRules->"GraphicsGrouping",
  CellHorizontalScrolling->False,
  PageBreakWithin->False,
  GeneratedCell->True,
  CellAutoOverwrite->True,
  ShowCellLabel->False,
  DefaultFormatType->StandardForm,
  InputAutoReplacements->{},
  TextAlignment->Left,
  LanguageCategory->None,
  FormatType->InputForm,
  SpanMaxSize->Automatic,
  CounterIncrements->"Graphics",
  ImageMargins->{{0, 0}, {0, 0}},
  StyleMenuListing->None],

Cell[StyleData["Graphics", "Printout"],
  CellMargins->{{27, 0}, {6, 3}},
  ImageMargins->{{0, 0}, {0, 0}},
  FontSize->9,
  Magnification->0.8]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["CellLabel"],
  SpanMaxSize->Automatic,
  StyleMenuListing->None,
  FontFamily->"Helvetica",
  FontSize->9,
  FontColor->RGBColor[0, 0, 1]],

Cell[StyleData["CellLabel", "Printout"],
  FontFamily->"Courier",
  FontSize->8,
  FontSlant->"Italic",
  FontColor->GrayLevel[0]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Help Browser Styles", "Subsection",
  StyleMenuListing->None],

Cell[CellGroupData[{

Cell[StyleData["MathCaption"],
  StyleMenuListing->None],

Cell[StyleData["MathCaption", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserTips"],
  StyleMenuListing->None],

Cell[StyleData["UserTips", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["UserTipsList"],
  StyleMenuListing->None],

Cell[StyleData["UserTipsList", "Printout"],
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["IndentedText"],
  StyleMenuListing->None],

Cell[StyleData["IndentedText", "Printout"],
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell["Alternative Item Styles", "Subsection"],

Cell[CellGroupData[{

Cell[StyleData["Item1NumberedNew"],
  CellMargins->{{12, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item1Numbered"], ". "}], "Item1NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times",
  FontSize->12],

Cell[StyleData["Item1NumberedNew", "Printout"],
  CellMargins->{{0, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item2NumberedNew"],
  CellMargins->{{24, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item2Numbered"], ". "}], "Item2NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item2Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Item2NumberedNew", "Printout"],
  CellMargins->{{12, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]],

Cell[CellGroupData[{

Cell[StyleData["Item3NumberedNew"],
  CellMargins->{{36, 10}, {3, 5}},
  CellGroupingRules->"GraphicsGrouping",
  CellFrameLabels->{{Cell[ 
          TextData[ {
            CounterBox[ "Item3Numbered"], ". "}], "Item3NumberedLabel", 
          CellBaseline -> Baseline], Inherited}, {Inherited, Inherited}},
  TextAlignment->Left,
  LineSpacing->{1, 3},
  ParagraphIndent->-24,
  CounterIncrements->"Item3Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None,
  FontFamily->"Times"],

Cell[StyleData["Item3NumberedNew", "Printout"],
  CellMargins->{{24, 12}, {1, 4}},
  TextJustification->1,
  LineSpacing->{1, 2},
  ParagraphIndent->-18,
  StyleMenuListing->None,
  FontSize->10]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
},
FrontEndVersion->"4.2 for Microsoft Windows",
ScreenRectangle->{{0, 1152}, {0, 788}},
WindowSize->{458, 659},
WindowMargins->{{11, Automatic}, {Automatic, 28}}
]

(*******************************************************************
Cached data follows.  If you edit this Notebook file directly, not
using Mathematica, you must remove the line containing CacheID at
the top of  the file.  The cache data will then be recreated when
you save this file from within Mathematica.
*******************************************************************)

(*CellTagsOutline
CellTagsIndex->{
  "CSSDefinitions"->{
    Cell[1878, 59, 18426, 857, 16063, "Text",
      CellTags->"CSSDefinitions"]},
  "TeXPreamble"->{
    Cell[20380, 923, 218, 10, 70, "Text",
      CellTags->"TeXPreamble"]}
  }
*)

(*CellTagsIndex
CellTagsIndex->{
  {"CSSDefinitions", 334772, 12965},
  {"TeXPreamble", 334873, 12968}
  }
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1775, 53, 53, 0, 114, "Title"],

Cell[CellGroupData[{
Cell[1853, 57, 22, 0, 54, "Section"],
Cell[1878, 59, 18426, 857, 16063, "Text",
  CellTags->"CSSDefinitions"]
}, Closed]],

Cell[CellGroupData[{
Cell[20341, 921, 36, 0, 34, "Section"],
Cell[20380, 923, 218, 10, 70, "Text",
  CellTags->"TeXPreamble"]
}, Closed]],

Cell[CellGroupData[{
Cell[20635, 938, 42, 0, 34, "Section"],
Cell[20680, 940, 99, 3, 70, 30, 0, "StyleData", "All", "Screen"],
Cell[20782, 945, 106, 3, 70, 37, 0, "StyleData", "All", "NumberedHeads"],
Cell[20891, 950, 251, 6, 70, 36, 0, "StyleData", "All", "Presentation"],
Cell[21145, 958, 194, 6, 70, 32, 0, "StyleData", "All", "Printout"],
Cell[21342, 966, 207, 6, 70, 45, 0, "StyleData", "All", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[21586, 977, 35, 0, 34, "Section"],
Cell[21624, 979, 99, 2, 27, "Text"],
Cell[21726, 983, 4581, 83, 40, 27, 0, "StyleData", "Notebook", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[26344, 1071, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[26399, 1075, 314, 9, 60, 35, 0, "StyleData", "FrontmatterGroup", "All",
  StyleMenuListing->None],
Cell[26716, 1086, 52, 0, 70, 52, 0, "StyleData", "FrontmatterGroup", \
"NumberedHeads"],
Cell[26771, 1088, 159, 4, 70, 51, 0, "StyleData", "FrontmatterGroup", \
"Presentation"],
Cell[26933, 1094, 122, 3, 70, 47, 0, "StyleData", "FrontmatterGroup", \
"Printout"],
Cell[27058, 1099, 135, 3, 70, 60, 0, "StyleData", "FrontmatterGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[27230, 1107, 53, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[27308, 1112, 267, 8, 70, 24, 0, "StyleData", "Title", "All",
  StyleMenuListing->None],
Cell[27578, 1122, 41, 0, 70, 41, 0, "StyleData", "Title", "NumberedHeads"],
Cell[27622, 1124, 92, 2, 70, 40, 0, "StyleData", "Title", "Presentation"],
Cell[27717, 1128, 86, 2, 70, 36, 0, "StyleData", "Title", "Printout"],
Cell[27806, 1132, 99, 2, 70, 49, 0, "StyleData", "Title", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[27942, 1139, 281, 9, 70, 27, 0, "StyleData", "Subtitle", "All",
  StyleMenuListing->None],
Cell[28226, 1150, 44, 0, 70, 44, 0, "StyleData", "Subtitle", \
"NumberedHeads"],
Cell[28273, 1152, 94, 2, 70, 43, 0, "StyleData", "Subtitle", "Presentation"],
Cell[28370, 1156, 138, 4, 70, 39, 0, "StyleData", "Subtitle", "Printout"],
Cell[28511, 1162, 151, 4, 70, 52, 0, "StyleData", "Subtitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[28699, 1171, 238, 7, 70, 30, 0, "StyleData", "Subsubtitle", "All",
  StyleMenuListing->None],
Cell[28940, 1180, 47, 0, 70, 47, 0, "StyleData", "Subsubtitle", \
"NumberedHeads"],
Cell[28990, 1182, 97, 2, 70, 46, 0, "StyleData", "Subsubtitle", \
"Presentation"],
Cell[29090, 1186, 118, 3, 70, 42, 0, "StyleData", "Subsubtitle", "Printout"],
Cell[29211, 1191, 131, 3, 70, 55, 0, "StyleData", "Subsubtitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[29379, 1199, 43, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[29447, 1203, 55, 1, 70, 29, 0, "StyleData", "TitleLabel", "All",
  StyleMenuListing->None],
Cell[29505, 1206, 46, 0, 70, 46, 0, "StyleData", "TitleLabel", \
"NumberedHeads"],
Cell[29554, 1208, 45, 0, 70, 45, 0, "StyleData", "TitleLabel", \
"Presentation"],
Cell[29602, 1210, 41, 0, 70, 41, 0, "StyleData", "TitleLabel", "Printout"],
Cell[29646, 1212, 54, 0, 70, 54, 0, "StyleData", "TitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[29737, 1217, 58, 1, 70, 32, 0, "StyleData", "SubtitleLabel", "All",
  StyleMenuListing->None],
Cell[29798, 1220, 49, 0, 70, 49, 0, "StyleData", "SubtitleLabel", \
"NumberedHeads"],
Cell[29850, 1222, 48, 0, 70, 48, 0, "StyleData", "SubtitleLabel", \
"Presentation"],
Cell[29901, 1224, 44, 0, 70, 44, 0, "StyleData", "SubtitleLabel", \
"Printout"],
Cell[29948, 1226, 57, 0, 70, 57, 0, "StyleData", "SubtitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[30042, 1231, 61, 1, 70, 35, 0, "StyleData", "SubsubtitleLabel", "All",
  StyleMenuListing->None],
Cell[30106, 1234, 52, 0, 70, 52, 0, "StyleData", "SubsubtitleLabel", \
"NumberedHeads"],
Cell[30161, 1236, 51, 0, 70, 51, 0, "StyleData", "SubsubtitleLabel", \
"Presentation"],
Cell[30215, 1238, 47, 0, 70, 47, 0, "StyleData", "SubsubtitleLabel", \
"Printout"],
Cell[30265, 1240, 60, 0, 70, 60, 0, "StyleData", "SubsubtitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[30386, 1247, 58, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[30469, 1252, 58, 1, 70, 32, 0, "StyleData", "CopyrightLine", "All",
  StyleMenuListing->None],
Cell[30530, 1255, 49, 0, 70, 49, 0, "StyleData", "CopyrightLine", \
"NumberedHeads"],
Cell[30582, 1257, 48, 0, 70, 48, 0, "StyleData", "CopyrightLine", \
"Presentation"],
Cell[30633, 1259, 44, 0, 70, 44, 0, "StyleData", "CopyrightLine", \
"Printout"],
Cell[30680, 1261, 57, 0, 70, 57, 0, "StyleData", "CopyrightLine", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[30774, 1266, 465, 12, 70, 32, 0, "StyleData", "CopyrightYear", "All",
  StyleMenuListing->None],
Cell[31242, 1280, 49, 0, 70, 49, 0, "StyleData", "CopyrightYear", \
"NumberedHeads"],
Cell[31294, 1282, 100, 2, 70, 48, 0, "StyleData", "CopyrightYear", \
"Presentation"],
Cell[31397, 1286, 94, 2, 70, 44, 0, "StyleData", "CopyrightYear", \
"Printout"],
Cell[31494, 1290, 107, 2, 70, 57, 0, "StyleData", "CopyrightYear", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[31638, 1297, 406, 11, 70, 30, 0, "StyleData", "CopyrightBy", "All",
  StyleMenuListing->None],
Cell[32047, 1310, 47, 0, 70, 47, 0, "StyleData", "CopyrightBy", \
"NumberedHeads"],
Cell[32097, 1312, 97, 2, 70, 46, 0, "StyleData", "CopyrightBy", \
"Presentation"],
Cell[32197, 1316, 91, 2, 70, 42, 0, "StyleData", "CopyrightBy", "Printout"],
Cell[32291, 1320, 104, 2, 70, 55, 0, "StyleData", "CopyrightBy", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[32444, 1328, 52, 1, 35, "Subsection"],
Cell[32499, 1331, 202, 6, 40, 22, 0, "StyleData", "Day", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[32704, 1339, 206, 6, 40, 24, 0, "StyleData", "Month", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[32913, 1347, 204, 6, 40, 23, 0, "StyleData", "Year", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],

Cell[CellGroupData[{
Cell[33142, 1357, 366, 11, 38, 23, 0, "StyleData", "Date", "All",
  StyleMenuListing->None],
Cell[33511, 1370, 40, 0, 38, 40, 0, "StyleData", "Date", "NumberedHeads"],
Cell[33554, 1372, 91, 2, 45, 39, 0, "StyleData", "Date", "Presentation"],
Cell[33648, 1376, 136, 4, 32, 35, 0, "StyleData", "Date", "Printout"],
Cell[33787, 1382, 149, 4, 32, 48, 0, "StyleData", "Date", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[33985, 1392, 54, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[34064, 1397, 282, 8, 56, 25, 0, "StyleData", "Author", "All",
  StyleMenuListing->None],
Cell[34349, 1407, 42, 0, 56, 42, 0, "StyleData", "Author", "NumberedHeads"],
Cell[34394, 1409, 94, 2, 74, 41, 0, "StyleData", "Author", "Presentation"],
Cell[34491, 1413, 117, 3, 49, 37, 0, "StyleData", "Author", "Printout"],
Cell[34611, 1418, 130, 3, 49, 50, 0, "StyleData", "Author", \
"NumberedHeadsPrintout"]
}, Closed]],
Cell[34756, 1424, 96, 3, 40, 29, 0, "StyleData", "AuthorData", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[34877, 1431, 56, 1, 40, 30, 0, "StyleData", "AuthorGroup", "All",
  StyleMenuListing->None],
Cell[34936, 1434, 47, 0, 70, 47, 0, "StyleData", "AuthorGroup", \
"NumberedHeads"],
Cell[34986, 1436, 46, 0, 70, 46, 0, "StyleData", "AuthorGroup", \
"Presentation"],
Cell[35035, 1438, 42, 0, 70, 42, 0, "StyleData", "AuthorGroup", "Printout"],
Cell[35080, 1440, 55, 0, 70, 55, 0, "StyleData", "AuthorGroup", \
"NumberedHeadsPrintout"]
}, Closed]],
Cell[35150, 1443, 169, 4, 40, 34, 0, "StyleData", "AuthorFirstName", "All",
  StyleMenuListing->None],
Cell[35322, 1449, 170, 4, 40, 35, 0, "StyleData", "AuthorMiddleName", "All",
  StyleMenuListing->None],
Cell[35495, 1455, 168, 4, 40, 33, 0, "StyleData", "AuthorLastName", "All",
  StyleMenuListing->None],
Cell[35666, 1461, 170, 4, 40, 35, 0, "StyleData", "AuthorNameSuffix", "All",
  StyleMenuListing->None],
Cell[35839, 1467, 194, 5, 40, 36, 0, "StyleData", "AuthorAffiliation", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[36058, 1476, 402, 12, 32, 30, 0, "StyleData", "AuthorTitle", "All",
  StyleMenuListing->None],
Cell[36463, 1490, 47, 0, 32, 47, 0, "StyleData", "AuthorTitle", \
"NumberedHeads"],
Cell[36513, 1492, 137, 3, 36, 46, 0, "StyleData", "AuthorTitle", \
"Presentation"],
Cell[36653, 1497, 121, 3, 29, 42, 0, "StyleData", "AuthorTitle", "Printout"],
Cell[36777, 1502, 134, 3, 29, 55, 0, "StyleData", "AuthorTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[36948, 1510, 575, 16, 32, 30, 0, "StyleData", "AuthorEmail", "All",
  StyleMenuListing->None],
Cell[37526, 1528, 47, 0, 32, 47, 0, "StyleData", "AuthorEmail", \
"NumberedHeads"],
Cell[37576, 1530, 137, 3, 37, 46, 0, "StyleData", "AuthorEmail", \
"Presentation"],
Cell[37716, 1535, 121, 3, 29, 42, 0, "StyleData", "AuthorEmail", "Printout"],
Cell[37840, 1540, 134, 3, 29, 55, 0, "StyleData", "AuthorEmail", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[38011, 1548, 56, 1, 40, 30, 0, "StyleData", "AuthorPhone", "All",
  StyleMenuListing->None],
Cell[38070, 1551, 47, 0, 70, 47, 0, "StyleData", "AuthorPhone", \
"NumberedHeads"],
Cell[38120, 1553, 46, 0, 70, 46, 0, "StyleData", "AuthorPhone", \
"Presentation"],
Cell[38169, 1555, 42, 0, 70, 42, 0, "StyleData", "AuthorPhone", "Printout"],
Cell[38214, 1557, 55, 0, 70, 55, 0, "StyleData", "AuthorPhone", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[38306, 1562, 199, 6, 36, 32, 0, "StyleData", "AuthorAddress", "All",
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None],
Cell[38508, 1570, 216, 6, 70, 49, 0, "StyleData", "AuthorAddress", \
"NumberedHeads",
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None],
Cell[38727, 1578, 215, 6, 70, 48, 0, "StyleData", "AuthorAddress", \
"Presentation",
  CounterIncrements->"AuthorAddress",
  StyleMenuListing->None],
Cell[38945, 1586, 93, 2, 70, 44, 0, "StyleData", "AuthorAddress", \
"Printout"],
Cell[39041, 1590, 106, 2, 70, 57, 0, "StyleData", "AuthorAddress", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[39184, 1597, 65, 1, 40, 39, 0, "StyleData", "AuthorCurrentAddress", \
"All",
  StyleMenuListing->None],
Cell[39252, 1600, 56, 0, 70, 56, 0, "StyleData", "AuthorCurrentAddress", \
"NumberedHeads"],
Cell[39311, 1602, 55, 0, 70, 55, 0, "StyleData", "AuthorCurrentAddress", \
"Presentation"],
Cell[39369, 1604, 51, 0, 70, 51, 0, "StyleData", "AuthorCurrentAddress", \
"Printout"],
Cell[39423, 1606, 64, 0, 70, 64, 0, "StyleData", "AuthorCurrentAddress", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[39524, 1611, 57, 1, 40, 31, 0, "StyleData", "AuthorThanks", "All",
  StyleMenuListing->None],
Cell[39584, 1614, 48, 0, 70, 48, 0, "StyleData", "AuthorThanks", \
"NumberedHeads"],
Cell[39635, 1616, 47, 0, 70, 47, 0, "StyleData", "AuthorThanks", \
"Presentation"],
Cell[39685, 1618, 43, 0, 70, 43, 0, "StyleData", "AuthorThanks", "Printout"],
Cell[39731, 1620, 56, 0, 70, 56, 0, "StyleData", "AuthorThanks", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[39824, 1625, 59, 1, 40, 33, 0, "StyleData", "AuthorHomepage", "All",
  StyleMenuListing->None],
Cell[39886, 1628, 50, 0, 70, 50, 0, "StyleData", "AuthorHomepage", \
"NumberedHeads"],
Cell[39939, 1630, 49, 0, 70, 49, 0, "StyleData", "AuthorHomepage", \
"Presentation"],
Cell[39991, 1632, 45, 0, 70, 45, 0, "StyleData", "AuthorHomepage", \
"Printout"],
Cell[40039, 1634, 58, 0, 70, 58, 0, "StyleData", "AuthorHomepage", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[40134, 1639, 55, 1, 40, 29, 0, "StyleData", "AuthorPACS", "All",
  StyleMenuListing->None],
Cell[40192, 1642, 46, 0, 70, 46, 0, "StyleData", "AuthorPACS", \
"NumberedHeads"],
Cell[40241, 1644, 45, 0, 70, 45, 0, "StyleData", "AuthorPACS", \
"Presentation"],
Cell[40289, 1646, 41, 0, 70, 41, 0, "StyleData", "AuthorPACS", "Printout"],
Cell[40333, 1648, 54, 0, 70, 54, 0, "StyleData", "AuthorPACS", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[40436, 1654, 59, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[40520, 1659, 209, 6, 32, 30, 0, "StyleData", "Institution", "All",
  StyleMenuListing->None],
Cell[40732, 1667, 47, 0, 32, 47, 0, "StyleData", "Institution", \
"NumberedHeads"],
Cell[40782, 1669, 98, 2, 36, 46, 0, "StyleData", "Institution", \
"Presentation"],
Cell[40883, 1673, 121, 3, 29, 42, 0, "StyleData", "Institution", "Printout"],
Cell[41007, 1678, 134, 3, 29, 55, 0, "StyleData", "Institution", \
"NumberedHeadsPrintout"]
}, Closed]],
Cell[41156, 1684, 171, 4, 40, 36, 0, "StyleData", "InstitutionNumber", "All",
  StyleMenuListing->None],
Cell[41330, 1690, 169, 4, 40, 34, 0, "StyleData", "InstitutionName", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[41524, 1698, 78, 2, 40, 33, 0, "StyleData", "AltInstitution", "All",
  StyleMenuListing->None],
Cell[41605, 1702, 50, 0, 70, 50, 0, "StyleData", "AltInstitution", \
"NumberedHeads"],
Cell[41658, 1704, 49, 0, 70, 49, 0, "StyleData", "AltInstitution", \
"Presentation"],
Cell[41710, 1706, 45, 0, 70, 45, 0, "StyleData", "AltInstitution", \
"Printout"],
Cell[41758, 1708, 58, 0, 70, 58, 0, "StyleData", "AltInstitution", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[41865, 1714, 56, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[41946, 1719, 303, 9, 54, 34, 0, "StyleData", "AbstractSection", "All",
  StyleMenuListing->None],
Cell[42252, 1730, 51, 0, 54, 51, 0, "StyleData", "AbstractSection", \
"NumberedHeads"],
Cell[42306, 1732, 103, 2, 71, 50, 0, "StyleData", "AbstractSection", \
"Presentation"],
Cell[42412, 1736, 152, 4, 51, 46, 0, "StyleData", "AbstractSection", \
"Printout",
  StyleMenuListing->None],
Cell[42567, 1742, 165, 4, 51, 59, 0, "StyleData", "AbstractSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[42769, 1751, 272, 8, 36, 37, 0, "StyleData", "AbstractSubsection", "All",
  
  StyleMenuListing->None],
Cell[43044, 1761, 54, 0, 35, 54, 0, "StyleData", "AbstractSubsection", \
"NumberedHeads"],
Cell[43101, 1763, 105, 2, 43, 53, 0, "StyleData", "AbstractSubsection", \
"Presentation"],
Cell[43209, 1767, 128, 3, 30, 49, 0, "StyleData", "AbstractSubsection", \
"Printout"],
Cell[43340, 1772, 141, 3, 30, 62, 0, "StyleData", "AbstractSubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[43518, 1780, 216, 7, 40, 27, 0, "StyleData", "Abstract", "All",
  StyleMenuListing->None],
Cell[43737, 1789, 70, 1, 40, 44, 0, "StyleData", "Abstract", "NumberedHeads",
  StyleMenuListing->None],
Cell[43810, 1792, 121, 3, 47, 43, 0, "StyleData", "Abstract", "Presentation",
  StyleMenuListing->None],
Cell[43934, 1797, 144, 4, 33, 39, 0, "StyleData", "Abstract", "Printout",
  StyleMenuListing->None],
Cell[44081, 1803, 157, 4, 33, 52, 0, "StyleData", "Abstract", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[44275, 1812, 228, 7, 40, 39, 0, "StyleData", "AbstractContinuation", \
"All",
  StyleMenuListing->None],
Cell[44506, 1821, 82, 1, 40, 56, 0, "StyleData", "AbstractContinuation", \
"NumberedHeads",
  StyleMenuListing->None],
Cell[44591, 1824, 133, 3, 47, 55, 0, "StyleData", "AbstractContinuation", \
"Presentation",
  StyleMenuListing->None],
Cell[44727, 1829, 156, 4, 33, 51, 0, "StyleData", "AbstractContinuation", \
"Printout",
  StyleMenuListing->None],
Cell[44886, 1835, 169, 4, 33, 64, 0, "StyleData", "AbstractContinuation", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[45092, 1844, 413, 10, 41, 31, 0, "StyleData", "AbstractMath", "All",
  CounterIncrements->"Equation",
  StyleMenuListing->None],
Cell[45508, 1856, 48, 0, 42, 48, 0, "StyleData", "AbstractMath", \
"NumberedHeads"],
Cell[45559, 1858, 99, 2, 54, 47, 0, "StyleData", "AbstractMath", \
"Presentation"],
Cell[45661, 1862, 122, 3, 37, 43, 0, "StyleData", "AbstractMath", \
"Printout"],
Cell[45786, 1867, 135, 3, 37, 56, 0, "StyleData", "AbstractMath", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[45970, 1876, 62, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[46057, 1881, 211, 6, 70, 39, 0, "StyleData", "AbstractShortSection", \
"All",
  StyleMenuListing->None],
Cell[46271, 1889, 56, 0, 70, 56, 0, "StyleData", "AbstractShortSection", \
"NumberedHeads"],
Cell[46330, 1891, 107, 2, 70, 55, 0, "StyleData", "AbstractShortSection", \
"Presentation"],
Cell[46440, 1895, 100, 2, 70, 51, 0, "StyleData", "AbstractShortSection", \
"Printout"],
Cell[46543, 1899, 113, 2, 70, 64, 0, "StyleData", "AbstractShortSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[46693, 1906, 93, 2, 70, 32, 0, "StyleData", "AbstractShort", "All",
  StyleMenuListing->None],
Cell[46789, 1910, 49, 0, 70, 49, 0, "StyleData", "AbstractShort", \
"NumberedHeads"],
Cell[46841, 1912, 99, 2, 70, 48, 0, "StyleData", "AbstractShort", \
"Presentation"],
Cell[46943, 1916, 93, 2, 70, 44, 0, "StyleData", "AbstractShort", \
"Printout"],
Cell[47039, 1920, 106, 2, 70, 57, 0, "StyleData", "AbstractShort", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[47194, 1928, 70, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[47289, 1933, 61, 1, 70, 35, 0, "StyleData", "UniqueIdentifier", "All",
  StyleMenuListing->None],
Cell[47353, 1936, 52, 0, 70, 52, 0, "StyleData", "UniqueIdentifier", \
"NumberedHeads"],
Cell[47408, 1938, 51, 0, 70, 51, 0, "StyleData", "UniqueIdentifier", \
"Presentation"],
Cell[47462, 1940, 47, 0, 70, 47, 0, "StyleData", "UniqueIdentifier", \
"Printout"],
Cell[47512, 1942, 60, 0, 70, 60, 0, "StyleData", "UniqueIdentifier", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[47609, 1947, 58, 1, 70, 32, 0, "StyleData", "DocumentLabel", "All",
  StyleMenuListing->None],
Cell[47670, 1950, 49, 0, 70, 49, 0, "StyleData", "DocumentLabel", \
"NumberedHeads"],
Cell[47722, 1952, 48, 0, 70, 48, 0, "StyleData", "DocumentLabel", \
"Presentation"],
Cell[47773, 1954, 44, 0, 70, 44, 0, "StyleData", "DocumentLabel", \
"Printout"],
Cell[47820, 1956, 57, 0, 70, 57, 0, "StyleData", "DocumentLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[47914, 1961, 393, 10, 70, 25, 0, "StyleData", "Source", "All",
  StyleMenuListing->None],
Cell[48310, 1973, 42, 0, 70, 42, 0, "StyleData", "Source", "NumberedHeads"],
Cell[48355, 1975, 92, 2, 70, 41, 0, "StyleData", "Source", "Presentation"],
Cell[48450, 1979, 86, 2, 70, 37, 0, "StyleData", "Source", "Printout"],
Cell[48539, 1983, 99, 2, 70, 50, 0, "StyleData", "Source", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[48675, 1990, 385, 10, 70, 23, 0, "StyleData", "ISSN", "All",
  StyleMenuListing->None],
Cell[49063, 2002, 40, 0, 70, 40, 0, "StyleData", "ISSN", "NumberedHeads"],
Cell[49106, 2004, 90, 2, 70, 39, 0, "StyleData", "ISSN", "Presentation"],
Cell[49199, 2008, 84, 2, 70, 35, 0, "StyleData", "ISSN", "Printout"],
Cell[49286, 2012, 97, 2, 70, 48, 0, "StyleData", "ISSN", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[49420, 2019, 393, 10, 70, 25, 0, "StyleData", "Volume", "All",
  StyleMenuListing->None],
Cell[49816, 2031, 42, 0, 70, 42, 0, "StyleData", "Volume", "NumberedHeads"],
Cell[49861, 2033, 92, 2, 70, 41, 0, "StyleData", "Volume", "Presentation"],
Cell[49956, 2037, 86, 2, 70, 37, 0, "StyleData", "Volume", "Printout"],
Cell[50045, 2041, 99, 2, 70, 50, 0, "StyleData", "Volume", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[50181, 2048, 392, 10, 70, 25, 0, "StyleData", "Number", "All",
  StyleMenuListing->None],
Cell[50576, 2060, 42, 0, 70, 42, 0, "StyleData", "Number", "NumberedHeads"],
Cell[50621, 2062, 92, 2, 70, 41, 0, "StyleData", "Number", "Presentation"],
Cell[50716, 2066, 86, 2, 70, 37, 0, "StyleData", "Number", "Printout"],
Cell[50805, 2070, 99, 2, 70, 50, 0, "StyleData", "Number", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[50941, 2077, 412, 11, 70, 28, 0, "StyleData", "FirstPage", "All",
  StyleMenuListing->None],
Cell[51356, 2090, 45, 0, 70, 45, 0, "StyleData", "FirstPage", \
"NumberedHeads"],
Cell[51404, 2092, 95, 2, 70, 44, 0, "StyleData", "FirstPage", \
"Presentation"],
Cell[51502, 2096, 89, 2, 70, 40, 0, "StyleData", "FirstPage", "Printout"],
Cell[51594, 2100, 102, 2, 70, 53, 0, "StyleData", "FirstPage", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[51733, 2107, 408, 11, 70, 27, 0, "StyleData", "LastPage", "All",
  StyleMenuListing->None],
Cell[52144, 2120, 44, 0, 70, 44, 0, "StyleData", "LastPage", \
"NumberedHeads"],
Cell[52191, 2122, 94, 2, 70, 43, 0, "StyleData", "LastPage", "Presentation"],
Cell[52288, 2126, 88, 2, 70, 39, 0, "StyleData", "LastPage", "Printout"],
Cell[52379, 2130, 101, 2, 70, 52, 0, "StyleData", "LastPage", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[52517, 2137, 381, 10, 70, 22, 0, "StyleData", "URL", "All",
  StyleMenuListing->None],
Cell[52901, 2149, 39, 0, 70, 39, 0, "StyleData", "URL", "NumberedHeads"],
Cell[52943, 2151, 89, 2, 70, 38, 0, "StyleData", "URL", "Presentation"],
Cell[53035, 2155, 83, 2, 70, 34, 0, "StyleData", "URL", "Printout"],
Cell[53121, 2159, 96, 2, 70, 47, 0, "StyleData", "URL", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[53254, 2166, 461, 12, 70, 31, 0, "StyleData", "DateReceived", "All",
  StyleMenuListing->None],
Cell[53718, 2180, 443, 11, 70, 48, 0, "StyleData", "DateReceived", \
"NumberedHeads",
  StyleMenuListing->None],
Cell[54164, 2193, 99, 2, 70, 47, 0, "StyleData", "DateReceived", \
"Presentation"],
Cell[54266, 2197, 93, 2, 70, 43, 0, "StyleData", "DateReceived", "Printout"],
Cell[54362, 2201, 106, 2, 70, 56, 0, "StyleData", "DateReceived", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[54505, 2208, 453, 11, 70, 40, 0, "StyleData", "DateRevisionRequested", \
"All",
  StyleMenuListing->None],
Cell[54961, 2221, 57, 0, 70, 57, 0, "StyleData", "DateRevisionRequested", \
"NumberedHeads"],
Cell[55021, 2223, 107, 2, 70, 56, 0, "StyleData", "DateRevisionRequested", \
"Presentation"],
Cell[55131, 2227, 101, 2, 70, 52, 0, "StyleData", "DateRevisionRequested", \
"Printout"],
Cell[55235, 2231, 114, 2, 70, 65, 0, "StyleData", "DateRevisionRequested", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[55386, 2238, 425, 11, 70, 39, 0, "StyleData", "DateRevisionReceived", \
"All",
  StyleMenuListing->None],
Cell[55814, 2251, 56, 0, 70, 56, 0, "StyleData", "DateRevisionReceived", \
"NumberedHeads"],
Cell[55873, 2253, 106, 2, 70, 55, 0, "StyleData", "DateRevisionReceived", \
"Presentation"],
Cell[55982, 2257, 100, 2, 70, 51, 0, "StyleData", "DateRevisionReceived", \
"Printout"],
Cell[56085, 2261, 113, 2, 70, 64, 0, "StyleData", "DateRevisionReceived", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[56235, 2268, 414, 11, 70, 31, 0, "StyleData", "DateAccepted", "All",
  StyleMenuListing->None],
Cell[56652, 2281, 48, 0, 70, 48, 0, "StyleData", "DateAccepted", \
"NumberedHeads"],
Cell[56703, 2283, 98, 2, 70, 47, 0, "StyleData", "DateAccepted", \
"Presentation"],
Cell[56804, 2287, 92, 2, 70, 43, 0, "StyleData", "DateAccepted", "Printout"],
Cell[56899, 2291, 105, 2, 70, 56, 0, "StyleData", "DateAccepted", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[57041, 2298, 418, 11, 70, 32, 0, "StyleData", "DatePublished", "All",
  StyleMenuListing->None],
Cell[57462, 2311, 49, 0, 70, 49, 0, "StyleData", "DatePublished", \
"NumberedHeads"],
Cell[57514, 2313, 99, 2, 70, 48, 0, "StyleData", "DatePublished", \
"Presentation"],
Cell[57616, 2317, 93, 2, 70, 44, 0, "StyleData", "DatePublished", \
"Printout"],
Cell[57712, 2321, 106, 2, 70, 57, 0, "StyleData", "DatePublished", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[57855, 2328, 66, 1, 70, 40, 0, "StyleData", "SubjectClassification", \
"All",
  StyleMenuListing->None],
Cell[57924, 2331, 57, 0, 70, 57, 0, "StyleData", "SubjectClassification", \
"NumberedHeads"],
Cell[57984, 2333, 56, 0, 70, 56, 0, "StyleData", "SubjectClassification", \
"Presentation"],
Cell[58043, 2335, 52, 0, 70, 52, 0, "StyleData", "SubjectClassification", \
"Printout"],
Cell[58098, 2337, 65, 0, 70, 65, 0, "StyleData", "SubjectClassification", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[58200, 2342, 57, 1, 70, 31, 0, "StyleData", "KeywordGroup", "All",
  StyleMenuListing->None],
Cell[58260, 2345, 48, 0, 70, 48, 0, "StyleData", "KeywordGroup", \
"NumberedHeads"],
Cell[58311, 2347, 47, 0, 70, 47, 0, "StyleData", "KeywordGroup", \
"Presentation"],
Cell[58361, 2349, 43, 0, 70, 43, 0, "StyleData", "KeywordGroup", "Printout"],
Cell[58407, 2351, 56, 0, 70, 56, 0, "StyleData", "KeywordGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[58500, 2356, 53, 1, 70, 27, 0, "StyleData", "Keywords", "All",
  StyleMenuListing->None],
Cell[58556, 2359, 44, 0, 70, 44, 0, "StyleData", "Keywords", \
"NumberedHeads"],
Cell[58603, 2361, 43, 0, 70, 43, 0, "StyleData", "Keywords", "Presentation"],
Cell[58649, 2363, 39, 0, 70, 39, 0, "StyleData", "Keywords", "Printout"],
Cell[58691, 2365, 52, 0, 70, 52, 0, "StyleData", "Keywords", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[58780, 2370, 55, 1, 70, 29, 0, "StyleData", "PreprintID", "All",
  StyleMenuListing->None],
Cell[58838, 2373, 46, 0, 70, 46, 0, "StyleData", "PreprintID", \
"NumberedHeads"],
Cell[58887, 2375, 45, 0, 70, 45, 0, "StyleData", "PreprintID", \
"Presentation"],
Cell[58935, 2377, 41, 0, 70, 41, 0, "StyleData", "PreprintID", "Printout"],
Cell[58979, 2379, 54, 0, 70, 54, 0, "StyleData", "PreprintID", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[59082, 2385, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[59139, 2389, 204, 7, 70, 29, 0, "StyleData", "Dedication", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[59346, 2398, 46, 0, 70, 46, 0, "StyleData", "Dedication", \
"NumberedHeads"],
Cell[59395, 2400, 96, 2, 70, 45, 0, "StyleData", "Dedication", \
"Presentation"],
Cell[59494, 2404, 113, 3, 70, 41, 0, "StyleData", "Dedication", "Printout"],
Cell[59610, 2409, 126, 3, 70, 54, 0, "StyleData", "Dedication", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[59785, 2418, 65, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[59875, 2423, 32, 0, 31, "Subsubsection"],

Cell[CellGroupData[{
Cell[59932, 2427, 42, 0, 28, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[59999, 2431, 321, 10, 67, 29, 0, "StyleData", "TOCHeading", "All",
  StyleMenuListing->None],
Cell[60323, 2443, 46, 0, 67, 46, 0, "StyleData", "TOCHeading", \
"NumberedHeads"],
Cell[60372, 2445, 91, 2, 57, 41, 0, "StyleData", "TOCHeading", "Printout"],
Cell[60466, 2449, 104, 2, 57, 54, 0, "StyleData", "TOCHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[60607, 2456, 367, 11, 47, 35, 0, "StyleData", "TOCIllustrations", "All",
  CounterAssignments->{{"TOCItem", 0}},
  StyleMenuListing->None],
Cell[60977, 2469, 52, 0, 67, 52, 0, "StyleData", "TOCIllustrations", \
"NumberedHeads"],
Cell[61032, 2471, 97, 2, 57, 47, 0, "StyleData", "TOCIllustrations", \
"Printout"],
Cell[61132, 2475, 110, 2, 57, 60, 0, "StyleData", "TOCIllustrations", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[61279, 2482, 360, 11, 47, 28, 0, "StyleData", "TOCTables", "All",
  CounterAssignments->{{"TOCItem", 0}},
  StyleMenuListing->None],
Cell[61642, 2495, 45, 0, 67, 45, 0, "StyleData", "TOCTables", \
"NumberedHeads"],
Cell[61690, 2497, 90, 2, 57, 40, 0, "StyleData", "TOCTables", "Printout"],
Cell[61783, 2501, 103, 2, 57, 53, 0, "StyleData", "TOCTables", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[61935, 2509, 45, 0, 26, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[62005, 2513, 227, 7, 36, 40, 0, "StyleData", "TOCFrontmatterHeading", \
"All",
  StyleMenuListing->None],
Cell[62235, 2522, 57, 0, 36, 57, 0, "StyleData", "TOCFrontmatterHeading", \
"NumberedHeads"],
Cell[62295, 2524, 121, 3, 32, 52, 0, "StyleData", "TOCFrontmatterHeading", \
"Printout"],
Cell[62419, 2529, 134, 3, 32, 65, 0, "StyleData", "TOCFrontmatterHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[62590, 2537, 226, 7, 39, 39, 0, "StyleData", "TOCBackmatterHeading", \
"All",
  StyleMenuListing->None],
Cell[62819, 2546, 56, 0, 36, 56, 0, "StyleData", "TOCBackmatterHeading", \
"NumberedHeads"],
Cell[62878, 2548, 120, 3, 32, 51, 0, "StyleData", "TOCBackmatterHeading", \
"Printout"],
Cell[63001, 2553, 133, 3, 32, 64, 0, "StyleData", "TOCBackmatterHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[63171, 2561, 225, 7, 39, 38, 0, "StyleData", "TOCFrontBackHeading", \
"All",
  StyleMenuListing->None],
Cell[63399, 2570, 55, 0, 36, 55, 0, "StyleData", "TOCFrontBackHeading", \
"NumberedHeads"],
Cell[63457, 2572, 119, 3, 32, 50, 0, "StyleData", "TOCFrontBackHeading", \
"Printout"],
Cell[63579, 2577, 132, 3, 32, 63, 0, "StyleData", "TOCFrontBackHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[63748, 2585, 459, 12, 39, 29, 0, "StyleData", "TOCSection", "All",
  CounterIncrements->"TOCSection",
  CounterAssignments->{{"TOCSubsection", 0}},
  StyleMenuListing->None],
Cell[64210, 2599, 46, 0, 36, 46, 0, "StyleData", "TOCSection", \
"NumberedHeads"],
Cell[64259, 2601, 134, 4, 34, 41, 0, "StyleData", "TOCSection", "Printout"],
Cell[64396, 2607, 147, 4, 34, 54, 0, "StyleData", "TOCSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[64580, 2616, 484, 11, 37, 32, 0, "StyleData", "TOCSubsection", "All",
  CounterIncrements->"TOCSubsection",
  CounterAssignments->{{"TOCSubsubsection", 0}},
  StyleMenuListing->None],
Cell[65067, 2629, 49, 0, 34, 49, 0, "StyleData", "TOCSubsection", \
"NumberedHeads"],
Cell[65119, 2631, 140, 4, 31, 44, 0, "StyleData", "TOCSubsection", \
"Printout"],
Cell[65262, 2637, 153, 4, 31, 57, 0, "StyleData", "TOCSubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[65452, 2646, 494, 11, 37, 35, 0, "StyleData", "TOCSubsubsection", "All",
  CounterIncrements->"TOCSubsubsection",
  StyleMenuListing->None],
Cell[65949, 2659, 52, 0, 34, 52, 0, "StyleData", "TOCSubsubsection", \
"NumberedHeads"],
Cell[66004, 2661, 143, 4, 31, 47, 0, "StyleData", "TOCSubsubsection", \
"Printout"],
Cell[66150, 2667, 156, 4, 31, 60, 0, "StyleData", "TOCSubsubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[66343, 2676, 341, 8, 37, 28, 0, "StyleData", "TOCFigure", "All",
  CounterIncrements->"TOCFigure",
  StyleMenuListing->None],
Cell[66687, 2686, 45, 0, 34, 45, 0, "StyleData", "TOCFigure", \
"NumberedHeads"],
Cell[66735, 2688, 110, 3, 31, 40, 0, "StyleData", "TOCFigure", "Printout"],
Cell[66848, 2693, 123, 3, 31, 53, 0, "StyleData", "TOCFigure", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[67008, 2701, 366, 8, 37, 34, 0, "StyleData", "TOCSupplemental", "All",
  CounterIncrements->"TOCSupplemental",
  StyleMenuListing->None],
Cell[67377, 2711, 51, 0, 34, 51, 0, "StyleData", "TOCSupplemental", \
"NumberedHeads"],
Cell[67431, 2713, 116, 3, 31, 46, 0, "StyleData", "TOCSupplemental", \
"Printout"],
Cell[67550, 2718, 129, 3, 31, 59, 0, "StyleData", "TOCSupplemental", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[67716, 2726, 346, 8, 37, 29, 0, "StyleData", "TOCPicture", "All",
  CounterIncrements->"TOCPicture",
  StyleMenuListing->None],
Cell[68065, 2736, 46, 0, 34, 46, 0, "StyleData", "TOCPicture", \
"NumberedHeads"],
Cell[68114, 2738, 111, 3, 31, 41, 0, "StyleData", "TOCPicture", "Printout"],
Cell[68228, 2743, 124, 3, 31, 54, 0, "StyleData", "TOCPicture", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[68389, 2751, 367, 8, 37, 34, 0, "StyleData", "TOCIllustration", "All",
  CounterIncrements->"TOCIllustration",
  StyleMenuListing->None],
Cell[68759, 2761, 51, 0, 34, 51, 0, "StyleData", "TOCIllustration", \
"NumberedHeads"],
Cell[68813, 2763, 116, 3, 31, 46, 0, "StyleData", "TOCIllustration", \
"Printout"],
Cell[68932, 2768, 129, 3, 31, 59, 0, "StyleData", "TOCIllustration", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[69098, 2776, 345, 8, 37, 29, 0, "StyleData", "TOCProgram", "All",
  CounterIncrements->"TOCProgram",
  StyleMenuListing->None],
Cell[69446, 2786, 46, 0, 34, 46, 0, "StyleData", "TOCProgram", \
"NumberedHeads"],
Cell[69495, 2788, 111, 3, 31, 41, 0, "StyleData", "TOCProgram", "Printout"],
Cell[69609, 2793, 124, 3, 31, 54, 0, "StyleData", "TOCProgram", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[69770, 2801, 338, 8, 37, 27, 0, "StyleData", "TOCTable", "All",
  CounterIncrements->"TOCTable",
  StyleMenuListing->None],
Cell[70111, 2811, 44, 0, 34, 44, 0, "StyleData", "TOCTable", \
"NumberedHeads"],
Cell[70158, 2813, 109, 3, 31, 39, 0, "StyleData", "TOCTable", "Printout"],
Cell[70270, 2818, 122, 3, 31, 52, 0, "StyleData", "TOCTable", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[70429, 2826, 319, 8, 37, 26, 0, "StyleData", "TOCItem", "All",
  CounterIncrements->"TOCItem",
  StyleMenuListing->None],
Cell[70751, 2836, 43, 0, 34, 43, 0, "StyleData", "TOCItem", "NumberedHeads"],
Cell[70797, 2838, 109, 3, 31, 38, 0, "StyleData", "TOCItem", "Printout"],
Cell[70909, 2843, 122, 3, 31, 51, 0, "StyleData", "TOCItem", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[71080, 2852, 43, 0, 26, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[71148, 2856, 89, 2, 32, 28, 0, "StyleData", "TOCSpacer", "All",
  StyleMenuListing->None],
Cell[71240, 2860, 106, 2, 32, 45, 0, "StyleData", "TOCSpacer", \
"NumberedHeads",
  StyleMenuListing->None],
Cell[71349, 2864, 73, 1, 32, 40, 0, "StyleData", "TOCSpacer", "Printout"],
Cell[71425, 2867, 86, 1, 32, 53, 0, "StyleData", "TOCSpacer", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[71548, 2873, 175, 5, 40, 34, 0, "StyleData", "TOCSectionLabel", "All",
  StyleMenuListing->None],
Cell[71726, 2880, 51, 0, 40, 51, 0, "StyleData", "TOCSectionLabel", \
"NumberedHeads"],
Cell[71780, 2882, 75, 1, 40, 46, 0, "StyleData", "TOCSectionLabel", \
"Printout"],
Cell[71858, 2885, 88, 1, 40, 59, 0, "StyleData", "TOCSectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[71983, 2891, 178, 5, 40, 37, 0, "StyleData", "TOCSubsectionLabel", "All",
  
  StyleMenuListing->None],
Cell[72164, 2898, 54, 0, 40, 54, 0, "StyleData", "TOCSubsectionLabel", \
"NumberedHeads"],
Cell[72221, 2900, 78, 1, 40, 49, 0, "StyleData", "TOCSubsectionLabel", \
"Printout"],
Cell[72302, 2903, 91, 1, 40, 62, 0, "StyleData", "TOCSubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[72430, 2909, 181, 5, 40, 40, 0, "StyleData", "TOCSubsubsectionLabel", \
"All",
  StyleMenuListing->None],
Cell[72614, 2916, 57, 0, 40, 57, 0, "StyleData", "TOCSubsubsectionLabel", \
"NumberedHeads"],
Cell[72674, 2918, 81, 1, 40, 52, 0, "StyleData", "TOCSubsubsectionLabel", \
"Printout"],
Cell[72758, 2921, 94, 1, 40, 65, 0, "StyleData", "TOCSubsubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[72889, 2927, 112, 3, 40, 33, 0, "StyleData", "TOCFigureLabel", "All",
  StyleMenuListing->None],
Cell[73004, 2932, 50, 0, 40, 50, 0, "StyleData", "TOCFigureLabel", \
"NumberedHeads"],
Cell[73057, 2934, 74, 1, 40, 45, 0, "StyleData", "TOCFigureLabel", \
"Printout"],
Cell[73134, 2937, 87, 1, 40, 58, 0, "StyleData", "TOCFigureLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[73258, 2943, 118, 3, 40, 39, 0, "StyleData", "TOCSupplementalLabel", \
"All",
  StyleMenuListing->None],
Cell[73379, 2948, 56, 0, 40, 56, 0, "StyleData", "TOCSupplementalLabel", \
"NumberedHeads"],
Cell[73438, 2950, 80, 1, 40, 51, 0, "StyleData", "TOCSupplementalLabel", \
"Printout"],
Cell[73521, 2953, 93, 1, 40, 64, 0, "StyleData", "TOCSupplementalLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[73651, 2959, 113, 3, 40, 34, 0, "StyleData", "TOCPictureLabel", "All",
  StyleMenuListing->None],
Cell[73767, 2964, 51, 0, 40, 51, 0, "StyleData", "TOCPictureLabel", \
"NumberedHeads"],
Cell[73821, 2966, 75, 1, 40, 46, 0, "StyleData", "TOCPictureLabel", \
"Printout"],
Cell[73899, 2969, 88, 1, 40, 59, 0, "StyleData", "TOCPictureLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[74024, 2975, 118, 3, 40, 39, 0, "StyleData", "TOCIllustrationLabel", \
"All",
  StyleMenuListing->None],
Cell[74145, 2980, 56, 0, 40, 56, 0, "StyleData", "TOCIllustrationLabel", \
"NumberedHeads"],
Cell[74204, 2982, 80, 1, 40, 51, 0, "StyleData", "TOCIllustrationLabel", \
"Printout"],
Cell[74287, 2985, 93, 1, 40, 64, 0, "StyleData", "TOCIllustrationLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[74417, 2991, 113, 3, 40, 34, 0, "StyleData", "TOCProgramLabel", "All",
  StyleMenuListing->None],
Cell[74533, 2996, 51, 0, 40, 51, 0, "StyleData", "TOCProgramLabel", \
"NumberedHeads"],
Cell[74587, 2998, 75, 1, 40, 46, 0, "StyleData", "TOCProgramLabel", \
"Printout"],
Cell[74665, 3001, 88, 1, 40, 59, 0, "StyleData", "TOCProgramLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[74790, 3007, 111, 3, 40, 32, 0, "StyleData", "TOCTableLabel", "All",
  StyleMenuListing->None],
Cell[74904, 3012, 49, 0, 40, 49, 0, "StyleData", "TOCTableLabel", \
"NumberedHeads"],
Cell[74956, 3014, 73, 1, 40, 44, 0, "StyleData", "TOCTableLabel", \
"Printout"],
Cell[75032, 3017, 86, 1, 40, 57, 0, "StyleData", "TOCTableLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[75155, 3023, 111, 3, 40, 32, 0, "StyleData", "TOCItemNumber", "All",
  StyleMenuListing->None],
Cell[75269, 3028, 49, 0, 40, 49, 0, "StyleData", "TOCItemNumber", \
"NumberedHeads"],
Cell[75321, 3030, 73, 1, 40, 44, 0, "StyleData", "TOCItemNumber", \
"Printout"],
Cell[75397, 3033, 86, 1, 40, 57, 0, "StyleData", "TOCItemNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[75520, 3039, 110, 3, 40, 31, 0, "StyleData", "TOCItemLabel", "All",
  StyleMenuListing->None],
Cell[75633, 3044, 48, 0, 40, 48, 0, "StyleData", "TOCItemLabel", \
"NumberedHeads"],
Cell[75684, 3046, 72, 1, 40, 43, 0, "StyleData", "TOCItemLabel", "Printout"],
Cell[75759, 3049, 85, 1, 40, 56, 0, "StyleData", "TOCItemLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[75881, 3055, 198, 7, 40, 28, 0, "StyleData", "TOCLeader", "All",
  StyleMenuListing->None],
Cell[76082, 3064, 45, 0, 70, 45, 0, "StyleData", "TOCLeader", \
"NumberedHeads"],
Cell[76130, 3066, 56, 1, 70, 40, 0, "StyleData", "TOCLeader", "Printout"],
Cell[76189, 3069, 69, 1, 70, 53, 0, "StyleData", "TOCLeader", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[76295, 3075, 218, 7, 40, 32, 0, "StyleData", "TOCPageNumber", "All",
  StyleMenuListing->None],
Cell[76516, 3084, 49, 0, 70, 49, 0, "StyleData", "TOCPageNumber", \
"NumberedHeads"],
Cell[76568, 3086, 73, 1, 70, 44, 0, "StyleData", "TOCPageNumber", \
"Printout"],
Cell[76644, 3089, 86, 1, 70, 57, 0, "StyleData", "TOCPageNumber", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[76791, 3097, 29, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[76845, 3101, 42, 0, 28, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[76912, 3105, 362, 10, 106, 33, 0, "StyleData", "TOCBookHeading", "All",
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None],
Cell[77277, 3117, 50, 0, 106, 50, 0, "StyleData", "TOCBookHeading", \
"NumberedHeads"],
Cell[77330, 3119, 92, 2, 92, 41, 0, "StyleData", "TOCHeading", "Printout"],
Cell[77425, 3123, 109, 2, 92, 58, 0, "StyleData", "TOCBookHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[77571, 3130, 320, 8, 74, 39, 0, "StyleData", "TOCBookIllustrations", \
"All",
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None],
Cell[77894, 3140, 56, 0, 106, 56, 0, "StyleData", "TOCBookIllustrations", \
"NumberedHeads"],
Cell[77953, 3142, 98, 2, 92, 47, 0, "StyleData", "TOCIllustrations", \
"Printout"],
Cell[78054, 3146, 195, 6, 92]
}, Closed]],

Cell[CellGroupData[{
Cell[78286, 3157, 313, 8, 74, 32, 0, "StyleData", "TOCBookTables", "All",
  CounterAssignments->{{"TOCBookFrontBackHeading", 0}, {
      "TOCBookChapterTitle", 0}, {"TOCItem", 0}},
  StyleMenuListing->None],
Cell[78602, 3167, 49, 0, 106, 49, 0, "StyleData", "TOCBookTables", \
"NumberedHeads"],
Cell[78654, 3169, 95, 2, 92, 44, 0, "StyleData", "TOCBookTables", \
"Printout"],
Cell[78752, 3173, 108, 2, 92, 57, 0, "StyleData", "TOCBookTables", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[78909, 3181, 45, 0, 26, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[78979, 3185, 484, 11, 36, 44, 0, "StyleData", \
"TOCBookFrontmatterHeading", "All",
  CounterIncrements->"TOCBookFrontmatterHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None],
Cell[79466, 3198, 61, 0, 36, 61, 0, "StyleData", "TOCBookFrontmatterHeading", \
"NumberedHeads"],
Cell[79530, 3200, 125, 3, 32, 56, 0, "StyleData", \
"TOCBookFrontmatterHeading", "Printout"],
Cell[79658, 3205, 138, 3, 32, 69, 0, "StyleData", \
"TOCBookFrontmatterHeading", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[79833, 3213, 482, 11, 39, 43, 0, "StyleData", \
"TOCBookBackmatterHeading", "All",
  CounterIncrements->"TOCBookBackmatterHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None],
Cell[80318, 3226, 60, 0, 36, 60, 0, "StyleData", "TOCBookBackmatterHeading", \
"NumberedHeads"],
Cell[80381, 3228, 124, 3, 32, 55, 0, "StyleData", "TOCBookBackmatterHeading", \
"Printout"],
Cell[80508, 3233, 137, 3, 32, 68, 0, "StyleData", "TOCBookBackmatterHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[80682, 3241, 480, 11, 39, 42, 0, "StyleData", "TOCBookFrontBackHeading", \
"All",
  CounterIncrements->"TOCBookFrontBackHeading",
  CounterAssignments->{{"TOCBookFigure", 0}, {"TOCBookSupplemental", 0}, {
      "TOCBookPicture", 0}, {"TOCBookIllustration", 0}, {
      "TOCBookProgram", 0}, {"TOCBookTable", 0}, {"TOCBookItem", 0}},
  StyleMenuListing->None],
Cell[81165, 3254, 59, 0, 36, 59, 0, "StyleData", "TOCBookFrontBackHeading", \
"NumberedHeads"],
Cell[81227, 3256, 123, 3, 32, 54, 0, "StyleData", "TOCBookFrontBackHeading", \
"Printout"],
Cell[81353, 3261, 136, 3, 32, 67, 0, "StyleData", "TOCBookFrontBackHeading", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[81526, 3269, 503, 12, 41, 35, 0, "StyleData", "TOCBookPartTitle", "All",
  CounterIncrements->"TOCBookPartTitle",
  CounterAssignments->{{"TOCBookChapterTitle", 0}},
  StyleMenuListing->None],
Cell[82032, 3283, 52, 0, 49, 52, 0, "StyleData", "TOCBookPartTitle", \
"NumberedHeads"],
Cell[82087, 3285, 98, 2, 44, 47, 0, "StyleData", "TOCBookPartTitle", \
"Printout"],
Cell[82188, 3289, 111, 2, 44, 60, 0, "StyleData", "TOCBookPartTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[82336, 3296, 496, 12, 39, 38, 0, "StyleData", "TOCBookChapterTitle", \
"All",
  CounterIncrements->"TOCBookChapterTitle",
  CounterAssignments->{{"TOCBookSection", 0}},
  StyleMenuListing->None],
Cell[82835, 3310, 55, 0, 36, 55, 0, "StyleData", "TOCBookChapterTitle", \
"NumberedHeads"],
Cell[82893, 3312, 143, 4, 34, 50, 0, "StyleData", "TOCBookChapterTitle", \
"Printout"],
Cell[83039, 3318, 156, 4, 34, 63, 0, "StyleData", "TOCBookChapterTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[83232, 3327, 498, 11, 37, 33, 0, "StyleData", "TOCBookSection", "All",
  CounterIncrements->"TOCBookSection",
  CounterAssignments->{{"TOCBookSubsection", 0}},
  StyleMenuListing->None],
Cell[83733, 3340, 50, 0, 34, 50, 0, "StyleData", "TOCBookSection", \
"NumberedHeads"],
Cell[83786, 3342, 141, 4, 31, 45, 0, "StyleData", "TOCBookSection", \
"Printout"],
Cell[83930, 3348, 154, 4, 31, 58, 0, "StyleData", "TOCBookSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[84121, 3357, 508, 11, 37, 36, 0, "StyleData", "TOCBookSubsection", "All",
  
  CounterIncrements->"TOCBookSubsection",
  StyleMenuListing->None],
Cell[84632, 3370, 53, 0, 34, 53, 0, "StyleData", "TOCBookSubsection", \
"NumberedHeads"],
Cell[84688, 3372, 144, 4, 31, 48, 0, "StyleData", "TOCBookSubsection", \
"Printout"],
Cell[84835, 3378, 157, 4, 31, 61, 0, "StyleData", "TOCBookSubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[85029, 3387, 415, 9, 37, 32, 0, "StyleData", "TOCBookFigure", "All",
  CounterIncrements->"TOCBookFigure",
  StyleMenuListing->None],
Cell[85447, 3398, 49, 0, 34, 49, 0, "StyleData", "TOCBookFigure", \
"NumberedHeads"],
Cell[85499, 3400, 114, 3, 31, 44, 0, "StyleData", "TOCBookFigure", \
"Printout"],
Cell[85616, 3405, 127, 3, 31, 57, 0, "StyleData", "TOCBookFigure", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[85780, 3413, 447, 10, 34, 38, 0, "StyleData", "TOCBookSupplemental", \
"All",
  CounterIncrements->"TOCBookSupplemental",
  StyleMenuListing->None],
Cell[86230, 3425, 55, 0, 34, 55, 0, "StyleData", "TOCBookSupplemental", \
"NumberedHeads"],
Cell[86288, 3427, 120, 3, 31, 50, 0, "StyleData", "TOCBookSupplemental", \
"Printout"],
Cell[86411, 3432, 133, 3, 31, 63, 0, "StyleData", "TOCBookSupplemental", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[86581, 3440, 420, 9, 34, 33, 0, "StyleData", "TOCBookPicture", "All",
  CounterIncrements->"TOCBookPicture",
  StyleMenuListing->None],
Cell[87004, 3451, 50, 0, 34, 50, 0, "StyleData", "TOCBookPicture", \
"NumberedHeads"],
Cell[87057, 3453, 115, 3, 31, 45, 0, "StyleData", "TOCBookPicture", \
"Printout"],
Cell[87175, 3458, 128, 3, 31, 58, 0, "StyleData", "TOCBookPicture", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[87340, 3466, 448, 10, 34, 38, 0, "StyleData", "TOCBookIllustration", \
"All",
  CounterIncrements->"TOCBookIllustration",
  StyleMenuListing->None],
Cell[87791, 3478, 55, 0, 34, 55, 0, "StyleData", "TOCBookIllustration", \
"NumberedHeads"],
Cell[87849, 3480, 120, 3, 31, 50, 0, "StyleData", "TOCBookIllustration", \
"Printout"],
Cell[87972, 3485, 133, 3, 31, 63, 0, "StyleData", "TOCBookIllustration", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[88142, 3493, 419, 9, 34, 33, 0, "StyleData", "TOCBookProgram", "All",
  CounterIncrements->"TOCBookProgram",
  StyleMenuListing->None],
Cell[88564, 3504, 50, 0, 34, 50, 0, "StyleData", "TOCBookProgram", \
"NumberedHeads"],
Cell[88617, 3506, 115, 3, 31, 45, 0, "StyleData", "TOCBookProgram", \
"Printout"],
Cell[88735, 3511, 128, 3, 31, 58, 0, "StyleData", "TOCBookProgram", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[88900, 3519, 412, 9, 34, 31, 0, "StyleData", "TOCBookTable", "All",
  CounterIncrements->"TOCBookTable",
  StyleMenuListing->None],
Cell[89315, 3530, 48, 0, 34, 48, 0, "StyleData", "TOCBookTable", \
"NumberedHeads"],
Cell[89366, 3532, 113, 3, 31, 43, 0, "StyleData", "TOCBookTable", \
"Printout"],
Cell[89482, 3537, 126, 3, 31, 56, 0, "StyleData", "TOCBookTable", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[89645, 3545, 398, 9, 34, 30, 0, "StyleData", "TOCBookItem", "All",
  CounterIncrements->"TOCBookItem",
  StyleMenuListing->None],
Cell[90046, 3556, 47, 0, 34, 47, 0, "StyleData", "TOCBookItem", \
"NumberedHeads"],
Cell[90096, 3558, 114, 3, 31, 42, 0, "StyleData", "TOCBookItem", "Printout"],
Cell[90213, 3563, 127, 3, 31, 55, 0, "StyleData", "TOCBookItem", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[90389, 3572, 43, 0, 26, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[90457, 3576, 93, 2, 32, 32, 0, "StyleData", "TOCBookSpacer", "All",
  StyleMenuListing->None],
Cell[90553, 3580, 110, 2, 32, 49, 0, "StyleData", "TOCBookSpacer", \
"NumberedHeads",
  StyleMenuListing->None],
Cell[90666, 3584, 77, 1, 32, 44, 0, "StyleData", "TOCBookSpacer", \
"Printout"],
Cell[90746, 3587, 90, 1, 32, 57, 0, "StyleData", "TOCBookSpacer", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[90873, 3593, 95, 2, 40, 40, 0, "StyleData", "TOCBookPartTitleLabel", \
"All",
  StyleMenuListing->None],
Cell[90971, 3597, 57, 0, 40, 57, 0, "StyleData", "TOCBookPartTitleLabel", \
"NumberedHeads"],
Cell[91031, 3599, 81, 1, 40, 52, 0, "StyleData", "TOCBookPartTitleLabel", \
"Printout"],
Cell[91115, 3602, 94, 1, 40, 65, 0, "StyleData", "TOCBookPartTitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[91246, 3608, 184, 5, 40, 43, 0, "StyleData", "TOCBookChapterTitleLabel", \
"All",
  StyleMenuListing->None],
Cell[91433, 3615, 60, 0, 40, 60, 0, "StyleData", "TOCBookChapterTitleLabel", \
"NumberedHeads"],
Cell[91496, 3617, 84, 1, 40, 55, 0, "StyleData", "TOCBookChapterTitleLabel", \
"Printout"],
Cell[91583, 3620, 97, 1, 40, 68, 0, "StyleData", "TOCBookChapterTitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[91717, 3626, 179, 5, 40, 38, 0, "StyleData", "TOCBookSectionLabel", \
"All",
  StyleMenuListing->None],
Cell[91899, 3633, 55, 0, 40, 55, 0, "StyleData", "TOCBookSectionLabel", \
"NumberedHeads"],
Cell[91957, 3635, 79, 1, 40, 50, 0, "StyleData", "TOCBookSectionLabel", \
"Printout"],
Cell[92039, 3638, 92, 1, 40, 63, 0, "StyleData", "TOCBookSectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[92168, 3644, 182, 5, 40, 41, 0, "StyleData", "TOCBookSubsectionLabel", \
"All",
  StyleMenuListing->None],
Cell[92353, 3651, 58, 0, 40, 58, 0, "StyleData", "TOCBookSubsectionLabel", \
"NumberedHeads"],
Cell[92414, 3653, 82, 1, 40, 53, 0, "StyleData", "TOCBookSubsectionLabel", \
"Printout"],
Cell[92499, 3656, 95, 1, 40, 66, 0, "StyleData", "TOCBookSubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[92631, 3662, 116, 3, 40, 37, 0, "StyleData", "TOCBookFigureLabel", "All",
  
  StyleMenuListing->None],
Cell[92750, 3667, 54, 0, 40, 54, 0, "StyleData", "TOCBookFigureLabel", \
"NumberedHeads"],
Cell[92807, 3669, 78, 1, 40, 49, 0, "StyleData", "TOCBookFigureLabel", \
"Printout"],
Cell[92888, 3672, 91, 1, 40, 62, 0, "StyleData", "TOCBookFigureLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[93016, 3678, 122, 3, 40, 43, 0, "StyleData", "TOCBookSupplementalLabel", \
"All",
  StyleMenuListing->None],
Cell[93141, 3683, 60, 0, 40, 60, 0, "StyleData", "TOCBookSupplementalLabel", \
"NumberedHeads"],
Cell[93204, 3685, 84, 1, 40, 55, 0, "StyleData", "TOCBookSupplementalLabel", \
"Printout"],
Cell[93291, 3688, 97, 1, 40, 68, 0, "StyleData", "TOCBookSupplementalLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[93425, 3694, 117, 3, 40, 38, 0, "StyleData", "TOCBookPictureLabel", \
"All",
  StyleMenuListing->None],
Cell[93545, 3699, 55, 0, 40, 55, 0, "StyleData", "TOCBookPictureLabel", \
"NumberedHeads"],
Cell[93603, 3701, 79, 1, 40, 50, 0, "StyleData", "TOCBookPictureLabel", \
"Printout"],
Cell[93685, 3704, 92, 1, 40, 63, 0, "StyleData", "TOCBookPictureLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[93814, 3710, 122, 3, 40, 43, 0, "StyleData", "TOCBookIllustrationLabel", \
"All",
  StyleMenuListing->None],
Cell[93939, 3715, 60, 0, 40, 60, 0, "StyleData", "TOCBookIllustrationLabel", \
"NumberedHeads"],
Cell[94002, 3717, 84, 1, 40, 55, 0, "StyleData", "TOCBookIllustrationLabel", \
"Printout"],
Cell[94089, 3720, 97, 1, 40, 68, 0, "StyleData", "TOCBookIllustrationLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[94223, 3726, 117, 3, 40, 38, 0, "StyleData", "TOCBookProgramLabel", \
"All",
  StyleMenuListing->None],
Cell[94343, 3731, 55, 0, 40, 55, 0, "StyleData", "TOCBookProgramLabel", \
"NumberedHeads"],
Cell[94401, 3733, 79, 1, 40, 50, 0, "StyleData", "TOCBookProgramLabel", \
"Printout"],
Cell[94483, 3736, 92, 1, 40, 63, 0, "StyleData", "TOCBookProgramLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[94612, 3742, 115, 3, 40, 36, 0, "StyleData", "TOCBookTableLabel", "All",
  StyleMenuListing->None],
Cell[94730, 3747, 53, 0, 40, 53, 0, "StyleData", "TOCBookTableLabel", \
"NumberedHeads"],
Cell[94786, 3749, 77, 1, 40, 48, 0, "StyleData", "TOCBookTableLabel", \
"Printout"],
Cell[94866, 3752, 90, 1, 40, 61, 0, "StyleData", "TOCBookTableLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[94993, 3758, 115, 3, 40, 36, 0, "StyleData", "TOCBookItemNumber", "All",
  StyleMenuListing->None],
Cell[95111, 3763, 53, 0, 40, 53, 0, "StyleData", "TOCBookItemNumber", \
"NumberedHeads"],
Cell[95167, 3765, 77, 1, 40, 48, 0, "StyleData", "TOCBookItemNumber", \
"Printout"],
Cell[95247, 3768, 90, 1, 40, 61, 0, "StyleData", "TOCBookItemNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[95374, 3774, 114, 3, 40, 35, 0, "StyleData", "TOCBookItemLabel", "All",
  StyleMenuListing->None],
Cell[95491, 3779, 52, 0, 40, 52, 0, "StyleData", "TOCBookItemLabel", \
"NumberedHeads"],
Cell[95546, 3781, 76, 1, 40, 47, 0, "StyleData", "TOCBookItemLabel", \
"Printout"],
Cell[95625, 3784, 89, 1, 40, 60, 0, "StyleData", "TOCBookItemLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[95751, 3790, 202, 7, 40, 32, 0, "StyleData", "TOCBookLeader", "All",
  StyleMenuListing->None],
Cell[95956, 3799, 49, 0, 40, 49, 0, "StyleData", "TOCBookLeader", \
"NumberedHeads"],
Cell[96008, 3801, 60, 1, 37, 44, 0, "StyleData", "TOCBookLeader", \
"Printout"],
Cell[96071, 3804, 73, 1, 37, 57, 0, "StyleData", "TOCBookLeader", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[96181, 3810, 222, 7, 40, 36, 0, "StyleData", "TOCBookPageNumber", "All",
  StyleMenuListing->None],
Cell[96406, 3819, 53, 0, 40, 53, 0, "StyleData", "TOCBookPageNumber", \
"NumberedHeads"],
Cell[96462, 3821, 77, 1, 40, 48, 0, "StyleData", "TOCBookPageNumber", \
"Printout"],
Cell[96542, 3824, 90, 1, 40, 61, 0, "StyleData", "TOCBookPageNumber", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[96705, 3833, 69, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[96799, 3838, 203, 6, 70, 29, 0, "StyleData", "LOASection", "All",
  StyleMenuListing->None],
Cell[97005, 3846, 46, 0, 70, 46, 0, "StyleData", "LOASection", \
"NumberedHeads"],
Cell[97054, 3848, 118, 3, 70, 41, 0, "StyleData", "LOASection", "Printout",
  StyleMenuListing->None],
Cell[97175, 3853, 131, 3, 70, 54, 0, "StyleData", "LOASection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[97343, 3861, 146, 4, 70, 26, 0, "StyleData", "LOAItem", "All",
  CounterIncrements->"LOAItem",
  StyleMenuListing->None],
Cell[97492, 3867, 43, 0, 70, 43, 0, "StyleData", "LOAItem", "NumberedHeads"],
Cell[97538, 3869, 113, 3, 70, 38, 0, "StyleData", "LOAItem", "Printout",
  StyleMenuListing->None],
Cell[97654, 3874, 126, 3, 70, 51, 0, "StyleData", "LOAItem", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[97817, 3882, 109, 3, 70, 34, 0, "StyleData", "LOAAbbreviation", "All",
  StyleMenuListing->None],
Cell[97929, 3887, 51, 0, 70, 51, 0, "StyleData", "LOAAbbreviation", \
"NumberedHeads"],
Cell[97983, 3889, 88, 2, 70, 46, 0, "StyleData", "LOAAbbreviation", \
"Printout",
  StyleMenuListing->None],
Cell[98074, 3893, 101, 2, 70, 59, 0, "StyleData", "LOAAbbreviation", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[98212, 3900, 85, 2, 70, 32, 0, "StyleData", "LOADefinition", "All",
  StyleMenuListing->None],
Cell[98300, 3904, 49, 0, 70, 49, 0, "StyleData", "LOADefinition", \
"NumberedHeads"],
Cell[98352, 3906, 86, 2, 70, 44, 0, "StyleData", "LOADefinition", "Printout",
  StyleMenuListing->None],
Cell[98441, 3910, 99, 2, 70, 57, 0, "StyleData", "LOADefinition", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[98577, 3917, 58, 1, 70, 32, 0, "StyleData", "LOAItemNumber", "All",
  StyleMenuListing->None],
Cell[98638, 3920, 49, 0, 70, 49, 0, "StyleData", "LOAItemNumber", \
"NumberedHeads"],
Cell[98690, 3922, 44, 0, 70, 44, 0, "StyleData", "LOAItemNumber", \
"Printout"],
Cell[98737, 3924, 57, 0, 70, 57, 0, "StyleData", "LOAItemNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[98831, 3929, 57, 1, 70, 31, 0, "StyleData", "LOAItemLabel", "All",
  StyleMenuListing->None],
Cell[98891, 3932, 48, 0, 70, 48, 0, "StyleData", "LOAItemLabel", \
"NumberedHeads"],
Cell[98942, 3934, 43, 0, 70, 43, 0, "StyleData", "LOAItemLabel", "Printout"],
Cell[98988, 3936, 56, 0, 70, 56, 0, "StyleData", "LOAItemLabel", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[99093, 3942, 65, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[99183, 3947, 308, 9, 70, 29, 0, "StyleData", "TitleGroup", "All",
  StyleMenuListing->None],
Cell[99494, 3958, 46, 0, 70, 46, 0, "StyleData", "TitleGroup", \
"NumberedHeads"],
Cell[99543, 3960, 116, 3, 70, 41, 0, "StyleData", "TitleGroup", "Printout"],
Cell[99662, 3965, 129, 3, 70, 54, 0, "StyleData", "TitleGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[99828, 3973, 312, 9, 70, 33, 0, "StyleData", "CopyrightGroup", "All",
  StyleMenuListing->None],
Cell[100143, 3984, 50, 0, 70, 50, 0, "StyleData", "CopyrightGroup", \
"NumberedHeads"],
Cell[100196, 3986, 120, 3, 70, 45, 0, "StyleData", "CopyrightGroup", \
"Printout"],
Cell[100319, 3991, 133, 3, 70, 58, 0, "StyleData", "CopyrightGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[100489, 3999, 59, 1, 70, 33, 0, "StyleData", "PhDThesisTitle", "All",
  StyleMenuListing->None],
Cell[100551, 4002, 50, 0, 70, 50, 0, "StyleData", "PhDThesisTitle", \
"NumberedHeads"],
Cell[100604, 4004, 45, 0, 70, 45, 0, "StyleData", "PhDThesisTitle", \
"Printout"],
Cell[100652, 4006, 58, 0, 70, 58, 0, "StyleData", "PhDThesisTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[100747, 4011, 58, 1, 70, 32, 0, "StyleData", "MSThesisTitle", "All",
  StyleMenuListing->None],
Cell[100808, 4014, 49, 0, 70, 49, 0, "StyleData", "MSThesisTitle", \
"NumberedHeads"],
Cell[100860, 4016, 44, 0, 70, 44, 0, "StyleData", "MSThesisTitle", \
"Printout"],
Cell[100907, 4018, 57, 0, 70, 57, 0, "StyleData", "MSThesisTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[101001, 4023, 58, 1, 70, 32, 0, "StyleData", "ThesisSchools", "All",
  StyleMenuListing->None],
Cell[101062, 4026, 49, 0, 70, 49, 0, "StyleData", "ThesisSchools", \
"NumberedHeads"],
Cell[101114, 4028, 44, 0, 70, 44, 0, "StyleData", "ThesisSchools", \
"Printout"],
Cell[101161, 4030, 57, 0, 70, 57, 0, "StyleData", "ThesisSchools", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[101255, 4035, 62, 1, 70, 36, 0, "StyleData", "ThesisAuthorField", "All",
  StyleMenuListing->None],
Cell[101320, 4038, 53, 0, 70, 53, 0, "StyleData", "ThesisAuthorField", \
"NumberedHeads"],
Cell[101376, 4040, 48, 0, 70, 48, 0, "StyleData", "ThesisAuthorField", \
"Printout"],
Cell[101427, 4042, 61, 0, 70, 61, 0, "StyleData", "ThesisAuthorField", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[101525, 4047, 66, 1, 70, 40, 0, "StyleData", "ThesisDepartmentField", \
"All",
  StyleMenuListing->None],
Cell[101594, 4050, 57, 0, 70, 57, 0, "StyleData", "ThesisDepartmentField", \
"NumberedHeads"],
Cell[101654, 4052, 52, 0, 70, 52, 0, "StyleData", "ThesisDepartmentField", \
"Printout"],
Cell[101709, 4054, 65, 0, 70, 65, 0, "StyleData", "ThesisDepartmentField", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[101811, 4059, 63, 1, 70, 37, 0, "StyleData", "ThesisCollegeField", "All",
  
  StyleMenuListing->None],
Cell[101877, 4062, 54, 0, 70, 54, 0, "StyleData", "ThesisCollegeField", \
"NumberedHeads"],
Cell[101934, 4064, 49, 0, 70, 49, 0, "StyleData", "ThesisCollegeField", \
"Printout"],
Cell[101986, 4066, 62, 0, 70, 62, 0, "StyleData", "ThesisCollegeField", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[102085, 4071, 74, 1, 70, 48, 0, "StyleData", \
"ThesisDegreeYearFieldNoExport", "All",
  StyleMenuListing->None],
Cell[102162, 4074, 65, 0, 70, 65, 0, "StyleData", \
"ThesisDegreeYearFieldNoExport", "NumberedHeads"],
Cell[102230, 4076, 60, 0, 70, 60, 0, "StyleData", \
"ThesisDegreeYearFieldNoExport", "Printout"],
Cell[102293, 4078, 73, 0, 70, 73, 0, "StyleData", \
"ThesisDegreeYearFieldNoExport", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[102403, 4083, 66, 1, 70, 40, 0, "StyleData", "ThesisDegreeYearField", \
"All",
  StyleMenuListing->None],
Cell[102472, 4086, 57, 0, 70, 57, 0, "StyleData", "ThesisDegreeYearField", \
"NumberedHeads"],
Cell[102532, 4088, 52, 0, 70, 52, 0, "StyleData", "ThesisDegreeYearField", \
"Printout"],
Cell[102587, 4090, 65, 0, 70, 65, 0, "StyleData", "ThesisDegreeYearField", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[102689, 4095, 63, 1, 70, 37, 0, "StyleData", "ThesisAbbreviation", "All",
  
  StyleMenuListing->None],
Cell[102755, 4098, 54, 0, 70, 54, 0, "StyleData", "ThesisAbbreviation", \
"NumberedHeads"],
Cell[102812, 4100, 49, 0, 70, 49, 0, "StyleData", "ThesisAbbreviation", \
"Printout"],
Cell[102864, 4102, 62, 0, 70, 62, 0, "StyleData", "ThesisAbbreviation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[102963, 4107, 74, 1, 70, 48, 0, "StyleData", \
"ThesisAbbreviationDescription", "All",
  StyleMenuListing->None],
Cell[103040, 4110, 65, 0, 70, 65, 0, "StyleData", \
"ThesisAbbreviationDescription", "NumberedHeads"],
Cell[103108, 4112, 60, 0, 70, 60, 0, "StyleData", \
"ThesisAbbreviationDescription", "Printout"],
Cell[103171, 4114, 73, 0, 70, 73, 0, "StyleData", \
"ThesisAbbreviationDescription", "NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[103305, 4121, 29, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[103359, 4125, 313, 9, 60, 34, 0, "StyleData", "MainmatterGroup", "All",
  StyleMenuListing->None],
Cell[103675, 4136, 51, 0, 70, 51, 0, "StyleData", "MainmatterGroup", \
"NumberedHeads"],
Cell[103729, 4138, 158, 4, 70, 50, 0, "StyleData", "MainmatterGroup", \
"Presentation"],
Cell[103890, 4144, 121, 3, 70, 46, 0, "StyleData", "MainmatterGroup", \
"Printout"],
Cell[104014, 4149, 134, 3, 70, 59, 0, "StyleData", "MainmatterGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[104185, 4157, 651, 17, 47, 26, 0, "StyleData", "Section", "All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Subsubsubsection", 0}},
  StyleMenuListing->None],
Cell[104839, 4176, 245, 5, 64, 43, 0, "StyleData", "Section", \
"NumberedHeads"],
Cell[105087, 4183, 163, 4, 95, 42, 0, "StyleData", "Section", \
"Presentation"],
Cell[105253, 4189, 115, 3, 57, 38, 0, "StyleData", "Section", "Printout"],
Cell[105371, 4194, 330, 8, 54, 51, 0, "StyleData", "Section", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[105738, 4207, 719, 17, 52, 29, 0, "StyleData", "Subsection", "All",
  CounterIncrements->"Subsection",
  CounterAssignments->{{"Subsubsection", 0}, {"Subsubsubsection", 0}},
  StyleMenuListing->None],
Cell[106460, 4226, 278, 5, 52, 46, 0, "StyleData", "Subsection", \
"NumberedHeads"],
Cell[106741, 4233, 97, 2, 70, 45, 0, "StyleData", "Subsection", \
"Presentation"],
Cell[106841, 4237, 118, 3, 48, 41, 0, "StyleData", "Subsection", "Printout"],
Cell[106962, 4242, 363, 8, 48, 54, 0, "StyleData", "Subsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[107362, 4255, 750, 17, 47, 32, 0, "StyleData", "Subsubsection", "All",
  CounterIncrements->"Subsubsection",
  CounterAssignments->{{"Subsubsubsection", 0}},
  StyleMenuListing->None],
Cell[108115, 4274, 332, 6, 44, 49, 0, "StyleData", "Subsubsection", \
"NumberedHeads"],
Cell[108450, 4282, 100, 2, 57, 48, 0, "StyleData", "Subsubsection", \
"Presentation"],
Cell[108553, 4286, 120, 3, 38, 44, 0, "StyleData", "Subsubsection", \
"Printout"],
Cell[108676, 4291, 416, 9, 38, 57, 0, "StyleData", "Subsubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[109129, 4305, 580, 12, 39, 35, 0, "StyleData", "Subsubsubsection", "All",
  
  CounterIncrements->"Subsubsubsection",
  StyleMenuListing->None],
Cell[109712, 4319, 52, 0, 41, 52, 0, "StyleData", "Subsubsubsection", \
"NumberedHeads"],
Cell[109767, 4321, 102, 2, 51, 51, 0, "StyleData", "Subsubsubsection", \
"Presentation"],
Cell[109872, 4325, 123, 3, 36, 47, 0, "StyleData", "Subsubsubsection", \
"Printout"],
Cell[109998, 4330, 136, 3, 36, 60, 0, "StyleData", "Subsubsubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[110171, 4338, 50, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[110246, 4342, 138, 4, 70, 31, 0, "StyleData", "SectionLabel", "All",
  StyleMenuListing->None],
Cell[110387, 4348, 48, 0, 70, 48, 0, "StyleData", "SectionLabel", \
"NumberedHeads"],
Cell[110438, 4350, 47, 0, 70, 47, 0, "StyleData", "SectionLabel", \
"Presentation"],
Cell[110488, 4352, 43, 0, 70, 43, 0, "StyleData", "SectionLabel", \
"Printout"],
Cell[110534, 4354, 56, 0, 70, 56, 0, "StyleData", "SectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[110627, 4359, 141, 4, 70, 34, 0, "StyleData", "SubsectionLabel", "All",
  StyleMenuListing->None],
Cell[110771, 4365, 51, 0, 70, 51, 0, "StyleData", "SubsectionLabel", \
"NumberedHeads"],
Cell[110825, 4367, 50, 0, 70, 50, 0, "StyleData", "SubsectionLabel", \
"Presentation"],
Cell[110878, 4369, 46, 0, 70, 46, 0, "StyleData", "SubsectionLabel", \
"Printout"],
Cell[110927, 4371, 59, 0, 70, 59, 0, "StyleData", "SubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[111023, 4376, 121, 3, 70, 37, 0, "StyleData", "SubsubsectionLabel", \
"All",
  StyleMenuListing->None],
Cell[111147, 4381, 54, 0, 70, 54, 0, "StyleData", "SubsubsectionLabel", \
"NumberedHeads"],
Cell[111204, 4383, 53, 0, 70, 53, 0, "StyleData", "SubsubsectionLabel", \
"Presentation"],
Cell[111260, 4385, 49, 0, 70, 49, 0, "StyleData", "SubsubsectionLabel", \
"Printout"],
Cell[111312, 4387, 62, 0, 70, 62, 0, "StyleData", "SubsubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[111411, 4392, 124, 3, 70, 40, 0, "StyleData", "SubsubsubsectionLabel", \
"All",
  StyleMenuListing->None],
Cell[111538, 4397, 57, 0, 70, 57, 0, "StyleData", "SubsubsubsectionLabel", \
"NumberedHeads"],
Cell[111598, 4399, 56, 0, 70, 56, 0, "StyleData", "SubsubsubsectionLabel", \
"Presentation"],
Cell[111657, 4401, 52, 0, 70, 52, 0, "StyleData", "SubsubsubsectionLabel", \
"Printout"],
Cell[111712, 4403, 65, 0, 70, 65, 0, "StyleData", "SubsubsubsectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[111814, 4408, 116, 3, 70, 32, 0, "StyleData", "SectionNumber", "All",
  StyleMenuListing->None],
Cell[111933, 4413, 49, 0, 70, 49, 0, "StyleData", "SectionNumber", \
"NumberedHeads"],
Cell[111985, 4415, 48, 0, 70, 48, 0, "StyleData", "SectionNumber", \
"Presentation"],
Cell[112036, 4417, 44, 0, 70, 44, 0, "StyleData", "SectionNumber", \
"Printout"],
Cell[112083, 4419, 57, 0, 70, 57, 0, "StyleData", "SectionNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[112177, 4424, 119, 3, 70, 35, 0, "StyleData", "SubsectionNumber", "All",
  StyleMenuListing->None],
Cell[112299, 4429, 52, 0, 70, 52, 0, "StyleData", "SubsectionNumber", \
"NumberedHeads"],
Cell[112354, 4431, 51, 0, 70, 51, 0, "StyleData", "SubsectionNumber", \
"Presentation"],
Cell[112408, 4433, 47, 0, 70, 47, 0, "StyleData", "SubsectionNumber", \
"Printout"],
Cell[112458, 4435, 60, 0, 70, 60, 0, "StyleData", "SubsectionNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[112555, 4440, 122, 3, 70, 38, 0, "StyleData", "SubsubsectionNumber", \
"All",
  StyleMenuListing->None],
Cell[112680, 4445, 55, 0, 70, 55, 0, "StyleData", "SubsubsectionNumber", \
"NumberedHeads"],
Cell[112738, 4447, 54, 0, 70, 54, 0, "StyleData", "SubsubsectionNumber", \
"Presentation"],
Cell[112795, 4449, 76, 1, 70, 50, 0, "StyleData", "SubsubsectionNumber", \
"Printout",
  StyleMenuListing->None],
Cell[112874, 4452, 89, 1, 70, 63, 0, "StyleData", "SubsubsectionNumber", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[113000, 4458, 125, 3, 70, 41, 0, "StyleData", "SubsubsubsectionNumber", \
"All",
  StyleMenuListing->None],
Cell[113128, 4463, 58, 0, 70, 58, 0, "StyleData", "SubsubsubsectionNumber", \
"NumberedHeads"],
Cell[113189, 4465, 57, 0, 70, 57, 0, "StyleData", "SubsubsubsectionNumber", \
"Presentation"],
Cell[113249, 4467, 79, 1, 70, 53, 0, "StyleData", "SubsubsubsectionNumber", \
"Printout",
  StyleMenuListing->None],
Cell[113331, 4470, 92, 1, 70, 66, 0, "StyleData", "SubsubsubsectionNumber", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[113460, 4476, 59, 1, 70, 33, 0, "StyleData", "SubsectionText", "All",
  StyleMenuListing->None],
Cell[113522, 4479, 50, 0, 70, 50, 0, "StyleData", "SubsectionText", \
"NumberedHeads"],
Cell[113575, 4481, 100, 2, 70, 49, 0, "StyleData", "SubsectionText", \
"Presentation"],
Cell[113678, 4485, 94, 2, 70, 45, 0, "StyleData", "SubsectionText", \
"Printout"],
Cell[113775, 4489, 107, 2, 70, 58, 0, "StyleData", "SubsectionText", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[113919, 4496, 62, 1, 70, 36, 0, "StyleData", "SubsubsectionText", "All",
  StyleMenuListing->None],
Cell[113984, 4499, 53, 0, 70, 53, 0, "StyleData", "SubsubsectionText", \
"NumberedHeads"],
Cell[114040, 4501, 103, 2, 70, 52, 0, "StyleData", "SubsubsectionText", \
"Presentation"],
Cell[114146, 4505, 97, 2, 70, 48, 0, "StyleData", "SubsubsectionText", \
"Printout"],
Cell[114246, 4509, 110, 2, 70, 61, 0, "StyleData", "SubsubsectionText", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[114393, 4516, 65, 1, 70, 39, 0, "StyleData", "SubsubsubsectionText", \
"All",
  StyleMenuListing->None],
Cell[114461, 4519, 56, 0, 70, 56, 0, "StyleData", "SubsubsubsectionText", \
"NumberedHeads"],
Cell[114520, 4521, 106, 2, 70, 55, 0, "StyleData", "SubsubsubsectionText", \
"Presentation"],
Cell[114629, 4525, 100, 2, 70, 51, 0, "StyleData", "SubsubsubsectionText", \
"Printout"],
Cell[114732, 4529, 113, 2, 70, 64, 0, "StyleData", "SubsubsubsectionText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[114894, 4537, 40, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[114959, 4541, 594, 16, 67, 29, 0, "StyleData", "SectionAlt", "All",
  CounterIncrements->"SectionAlt",
  CounterAssignments->{{"SubsectionAlt", 0}, {"SubsubsectionAlt", 0}, {
      "SubsubsubsectionAlt", 0}},
  StyleMenuListing->None],
Cell[115556, 4559, 46, 0, 67, 46, 0, "StyleData", "SectionAlt", \
"NumberedHeads"],
Cell[115605, 4561, 166, 4, 95, 45, 0, "StyleData", "SectionAlt", \
"Presentation"],
Cell[115774, 4567, 118, 3, 57, 41, 0, "StyleData", "SectionAlt", "Printout"],
Cell[115895, 4572, 131, 3, 57, 54, 0, "StyleData", "SectionAlt", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[116063, 4580, 605, 16, 52, 32, 0, "StyleData", "SubsectionAlt", "All",
  CounterIncrements->"Subsection",
  CounterAssignments->{{"SubsubsectionAlt", 0}, {"SubsubsubsectionAlt", 0}},
  StyleMenuListing->None],
Cell[116671, 4598, 49, 0, 52, 49, 0, "StyleData", "SubsectionAlt", \
"NumberedHeads"],
Cell[116723, 4600, 100, 2, 70, 48, 0, "StyleData", "SubsectionAlt", \
"Presentation"],
Cell[116826, 4604, 121, 3, 48, 44, 0, "StyleData", "SubsectionAlt", \
"Printout"],
Cell[116950, 4609, 134, 3, 48, 57, 0, "StyleData", "SubsectionAlt", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[117121, 4617, 585, 14, 47, 35, 0, "StyleData", "SubsubsectionAlt", "All",
  
  CounterIncrements->"SubsubsectionAlt",
  CounterAssignments->{{"SubsubsubsectionAlt", 0}},
  StyleMenuListing->None],
Cell[117709, 4633, 52, 0, 44, 52, 0, "StyleData", "SubsubsectionAlt", \
"NumberedHeads"],
Cell[117764, 4635, 103, 2, 57, 51, 0, "StyleData", "SubsubsectionAlt", \
"Presentation"],
Cell[117870, 4639, 123, 3, 38, 47, 0, "StyleData", "SubsubsectionAlt", \
"Printout"],
Cell[117996, 4644, 136, 3, 38, 60, 0, "StyleData", "SubsubsectionAlt", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[118169, 4652, 261, 7, 39, 38, 0, "StyleData", "SubsubsubsectionAlt", \
"All",
  CounterIncrements->"SubsubsubsectionAlt",
  StyleMenuListing->None],
Cell[118433, 4661, 55, 0, 41, 55, 0, "StyleData", "SubsubsubsectionAlt", \
"NumberedHeads"],
Cell[118491, 4663, 105, 2, 51, 54, 0, "StyleData", "SubsubsubsectionAlt", \
"Presentation"],
Cell[118599, 4667, 126, 3, 36, 50, 0, "StyleData", "SubsubsubsectionAlt", \
"Printout"],
Cell[118728, 4672, 139, 3, 36, 63, 0, "StyleData", "SubsubsubsectionAlt", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[118916, 4681, 31, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[118972, 4685, 322, 9, 38, 23, 0, "StyleData", "Text", "All",
  CounterIncrements->"Text",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[119297, 4696, 40, 0, 70, 40, 0, "StyleData", "Text", "NumberedHeads"],
Cell[119340, 4698, 90, 2, 70, 39, 0, "StyleData", "Text", "Presentation"],
Cell[119433, 4702, 131, 4, 70, 35, 0, "StyleData", "Text", "Printout"],
Cell[119567, 4708, 144, 4, 70, 48, 0, "StyleData", "Text", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[119748, 4717, 438, 11, 37, 31, 0, "StyleData", "TextNoIndent", "All",
  CounterIncrements->"TextNoIndent",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[120189, 4730, 48, 0, 70, 48, 0, "StyleData", "TextNoIndent", \
"NumberedHeads"],
Cell[120240, 4732, 98, 2, 70, 47, 0, "StyleData", "TextNoIndent", \
"Presentation"],
Cell[120341, 4736, 139, 4, 70, 43, 0, "StyleData", "TextNoIndent", \
"Printout"],
Cell[120483, 4742, 152, 4, 70, 56, 0, "StyleData", "TextNoIndent", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[120672, 4751, 413, 10, 37, 35, 0, "StyleData", "TextContinuation", "All",
  
  CounterIncrements->"TextNoIndent",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[121088, 4763, 52, 0, 70, 52, 0, "StyleData", "TextContinuation", \
"NumberedHeads"],
Cell[121143, 4765, 102, 2, 70, 51, 0, "StyleData", "TextContinuation", \
"Presentation"],
Cell[121248, 4769, 143, 4, 70, 47, 0, "StyleData", "TextContinuation", \
"Printout"],
Cell[121394, 4775, 156, 4, 70, 60, 0, "StyleData", "TextContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[121611, 4786, 33, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[121669, 4790, 62, 1, 70, "Subsection"],

Cell[CellGroupData[{
Cell[121756, 4795, 658, 13, 70, 24, 0, "StyleData", "Item1", "All",
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[122417, 4810, 41, 0, 70, 41, 0, "StyleData", "Item1", "NumberedHeads"],
Cell[122461, 4812, 117, 3, 70, 40, 0, "StyleData", "Item1", "Presentation",
  StyleMenuListing->None],
Cell[122581, 4817, 111, 3, 70, 36, 0, "StyleData", "Item1", "Printout",
  StyleMenuListing->None],
Cell[122695, 4822, 124, 3, 70, 49, 0, "StyleData", "Item1", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[122856, 4830, 636, 13, 70, 24, 0, "StyleData", "Item2", "All",
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[123495, 4845, 41, 0, 70, 41, 0, "StyleData", "Item2", "NumberedHeads"],
Cell[123539, 4847, 117, 3, 70, 40, 0, "StyleData", "Item2", "Presentation",
  StyleMenuListing->None],
Cell[123659, 4852, 112, 3, 70, 36, 0, "StyleData", "Item2", "Printout",
  StyleMenuListing->None],
Cell[123774, 4857, 125, 3, 70, 49, 0, "StyleData", "Item2", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[123936, 4865, 590, 12, 70, 24, 0, "StyleData", "Item3", "All",
  CounterIncrements->"Item3",
  StyleMenuListing->None],
Cell[124529, 4879, 41, 0, 70, 41, 0, "StyleData", "Item3", "NumberedHeads"],
Cell[124573, 4881, 117, 3, 70, 40, 0, "StyleData", "Item3", "Presentation",
  StyleMenuListing->None],
Cell[124693, 4886, 112, 3, 70, 36, 0, "StyleData", "Item3", "Printout",
  StyleMenuListing->None],
Cell[124808, 4891, 125, 3, 70, 49, 0, "StyleData", "Item3", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[124970, 4899, 230, 7, 70, 29, 0, "StyleData", "Item1Label", "All",
  StyleMenuListing->None],
Cell[125203, 4908, 46, 0, 70, 46, 0, "StyleData", "Item1Label", \
"NumberedHeads"],
Cell[125252, 4910, 116, 3, 70, 45, 0, "StyleData", "Item1Label", \
"Presentation",
  StyleMenuListing->None],
Cell[125371, 4915, 112, 3, 70, 41, 0, "StyleData", "Item1Label", "Printout",
  StyleMenuListing->None],
Cell[125486, 4920, 125, 3, 70, 54, 0, "StyleData", "Item1Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[125648, 4928, 230, 7, 70, 29, 0, "StyleData", "Item2Label", "All",
  StyleMenuListing->None],
Cell[125881, 4937, 46, 0, 70, 46, 0, "StyleData", "Item2Label", \
"NumberedHeads"],
Cell[125930, 4939, 116, 3, 70, 45, 0, "StyleData", "Item2Label", \
"Presentation",
  StyleMenuListing->None],
Cell[126049, 4944, 96, 2, 70, 41, 0, "StyleData", "Item2Label", "Printout",
  StyleMenuListing->None],
Cell[126148, 4948, 109, 2, 70, 54, 0, "StyleData", "Item2Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[126294, 4955, 230, 7, 70, 29, 0, "StyleData", "Item3Label", "All",
  StyleMenuListing->None],
Cell[126527, 4964, 46, 0, 70, 46, 0, "StyleData", "Item3Label", \
"NumberedHeads"],
Cell[126576, 4966, 116, 3, 70, 45, 0, "StyleData", "Item3Label", \
"Presentation",
  StyleMenuListing->None],
Cell[126695, 4971, 96, 2, 70, 41, 0, "StyleData", "Item3Label", "Printout",
  StyleMenuListing->None],
Cell[126794, 4975, 109, 2, 70, 54, 0, "StyleData", "Item3Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[126952, 4983, 62, 1, 70, "Subsection"],

Cell[CellGroupData[{
Cell[127039, 4988, 729, 14, 70, 32, 0, "StyleData", "Item1Numbered", "All",
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[127771, 5004, 49, 0, 70, 49, 0, "StyleData", "Item1Numbered", \
"NumberedHeads"],
Cell[127823, 5006, 125, 3, 70, 48, 0, "StyleData", "Item1Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[127951, 5011, 119, 3, 70, 44, 0, "StyleData", "Item1Numbered", \
"Printout",
  StyleMenuListing->None],
Cell[128073, 5016, 132, 3, 70, 57, 0, "StyleData", "Item1Numbered", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[128242, 5024, 799, 16, 70, 32, 0, "StyleData", "Item2Numbered", "All",
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[129044, 5042, 49, 0, 70, 49, 0, "StyleData", "Item2Numbered", \
"NumberedHeads"],
Cell[129096, 5044, 125, 3, 70, 48, 0, "StyleData", "Item2Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[129224, 5049, 120, 3, 70, 44, 0, "StyleData", "Item2Numbered", \
"Printout",
  StyleMenuListing->None],
Cell[129347, 5054, 133, 3, 70, 57, 0, "StyleData", "Item2Numbered", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[129517, 5062, 715, 14, 70, 32, 0, "StyleData", "Item3Numbered", "All",
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None],
Cell[130235, 5078, 49, 0, 70, 49, 0, "StyleData", "Item3Numbered", \
"NumberedHeads"],
Cell[130287, 5080, 125, 3, 70, 48, 0, "StyleData", "Item3Numbered", \
"Presentation",
  StyleMenuListing->None],
Cell[130415, 5085, 120, 3, 70, 44, 0, "StyleData", "Item3Numbered", \
"Printout",
  StyleMenuListing->None],
Cell[130538, 5090, 133, 3, 70, 57, 0, "StyleData", "Item3Numbered", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[130708, 5098, 227, 6, 70, 37, 0, "StyleData", "Item1NumberedLabel", \
"All",
  StyleMenuListing->None],
Cell[130938, 5106, 54, 0, 70, 54, 0, "StyleData", "Item1NumberedLabel", \
"NumberedHeads"],
Cell[130995, 5108, 124, 3, 70, 53, 0, "StyleData", "Item1NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[131122, 5113, 120, 3, 70, 49, 0, "StyleData", "Item1NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[131245, 5118, 133, 3, 70, 62, 0, "StyleData", "Item1NumberedLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[131415, 5126, 227, 6, 70, 37, 0, "StyleData", "Item2NumberedLabel", \
"All",
  StyleMenuListing->None],
Cell[131645, 5134, 54, 0, 70, 54, 0, "StyleData", "Item2NumberedLabel", \
"NumberedHeads"],
Cell[131702, 5136, 124, 3, 70, 53, 0, "StyleData", "Item2NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[131829, 5141, 104, 2, 70, 49, 0, "StyleData", "Item2NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[131936, 5145, 117, 2, 70, 62, 0, "StyleData", "Item2NumberedLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[132090, 5152, 227, 6, 70, 37, 0, "StyleData", "Item3NumberedLabel", \
"All",
  StyleMenuListing->None],
Cell[132320, 5160, 54, 0, 70, 54, 0, "StyleData", "Item3NumberedLabel", \
"NumberedHeads"],
Cell[132377, 5162, 124, 3, 70, 53, 0, "StyleData", "Item3NumberedLabel", \
"Presentation",
  StyleMenuListing->None],
Cell[132504, 5167, 104, 2, 70, 49, 0, "StyleData", "Item3NumberedLabel", \
"Printout",
  StyleMenuListing->None],
Cell[132611, 5171, 117, 2, 70, 62, 0, "StyleData", "Item3NumberedLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[132777, 5179, 63, 1, 70, "Subsection"],

Cell[CellGroupData[{
Cell[132865, 5184, 403, 7, 70, 33, 0, "StyleData", "Item1Paragraph", "All",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[133271, 5193, 50, 0, 70, 50, 0, "StyleData", "Item1Paragraph", \
"NumberedHeads"],
Cell[133324, 5195, 126, 3, 70, 49, 0, "StyleData", "Item1Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[133453, 5200, 121, 3, 70, 45, 0, "StyleData", "Item1Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[133577, 5205, 134, 3, 70, 58, 0, "StyleData", "Item1Paragraph", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[133748, 5213, 381, 7, 70, 33, 0, "StyleData", "Item2Paragraph", "All",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[134132, 5222, 50, 0, 70, 50, 0, "StyleData", "Item2Paragraph", \
"NumberedHeads"],
Cell[134185, 5224, 126, 3, 70, 49, 0, "StyleData", "Item2Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[134314, 5229, 121, 3, 70, 45, 0, "StyleData", "Item2Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[134438, 5234, 134, 3, 70, 58, 0, "StyleData", "Item2Paragraph", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[134609, 5242, 335, 6, 70, 33, 0, "StyleData", "Item3Paragraph", "All",
  StyleMenuListing->None],
Cell[134947, 5250, 50, 0, 70, 50, 0, "StyleData", "Item3Paragraph", \
"NumberedHeads"],
Cell[135000, 5252, 127, 3, 70, 49, 0, "StyleData", "Item3Paragraph", \
"Presentation",
  StyleMenuListing->None],
Cell[135130, 5257, 121, 3, 70, 45, 0, "StyleData", "Item3Paragraph", \
"Printout",
  StyleMenuListing->None],
Cell[135254, 5262, 134, 3, 70, 58, 0, "StyleData", "Item3Paragraph", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[135449, 5272, 45, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[135519, 5276, 28, 0, 70, "Subsection"],
Cell[135550, 5278, 258, 7, 70, "Text"],

Cell[CellGroupData[{
Cell[135833, 5289, 529, 11, 70, 25, 0, "StyleData", "Figure", "All",
  CounterIncrements->"Figure",
  StyleMenuListing->None],
Cell[136365, 5302, 42, 0, 70, 42, 0, "StyleData", "Figure", "NumberedHeads"],
Cell[136410, 5304, 122, 3, 70, 41, 0, "StyleData", "Figure", "Presentation"],
Cell[136535, 5309, 100, 2, 70, 37, 0, "StyleData", "Figure", "Printout"],
Cell[136638, 5313, 113, 2, 70, 50, 0, "StyleData", "Figure", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[136788, 5320, 633, 14, 70, 32, 0, "StyleData", "FigureCaption", "All",
  CounterIncrements->"FigureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[137424, 5336, 49, 0, 70, 49, 0, "StyleData", "FigureCaption", \
"NumberedHeads"],
Cell[137476, 5338, 99, 2, 70, 48, 0, "StyleData", "FigureCaption", \
"Presentation"],
Cell[137578, 5342, 93, 2, 70, 44, 0, "StyleData", "FigureCaption", \
"Printout"],
Cell[137674, 5346, 106, 2, 70, 57, 0, "StyleData", "FigureCaption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[137817, 5353, 143, 4, 70, 37, 0, "StyleData", "FigureCaptionLabel", \
"All",
  StyleMenuListing->None],
Cell[137963, 5359, 54, 0, 70, 54, 0, "StyleData", "FigureCaptionLabel", \
"NumberedHeads"],
Cell[138020, 5361, 53, 0, 70, 53, 0, "StyleData", "FigureCaptionLabel", \
"Presentation"],
Cell[138076, 5363, 49, 0, 70, 49, 0, "StyleData", "FigureCaptionLabel", \
"Printout"],
Cell[138128, 5365, 62, 0, 70, 62, 0, "StyleData", "FigureCaptionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[138227, 5370, 79, 2, 70, 31, 0, "StyleData", "FigureNumber", "All",
  StyleMenuListing->None],
Cell[138309, 5374, 48, 0, 70, 48, 0, "StyleData", "FigureNumber", \
"NumberedHeads"],
Cell[138360, 5376, 47, 0, 70, 47, 0, "StyleData", "FigureNumber", \
"Presentation"],
Cell[138410, 5378, 43, 0, 70, 43, 0, "StyleData", "FigureNumber", \
"Printout"],
Cell[138456, 5380, 56, 0, 70, 56, 0, "StyleData", "FigureNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[138549, 5385, 358, 10, 70, 29, 0, "StyleData", "FigureText", "All",
  CounterIncrements->"FigureText",
  StyleMenuListing->None],
Cell[138910, 5397, 46, 0, 70, 46, 0, "StyleData", "FigureText", \
"NumberedHeads"],
Cell[138959, 5399, 97, 2, 70, 45, 0, "StyleData", "FigureText", \
"Presentation"],
Cell[139059, 5403, 115, 3, 70, 41, 0, "StyleData", "FigureText", "Printout"],
Cell[139177, 5408, 128, 3, 70, 54, 0, "StyleData", "FigureText", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[139342, 5416, 202, 5, 70, 29, 0, "StyleData", "FigureFile", "All",
  StyleMenuListing->None],
Cell[139547, 5423, 46, 0, 70, 46, 0, "StyleData", "FigureFile", \
"NumberedHeads"],
Cell[139596, 5425, 97, 2, 70, 45, 0, "StyleData", "FigureFile", \
"Presentation"],
Cell[139696, 5429, 120, 3, 70, 41, 0, "StyleData", "FigureFile", "Printout"],
Cell[139819, 5434, 133, 3, 70, 54, 0, "StyleData", "FigureFile", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[140001, 5443, 43, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[140069, 5447, 544, 14, 70, 43, 0, "StyleData", \
"SupplementalCaptionLabel", "All",
  CounterIncrements->"SupplementalCaptionLabel",
  StyleMenuListing->None],
Cell[140616, 5463, 60, 0, 70, 60, 0, "StyleData", "SupplementalCaptionLabel", \
"NumberedHeads"],
Cell[140679, 5465, 111, 2, 70, 59, 0, "StyleData", \
"SupplementalCaptionLabel", "Presentation"],
Cell[140793, 5469, 103, 2, 70, 55, 0, "StyleData", \
"SupplementalCaptionLabel", "Printout"],
Cell[140899, 5473, 116, 2, 70, 68, 0, "StyleData", \
"SupplementalCaptionLabel", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[141052, 5480, 419, 12, 70, 38, 0, "StyleData", "SupplementalCaption", \
"All",
  StyleMenuListing->None],
Cell[141474, 5494, 55, 0, 70, 55, 0, "StyleData", "SupplementalCaption", \
"NumberedHeads"],
Cell[141532, 5496, 106, 2, 70, 54, 0, "StyleData", "SupplementalCaption", \
"Presentation"],
Cell[141641, 5500, 98, 2, 70, 50, 0, "StyleData", "SupplementalCaption", \
"Printout"],
Cell[141742, 5504, 111, 2, 70, 63, 0, "StyleData", "SupplementalCaption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[141890, 5511, 338, 9, 70, 35, 0, "StyleData", "SupplementalText", "All",
  StyleMenuListing->None],
Cell[142231, 5522, 52, 0, 70, 52, 0, "StyleData", "SupplementalText", \
"NumberedHeads"],
Cell[142286, 5524, 103, 2, 70, 51, 0, "StyleData", "SupplementalText", \
"Presentation"],
Cell[142392, 5528, 95, 2, 70, 47, 0, "StyleData", "SupplementalText", \
"Printout"],
Cell[142490, 5532, 108, 2, 70, 60, 0, "StyleData", "SupplementalText", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[142635, 5539, 455, 11, 70, 31, 0, "StyleData", "Supplemental", "All",
  CounterIncrements->"Supplemental",
  StyleMenuListing->None],
Cell[143093, 5552, 48, 0, 70, 48, 0, "StyleData", "Supplemental", \
"NumberedHeads"],
Cell[143144, 5554, 99, 2, 70, 47, 0, "StyleData", "Supplemental", \
"Presentation"],
Cell[143246, 5558, 121, 3, 70, 43, 0, "StyleData", "Supplemental", \
"Printout"],
Cell[143370, 5563, 134, 3, 70, 56, 0, "StyleData", "Supplemental", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[143553, 5572, 29, 0, 70, "Subsection"],
Cell[143585, 5574, 259, 7, 70, "Text"],

Cell[CellGroupData[{
Cell[143869, 5585, 532, 11, 70, 26, 0, "StyleData", "Picture", "All",
  CounterIncrements->"Picture",
  StyleMenuListing->None],
Cell[144404, 5598, 43, 0, 70, 43, 0, "StyleData", "Picture", \
"NumberedHeads"],
Cell[144450, 5600, 107, 2, 70, 42, 0, "StyleData", "Picture", \
"Presentation"],
Cell[144560, 5604, 101, 2, 70, 38, 0, "StyleData", "Picture", "Printout"],
Cell[144664, 5608, 114, 2, 70, 51, 0, "StyleData", "Picture", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[144815, 5615, 637, 14, 70, 33, 0, "StyleData", "PictureCaption", "All",
  CounterIncrements->"PictureCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[145455, 5631, 50, 0, 70, 50, 0, "StyleData", "PictureCaption", \
"NumberedHeads"],
Cell[145508, 5633, 100, 2, 70, 49, 0, "StyleData", "PictureCaption", \
"Presentation"],
Cell[145611, 5637, 94, 2, 70, 45, 0, "StyleData", "PictureCaption", \
"Printout"],
Cell[145708, 5641, 107, 2, 70, 58, 0, "StyleData", "PictureCaption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[145852, 5648, 86, 2, 70, 38, 0, "StyleData", "PictureCaptionLabel", \
"All",
  StyleMenuListing->None],
Cell[145941, 5652, 55, 0, 70, 55, 0, "StyleData", "PictureCaptionLabel", \
"NumberedHeads"],
Cell[145999, 5654, 54, 0, 70, 54, 0, "StyleData", "PictureCaptionLabel", \
"Presentation"],
Cell[146056, 5656, 50, 0, 70, 50, 0, "StyleData", "PictureCaptionLabel", \
"Printout"],
Cell[146109, 5658, 63, 0, 70, 63, 0, "StyleData", "PictureCaptionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[146209, 5663, 80, 2, 70, 32, 0, "StyleData", "PictureNumber", "All",
  StyleMenuListing->None],
Cell[146292, 5667, 49, 0, 70, 49, 0, "StyleData", "PictureNumber", \
"NumberedHeads"],
Cell[146344, 5669, 48, 0, 70, 48, 0, "StyleData", "PictureNumber", \
"Presentation"],
Cell[146395, 5671, 44, 0, 70, 44, 0, "StyleData", "PictureNumber", \
"Printout"],
Cell[146442, 5673, 57, 0, 70, 57, 0, "StyleData", "PictureNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[146536, 5678, 361, 10, 70, 30, 0, "StyleData", "PictureText", "All",
  CounterIncrements->"PictureText",
  StyleMenuListing->None],
Cell[146900, 5690, 47, 0, 70, 47, 0, "StyleData", "PictureText", \
"NumberedHeads"],
Cell[146950, 5692, 98, 2, 70, 46, 0, "StyleData", "PictureText", \
"Presentation"],
Cell[147051, 5696, 116, 3, 70, 42, 0, "StyleData", "PictureText", \
"Printout"],
Cell[147170, 5701, 129, 3, 70, 55, 0, "StyleData", "PictureText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[147348, 5710, 34, 0, 70, "Subsection"],
Cell[147385, 5712, 264, 7, 70, "Text"],

Cell[CellGroupData[{
Cell[147674, 5723, 547, 11, 70, 31, 0, "StyleData", "Illustration", "All",
  CounterIncrements->"Illustration",
  StyleMenuListing->None],
Cell[148224, 5736, 48, 0, 70, 48, 0, "StyleData", "Illustration", \
"NumberedHeads"],
Cell[148275, 5738, 112, 2, 70, 47, 0, "StyleData", "Illustration", \
"Presentation"],
Cell[148390, 5742, 106, 2, 70, 43, 0, "StyleData", "Illustration", \
"Printout"],
Cell[148499, 5746, 119, 2, 70, 56, 0, "StyleData", "Illustration", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[148655, 5753, 657, 14, 70, 38, 0, "StyleData", "IllustrationCaption", \
"All",
  CounterIncrements->"IllustrationCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[149315, 5769, 55, 0, 70, 55, 0, "StyleData", "IllustrationCaption", \
"NumberedHeads"],
Cell[149373, 5771, 105, 2, 70, 54, 0, "StyleData", "IllustrationCaption", \
"Presentation"],
Cell[149481, 5775, 99, 2, 70, 50, 0, "StyleData", "IllustrationCaption", \
"Printout"],
Cell[149583, 5779, 112, 2, 70, 63, 0, "StyleData", "IllustrationCaption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[149732, 5786, 91, 2, 70, 43, 0, "StyleData", "IllustrationCaptionLabel", \
"All",
  StyleMenuListing->None],
Cell[149826, 5790, 60, 0, 70, 60, 0, "StyleData", "IllustrationCaptionLabel", \
"NumberedHeads"],
Cell[149889, 5792, 59, 0, 70, 59, 0, "StyleData", "IllustrationCaptionLabel", \
"Presentation"],
Cell[149951, 5794, 55, 0, 70, 55, 0, "StyleData", "IllustrationCaptionLabel", \
"Printout"],
Cell[150009, 5796, 68, 0, 70, 68, 0, "StyleData", "IllustrationCaptionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[150114, 5801, 85, 2, 70, 37, 0, "StyleData", "IllustrationNumber", "All",
  
  StyleMenuListing->None],
Cell[150202, 5805, 54, 0, 70, 54, 0, "StyleData", "IllustrationNumber", \
"NumberedHeads"],
Cell[150259, 5807, 53, 0, 70, 53, 0, "StyleData", "IllustrationNumber", \
"Presentation"],
Cell[150315, 5809, 49, 0, 70, 49, 0, "StyleData", "IllustrationNumber", \
"Printout"],
Cell[150367, 5811, 62, 0, 70, 62, 0, "StyleData", "IllustrationNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[150466, 5816, 376, 10, 70, 35, 0, "StyleData", "IllustrationText", "All",
  
  CounterIncrements->"IllustrationText",
  StyleMenuListing->None],
Cell[150845, 5828, 52, 0, 70, 52, 0, "StyleData", "IllustrationText", \
"NumberedHeads"],
Cell[150900, 5830, 103, 2, 70, 51, 0, "StyleData", "IllustrationText", \
"Presentation"],
Cell[151006, 5834, 121, 3, 70, 47, 0, "StyleData", "IllustrationText", \
"Printout"],
Cell[151130, 5839, 134, 3, 70, 60, 0, "StyleData", "IllustrationText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[151313, 5848, 36, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[151374, 5852, 384, 9, 70, 26, 0, "StyleData", "Program", "All",
  CounterIncrements->"Program",
  StyleMenuListing->None],
Cell[151761, 5863, 43, 0, 70, 43, 0, "StyleData", "Program", \
"NumberedHeads"],
Cell[151807, 5865, 93, 2, 70, 42, 0, "StyleData", "Program", "Presentation"],
Cell[151903, 5869, 114, 3, 70, 38, 0, "StyleData", "Program", "Printout",
  StyleMenuListing->None],
Cell[152020, 5874, 127, 3, 70, 51, 0, "StyleData", "Program", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[152184, 5882, 406, 11, 70, 33, 0, "StyleData", "ProgramCaption", "All",
  CounterIncrements->"ProgramCaption",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[152593, 5895, 50, 0, 70, 50, 0, "StyleData", "ProgramCaption", \
"NumberedHeads"],
Cell[152646, 5897, 100, 2, 70, 49, 0, "StyleData", "ProgramCaption", \
"Presentation"],
Cell[152749, 5901, 94, 2, 70, 45, 0, "StyleData", "ProgramCaption", \
"Printout"],
Cell[152846, 5905, 107, 2, 70, 58, 0, "StyleData", "ProgramCaption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[152990, 5912, 86, 2, 70, 38, 0, "StyleData", "ProgramCaptionLabel", \
"All",
  StyleMenuListing->None],
Cell[153079, 5916, 55, 0, 70, 55, 0, "StyleData", "ProgramCaptionLabel", \
"NumberedHeads"],
Cell[153137, 5918, 54, 0, 70, 54, 0, "StyleData", "ProgramCaptionLabel", \
"Presentation"],
Cell[153194, 5920, 76, 1, 70, 50, 0, "StyleData", "ProgramCaptionLabel", \
"Printout",
  StyleMenuListing->None],
Cell[153273, 5923, 89, 1, 70, 63, 0, "StyleData", "ProgramCaptionLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[153399, 5929, 80, 2, 70, 32, 0, "StyleData", "ProgramNumber", "All",
  StyleMenuListing->None],
Cell[153482, 5933, 49, 0, 70, 49, 0, "StyleData", "ProgramNumber", \
"NumberedHeads"],
Cell[153534, 5935, 48, 0, 70, 48, 0, "StyleData", "ProgramNumber", \
"Presentation"],
Cell[153585, 5937, 44, 0, 70, 44, 0, "StyleData", "ProgramNumber", \
"Printout"],
Cell[153632, 5939, 57, 0, 70, 57, 0, "StyleData", "ProgramNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[153726, 5944, 361, 10, 70, 30, 0, "StyleData", "ProgramText", "All",
  CounterIncrements->"ProgramText",
  StyleMenuListing->None],
Cell[154090, 5956, 47, 0, 70, 47, 0, "StyleData", "ProgramText", \
"NumberedHeads"],
Cell[154140, 5958, 98, 2, 70, 46, 0, "StyleData", "ProgramText", \
"Presentation"],
Cell[154241, 5962, 116, 3, 70, 42, 0, "StyleData", "ProgramText", \
"Printout"],
Cell[154360, 5967, 129, 3, 70, 55, 0, "StyleData", "ProgramText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[154538, 5976, 28, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[154591, 5980, 717, 17, 70, 29, 0, "StyleData", "TableTitle", "All",
  CounterIncrements->"TableTitle",
  CounterAssignments->{{"Nil", 0}},
  StyleMenuListing->None],
Cell[155311, 5999, 46, 0, 70, 46, 0, "StyleData", "TableTitle", \
"NumberedHeads"],
Cell[155360, 6001, 97, 2, 70, 45, 0, "StyleData", "TableTitle", \
"Presentation"],
Cell[155460, 6005, 91, 2, 70, 41, 0, "StyleData", "TableTitle", "Printout"],
Cell[155554, 6009, 104, 2, 70, 54, 0, "StyleData", "TableTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[155695, 6016, 292, 9, 70, 34, 0, "StyleData", "TableTitleLabel", "All",
  CounterIncrements->"TableTitleLabel",
  StyleMenuListing->None],
Cell[155990, 6027, 51, 0, 70, 51, 0, "StyleData", "TableTitleLabel", \
"NumberedHeads"],
Cell[156044, 6029, 50, 0, 70, 50, 0, "StyleData", "TableTitleLabel", \
"Presentation"],
Cell[156097, 6031, 62, 1, 70, 46, 0, "StyleData", "TableTitleLabel", \
"Printout"],
Cell[156162, 6034, 75, 1, 70, 59, 0, "StyleData", "TableTitleLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[156274, 6040, 825, 19, 70, 24, 0, "StyleData", "Table", "All",
  CounterIncrements->"Table",
  CounterAssignments->{{"TableNote", 0}},
  StyleMenuListing->None],
Cell[157102, 6061, 41, 0, 70, 41, 0, "StyleData", "Table", "NumberedHeads"],
Cell[157146, 6063, 91, 2, 70, 40, 0, "StyleData", "Table", "Presentation"],
Cell[157240, 6067, 111, 3, 70, 36, 0, "StyleData", "Table", "Printout"],
Cell[157354, 6072, 90, 2, 70, 49, 0, "StyleData", "Table", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[157481, 6079, 56, 1, 70, 30, 0, "StyleData", "TableNumber", "All",
  StyleMenuListing->None],
Cell[157540, 6082, 47, 0, 70, 47, 0, "StyleData", "TableNumber", \
"NumberedHeads"],
Cell[157590, 6084, 46, 0, 70, 46, 0, "StyleData", "TableNumber", \
"Presentation"],
Cell[157639, 6086, 42, 0, 70, 42, 0, "StyleData", "TableNumber", "Printout"],
Cell[157684, 6088, 55, 0, 70, 55, 0, "StyleData", "TableNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[157776, 6093, 500, 15, 70, 28, 0, "StyleData", "TableNote", "All",
  CounterIncrements->"TableNote",
  StyleMenuListing->None],
Cell[158279, 6110, 45, 0, 70, 45, 0, "StyleData", "TableNote", \
"NumberedHeads"],
Cell[158327, 6112, 97, 2, 70, 44, 0, "StyleData", "TableNote", \
"Presentation"],
Cell[158427, 6116, 90, 2, 70, 40, 0, "StyleData", "TableNote", "Printout"],
Cell[158520, 6120, 103, 2, 70, 53, 0, "StyleData", "TableNote", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[158660, 6127, 81, 2, 70, 33, 0, "StyleData", "TableNoteLabel", "All",
  StyleMenuListing->None],
Cell[158744, 6131, 50, 0, 70, 50, 0, "StyleData", "TableNoteLabel", \
"NumberedHeads"],
Cell[158797, 6133, 49, 0, 70, 49, 0, "StyleData", "TableNoteLabel", \
"Presentation"],
Cell[158849, 6135, 45, 0, 70, 45, 0, "StyleData", "TableNoteLabel", \
"Printout"],
Cell[158897, 6137, 58, 0, 70, 58, 0, "StyleData", "TableNoteLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[158992, 6142, 56, 1, 70, 30, 0, "StyleData", "TableSpacer", "All",
  StyleMenuListing->None],
Cell[159051, 6145, 47, 0, 70, 47, 0, "StyleData", "TableSpacer", \
"NumberedHeads"],
Cell[159101, 6147, 46, 0, 70, 46, 0, "StyleData", "TableSpacer", \
"Presentation"],
Cell[159150, 6149, 68, 1, 70, 42, 0, "StyleData", "TableSpacer", "Printout",
  StyleMenuListing->None],
Cell[159221, 6152, 81, 1, 70, 55, 0, "StyleData", "TableSpacer", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[159339, 6158, 44, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[159408, 6162, 498, 18, 70, 34, 0, "StyleData", "TableColumnHead", "All",
  StyleMenuListing->None],
Cell[159909, 6182, 51, 0, 70, 51, 0, "StyleData", "TableColumnHead", \
"NumberedHeads"],
Cell[159963, 6184, 66, 1, 70, 50, 0, "StyleData", "TableColumnHead", \
"Presentation"],
Cell[160032, 6187, 62, 1, 70, 46, 0, "StyleData", "TableColumnHead", \
"Printout"],
Cell[160097, 6190, 75, 1, 70, 59, 0, "StyleData", "TableColumnHead", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[160209, 6196, 521, 19, 70, 32, 0, "StyleData", "TableSpanHead", "All",
  StyleMenuListing->None],
Cell[160733, 6217, 49, 0, 70, 49, 0, "StyleData", "TableSpanHead", \
"NumberedHeads"],
Cell[160785, 6219, 64, 1, 70, 48, 0, "StyleData", "TableSpanHead", \
"Presentation"],
Cell[160852, 6222, 60, 1, 70, 44, 0, "StyleData", "TableSpanHead", \
"Printout"],
Cell[160915, 6225, 73, 1, 70, 57, 0, "StyleData", "TableSpanHead", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[161025, 6231, 531, 20, 70, 28, 0, "StyleData", "TableText", "All",
  StyleMenuListing->None],
Cell[161559, 6253, 45, 0, 70, 45, 0, "StyleData", "TableText", \
"NumberedHeads"],
Cell[161607, 6255, 60, 1, 70, 44, 0, "StyleData", "TableText", \
"Presentation"],
Cell[161670, 6258, 56, 1, 70, 40, 0, "StyleData", "TableText", "Printout"],
Cell[161729, 6261, 69, 1, 70, 53, 0, "StyleData", "TableText", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[161835, 6267, 267, 10, 70, 32, 0, "StyleData", "TableSpanText", "All",
  StyleMenuListing->None],
Cell[162105, 6279, 49, 0, 70, 49, 0, "StyleData", "TableSpanText", \
"NumberedHeads"],
Cell[162157, 6281, 64, 1, 70, 48, 0, "StyleData", "TableSpanText", \
"Presentation"],
Cell[162224, 6284, 60, 1, 70, 44, 0, "StyleData", "TableSpanText", \
"Printout"],
Cell[162287, 6287, 73, 1, 70, 57, 0, "StyleData", "TableSpanText", \
"NumberedHeadsPrintout"]
}, Closed]],
Cell[162375, 6291, 264, 8, 70, 31, 0, "StyleData", "TableSubGrid", "All",
  StyleMenuListing->None],
Cell[162642, 6301, 122, 3, 70, 34, 0, "StyleData", "TableMasterGrid", "All",
  StyleMenuListing->None],
Cell[162767, 6306, 332, 10, 70, 35, 0, "StyleData", "TableLineElement", "All",
  
  StyleMenuListing->None],
Cell[163102, 6318, 172, 5, 70, 36, 0, "StyleData", "TableBlankElement", "All",
  
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[163299, 6327, 133, 5, 70, 27, 0, "StyleData", "SpanLeft", "All",
  StyleMenuListing->None],
Cell[163435, 6334, 44, 0, 70, 44, 0, "StyleData", "SpanLeft", \
"NumberedHeads"],
Cell[163482, 6336, 55, 1, 70, 39, 0, "StyleData", "SpanLeft", "Printout"],
Cell[163540, 6339, 43, 0, 70, 43, 0, "StyleData", "SpanLeft", \
"Presentation"],
Cell[163586, 6341, 68, 1, 70, 52, 0, "StyleData", "SpanLeft", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[163691, 6347, 135, 5, 70, 29, 0, "StyleData", "SpanCenter", "All",
  StyleMenuListing->None],
Cell[163829, 6354, 46, 0, 70, 46, 0, "StyleData", "SpanCenter", \
"NumberedHeads"],
Cell[163878, 6356, 45, 0, 70, 45, 0, "StyleData", "SpanCenter", \
"Presentation"],
Cell[163926, 6358, 57, 1, 70, 41, 0, "StyleData", "SpanCenter", "Printout"],
Cell[163986, 6361, 70, 1, 70, 54, 0, "StyleData", "SpanCenter", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[164093, 6367, 134, 5, 70, 28, 0, "StyleData", "SpanRight", "All",
  StyleMenuListing->None],
Cell[164230, 6374, 45, 0, 70, 45, 0, "StyleData", "SpanRight", \
"NumberedHeads"],
Cell[164278, 6376, 44, 0, 70, 44, 0, "StyleData", "SpanRight", \
"Presentation"],
Cell[164325, 6378, 56, 1, 70, 40, 0, "StyleData", "SpanRight", "Printout"],
Cell[164384, 6381, 69, 1, 70, 53, 0, "StyleData", "SpanRight", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[164514, 6389, 29, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[164568, 6393, 319, 9, 70, 26, 0, "StyleData", "Caption", "All",
  CounterIncrements->"Caption",
  StyleMenuListing->None],
Cell[164890, 6404, 43, 0, 70, 43, 0, "StyleData", "Caption", \
"NumberedHeads"],
Cell[164936, 6406, 93, 2, 70, 42, 0, "StyleData", "Caption", "Presentation"],
Cell[165032, 6410, 87, 2, 70, 38, 0, "StyleData", "Caption", "Printout"],
Cell[165122, 6414, 100, 2, 70, 51, 0, "StyleData", "Caption", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[165259, 6421, 79, 2, 70, 31, 0, "StyleData", "CaptionLabel", "All",
  StyleMenuListing->None],
Cell[165341, 6425, 48, 0, 70, 48, 0, "StyleData", "CaptionLabel", \
"NumberedHeads"],
Cell[165392, 6427, 47, 0, 70, 47, 0, "StyleData", "CaptionLabel", \
"Presentation"],
Cell[165442, 6429, 69, 1, 70, 43, 0, "StyleData", "CaptionLabel", "Printout",
  StyleMenuListing->None],
Cell[165514, 6432, 82, 1, 70, 56, 0, "StyleData", "CaptionLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[165633, 6438, 80, 2, 70, 32, 0, "StyleData", "CaptionNumber", "All",
  StyleMenuListing->None],
Cell[165716, 6442, 49, 0, 70, 49, 0, "StyleData", "CaptionNumber", \
"NumberedHeads"],
Cell[165768, 6444, 48, 0, 70, 48, 0, "StyleData", "CaptionNumber", \
"Presentation"],
Cell[165819, 6446, 44, 0, 70, 44, 0, "StyleData", "CaptionNumber", \
"Printout"],
Cell[165866, 6448, 57, 0, 70, 57, 0, "StyleData", "CaptionNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[165960, 6453, 251, 8, 70, 30, 0, "StyleData", "CaptionText", "All",
  CounterIncrements->"CaptionText",
  StyleMenuListing->None],
Cell[166214, 6463, 47, 0, 70, 47, 0, "StyleData", "CaptionText", \
"NumberedHeads"],
Cell[166264, 6465, 98, 2, 70, 46, 0, "StyleData", "CaptionText", \
"Presentation"],
Cell[166365, 6469, 116, 3, 70, 42, 0, "StyleData", "CaptionText", \
"Printout"],
Cell[166484, 6474, 129, 3, 70, 55, 0, "StyleData", "CaptionText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[166662, 6483, 34, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[166721, 6487, 126, 4, 70, 26, 0, "StyleData", "Extract", "All",
  StyleMenuListing->None],
Cell[166850, 6493, 43, 0, 70, 43, 0, "StyleData", "Extract", \
"NumberedHeads"],
Cell[166896, 6495, 95, 2, 70, 42, 0, "StyleData", "Extract", "Presentation"],
Cell[166994, 6499, 112, 3, 70, 38, 0, "StyleData", "Extract", "Printout"],
Cell[167109, 6504, 125, 3, 70, 51, 0, "StyleData", "Extract", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[167295, 6514, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[167350, 6518, 57, 1, 39, "Subsection"],

Cell[CellGroupData[{
Cell[167432, 6523, 451, 11, 46, 27, 0, "StyleData", "Equation", "All",
  CounterIncrements->"Equation",
  StyleMenuListing->None],
Cell[167886, 6536, 44, 0, 70, 44, 0, "StyleData", "Equation", \
"NumberedHeads"],
Cell[167933, 6538, 96, 2, 70, 43, 0, "StyleData", "Equation", \
"Presentation"],
Cell[168032, 6542, 89, 2, 70, 39, 0, "StyleData", "Equation", "Printout"],
Cell[168124, 6546, 102, 2, 70, 52, 0, "StyleData", "Equation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[168263, 6553, 461, 11, 43, 31, 0, "StyleData", "EquationWide", "All",
  CounterIncrements->"Equation",
  StyleMenuListing->None],
Cell[168727, 6566, 48, 0, 70, 48, 0, "StyleData", "EquationWide", \
"NumberedHeads"],
Cell[168778, 6568, 100, 2, 70, 47, 0, "StyleData", "EquationWide", \
"Presentation"],
Cell[168881, 6572, 93, 2, 70, 43, 0, "StyleData", "EquationWide", \
"Printout"],
Cell[168977, 6576, 106, 2, 70, 56, 0, "StyleData", "EquationWide", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[169120, 6583, 341, 7, 36, 32, 0, "StyleData", "EquationGroup", "All",
  StyleMenuListing->None],
Cell[169464, 6592, 49, 0, 70, 49, 0, "StyleData", "EquationGroup", \
"NumberedHeads"],
Cell[169516, 6594, 99, 2, 70, 48, 0, "StyleData", "EquationGroup", \
"Presentation"],
Cell[169618, 6598, 94, 2, 70, 44, 0, "StyleData", "EquationGroup", \
"Printout"],
Cell[169715, 6602, 107, 2, 70, 57, 0, "StyleData", "EquationGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[169859, 6609, 558, 11, 36, 39, 0, "StyleData", "EquationGroupAligned", \
"All",
  StyleMenuListing->None],
Cell[170420, 6622, 56, 0, 70, 56, 0, "StyleData", "EquationGroupAligned", \
"NumberedHeads"],
Cell[170479, 6624, 106, 2, 70, 55, 0, "StyleData", "EquationGroupAligned", \
"Presentation"],
Cell[170588, 6628, 101, 2, 70, 51, 0, "StyleData", "EquationGroupAligned", \
"Printout"],
Cell[170692, 6632, 114, 2, 70, 64, 0, "StyleData", "EquationGroupAligned", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[170855, 6640, 40, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[170920, 6644, 887, 19, 46, 35, 0, "StyleData", "EquationNumbered", "All",
  
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[171810, 6665, 52, 0, 70, 52, 0, "StyleData", "EquationNumbered", \
"NumberedHeads"],
Cell[171865, 6667, 104, 2, 70, 51, 0, "StyleData", "EquationNumbered", \
"Presentation"],
Cell[171972, 6671, 96, 2, 70, 47, 0, "StyleData", "EquationNumbered", \
"Printout"],
Cell[172071, 6675, 109, 2, 70, 60, 0, "StyleData", "EquationNumbered", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[172217, 6682, 901, 19, 43, 39, 0, "StyleData", "EquationWideNumbered", \
"All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[173121, 6703, 56, 0, 70, 56, 0, "StyleData", "EquationWideNumbered", \
"NumberedHeads"],
Cell[173180, 6705, 108, 2, 70, 55, 0, "StyleData", "EquationWideNumbered", \
"Presentation"],
Cell[173291, 6709, 100, 2, 70, 51, 0, "StyleData", "EquationWideNumbered", \
"Printout"],
Cell[173394, 6713, 113, 2, 70, 64, 0, "StyleData", "EquationWideNumbered", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[173544, 6720, 899, 18, 36, 40, 0, "StyleData", "EquationGroupNumbered", \
"All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[174446, 6740, 57, 0, 70, 57, 0, "StyleData", "EquationGroupNumbered", \
"NumberedHeads"],
Cell[174506, 6742, 106, 2, 70, 56, 0, "StyleData", "EquationGroupNumbered", \
"Presentation"],
Cell[174615, 6746, 101, 2, 70, 52, 0, "StyleData", "EquationGroupNumbered", \
"Printout"],
Cell[174719, 6750, 114, 2, 70, 65, 0, "StyleData", "EquationGroupNumbered", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[174870, 6757, 1134, 23, 36, 47, 0, "StyleData", \
"EquationGroupAlignedNumbered", "All",
  CounterIncrements->"EquationNumbered",
  StyleMenuListing->None],
Cell[176007, 6782, 64, 0, 70, 64, 0, "StyleData", \
"EquationGroupAlignedNumbered", "NumberedHeads"],
Cell[176074, 6784, 113, 2, 70, 63, 0, "StyleData", \
"EquationGroupAlignedNumbered", "Presentation"],
Cell[176190, 6788, 108, 2, 70, 59, 0, "StyleData", \
"EquationGroupAlignedNumbered", "Printout"],
Cell[176301, 6792, 121, 2, 70, 72, 0, "StyleData", \
"EquationGroupAlignedNumbered", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[176459, 6799, 1119, 21, 36, 38, 0, "StyleData", "SubequationNumbered", \
"All",
  CounterIncrements->"SubequationNumbered",
  StyleMenuListing->None],
Cell[177581, 6822, 55, 0, 70, 55, 0, "StyleData", "SubequationNumbered", \
"NumberedHeads"],
Cell[177639, 6824, 104, 2, 70, 54, 0, "StyleData", "SubequationNumbered", \
"Presentation"],
Cell[177746, 6828, 125, 3, 70, 50, 0, "StyleData", "SubequationNumbered", \
"Printout",
  StyleMenuListing->None],
Cell[177874, 6833, 138, 3, 70, 63, 0, "StyleData", "SubequationNumbered", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[178049, 6841, 1354, 26, 36, 45, 0, "StyleData", \
"SubequationAlignedNumbered", "All",
  CounterIncrements->"SubequationNumbered",
  StyleMenuListing->None],
Cell[179406, 6869, 62, 0, 70, 62, 0, "StyleData", \
"SubequationAlignedNumbered", "NumberedHeads"],
Cell[179471, 6871, 111, 2, 70, 61, 0, "StyleData", \
"SubequationAlignedNumbered", "Presentation"],
Cell[179585, 6875, 132, 3, 70, 57, 0, "StyleData", \
"SubequationAlignedNumbered", "Printout",
  StyleMenuListing->None],
Cell[179720, 6880, 145, 3, 70, 70, 0, "StyleData", \
"SubequationAlignedNumbered", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[179902, 6888, 112, 3, 40, 33, 0, "StyleData", "EquationNumber", "All",
  StyleMenuListing->None],
Cell[180017, 6893, 50, 0, 70, 50, 0, "StyleData", "EquationNumber", \
"NumberedHeads"],
Cell[180070, 6895, 78, 1, 70, 49, 0, "StyleData", "EquationNumber", \
"Presentation"],
Cell[180151, 6898, 74, 1, 70, 45, 0, "StyleData", "EquationNumber", \
"Printout"],
Cell[180228, 6901, 87, 1, 70, 58, 0, "StyleData", "EquationNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[180352, 6907, 115, 3, 40, 36, 0, "StyleData", "SubequationNumber", "All",
  
  StyleMenuListing->None],
Cell[180470, 6912, 53, 0, 70, 53, 0, "StyleData", "SubequationNumber", \
"NumberedHeads"],
Cell[180526, 6914, 81, 1, 70, 52, 0, "StyleData", "SubequationNumber", \
"Presentation"],
Cell[180610, 6917, 77, 1, 70, 48, 0, "StyleData", "SubequationNumber", \
"Printout"],
Cell[180690, 6920, 90, 1, 70, 61, 0, "StyleData", "SubequationNumber", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[180829, 6927, 46, 0, 35, "Subsection"],
Cell[180878, 6929, 57, 1, 70, 31, 0, "StyleData", "EquationGrid", "All",
  StyleMenuListing->None],
Cell[180938, 6932, 58, 1, 70, 32, 0, "StyleData", "SplitEquation", "All",
  StyleMenuListing->None],
Cell[180999, 6935, 54, 1, 70, 28, 0, "StyleData", "Piecewise", "All",
  StyleMenuListing->None],
Cell[181056, 6938, 51, 1, 70, 25, 0, "StyleData", "Matrix", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[181144, 6944, 34, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[181203, 6948, 58, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[181286, 6953, 634, 14, 70, 26, 0, "StyleData", "Theorem", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[181923, 6969, 43, 0, 70, 43, 0, "StyleData", "Theorem", \
"NumberedHeads"],
Cell[181969, 6971, 118, 3, 70, 42, 0, "StyleData", "Theorem", \
"Presentation"],
Cell[182090, 6976, 110, 3, 70, 38, 0, "StyleData", "Theorem", "Printout"],
Cell[182203, 6981, 123, 3, 70, 51, 0, "StyleData", "Theorem", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[182363, 6989, 182, 5, 70, 31, 0, "StyleData", "TheoremLabel", "All",
  StyleMenuListing->None],
Cell[182548, 6996, 48, 0, 70, 48, 0, "StyleData", "TheoremLabel", \
"NumberedHeads"],
Cell[182599, 6998, 63, 1, 70, 47, 0, "StyleData", "TheoremLabel", \
"Presentation"],
Cell[182665, 7001, 85, 2, 70, 43, 0, "StyleData", "TheoremLabel", "Printout",
  StyleMenuListing->None],
Cell[182753, 7005, 98, 2, 70, 56, 0, "StyleData", "TheoremLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[182888, 7012, 468, 11, 70, 38, 0, "StyleData", "TheoremContinuation", \
"All",
  CounterIncrements->"TheoremContinuation",
  StyleMenuListing->None],
Cell[183359, 7025, 55, 0, 70, 55, 0, "StyleData", "TheoremContinuation", \
"NumberedHeads"],
Cell[183417, 7027, 105, 2, 70, 54, 0, "StyleData", "TheoremContinuation", \
"Presentation"],
Cell[183525, 7031, 99, 2, 70, 50, 0, "StyleData", "TheoremContinuation", \
"Printout"],
Cell[183627, 7035, 112, 2, 70, 63, 0, "StyleData", "TheoremContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[183788, 7043, 60, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[183873, 7048, 643, 15, 70, 28, 0, "StyleData", "Corollary", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[184519, 7065, 45, 0, 70, 45, 0, "StyleData", "Corollary", \
"NumberedHeads"],
Cell[184567, 7067, 120, 3, 70, 44, 0, "StyleData", "Corollary", \
"Presentation"],
Cell[184690, 7072, 112, 3, 70, 40, 0, "StyleData", "Corollary", "Printout"],
Cell[184805, 7077, 125, 3, 70, 53, 0, "StyleData", "Corollary", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[184967, 7085, 184, 5, 70, 33, 0, "StyleData", "CorollaryLabel", "All",
  StyleMenuListing->None],
Cell[185154, 7092, 50, 0, 70, 50, 0, "StyleData", "CorollaryLabel", \
"NumberedHeads"],
Cell[185207, 7094, 65, 1, 70, 49, 0, "StyleData", "CorollaryLabel", \
"Presentation"],
Cell[185275, 7097, 87, 2, 70, 45, 0, "StyleData", "CorollaryLabel", \
"Printout",
  StyleMenuListing->None],
Cell[185365, 7101, 100, 2, 70, 58, 0, "StyleData", "CorollaryLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[185502, 7108, 474, 11, 70, 40, 0, "StyleData", "CorollaryContinuation", \
"All",
  CounterIncrements->"CorollaryContinuation",
  StyleMenuListing->None],
Cell[185979, 7121, 57, 0, 70, 57, 0, "StyleData", "CorollaryContinuation", \
"NumberedHeads"],
Cell[186039, 7123, 107, 2, 70, 56, 0, "StyleData", "CorollaryContinuation", \
"Presentation"],
Cell[186149, 7127, 101, 2, 70, 52, 0, "StyleData", "CorollaryContinuation", \
"Printout"],
Cell[186253, 7131, 114, 2, 70, 65, 0, "StyleData", "CorollaryContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[186416, 7139, 56, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[186497, 7144, 635, 15, 70, 24, 0, "StyleData", "Lemma", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[187135, 7161, 41, 0, 70, 41, 0, "StyleData", "Lemma", "NumberedHeads"],
Cell[187179, 7163, 116, 3, 70, 40, 0, "StyleData", "Lemma", "Presentation"],
Cell[187298, 7168, 108, 3, 70, 36, 0, "StyleData", "Lemma", "Printout"],
Cell[187409, 7173, 121, 3, 70, 49, 0, "StyleData", "Lemma", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[187567, 7181, 180, 5, 70, 29, 0, "StyleData", "LemmaLabel", "All",
  StyleMenuListing->None],
Cell[187750, 7188, 46, 0, 70, 46, 0, "StyleData", "LemmaLabel", \
"NumberedHeads"],
Cell[187799, 7190, 61, 1, 70, 45, 0, "StyleData", "LemmaLabel", \
"Presentation"],
Cell[187863, 7193, 83, 2, 70, 41, 0, "StyleData", "LemmaLabel", "Printout",
  StyleMenuListing->None],
Cell[187949, 7197, 96, 2, 70, 54, 0, "StyleData", "LemmaLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[188082, 7204, 462, 11, 70, 36, 0, "StyleData", "LemmaContinuation", \
"All",
  CounterIncrements->"LemmaContinuation",
  StyleMenuListing->None],
Cell[188547, 7217, 53, 0, 70, 53, 0, "StyleData", "LemmaContinuation", \
"NumberedHeads"],
Cell[188603, 7219, 103, 2, 70, 52, 0, "StyleData", "LemmaContinuation", \
"Presentation"],
Cell[188709, 7223, 97, 2, 70, 48, 0, "StyleData", "LemmaContinuation", \
"Printout"],
Cell[188809, 7227, 110, 2, 70, 61, 0, "StyleData", "LemmaContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[188968, 7235, 62, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[189055, 7240, 647, 15, 70, 30, 0, "StyleData", "Proposition", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[189705, 7257, 47, 0, 70, 47, 0, "StyleData", "Proposition", \
"NumberedHeads"],
Cell[189755, 7259, 122, 3, 70, 46, 0, "StyleData", "Proposition", \
"Presentation"],
Cell[189880, 7264, 114, 3, 70, 42, 0, "StyleData", "Proposition", \
"Printout"],
Cell[189997, 7269, 127, 3, 70, 55, 0, "StyleData", "Proposition", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[190161, 7277, 186, 5, 70, 35, 0, "StyleData", "PropositionLabel", "All",
  StyleMenuListing->None],
Cell[190350, 7284, 52, 0, 70, 52, 0, "StyleData", "PropositionLabel", \
"NumberedHeads"],
Cell[190405, 7286, 67, 1, 70, 51, 0, "StyleData", "PropositionLabel", \
"Presentation"],
Cell[190475, 7289, 89, 2, 70, 47, 0, "StyleData", "PropositionLabel", \
"Printout",
  StyleMenuListing->None],
Cell[190567, 7293, 102, 2, 70, 60, 0, "StyleData", "PropositionLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[190706, 7300, 480, 11, 70, 42, 0, "StyleData", \
"PropositionContinuation", "All",
  CounterIncrements->"PropositionContinuation",
  StyleMenuListing->None],
Cell[191189, 7313, 59, 0, 70, 59, 0, "StyleData", "PropositionContinuation", \
"NumberedHeads"],
Cell[191251, 7315, 109, 2, 70, 58, 0, "StyleData", "PropositionContinuation", \
"Presentation"],
Cell[191363, 7319, 103, 2, 70, 54, 0, "StyleData", "PropositionContinuation", \
"Printout"],
Cell[191469, 7323, 116, 2, 70, 67, 0, "StyleData", "PropositionContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[191634, 7331, 61, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[191720, 7336, 645, 15, 70, 29, 0, "StyleData", "Conjecture", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[192368, 7353, 46, 0, 70, 46, 0, "StyleData", "Conjecture", \
"NumberedHeads"],
Cell[192417, 7355, 121, 3, 70, 45, 0, "StyleData", "Conjecture", \
"Presentation"],
Cell[192541, 7360, 113, 3, 70, 41, 0, "StyleData", "Conjecture", "Printout"],
Cell[192657, 7365, 126, 3, 70, 54, 0, "StyleData", "Conjecture", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[192820, 7373, 185, 5, 70, 34, 0, "StyleData", "ConjectureLabel", "All",
  StyleMenuListing->None],
Cell[193008, 7380, 51, 0, 70, 51, 0, "StyleData", "ConjectureLabel", \
"NumberedHeads"],
Cell[193062, 7382, 66, 1, 70, 50, 0, "StyleData", "ConjectureLabel", \
"Presentation"],
Cell[193131, 7385, 88, 2, 70, 46, 0, "StyleData", "ConjectureLabel", \
"Printout",
  StyleMenuListing->None],
Cell[193222, 7389, 101, 2, 70, 59, 0, "StyleData", "ConjectureLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[193360, 7396, 477, 11, 70, 41, 0, "StyleData", "ConjectureContinuation", \
"All",
  CounterIncrements->"ConjectureContinuation",
  StyleMenuListing->None],
Cell[193840, 7409, 58, 0, 70, 58, 0, "StyleData", "ConjectureContinuation", \
"NumberedHeads"],
Cell[193901, 7411, 108, 2, 70, 57, 0, "StyleData", "ConjectureContinuation", \
"Presentation"],
Cell[194012, 7415, 102, 2, 70, 53, 0, "StyleData", "ConjectureContinuation", \
"Printout"],
Cell[194117, 7419, 115, 2, 70, 66, 0, "StyleData", "ConjectureContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[194281, 7427, 61, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[194367, 7432, 644, 15, 70, 29, 0, "StyleData", "Definition", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[195014, 7449, 46, 0, 70, 46, 0, "StyleData", "Definition", \
"NumberedHeads"],
Cell[195063, 7451, 121, 3, 70, 45, 0, "StyleData", "Definition", \
"Presentation"],
Cell[195187, 7456, 113, 3, 70, 41, 0, "StyleData", "Definition", "Printout"],
Cell[195303, 7461, 126, 3, 70, 54, 0, "StyleData", "Definition", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[195466, 7469, 185, 5, 70, 34, 0, "StyleData", "DefinitionLabel", "All",
  StyleMenuListing->None],
Cell[195654, 7476, 51, 0, 70, 51, 0, "StyleData", "DefinitionLabel", \
"NumberedHeads"],
Cell[195708, 7478, 66, 1, 70, 50, 0, "StyleData", "DefinitionLabel", \
"Presentation"],
Cell[195777, 7481, 88, 2, 70, 46, 0, "StyleData", "DefinitionLabel", \
"Printout",
  StyleMenuListing->None],
Cell[195868, 7485, 101, 2, 70, 59, 0, "StyleData", "DefinitionLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[196006, 7492, 454, 10, 70, 41, 0, "StyleData", "DefinitionContinuation", \
"All",
  CounterIncrements->"DefinitionContinuation",
  StyleMenuListing->None],
Cell[196463, 7504, 58, 0, 70, 58, 0, "StyleData", "DefinitionContinuation", \
"NumberedHeads"],
Cell[196524, 7506, 108, 2, 70, 57, 0, "StyleData", "DefinitionContinuation", \
"Presentation"],
Cell[196635, 7510, 102, 2, 70, 53, 0, "StyleData", "DefinitionContinuation", \
"Printout"],
Cell[196740, 7514, 115, 2, 70, 66, 0, "StyleData", "DefinitionContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[196904, 7522, 56, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[196985, 7527, 634, 15, 70, 24, 0, "StyleData", "Axiom", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[197622, 7544, 41, 0, 70, 41, 0, "StyleData", "Axiom", "NumberedHeads"],
Cell[197666, 7546, 116, 3, 70, 40, 0, "StyleData", "Axiom", "Presentation"],
Cell[197785, 7551, 108, 3, 70, 36, 0, "StyleData", "Axiom", "Printout"],
Cell[197896, 7556, 121, 3, 70, 49, 0, "StyleData", "Axiom", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[198054, 7564, 180, 5, 70, 29, 0, "StyleData", "AxiomLabel", "All",
  StyleMenuListing->None],
Cell[198237, 7571, 46, 0, 70, 46, 0, "StyleData", "AxiomLabel", \
"NumberedHeads"],
Cell[198286, 7573, 61, 1, 70, 45, 0, "StyleData", "AxiomLabel", \
"Presentation"],
Cell[198350, 7576, 83, 2, 70, 41, 0, "StyleData", "AxiomLabel", "Printout",
  StyleMenuListing->None],
Cell[198436, 7580, 96, 2, 70, 54, 0, "StyleData", "AxiomLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[198569, 7587, 439, 10, 70, 36, 0, "StyleData", "AxiomContinuation", \
"All",
  CounterIncrements->"AxiomContinuation",
  StyleMenuListing->None],
Cell[199011, 7599, 53, 0, 70, 53, 0, "StyleData", "AxiomContinuation", \
"NumberedHeads"],
Cell[199067, 7601, 103, 2, 70, 52, 0, "StyleData", "AxiomContinuation", \
"Presentation"],
Cell[199173, 7605, 97, 2, 70, 48, 0, "StyleData", "AxiomContinuation", \
"Printout"],
Cell[199273, 7609, 110, 2, 70, 61, 0, "StyleData", "AxiomContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[199432, 7617, 58, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[199515, 7622, 638, 15, 70, 26, 0, "StyleData", "Example", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[200156, 7639, 43, 0, 70, 43, 0, "StyleData", "Example", \
"NumberedHeads"],
Cell[200202, 7641, 118, 3, 70, 42, 0, "StyleData", "Example", \
"Presentation"],
Cell[200323, 7646, 110, 3, 70, 38, 0, "StyleData", "Example", "Printout"],
Cell[200436, 7651, 123, 3, 70, 51, 0, "StyleData", "Example", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[200596, 7659, 182, 5, 70, 31, 0, "StyleData", "ExampleLabel", "All",
  StyleMenuListing->None],
Cell[200781, 7666, 48, 0, 70, 48, 0, "StyleData", "ExampleLabel", \
"NumberedHeads"],
Cell[200832, 7668, 63, 1, 70, 47, 0, "StyleData", "ExampleLabel", \
"Presentation"],
Cell[200898, 7671, 85, 2, 70, 43, 0, "StyleData", "ExampleLabel", "Printout",
  StyleMenuListing->None],
Cell[200986, 7675, 98, 2, 70, 56, 0, "StyleData", "ExampleLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[201121, 7682, 445, 10, 70, 38, 0, "StyleData", "ExampleContinuation", \
"All",
  CounterIncrements->"ExampleContinuation",
  StyleMenuListing->None],
Cell[201569, 7694, 55, 0, 70, 55, 0, "StyleData", "ExampleContinuation", \
"NumberedHeads"],
Cell[201627, 7696, 105, 2, 70, 54, 0, "StyleData", "ExampleContinuation", \
"Presentation"],
Cell[201735, 7700, 99, 2, 70, 50, 0, "StyleData", "ExampleContinuation", \
"Printout"],
Cell[201837, 7704, 112, 2, 70, 63, 0, "StyleData", "ExampleContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[201998, 7712, 57, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[202080, 7717, 636, 15, 70, 25, 0, "StyleData", "Remark", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[202719, 7734, 42, 0, 70, 42, 0, "StyleData", "Remark", "NumberedHeads"],
Cell[202764, 7736, 117, 3, 70, 41, 0, "StyleData", "Remark", "Presentation"],
Cell[202884, 7741, 109, 3, 70, 37, 0, "StyleData", "Remark", "Printout"],
Cell[202996, 7746, 122, 3, 70, 50, 0, "StyleData", "Remark", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[203155, 7754, 183, 5, 70, 30, 0, "StyleData", "RemarkLabel", "All",
  StyleMenuListing->None],
Cell[203341, 7761, 47, 0, 70, 47, 0, "StyleData", "RemarkLabel", \
"NumberedHeads"],
Cell[203391, 7763, 62, 1, 70, 46, 0, "StyleData", "RemarkLabel", \
"Presentation"],
Cell[203456, 7766, 84, 2, 70, 42, 0, "StyleData", "RemarkLabel", "Printout",
  StyleMenuListing->None],
Cell[203543, 7770, 97, 2, 70, 55, 0, "StyleData", "RemarkLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[203677, 7777, 442, 10, 70, 37, 0, "StyleData", "RemarkContinuation", \
"All",
  CounterIncrements->"RemarkContinuation",
  StyleMenuListing->None],
Cell[204122, 7789, 54, 0, 70, 54, 0, "StyleData", "RemarkContinuation", \
"NumberedHeads"],
Cell[204179, 7791, 104, 2, 70, 53, 0, "StyleData", "RemarkContinuation", \
"Presentation"],
Cell[204286, 7795, 98, 2, 70, 49, 0, "StyleData", "RemarkContinuation", \
"Printout"],
Cell[204387, 7799, 111, 2, 70, 62, 0, "StyleData", "RemarkContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[204547, 7807, 56, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[204628, 7812, 581, 14, 70, 24, 0, "StyleData", "Proof", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[205212, 7828, 41, 0, 70, 41, 0, "StyleData", "Proof", "NumberedHeads"],
Cell[205256, 7830, 116, 3, 70, 40, 0, "StyleData", "Proof", "Presentation"],
Cell[205375, 7835, 108, 3, 70, 36, 0, "StyleData", "Proof", "Printout"],
Cell[205486, 7840, 121, 3, 70, 49, 0, "StyleData", "Proof", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[205644, 7848, 182, 5, 70, 29, 0, "StyleData", "ProofLabel", "All",
  StyleMenuListing->None],
Cell[205829, 7855, 46, 0, 70, 46, 0, "StyleData", "ProofLabel", \
"NumberedHeads"],
Cell[205878, 7857, 61, 1, 70, 45, 0, "StyleData", "ProofLabel", \
"Presentation"],
Cell[205942, 7860, 83, 2, 70, 41, 0, "StyleData", "ProofLabel", "Printout",
  StyleMenuListing->None],
Cell[206028, 7864, 96, 2, 70, 54, 0, "StyleData", "ProofLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[206161, 7871, 439, 10, 70, 36, 0, "StyleData", "ProofContinuation", \
"All",
  CounterIncrements->"ProofContinuation",
  StyleMenuListing->None],
Cell[206603, 7883, 53, 0, 70, 53, 0, "StyleData", "ProofContinuation", \
"NumberedHeads"],
Cell[206659, 7885, 103, 2, 70, 52, 0, "StyleData", "ProofContinuation", \
"Presentation"],
Cell[206765, 7889, 97, 2, 70, 48, 0, "StyleData", "ProofContinuation", \
"Printout"],
Cell[206865, 7893, 110, 2, 70, 61, 0, "StyleData", "ProofContinuation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[207012, 7900, 155, 4, 70, 31, 0, "StyleData", "ProofSection", "All",
  StyleMenuListing->None],
Cell[207170, 7906, 48, 0, 70, 48, 0, "StyleData", "ProofSection", \
"NumberedHeads"],
Cell[207221, 7908, 100, 2, 70, 47, 0, "StyleData", "ProofSection", \
"Presentation"],
Cell[207324, 7912, 118, 3, 70, 43, 0, "StyleData", "ProofSection", "Printout",
  
  StyleMenuListing->None],
Cell[207445, 7917, 131, 3, 70, 56, 0, "StyleData", "ProofSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],
Cell[207591, 7923, 129, 3, 70, 22, 0, "StyleData", "QED", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[207757, 7931, 29, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[207811, 7935, 433, 12, 70, 23, 0, "StyleData", "Case", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[208247, 7949, 40, 0, 70, 40, 0, "StyleData", "Case", "NumberedHeads"],
Cell[208290, 7951, 115, 3, 70, 39, 0, "StyleData", "Case", "Presentation"],
Cell[208408, 7956, 107, 3, 70, 35, 0, "StyleData", "Case", "Printout"],
Cell[208518, 7961, 120, 3, 70, 48, 0, "StyleData", "Case", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[208675, 7969, 158, 5, 70, 28, 0, "StyleData", "CaseLabel", "All",
  StyleMenuListing->None],
Cell[208836, 7976, 45, 0, 70, 45, 0, "StyleData", "CaseLabel", \
"NumberedHeads"],
Cell[208884, 7978, 44, 0, 70, 44, 0, "StyleData", "CaseLabel", \
"Presentation"],
Cell[208931, 7980, 56, 1, 70, 40, 0, "StyleData", "CaseLabel", "Printout"],
Cell[208990, 7983, 69, 1, 70, 53, 0, "StyleData", "CaseLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[209096, 7989, 435, 10, 70, 35, 0, "StyleData", "CaseContinuation", "All",
  
  CounterIncrements->"CaseContinuation",
  StyleMenuListing->None],
Cell[209534, 8001, 52, 0, 70, 52, 0, "StyleData", "CaseContinuation", \
"NumberedHeads"],
Cell[209589, 8003, 102, 2, 70, 51, 0, "StyleData", "CaseContinuation", \
"Presentation"],
Cell[209694, 8007, 96, 2, 70, 47, 0, "StyleData", "CaseContinuation", \
"Printout"],
Cell[209793, 8011, 109, 2, 70, 60, 0, "StyleData", "CaseContinuation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[209939, 8018, 154, 4, 70, 30, 0, "StyleData", "CaseSection", "All",
  StyleMenuListing->None],
Cell[210096, 8024, 47, 0, 70, 47, 0, "StyleData", "CaseSection", \
"NumberedHeads"],
Cell[210146, 8026, 99, 2, 70, 46, 0, "StyleData", "CaseSection", \
"Presentation"],
Cell[210248, 8030, 117, 3, 70, 42, 0, "StyleData", "CaseSection", "Printout",
  StyleMenuListing->None],
Cell[210368, 8035, 130, 3, 70, 55, 0, "StyleData", "CaseSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[210547, 8044, 33, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[210605, 8048, 437, 12, 70, 27, 0, "StyleData", "Problems", "All",
  CounterIncrements->"Theorem",
  CounterAssignments->{{"EnunciationItem1Numbered", 0}, {"Item1Numbered", 0}},
  
  StyleMenuListing->None],
Cell[211045, 8062, 44, 0, 70, 44, 0, "StyleData", "Problems", \
"NumberedHeads"],
Cell[211092, 8064, 119, 3, 70, 43, 0, "StyleData", "Problems", \
"Presentation"],
Cell[211214, 8069, 111, 3, 70, 39, 0, "StyleData", "Problems", "Printout"],
Cell[211328, 8074, 124, 3, 70, 52, 0, "StyleData", "Problems", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[211489, 8082, 162, 5, 70, 32, 0, "StyleData", "ProblemsLabel", "All",
  StyleMenuListing->None],
Cell[211654, 8089, 49, 0, 70, 49, 0, "StyleData", "ProblemsLabel", \
"NumberedHeads"],
Cell[211706, 8091, 48, 0, 70, 48, 0, "StyleData", "ProblemsLabel", \
"Presentation"],
Cell[211757, 8093, 86, 2, 70, 44, 0, "StyleData", "ProblemsLabel", "Printout",
  
  StyleMenuListing->None],
Cell[211846, 8097, 99, 2, 70, 57, 0, "StyleData", "ProblemsLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[211982, 8104, 447, 10, 70, 39, 0, "StyleData", "ProblemsContinuation", \
"All",
  CounterIncrements->"ProblemsContinuation",
  StyleMenuListing->None],
Cell[212432, 8116, 56, 0, 70, 56, 0, "StyleData", "ProblemsContinuation", \
"NumberedHeads"],
Cell[212491, 8118, 106, 2, 70, 55, 0, "StyleData", "ProblemsContinuation", \
"Presentation"],
Cell[212600, 8122, 100, 2, 70, 51, 0, "StyleData", "ProblemsContinuation", \
"Printout"],
Cell[212703, 8126, 113, 2, 70, 64, 0, "StyleData", "ProblemsContinuation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[212853, 8133, 158, 4, 70, 34, 0, "StyleData", "ProblemsSection", "All",
  StyleMenuListing->None],
Cell[213014, 8139, 51, 0, 70, 51, 0, "StyleData", "ProblemsSection", \
"NumberedHeads"],
Cell[213068, 8141, 103, 2, 70, 50, 0, "StyleData", "ProblemsSection", \
"Presentation"],
Cell[213174, 8145, 121, 3, 70, 46, 0, "StyleData", "ProblemsSection", \
"Printout",
  StyleMenuListing->None],
Cell[213298, 8150, 134, 3, 70, 59, 0, "StyleData", "ProblemsSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[213481, 8159, 59, 1, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[213565, 8164, 531, 11, 70, 27, 0, "StyleData", "Question", "All",
  CounterIncrements->"Theorem",
  StyleMenuListing->None],
Cell[214099, 8177, 44, 0, 70, 44, 0, "StyleData", "Question", \
"NumberedHeads"],
Cell[214146, 8179, 119, 3, 70, 43, 0, "StyleData", "Question", \
"Presentation"],
Cell[214268, 8184, 111, 3, 70, 39, 0, "StyleData", "Question", "Printout"],
Cell[214382, 8189, 124, 3, 70, 52, 0, "StyleData", "Question", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[214543, 8197, 183, 5, 70, 32, 0, "StyleData", "QuestionLabel", "All",
  StyleMenuListing->None],
Cell[214729, 8204, 49, 0, 70, 49, 0, "StyleData", "QuestionLabel", \
"NumberedHeads"],
Cell[214781, 8206, 64, 1, 70, 48, 0, "StyleData", "QuestionLabel", \
"Presentation"],
Cell[214848, 8209, 86, 2, 70, 44, 0, "StyleData", "QuestionLabel", "Printout",
  
  StyleMenuListing->None],
Cell[214937, 8213, 99, 2, 70, 57, 0, "StyleData", "QuestionLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[215073, 8220, 448, 10, 70, 39, 0, "StyleData", "QuestionContinuation", \
"All",
  CounterIncrements->"QuestionContinuation",
  StyleMenuListing->None],
Cell[215524, 8232, 56, 0, 70, 56, 0, "StyleData", "QuestionContinuation", \
"NumberedHeads"],
Cell[215583, 8234, 106, 2, 70, 55, 0, "StyleData", "QuestionContinuation", \
"Presentation"],
Cell[215692, 8238, 100, 2, 70, 51, 0, "StyleData", "QuestionContinuation", \
"Printout"],
Cell[215795, 8242, 113, 2, 70, 64, 0, "StyleData", "QuestionContinuation", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[215957, 8250, 60, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[216042, 8254, 68, 1, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[216135, 8259, 698, 14, 70, 35, 0, "StyleData", "EnunciationItem1", "All",
  
  CounterIncrements->"Item1",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[216836, 8275, 52, 0, 70, 52, 0, "StyleData", "EnunciationItem1", \
"NumberedHeads"],
Cell[216891, 8277, 128, 3, 70, 51, 0, "StyleData", "EnunciationItem1", \
"Presentation",
  StyleMenuListing->None],
Cell[217022, 8282, 122, 3, 70, 47, 0, "StyleData", "EnunciationItem1", \
"Printout",
  StyleMenuListing->None],
Cell[217147, 8287, 135, 3, 70, 60, 0, "StyleData", "EnunciationItem1", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[217319, 8295, 670, 14, 70, 35, 0, "StyleData", "EnunciationItem2", "All",
  
  CounterIncrements->"Item2",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[217992, 8311, 52, 0, 70, 52, 0, "StyleData", "EnunciationItem2", \
"NumberedHeads"],
Cell[218047, 8313, 128, 3, 70, 51, 0, "StyleData", "EnunciationItem2", \
"Presentation",
  StyleMenuListing->None],
Cell[218178, 8318, 123, 3, 70, 47, 0, "StyleData", "EnunciationItem2", \
"Printout",
  StyleMenuListing->None],
Cell[218304, 8323, 136, 3, 70, 60, 0, "StyleData", "EnunciationItem2", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[218477, 8331, 624, 13, 70, 35, 0, "StyleData", "EnunciationItem3", "All",
  
  CounterIncrements->"Item3",
  StyleMenuListing->None],
Cell[219104, 8346, 52, 0, 70, 52, 0, "StyleData", "EnunciationItem3", \
"NumberedHeads"],
Cell[219159, 8348, 128, 3, 70, 51, 0, "StyleData", "EnunciationItem3", \
"Presentation",
  StyleMenuListing->None],
Cell[219290, 8353, 123, 3, 70, 47, 0, "StyleData", "EnunciationItem3", \
"Printout",
  StyleMenuListing->None],
Cell[219416, 8358, 136, 3, 70, 60, 0, "StyleData", "EnunciationItem3", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[219589, 8366, 263, 8, 70, 40, 0, "StyleData", "EnunciationItem1Label", \
"All",
  StyleMenuListing->None],
Cell[219855, 8376, 57, 0, 70, 57, 0, "StyleData", "EnunciationItem1Label", \
"NumberedHeads"],
Cell[219915, 8378, 127, 3, 70, 56, 0, "StyleData", "EnunciationItem1Label", \
"Presentation",
  StyleMenuListing->None],
Cell[220045, 8383, 123, 3, 70, 52, 0, "StyleData", "EnunciationItem1Label", \
"Printout",
  StyleMenuListing->None],
Cell[220171, 8388, 136, 3, 70, 65, 0, "StyleData", "EnunciationItem1Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[220344, 8396, 263, 8, 70, 40, 0, "StyleData", "EnunciationItem2Label", \
"All",
  StyleMenuListing->None],
Cell[220610, 8406, 57, 0, 70, 57, 0, "StyleData", "EnunciationItem2Label", \
"NumberedHeads"],
Cell[220670, 8408, 127, 3, 70, 56, 0, "StyleData", "EnunciationItem2Label", \
"Presentation",
  StyleMenuListing->None],
Cell[220800, 8413, 107, 2, 70, 52, 0, "StyleData", "EnunciationItem2Label", \
"Printout",
  StyleMenuListing->None],
Cell[220910, 8417, 120, 2, 70, 65, 0, "StyleData", "EnunciationItem2Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[221067, 8424, 263, 8, 70, 40, 0, "StyleData", "EnunciationItem3Label", \
"All",
  StyleMenuListing->None],
Cell[221333, 8434, 57, 0, 70, 57, 0, "StyleData", "EnunciationItem3Label", \
"NumberedHeads"],
Cell[221393, 8436, 127, 3, 70, 56, 0, "StyleData", "EnunciationItem3Label", \
"Presentation",
  StyleMenuListing->None],
Cell[221523, 8441, 107, 2, 70, 52, 0, "StyleData", "EnunciationItem3Label", \
"Printout",
  StyleMenuListing->None],
Cell[221633, 8445, 120, 2, 70, 65, 0, "StyleData", "EnunciationItem3Label", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[221802, 8453, 68, 1, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[221895, 8458, 763, 15, 70, 43, 0, "StyleData", \
"EnunciationItem1Numbered", "All",
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[222661, 8475, 60, 0, 70, 60, 0, "StyleData", "EnunciationItem1Numbered", \
"NumberedHeads"],
Cell[222724, 8477, 136, 3, 70, 59, 0, "StyleData", \
"EnunciationItem1Numbered", "Presentation",
  StyleMenuListing->None],
Cell[222863, 8482, 130, 3, 70, 55, 0, "StyleData", \
"EnunciationItem1Numbered", "Printout",
  StyleMenuListing->None],
Cell[222996, 8487, 143, 3, 70, 68, 0, "StyleData", \
"EnunciationItem1Numbered", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[223176, 8495, 833, 17, 70, 43, 0, "StyleData", \
"EnunciationItem2Numbered", "All",
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[224012, 8514, 60, 0, 70, 60, 0, "StyleData", "EnunciationItem2Numbered", \
"NumberedHeads"],
Cell[224075, 8516, 136, 3, 70, 59, 0, "StyleData", \
"EnunciationItem2Numbered", "Presentation",
  StyleMenuListing->None],
Cell[224214, 8521, 131, 3, 70, 55, 0, "StyleData", \
"EnunciationItem2Numbered", "Printout",
  StyleMenuListing->None],
Cell[224348, 8526, 144, 3, 70, 68, 0, "StyleData", \
"EnunciationItem2Numbered", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[224529, 8534, 749, 15, 70, 43, 0, "StyleData", \
"EnunciationItem3Numbered", "All",
  CounterIncrements->"Item3Numbered",
  StyleMenuListing->None],
Cell[225281, 8551, 60, 0, 70, 60, 0, "StyleData", "EnunciationItem3Numbered", \
"NumberedHeads"],
Cell[225344, 8553, 136, 3, 70, 59, 0, "StyleData", \
"EnunciationItem3Numbered", "Presentation",
  StyleMenuListing->None],
Cell[225483, 8558, 131, 3, 70, 55, 0, "StyleData", \
"EnunciationItem3Numbered", "Printout",
  StyleMenuListing->None],
Cell[225617, 8563, 144, 3, 70, 68, 0, "StyleData", \
"EnunciationItem3Numbered", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[225798, 8571, 260, 7, 70, 48, 0, "StyleData", \
"EnunciationItem1NumberedLabel", "All",
  StyleMenuListing->None],
Cell[226061, 8580, 65, 0, 70, 65, 0, "StyleData", \
"EnunciationItem1NumberedLabel", "NumberedHeads"],
Cell[226129, 8582, 135, 3, 70, 64, 0, "StyleData", \
"EnunciationItem1NumberedLabel", "Presentation",
  StyleMenuListing->None],
Cell[226267, 8587, 131, 3, 70, 60, 0, "StyleData", \
"EnunciationItem1NumberedLabel", "Printout",
  StyleMenuListing->None],
Cell[226401, 8592, 144, 3, 70, 73, 0, "StyleData", \
"EnunciationItem1NumberedLabel", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[226582, 8600, 260, 7, 70, 48, 0, "StyleData", \
"EnunciationItem2NumberedLabel", "All",
  StyleMenuListing->None],
Cell[226845, 8609, 65, 0, 70, 65, 0, "StyleData", \
"EnunciationItem2NumberedLabel", "NumberedHeads"],
Cell[226913, 8611, 135, 3, 70, 64, 0, "StyleData", \
"EnunciationItem2NumberedLabel", "Presentation",
  StyleMenuListing->None],
Cell[227051, 8616, 115, 2, 70, 60, 0, "StyleData", \
"EnunciationItem2NumberedLabel", "Printout",
  StyleMenuListing->None],
Cell[227169, 8620, 128, 2, 70, 73, 0, "StyleData", \
"EnunciationItem2NumberedLabel", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[227334, 8627, 260, 7, 70, 48, 0, "StyleData", \
"EnunciationItem3NumberedLabel", "All",
  StyleMenuListing->None],
Cell[227597, 8636, 65, 0, 70, 65, 0, "StyleData", \
"EnunciationItem3NumberedLabel", "NumberedHeads"],
Cell[227665, 8638, 135, 3, 70, 64, 0, "StyleData", \
"EnunciationItem3NumberedLabel", "Presentation",
  StyleMenuListing->None],
Cell[227803, 8643, 115, 2, 70, 60, 0, "StyleData", \
"EnunciationItem3NumberedLabel", "Printout",
  StyleMenuListing->None],
Cell[227921, 8647, 128, 2, 70, 73, 0, "StyleData", \
"EnunciationItem3NumberedLabel", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[228098, 8655, 69, 1, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[228192, 8660, 437, 8, 70, 44, 0, "StyleData", \
"EnunciationItem1Paragraph", "All",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[228632, 8670, 61, 0, 70, 61, 0, "StyleData", \
"EnunciationItem1Paragraph", "NumberedHeads"],
Cell[228696, 8672, 137, 3, 70, 60, 0, "StyleData", \
"EnunciationItem1Paragraph", "Presentation",
  StyleMenuListing->None],
Cell[228836, 8677, 132, 3, 70, 56, 0, "StyleData", \
"EnunciationItem1Paragraph", "Printout",
  StyleMenuListing->None],
Cell[228971, 8682, 145, 3, 70, 69, 0, "StyleData", \
"EnunciationItem1Paragraph", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[229153, 8690, 415, 8, 70, 44, 0, "StyleData", \
"EnunciationItem2Paragraph", "All",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[229571, 8700, 61, 0, 70, 61, 0, "StyleData", \
"EnunciationItem2Paragraph", "NumberedHeads"],
Cell[229635, 8702, 137, 3, 70, 60, 0, "StyleData", \
"EnunciationItem2Paragraph", "Presentation",
  StyleMenuListing->None],
Cell[229775, 8707, 132, 3, 70, 56, 0, "StyleData", \
"EnunciationItem2Paragraph", "Printout",
  StyleMenuListing->None],
Cell[229910, 8712, 145, 3, 70, 69, 0, "StyleData", \
"EnunciationItem2Paragraph", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[230092, 8720, 369, 7, 70, 44, 0, "StyleData", \
"EnunciationItem3Paragraph", "All",
  StyleMenuListing->None],
Cell[230464, 8729, 61, 0, 70, 61, 0, "StyleData", \
"EnunciationItem3Paragraph", "NumberedHeads"],
Cell[230528, 8731, 138, 3, 70, 60, 0, "StyleData", \
"EnunciationItem3Paragraph", "Presentation",
  StyleMenuListing->None],
Cell[230669, 8736, 132, 3, 70, 56, 0, "StyleData", \
"EnunciationItem3Paragraph", "Printout",
  StyleMenuListing->None],
Cell[230804, 8741, 145, 3, 70, 69, 0, "StyleData", \
"EnunciationItem3Paragraph", "NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[231034, 8753, 61, 1, 34, "Section"],

Cell[CellGroupData[{
Cell[231120, 8758, 181, 4, 70, 23, 0, "StyleData", "XRef", "All",
  StyleMenuListing->None],
Cell[231304, 8764, 40, 0, 70, 40, 0, "StyleData", "XRef", "NumberedHeads"],
Cell[231347, 8766, 39, 0, 70, 39, 0, "StyleData", "XRef", "Presentation"],
Cell[231389, 8768, 62, 1, 70, 35, 0, "StyleData", "XRef", "Printout"],
Cell[231454, 8771, 75, 1, 70, 48, 0, "StyleData", "XRef", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[231566, 8777, 54, 1, 70, 28, 0, "StyleData", "TableXRef", "All",
  StyleMenuListing->None],
Cell[231623, 8780, 45, 0, 70, 45, 0, "StyleData", "TableXRef", \
"NumberedHeads"],
Cell[231671, 8782, 44, 0, 70, 44, 0, "StyleData", "TableXRef", \
"Presentation"],
Cell[231718, 8784, 40, 0, 70, 40, 0, "StyleData", "TableXRef", "Printout"],
Cell[231761, 8786, 53, 0, 70, 53, 0, "StyleData", "TableXRef", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[231851, 8791, 55, 1, 70, 29, 0, "StyleData", "FigureXRef", "All",
  StyleMenuListing->None],
Cell[231909, 8794, 46, 0, 70, 46, 0, "StyleData", "FigureXRef", \
"NumberedHeads"],
Cell[231958, 8796, 45, 0, 70, 45, 0, "StyleData", "FigureXRef", \
"Presentation"],
Cell[232006, 8798, 41, 0, 70, 41, 0, "StyleData", "FigureXRef", "Printout"],
Cell[232050, 8800, 54, 0, 70, 54, 0, "StyleData", "FigureXRef", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[232141, 8805, 52, 1, 70, 26, 0, "StyleData", "PageRef", "All",
  StyleMenuListing->None],
Cell[232196, 8808, 43, 0, 70, 43, 0, "StyleData", "PageRef", \
"NumberedHeads"],
Cell[232242, 8810, 42, 0, 70, 42, 0, "StyleData", "PageRef", "Presentation"],
Cell[232287, 8812, 38, 0, 70, 38, 0, "StyleData", "PageRef", "Printout"],
Cell[232328, 8814, 51, 0, 70, 51, 0, "StyleData", "PageRef", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[232428, 8820, 29, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[232482, 8824, 313, 9, 60, 34, 0, "StyleData", "BackmatterGroup", "All",
  StyleMenuListing->None],
Cell[232798, 8835, 51, 0, 70, 51, 0, "StyleData", "BackmatterGroup", \
"NumberedHeads"],
Cell[232852, 8837, 158, 4, 70, 50, 0, "StyleData", "BackmatterGroup", \
"Presentation"],
Cell[233013, 8843, 121, 3, 70, 46, 0, "StyleData", "BackmatterGroup", \
"Printout"],
Cell[233137, 8848, 134, 3, 70, 59, 0, "StyleData", "BackmatterGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[233308, 8856, 95, 2, 35, "Subsection"],

Cell[CellGroupData[{
Cell[233428, 8862, 443, 11, 70, 41, 0, "StyleData", "AcknowledgmentsSection", \
"All",
  StyleMenuListing->None],
Cell[233874, 8875, 58, 0, 70, 58, 0, "StyleData", "AcknowledgmentsSection", \
"NumberedHeads"],
Cell[233935, 8877, 178, 4, 70, 57, 0, "StyleData", "AcknowledgmentsSection", \
"Presentation"],
Cell[234116, 8883, 104, 2, 70, 53, 0, "StyleData", "AcknowledgmentsSection", \
"Printout"],
Cell[234223, 8887, 117, 2, 70, 66, 0, "StyleData", "AcknowledgmentsSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[234377, 8894, 209, 7, 70, 34, 0, "StyleData", "Acknowledgments", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[234589, 8903, 51, 0, 70, 51, 0, "StyleData", "Acknowledgments", \
"NumberedHeads"],
Cell[234643, 8905, 101, 2, 70, 50, 0, "StyleData", "Acknowledgments", \
"Presentation"],
Cell[234747, 8909, 143, 4, 70, 46, 0, "StyleData", "Acknowledgments", \
"Printout"],
Cell[234893, 8915, 156, 4, 70, 59, 0, "StyleData", "Acknowledgments", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[235098, 8925, 88, 2, 35, "Subsection"],

Cell[CellGroupData[{
Cell[235211, 8931, 311, 9, 70, 32, 0, "StyleData", "AppendixGroup", "All",
  StyleMenuListing->None],
Cell[235525, 8942, 232, 6, 70, 49, 0, "StyleData", "AppendixGroup", \
"NumberedHeads",
  StyleMenuListing->None],
Cell[235760, 8950, 156, 4, 70, 48, 0, "StyleData", "AppendixGroup", \
"Presentation"],
Cell[235919, 8956, 119, 3, 70, 44, 0, "StyleData", "AppendixGroup", \
"Printout"],
Cell[236041, 8961, 132, 3, 70, 57, 0, "StyleData", "AppendixGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[236210, 8969, 611, 15, 70, 34, 0, "StyleData", "AppendixSection", "All",
  CounterIncrements->"AppendixSection",
  CounterAssignments->{{"AppendixEquation", 0}, {"Appendix", 0}},
  StyleMenuListing->None],
Cell[236824, 8986, 261, 5, 70, 51, 0, "StyleData", "AppendixSection", \
"NumberedHeads"],
Cell[237088, 8993, 171, 4, 70, 50, 0, "StyleData", "AppendixSection", \
"Presentation"],
Cell[237262, 8999, 97, 2, 70, 46, 0, "StyleData", "AppendixSection", \
"Printout"],
Cell[237362, 9003, 110, 2, 70, 59, 0, "StyleData", "AppendixSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[237509, 9010, 155, 4, 70, 39, 0, "StyleData", "AppendixSectionLabel", \
"All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[237667, 9016, 56, 0, 70, 56, 0, "StyleData", "AppendixSectionLabel", \
"NumberedHeads"],
Cell[237726, 9018, 55, 0, 70, 55, 0, "StyleData", "AppendixSectionLabel", \
"Presentation"],
Cell[237784, 9020, 51, 0, 70, 51, 0, "StyleData", "AppendixSectionLabel", \
"Printout"],
Cell[237838, 9022, 64, 0, 70, 64, 0, "StyleData", "AppendixSectionLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[237939, 9027, 98, 2, 70, 40, 0, "StyleData", "AppendixSectionNumber", \
"All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[238040, 9031, 57, 0, 70, 57, 0, "StyleData", "AppendixSectionNumber", \
"NumberedHeads"],
Cell[238100, 9033, 56, 0, 70, 56, 0, "StyleData", "AppendixSectionNumber", \
"Presentation"],
Cell[238159, 9035, 52, 0, 70, 52, 0, "StyleData", "AppendixSectionNumber", \
"Printout"],
Cell[238214, 9037, 65, 0, 70, 65, 0, "StyleData", "AppendixSectionNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[238316, 9042, 849, 18, 70, 35, 0, "StyleData", "AppendixEquation", "All",
  
  CounterIncrements->"AppendixEquation",
  StyleMenuListing->None],
Cell[239168, 9062, 52, 0, 70, 52, 0, "StyleData", "AppendixEquation", \
"NumberedHeads"],
Cell[239223, 9064, 104, 2, 70, 51, 0, "StyleData", "AppendixEquation", \
"Presentation"],
Cell[239330, 9068, 96, 2, 70, 47, 0, "StyleData", "AppendixEquation", \
"Printout"],
Cell[239429, 9072, 109, 2, 70, 60, 0, "StyleData", "AppendixEquation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[239575, 9079, 161, 4, 70, 27, 0, "StyleData", "Appendix", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[239739, 9085, 44, 0, 70, 44, 0, "StyleData", "Appendix", \
"NumberedHeads"],
Cell[239786, 9087, 94, 2, 70, 43, 0, "StyleData", "Appendix", \
"Presentation"],
Cell[239883, 9091, 88, 2, 70, 39, 0, "StyleData", "Appendix", "Printout"],
Cell[239974, 9095, 101, 2, 70, 52, 0, "StyleData", "Appendix", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[240124, 9103, 56, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[240205, 9108, 610, 16, 70, 33, 0, "StyleData", "EndnoteSection", "All",
  CounterIncrements->"Section",
  CounterAssignments->{{"Subsection", 0}, {"Subsubsection", 0}, {
      "Endnote", 0}},
  StyleMenuListing->None],
Cell[240818, 9126, 50, 0, 70, 50, 0, "StyleData", "EndnoteSection", \
"NumberedHeads"],
Cell[240871, 9128, 170, 4, 70, 49, 0, "StyleData", "EndnoteSection", \
"Presentation"],
Cell[241044, 9134, 96, 2, 70, 45, 0, "StyleData", "EndnoteSection", \
"Printout"],
Cell[241143, 9138, 109, 2, 70, 58, 0, "StyleData", "EndnoteSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[241289, 9145, 400, 11, 70, 26, 0, "StyleData", "Endnote", "All",
  CounterIncrements->"Endnote",
  StyleMenuListing->None],
Cell[241692, 9158, 43, 0, 70, 43, 0, "StyleData", "Endnote", \
"NumberedHeads"],
Cell[241738, 9160, 117, 3, 70, 42, 0, "StyleData", "Endnote", \
"Presentation"],
Cell[241858, 9165, 113, 3, 70, 38, 0, "StyleData", "Endnote", "Printout"],
Cell[241974, 9170, 126, 3, 70, 51, 0, "StyleData", "Endnote", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[242137, 9178, 251, 6, 70, 31, 0, "StyleData", "EndnoteLabel", "All",
  CounterIncrements->"EndnoteLabel",
  StyleMenuListing->None],
Cell[242391, 9186, 48, 0, 70, 48, 0, "StyleData", "EndnoteLabel", \
"NumberedHeads"],
Cell[242442, 9188, 76, 1, 70, 47, 0, "StyleData", "EndnoteLabel", \
"Presentation"],
Cell[242521, 9191, 43, 0, 70, 43, 0, "StyleData", "EndnoteLabel", \
"Printout"],
Cell[242567, 9193, 56, 0, 70, 56, 0, "StyleData", "EndnoteLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[242660, 9198, 149, 4, 70, 32, 0, "StyleData", "EndnoteNumber", "All",
  CounterIncrements->"EndnoteNumber",
  StyleMenuListing->None],
Cell[242812, 9204, 49, 0, 70, 49, 0, "StyleData", "EndnoteNumber", \
"NumberedHeads"],
Cell[242864, 9206, 77, 1, 70, 48, 0, "StyleData", "EndnoteNumber", \
"Presentation"],
Cell[242944, 9209, 44, 0, 70, 44, 0, "StyleData", "EndnoteNumber", \
"Printout"],
Cell[242991, 9211, 57, 0, 70, 57, 0, "StyleData", "EndnoteNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[243085, 9216, 247, 7, 70, 26, 0, "StyleData", "NoteKey", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[243335, 9225, 43, 0, 70, 43, 0, "StyleData", "NoteKey", \
"NumberedHeads"],
Cell[243381, 9227, 42, 0, 70, 42, 0, "StyleData", "NoteKey", "Presentation"],
Cell[243426, 9229, 65, 1, 70, 38, 0, "StyleData", "NoteKey", "Printout"],
Cell[243494, 9232, 78, 1, 70, 51, 0, "StyleData", "NoteKey", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[243609, 9238, 273, 7, 70, 36, 0, "StyleData", "EndnoteReturnLink", "All",
  
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[243885, 9247, 53, 0, 70, 53, 0, "StyleData", "EndnoteReturnLink", \
"NumberedHeads"],
Cell[243941, 9249, 52, 0, 70, 52, 0, "StyleData", "EndnoteReturnLink", \
"Presentation"],
Cell[243996, 9251, 115, 2, 70, 48, 0, "StyleData", "EndnoteReturnLink", \
"Printout"],
Cell[244114, 9255, 128, 2, 70, 61, 0, "StyleData", "EndnoteReturnLink", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[244279, 9262, 293, 8, 70, 31, 0, "StyleData", "TableNoteKey", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[244575, 9272, 48, 0, 70, 48, 0, "StyleData", "TableNoteKey", \
"NumberedHeads"],
Cell[244626, 9274, 47, 0, 70, 47, 0, "StyleData", "TableNoteKey", \
"Presentation"],
Cell[244676, 9276, 70, 1, 70, 43, 0, "StyleData", "TableNoteKey", \
"Printout"],
Cell[244749, 9279, 83, 1, 70, 56, 0, "StyleData", "TableNoteKey", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[244869, 9285, 307, 8, 70, 23, 0, "StyleData", "Note", "All",
  StyleMenuListing->None],
Cell[245179, 9295, 40, 0, 70, 40, 0, "StyleData", "Note", "NumberedHeads"],
Cell[245222, 9297, 39, 0, 70, 39, 0, "StyleData", "Note", "Presentation"],
Cell[245264, 9299, 55, 1, 70, 35, 0, "StyleData", "Note", "Printout"],
Cell[245322, 9302, 68, 1, 70, 48, 0, "StyleData", "Note", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[245439, 9309, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[245496, 9313, 678, 17, 67, 35, 0, "StyleData", "ReferenceSection", "All",
  
  CounterAssignments->{{"Reference", 0}},
  StyleMenuListing->None],
Cell[246177, 9332, 52, 0, 70, 52, 0, "StyleData", "ReferenceSection", \
"NumberedHeads"],
Cell[246232, 9334, 172, 4, 70, 51, 0, "StyleData", "ReferenceSection", \
"Presentation"],
Cell[246407, 9340, 124, 3, 70, 47, 0, "StyleData", "ReferenceSection", \
"Printout",
  StyleMenuListing->None],
Cell[246534, 9345, 137, 3, 70, 60, 0, "StyleData", "ReferenceSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[246708, 9353, 500, 11, 38, 28, 0, "StyleData", "Reference", "All",
  CounterIncrements->"Reference",
  StyleMenuListing->None],
Cell[247211, 9366, 45, 0, 70, 45, 0, "StyleData", "Reference", \
"NumberedHeads"],
Cell[247259, 9368, 119, 3, 70, 44, 0, "StyleData", "Reference", \
"Presentation"],
Cell[247381, 9373, 115, 3, 70, 40, 0, "StyleData", "Reference", "Printout",
  StyleMenuListing->None],
Cell[247499, 9378, 128, 3, 70, 53, 0, "StyleData", "Reference", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[247664, 9386, 257, 6, 40, 33, 0, "StyleData", "ReferenceLabel", "All",
  CounterIncrements->"ReferenceLabel",
  StyleMenuListing->None],
Cell[247924, 9394, 50, 0, 70, 50, 0, "StyleData", "ReferenceLabel", \
"NumberedHeads"],
Cell[247977, 9396, 78, 1, 70, 49, 0, "StyleData", "ReferenceLabel", \
"Presentation"],
Cell[248058, 9399, 45, 0, 70, 45, 0, "StyleData", "ReferenceLabel", \
"Printout"],
Cell[248106, 9401, 58, 0, 70, 58, 0, "StyleData", "ReferenceLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[248201, 9406, 60, 1, 40, 34, 0, "StyleData", "ReferenceNumber", "All",
  StyleMenuListing->None],
Cell[248264, 9409, 51, 0, 70, 51, 0, "StyleData", "ReferenceNumber", \
"NumberedHeads"],
Cell[248318, 9411, 50, 0, 70, 50, 0, "StyleData", "ReferenceNumber", \
"Presentation"],
Cell[248371, 9413, 46, 0, 70, 46, 0, "StyleData", "ReferenceNumber", \
"Printout"],
Cell[248420, 9415, 59, 0, 70, 59, 0, "StyleData", "ReferenceNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[248516, 9420, 109, 3, 40, 25, 0, "StyleData", "RefSep", "All",
  StyleMenuListing->None],
Cell[248628, 9425, 42, 0, 70, 42, 0, "StyleData", "RefSep", "NumberedHeads"],
Cell[248673, 9427, 41, 0, 70, 41, 0, "StyleData", "RefSep", "Presentation"],
Cell[248717, 9429, 37, 0, 70, 37, 0, "StyleData", "RefSep", "Printout"],
Cell[248757, 9431, 50, 0, 70, 50, 0, "StyleData", "RefSep", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[248844, 9436, 398, 10, 40, 32, 0, "StyleData", "RefReturnLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[249245, 9448, 49, 0, 70, 49, 0, "StyleData", "RefReturnLink", \
"NumberedHeads"],
Cell[249297, 9450, 48, 0, 70, 48, 0, "StyleData", "RefReturnLink", \
"Presentation"],
Cell[249348, 9452, 71, 1, 70, 44, 0, "StyleData", "RefReturnLink", \
"Printout"],
Cell[249422, 9455, 84, 1, 70, 57, 0, "StyleData", "RefReturnLink", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[249543, 9461, 299, 8, 39, 35, 0, "StyleData", "RefReturnPointer", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[249845, 9471, 52, 0, 70, 52, 0, "StyleData", "RefReturnPointer", \
"NumberedHeads"],
Cell[249900, 9473, 51, 0, 70, 51, 0, "StyleData", "RefReturnPointer", \
"Presentation"],
Cell[249954, 9475, 74, 1, 70, 47, 0, "StyleData", "RefReturnPointer", \
"Printout"],
Cell[250031, 9478, 87, 1, 70, 60, 0, "StyleData", "RefReturnPointer", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[250155, 9484, 397, 11, 28, 38, 0, "StyleData", "ReferenceSourceLink", \
"All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[250555, 9497, 55, 0, 28, 55, 0, "StyleData", "ReferenceSourceLink", \
"NumberedHeads"],
Cell[250613, 9499, 54, 0, 28, 54, 0, "StyleData", "ReferenceSourceLink", \
"Presentation"],
Cell[250670, 9501, 77, 1, 28, 50, 0, "StyleData", "ReferenceSourceLink", \
"Printout"],
Cell[250750, 9504, 90, 1, 28, 63, 0, "StyleData", "ReferenceSourceLink", \
"NumberedHeadsPrintout"]
}, Closed]],
Cell[250855, 9508, 63, 1, 40, 37, 0, "StyleData", "ReferenceSourceURL", "All",
  
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[250943, 9513, 328, 9, 40, 27, 0, "StyleData", "Citation", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[251274, 9524, 44, 0, 70, 44, 0, "StyleData", "Citation", \
"NumberedHeads"],
Cell[251321, 9526, 43, 0, 70, 43, 0, "StyleData", "Citation", \
"Presentation"],
Cell[251367, 9528, 66, 1, 70, 39, 0, "StyleData", "Citation", "Printout"],
Cell[251436, 9531, 79, 1, 70, 52, 0, "StyleData", "Citation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[251552, 9537, 245, 7, 40, 25, 0, "StyleData", "RefKey", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[251800, 9546, 42, 0, 70, 42, 0, "StyleData", "RefKey", "NumberedHeads"],
Cell[251845, 9548, 41, 0, 70, 41, 0, "StyleData", "RefKey", "Presentation"],
Cell[251889, 9550, 64, 1, 70, 37, 0, "StyleData", "RefKey", "Printout"],
Cell[251956, 9553, 77, 1, 70, 50, 0, "StyleData", "RefKey", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[252070, 9559, 71, 1, 34, "Subsubsection"],
Cell[252144, 9562, 83, 1, 70, "ReferenceTemplate"],
Cell[252230, 9565, 86, 1, 70, "ReferenceTemplate"],
Cell[252319, 9568, 86, 1, 70, "ReferenceTemplate"],
Cell[252408, 9571, 82, 1, 70, "ReferenceTemplate"],
Cell[252493, 9574, 85, 1, 70, "ReferenceTemplate"],
Cell[252581, 9577, 84, 1, 70, "ReferenceTemplate"],
Cell[252668, 9580, 41, 0, 70, "ReferenceTemplate"],
Cell[252712, 9582, 49, 0, 70, "ReferenceTemplate"],
Cell[252764, 9584, 49, 0, 70, "ReferenceTemplate"],
Cell[252816, 9586, 49, 0, 70, "ReferenceTemplate"],
Cell[252868, 9588, 49, 0, 70, "ReferenceTemplate"],
Cell[252920, 9590, 56, 0, 70, "ReferenceTemplate"],
Cell[252979, 9592, 56, 0, 70, "ReferenceTemplate"],

Cell[CellGroupData[{
Cell[253060, 9596, 45, 0, 70, "Subsubsubsection"],
Cell[253108, 9598, 191, 4, 70, "ReferenceTemplate"],
Cell[253302, 9604, 152, 3, 70, "ReferenceTemplate"],
Cell[253457, 9609, 177, 3, 70, "ReferenceTemplate"],
Cell[253637, 9614, 139, 3, 70, "ReferenceTemplate"],
Cell[253779, 9619, 172, 3, 70, "ReferenceTemplate"],
Cell[253954, 9624, 136, 3, 70, "ReferenceTemplate"],
Cell[254093, 9629, 159, 3, 70, "ReferenceTemplate"],
Cell[254255, 9634, 123, 3, 70, "ReferenceTemplate"],
Cell[254381, 9639, 185, 4, 70, "ReferenceTemplate"],
Cell[254569, 9645, 146, 3, 70, "ReferenceTemplate"],
Cell[254718, 9650, 171, 3, 70, "ReferenceTemplate"],
Cell[254892, 9655, 133, 3, 70, "ReferenceTemplate"],
Cell[255028, 9660, 166, 3, 70, "ReferenceTemplate"],
Cell[255197, 9665, 130, 3, 70, "ReferenceTemplate"],
Cell[255330, 9670, 153, 3, 70, "ReferenceTemplate"],
Cell[255486, 9675, 117, 3, 70, "ReferenceTemplate"],
Cell[255606, 9680, 176, 4, 70, "ReferenceTemplate"],
Cell[255785, 9686, 137, 3, 70, "ReferenceTemplate"],
Cell[255925, 9691, 162, 3, 70, "ReferenceTemplate"],
Cell[256090, 9696, 124, 3, 70, "ReferenceTemplate"],
Cell[256217, 9701, 157, 3, 70, "ReferenceTemplate"],
Cell[256377, 9706, 121, 3, 70, "ReferenceTemplate"],
Cell[256501, 9711, 144, 3, 70, "ReferenceTemplate"],
Cell[256648, 9716, 106, 2, 70, "ReferenceTemplate"],
Cell[256757, 9720, 146, 3, 70, "Text"],
Cell[256906, 9725, 152, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[257095, 9733, 45, 0, 70, "Subsubsubsection"],
Cell[257143, 9735, 99, 2, 70, "Text"],
Cell[257245, 9739, 144, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[257426, 9747, 48, 0, 70, "Subsubsubsection"],
Cell[257477, 9749, 138, 3, 70, "ReferenceTemplate"],
Cell[257618, 9754, 99, 2, 70, "ReferenceTemplate"],
Cell[257720, 9758, 117, 3, 70, "ReferenceTemplate"],
Cell[257840, 9763, 143, 3, 70, "Text"],
Cell[257986, 9768, 99, 2, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[258122, 9775, 44, 0, 70, "Subsubsubsection"],
Cell[258169, 9777, 168, 3, 70, "ReferenceTemplate"],
Cell[258340, 9782, 133, 3, 70, "ReferenceTemplate"],
Cell[258476, 9787, 148, 3, 70, "Text"],
Cell[258627, 9792, 168, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[258832, 9800, 54, 0, 70, "Subsubsubsection"],
Cell[258889, 9802, 105, 3, 70, "Text"],
Cell[258997, 9807, 125, 3, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[259159, 9815, 51, 0, 70, "Subsubsubsection"],
Cell[259213, 9817, 107, 3, 70, "Text"],
Cell[259323, 9822, 105, 2, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[259465, 9829, 46, 0, 70, "Subsubsubsection"],
Cell[259514, 9831, 103, 3, 70, "Text"],
Cell[259620, 9836, 87, 1, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[259744, 9842, 52, 0, 70, "Subsubsubsection"],
Cell[259799, 9844, 127, 3, 70, "Text"],
Cell[259929, 9849, 58, 0, 70, "ReferenceTemplate"]
}, Closed]],

Cell[CellGroupData[{
Cell[260024, 9854, 42, 0, 70, "Subsubsubsection"],
Cell[260069, 9856, 97, 2, 70, "Text"],
Cell[260169, 9860, 44, 0, 70, "ReferenceTemplate"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[260262, 9866, 75, 1, 34, "Subsubsection"],
Cell[260340, 9869, 98, 3, 70, 27, 0, "StyleData", "RefTitle", "All",
  StyleMenuListing->None],
Cell[260441, 9874, 73, 2, 70, 26, 0, "StyleData", "RefType", "All",
  StyleMenuListing->None],
Cell[260517, 9878, 51, 1, 70, 25, 0, "StyleData", "RefURL", "All",
  StyleMenuListing->None],
Cell[260571, 9881, 61, 1, 70, 35, 0, "StyleData", "RefRetrievalDate", "All",
  StyleMenuListing->None],
Cell[260635, 9884, 64, 1, 70, 38, 0, "StyleData", "RefSourceOfAbstract", \
"All",
  StyleMenuListing->None],
Cell[260702, 9887, 63, 1, 70, 37, 0, "StyleData", "RefInsertedBibText", "All",
  
  StyleMenuListing->None],
Cell[260768, 9890, 52, 1, 70, 26, 0, "StyleData", "RefNote", "All",
  StyleMenuListing->None],
Cell[260823, 9893, 132, 3, 70, 34, 0, "StyleData", "RefReviewVolume", "All",
  StyleMenuListing->None],
Cell[260958, 9898, 60, 1, 70, 34, 0, "StyleData", "RefReviewNumber", "All",
  StyleMenuListing->None],
Cell[261021, 9901, 56, 1, 70, 30, 0, "StyleData", "RefDatabase", "All",
  StyleMenuListing->None],
Cell[261080, 9904, 54, 1, 70, 28, 0, "StyleData", "RefVolume", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[261171, 9910, 73, 1, 34, "Subsubsection"],
Cell[261247, 9913, 153, 4, 70, 31, 0, "StyleData", "RefBookTitle", "All",
  StyleMenuListing->None],
Cell[261403, 9919, 60, 1, 70, 34, 0, "StyleData", "RefBookSubTitle", "All",
  StyleMenuListing->None],
Cell[261466, 9922, 63, 1, 70, 37, 0, "StyleData", "RefBookSubsubTitle", "All",
  
  StyleMenuListing->None],
Cell[261532, 9925, 59, 1, 70, 33, 0, "StyleData", "RefBookEdition", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[261628, 9931, 76, 1, 34, "Subsubsection"],
Cell[261707, 9934, 156, 4, 70, 34, 0, "StyleData", "RefJournalTitle", "All",
  StyleMenuListing->None],
Cell[261866, 9940, 137, 3, 70, 35, 0, "StyleData", "RefJournalVolume", "All",
  StyleMenuListing->None],
Cell[262006, 9945, 61, 1, 70, 35, 0, "StyleData", "RefJournalNumber", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[262104, 9951, 78, 1, 34, "Subsubsection"],
Cell[262185, 9954, 57, 1, 70, 31, 0, "StyleData", "RefPublisher", "All",
  StyleMenuListing->None],
Cell[262245, 9957, 55, 1, 70, 29, 0, "StyleData", "RefAddress", "All",
  StyleMenuListing->None],
Cell[262303, 9960, 52, 1, 70, 26, 0, "StyleData", "RefCity", "All",
  StyleMenuListing->None],
Cell[262358, 9963, 53, 1, 70, 27, 0, "StyleData", "RefState", "All",
  StyleMenuListing->None],
Cell[262414, 9966, 55, 1, 70, 29, 0, "StyleData", "RefCountry", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[262506, 9972, 75, 1, 34, "Subsubsection"],
Cell[262584, 9975, 59, 1, 70, 33, 0, "StyleData", "RefAuthorGroup", "All",
  StyleMenuListing->None],
Cell[262646, 9978, 56, 1, 70, 30, 0, "StyleData", "RefAuthorFN", "All",
  StyleMenuListing->None],
Cell[262705, 9981, 56, 1, 70, 30, 0, "StyleData", "RefAuthorLN", "All",
  StyleMenuListing->None],
Cell[262764, 9984, 56, 1, 70, 30, 0, "StyleData", "RefAuthorMN", "All",
  StyleMenuListing->None],
Cell[262823, 9987, 59, 1, 70, 33, 0, "StyleData", "RefInstitution", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[262919, 9993, 75, 1, 34, "Subsubsection"],
Cell[262997, 9996, 59, 1, 70, 33, 0, "StyleData", "RefEditorGroup", "All",
  StyleMenuListing->None],
Cell[263059, 9999, 56, 1, 70, 30, 0, "StyleData", "RefEditorFN", "All",
  StyleMenuListing->None],
Cell[263118, 10002, 56, 1, 70, 30, 0, "StyleData", "RefEditorMN", "All",
  StyleMenuListing->None],
Cell[263177, 10005, 56, 1, 70, 30, 0, "StyleData", "RefEditorLN", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[263270, 10011, 75, 1, 34, "Subsubsection"],
Cell[263348, 10014, 54, 1, 70, 28, 0, "StyleData", "RefSchool", "All",
  StyleMenuListing->None],
Cell[263405, 10017, 131, 3, 70, 32, 0, "StyleData", "RefSchoolDept", "All",
  StyleMenuListing->None],
Cell[263539, 10022, 61, 1, 70, 35, 0, "StyleData", "RefSchoolAddress", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[263637, 10028, 85, 1, 34, "Subsubsection"],
Cell[263725, 10031, 51, 1, 70, 25, 0, "StyleData", "RefDay", "All",
  StyleMenuListing->None],
Cell[263779, 10034, 53, 1, 70, 27, 0, "StyleData", "RefMonth", "All",
  StyleMenuListing->None],
Cell[263835, 10037, 52, 1, 70, 26, 0, "StyleData", "RefYear", "All",
  StyleMenuListing->None],
Cell[263890, 10040, 65, 1, 70, 39, 0, "StyleData", "RefPublicationStatus", \
"All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[263992, 10046, 112, 2, 34, "Subsubsection"],
Cell[264107, 10050, 57, 1, 70, 31, 0, "StyleData", "RefPageRange", "All",
  StyleMenuListing->None],
Cell[264167, 10053, 57, 1, 70, 31, 0, "StyleData", "RefFirstPage", "All",
  StyleMenuListing->None],
Cell[264227, 10056, 56, 1, 70, 30, 0, "StyleData", "RefLastPage", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[264320, 10062, 94, 1, 34, "Subsubsection"],
Cell[264417, 10065, 64, 1, 70, 38, 0, "StyleData", "RefDiscretePageList", \
"All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[264518, 10071, 66, 1, 34, "Subsubsection"],
Cell[264587, 10074, 56, 1, 70, 30, 0, "StyleData", "RefNoteText", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[264680, 10080, 72, 1, 34, "Subsubsection"],
Cell[264755, 10083, 60, 1, 70, 34, 0, "StyleData", "RefReportNumber", "All",
  StyleMenuListing->None],
Cell[264818, 10086, 59, 1, 70, 33, 0, "StyleData", "RefSubmittedby", "All",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[264926, 10093, 53, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[265004, 10098, 552, 15, 70, 31, 0, "StyleData", "IndexSection", "All",
  CounterAssignments->{{"IndexEntry", 0}},
  StyleMenuListing->None],
Cell[265559, 10115, 48, 0, 70, 48, 0, "StyleData", "IndexSection", \
"NumberedHeads"],
Cell[265610, 10117, 168, 4, 70, 47, 0, "StyleData", "IndexSection", \
"Presentation"],
Cell[265781, 10123, 120, 3, 70, 43, 0, "StyleData", "IndexSection", \
"Printout",
  StyleMenuListing->None],
Cell[265904, 10128, 133, 3, 70, 56, 0, "StyleData", "IndexSection", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[266074, 10136, 194, 6, 70, 29, 0, "StyleData", "IndexEntry", "All",
  StyleMenuListing->None],
Cell[266271, 10144, 46, 0, 70, 46, 0, "StyleData", "IndexEntry", \
"NumberedHeads"],
Cell[266320, 10146, 120, 3, 70, 45, 0, "StyleData", "IndexEntry", \
"Presentation"],
Cell[266443, 10151, 115, 3, 70, 41, 0, "StyleData", "IndexEntry", "Printout",
  StyleMenuListing->None],
Cell[266561, 10156, 128, 3, 70, 54, 0, "StyleData", "IndexEntry", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[266726, 10164, 197, 6, 70, 32, 0, "StyleData", "IndexSubentry", "All",
  StyleMenuListing->None],
Cell[266926, 10172, 49, 0, 70, 49, 0, "StyleData", "IndexSubentry", \
"NumberedHeads"],
Cell[266978, 10174, 123, 3, 70, 48, 0, "StyleData", "IndexSubentry", \
"Presentation"],
Cell[267104, 10179, 119, 3, 70, 44, 0, "StyleData", "IndexSubentry", \
"Printout",
  StyleMenuListing->None],
Cell[267226, 10184, 132, 3, 70, 57, 0, "StyleData", "IndexSubentry", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[267395, 10192, 200, 6, 70, 35, 0, "StyleData", "IndexSubsubentry", "All",
  
  StyleMenuListing->None],
Cell[267598, 10200, 52, 0, 70, 52, 0, "StyleData", "IndexSubsubentry", \
"NumberedHeads"],
Cell[267653, 10202, 126, 3, 70, 51, 0, "StyleData", "IndexSubsubentry", \
"Presentation"],
Cell[267782, 10207, 122, 3, 70, 47, 0, "StyleData", "IndexSubsubentry", \
"Printout",
  StyleMenuListing->None],
Cell[267907, 10212, 135, 3, 70, 60, 0, "StyleData", "IndexSubsubentry", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[268079, 10220, 215, 7, 70, 28, 0, "StyleData", "IndexNote", "All",
  StyleMenuListing->None],
Cell[268297, 10229, 45, 0, 70, 45, 0, "StyleData", "IndexNote", \
"NumberedHeads"],
Cell[268345, 10231, 95, 2, 70, 44, 0, "StyleData", "IndexNote", \
"Presentation"],
Cell[268443, 10235, 114, 3, 70, 40, 0, "StyleData", "IndexNote", "Printout",
  StyleMenuListing->None],
Cell[268560, 10240, 127, 3, 70, 53, 0, "StyleData", "IndexNote", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[268724, 10248, 56, 1, 70, 30, 0, "StyleData", "IndexSpacer", "All",
  StyleMenuListing->None],
Cell[268783, 10251, 47, 0, 70, 47, 0, "StyleData", "IndexSpacer", \
"NumberedHeads"],
Cell[268833, 10253, 46, 0, 70, 46, 0, "StyleData", "IndexSpacer", \
"Presentation"],
Cell[268882, 10255, 42, 0, 70, 42, 0, "StyleData", "IndexSpacer", \
"Printout"],
Cell[268927, 10257, 42, 0, 70, 42, 0, "StyleData", "IndexSpacer", "Printout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[269030, 10264, 58, 1, 34, "Section"],

Cell[CellGroupData[{
Cell[269113, 10269, 38, 0, 39, "Subsection"],

Cell[CellGroupData[{
Cell[269176, 10273, 61, 1, 40, 35, 0, "StyleData", "FrontMatterTitle", "All",
  StyleMenuListing->None],
Cell[269240, 10276, 52, 0, 70, 52, 0, "StyleData", "FrontMatterTitle", \
"NumberedHeads"],
Cell[269295, 10278, 51, 0, 70, 51, 0, "StyleData", "FrontMatterTitle", \
"Presentation"],
Cell[269349, 10280, 47, 0, 70, 47, 0, "StyleData", "FrontMatterTitle", \
"Printout"],
Cell[269399, 10282, 60, 0, 70, 60, 0, "StyleData", "FrontMatterTitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[269496, 10287, 43, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[269564, 10291, 54, 1, 70, 28, 0, "StyleData", "HalfTitle", "All",
  StyleMenuListing->None],
Cell[269621, 10294, 45, 0, 70, 45, 0, "StyleData", "HalfTitle", \
"NumberedHeads"],
Cell[269669, 10296, 44, 0, 70, 44, 0, "StyleData", "HalfTitle", \
"Presentation"],
Cell[269716, 10298, 40, 0, 70, 40, 0, "StyleData", "HalfTitle", "Printout"],
Cell[269759, 10300, 53, 0, 70, 53, 0, "StyleData", "HalfTitle", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[269861, 10306, 48, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[269934, 10310, 51, 1, 70, 25, 0, "StyleData", "Series", "All",
  StyleMenuListing->None],
Cell[269988, 10313, 42, 0, 70, 42, 0, "StyleData", "Series", \
"NumberedHeads"],
Cell[270033, 10315, 41, 0, 70, 41, 0, "StyleData", "Series", "Presentation"],
Cell[270077, 10317, 37, 0, 70, 37, 0, "StyleData", "Series", "Printout"],
Cell[270117, 10319, 50, 0, 70, 50, 0, "StyleData", "Series", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[270204, 10324, 57, 1, 70, 31, 0, "StyleData", "SeriesVolume", "All",
  StyleMenuListing->None],
Cell[270264, 10327, 48, 0, 70, 48, 0, "StyleData", "SeriesVolume", \
"NumberedHeads"],
Cell[270315, 10329, 47, 0, 70, 47, 0, "StyleData", "SeriesVolume", \
"Presentation"],
Cell[270365, 10331, 43, 0, 70, 43, 0, "StyleData", "SeriesVolume", \
"Printout"],
Cell[270411, 10333, 56, 0, 70, 56, 0, "StyleData", "SeriesVolume", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[270504, 10338, 57, 1, 70, 31, 0, "StyleData", "SeriesEditor", "All",
  StyleMenuListing->None],
Cell[270564, 10341, 48, 0, 70, 48, 0, "StyleData", "SeriesEditor", \
"NumberedHeads"],
Cell[270615, 10343, 47, 0, 70, 47, 0, "StyleData", "SeriesEditor", \
"Presentation"],
Cell[270665, 10345, 43, 0, 70, 43, 0, "StyleData", "SeriesEditor", \
"Printout"],
Cell[270711, 10347, 56, 0, 70, 56, 0, "StyleData", "SeriesEditor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[270816, 10353, 51, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[270892, 10357, 54, 1, 70, 28, 0, "StyleData", "Symposium", "All",
  StyleMenuListing->None],
Cell[270949, 10360, 45, 0, 70, 45, 0, "StyleData", "Symposium", \
"NumberedHeads"],
Cell[270997, 10362, 44, 0, 70, 44, 0, "StyleData", "Symposium", \
"Presentation"],
Cell[271044, 10364, 40, 0, 70, 40, 0, "StyleData", "Symposium", "Printout"],
Cell[271087, 10366, 53, 0, 70, 53, 0, "StyleData", "Symposium", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[271177, 10371, 58, 1, 70, 32, 0, "StyleData", "SymposiumCity", "All",
  StyleMenuListing->None],
Cell[271238, 10374, 49, 0, 70, 49, 0, "StyleData", "SymposiumCity", \
"NumberedHeads"],
Cell[271290, 10376, 48, 0, 70, 48, 0, "StyleData", "SymposiumCity", \
"Presentation"],
Cell[271341, 10378, 44, 0, 70, 44, 0, "StyleData", "SymposiumCity", \
"Printout"],
Cell[271388, 10380, 57, 0, 70, 57, 0, "StyleData", "SymposiumCity", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[271482, 10385, 58, 1, 70, 32, 0, "StyleData", "SymposiumDate", "All",
  StyleMenuListing->None],
Cell[271543, 10388, 49, 0, 70, 49, 0, "StyleData", "SymposiumDate", \
"NumberedHeads"],
Cell[271595, 10390, 48, 0, 70, 48, 0, "StyleData", "SymposiumDate", \
"Presentation"],
Cell[271646, 10392, 44, 0, 70, 44, 0, "StyleData", "SymposiumDate", \
"Printout"],
Cell[271693, 10394, 57, 0, 70, 57, 0, "StyleData", "SymposiumDate", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[271787, 10399, 60, 1, 70, 34, 0, "StyleData", "SymposiumEditor", "All",
  StyleMenuListing->None],
Cell[271850, 10402, 51, 0, 70, 51, 0, "StyleData", "SymposiumEditor", \
"NumberedHeads"],
Cell[271904, 10404, 50, 0, 70, 50, 0, "StyleData", "SymposiumEditor", \
"Presentation"],
Cell[271957, 10406, 46, 0, 70, 46, 0, "StyleData", "SymposiumEditor", \
"Printout"],
Cell[272006, 10408, 59, 0, 70, 59, 0, "StyleData", "SymposiumEditor", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[272102, 10413, 61, 1, 70, 35, 0, "StyleData", "SymposiumSponsor", "All",
  StyleMenuListing->None],
Cell[272166, 10416, 52, 0, 70, 52, 0, "StyleData", "SymposiumSponsor", \
"NumberedHeads"],
Cell[272221, 10418, 51, 0, 70, 51, 0, "StyleData", "SymposiumSponsor", \
"Presentation"],
Cell[272275, 10420, 47, 0, 70, 47, 0, "StyleData", "SymposiumSponsor", \
"Printout"],
Cell[272325, 10422, 60, 0, 70, 60, 0, "StyleData", "SymposiumSponsor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[272434, 10428, 60, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[272519, 10432, 72, 1, 70, 46, 0, "StyleData", \
"AuthorsPreviousPublications", "All",
  StyleMenuListing->None],
Cell[272594, 10435, 63, 0, 70, 63, 0, "StyleData", \
"AuthorsPreviousPublications", "NumberedHeads"],
Cell[272660, 10437, 62, 0, 70, 62, 0, "StyleData", \
"AuthorsPreviousPublications", "Presentation"],
Cell[272725, 10439, 58, 0, 70, 58, 0, "StyleData", \
"AuthorsPreviousPublications", "Printout"],
Cell[272786, 10441, 71, 0, 70, 71, 0, "StyleData", \
"AuthorsPreviousPublications", "NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[272906, 10447, 40, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[272971, 10451, 39, 0, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[273035, 10455, 60, 1, 70, 34, 0, "StyleData", "EditorFirstName", "All",
  StyleMenuListing->None],
Cell[273098, 10458, 51, 0, 70, 51, 0, "StyleData", "EditorFirstName", \
"NumberedHeads"],
Cell[273152, 10460, 50, 0, 70, 50, 0, "StyleData", "EditorFirstName", \
"Presentation"],
Cell[273205, 10462, 46, 0, 70, 46, 0, "StyleData", "EditorFirstName", \
"Printout"],
Cell[273254, 10464, 59, 0, 70, 59, 0, "StyleData", "EditorFirstName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[273350, 10469, 61, 1, 70, 35, 0, "StyleData", "EditorMiddleName", "All",
  StyleMenuListing->None],
Cell[273414, 10472, 52, 0, 70, 52, 0, "StyleData", "EditorMiddleName", \
"NumberedHeads"],
Cell[273469, 10474, 51, 0, 70, 51, 0, "StyleData", "EditorMiddleName", \
"Presentation"],
Cell[273523, 10476, 47, 0, 70, 47, 0, "StyleData", "EditorMiddleName", \
"Printout"],
Cell[273573, 10478, 60, 0, 70, 60, 0, "StyleData", "EditorMiddleName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[273670, 10483, 59, 1, 70, 33, 0, "StyleData", "EditorLastName", "All",
  StyleMenuListing->None],
Cell[273732, 10486, 50, 0, 70, 50, 0, "StyleData", "EditorLastName", \
"NumberedHeads"],
Cell[273785, 10488, 49, 0, 70, 49, 0, "StyleData", "EditorLastName", \
"Presentation"],
Cell[273837, 10490, 45, 0, 70, 45, 0, "StyleData", "EditorLastName", \
"Printout"],
Cell[273885, 10492, 58, 0, 70, 58, 0, "StyleData", "EditorLastName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[273980, 10497, 61, 1, 70, 35, 0, "StyleData", "EditorNameSuffix", "All",
  StyleMenuListing->None],
Cell[274044, 10500, 52, 0, 70, 52, 0, "StyleData", "EditorNameSuffix", \
"NumberedHeads"],
Cell[274099, 10502, 51, 0, 70, 51, 0, "StyleData", "EditorNameSuffix", \
"Presentation"],
Cell[274153, 10504, 47, 0, 70, 47, 0, "StyleData", "EditorNameSuffix", \
"Printout"],
Cell[274203, 10506, 60, 0, 70, 60, 0, "StyleData", "EditorNameSuffix", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[274300, 10511, 62, 1, 70, 36, 0, "StyleData", "EditorInstitution", "All",
  
  StyleMenuListing->None],
Cell[274365, 10514, 53, 0, 70, 53, 0, "StyleData", "EditorInstitution", \
"NumberedHeads"],
Cell[274421, 10516, 52, 0, 70, 52, 0, "StyleData", "EditorInstitution", \
"Presentation"],
Cell[274476, 10518, 48, 0, 70, 48, 0, "StyleData", "EditorInstitution", \
"Printout"],
Cell[274527, 10520, 61, 0, 70, 61, 0, "StyleData", "EditorInstitution", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[274625, 10525, 65, 1, 70, 39, 0, "StyleData", "EditorAltInstitution", \
"All",
  StyleMenuListing->None],
Cell[274693, 10528, 56, 0, 70, 56, 0, "StyleData", "EditorAltInstitution", \
"NumberedHeads"],
Cell[274752, 10530, 55, 0, 70, 55, 0, "StyleData", "EditorAltInstitution", \
"Presentation"],
Cell[274810, 10532, 51, 0, 70, 51, 0, "StyleData", "EditorAltInstitution", \
"Printout"],
Cell[274864, 10534, 64, 0, 70, 64, 0, "StyleData", "EditorAltInstitution", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[274977, 10540, 43, 0, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[275045, 10544, 64, 1, 70, 38, 0, "StyleData", "TranslatorFirstName", \
"All",
  StyleMenuListing->None],
Cell[275112, 10547, 55, 0, 70, 55, 0, "StyleData", "TranslatorFirstName", \
"NumberedHeads"],
Cell[275170, 10549, 54, 0, 70, 54, 0, "StyleData", "TranslatorFirstName", \
"Presentation"],
Cell[275227, 10551, 50, 0, 70, 50, 0, "StyleData", "TranslatorFirstName", \
"Printout"],
Cell[275280, 10553, 63, 0, 70, 63, 0, "StyleData", "TranslatorFirstName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[275380, 10558, 65, 1, 70, 39, 0, "StyleData", "TranslatorMiddleName", \
"All",
  StyleMenuListing->None],
Cell[275448, 10561, 56, 0, 70, 56, 0, "StyleData", "TranslatorMiddleName", \
"NumberedHeads"],
Cell[275507, 10563, 55, 0, 70, 55, 0, "StyleData", "TranslatorMiddleName", \
"Presentation"],
Cell[275565, 10565, 51, 0, 70, 51, 0, "StyleData", "TranslatorMiddleName", \
"Printout"],
Cell[275619, 10567, 64, 0, 70, 64, 0, "StyleData", "TranslatorMiddleName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[275720, 10572, 63, 1, 70, 37, 0, "StyleData", "TranslatorLastName", \
"All",
  StyleMenuListing->None],
Cell[275786, 10575, 54, 0, 70, 54, 0, "StyleData", "TranslatorLastName", \
"NumberedHeads"],
Cell[275843, 10577, 53, 0, 70, 53, 0, "StyleData", "TranslatorLastName", \
"Presentation"],
Cell[275899, 10579, 49, 0, 70, 49, 0, "StyleData", "TranslatorLastName", \
"Printout"],
Cell[275951, 10581, 62, 0, 70, 62, 0, "StyleData", "TranslatorLastName", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[276050, 10586, 65, 1, 70, 39, 0, "StyleData", "TranslatorNameSuffix", \
"All",
  StyleMenuListing->None],
Cell[276118, 10589, 56, 0, 70, 56, 0, "StyleData", "TranslatorNameSuffix", \
"NumberedHeads"],
Cell[276177, 10591, 55, 0, 70, 55, 0, "StyleData", "TranslatorNameSuffix", \
"Presentation"],
Cell[276235, 10593, 51, 0, 70, 51, 0, "StyleData", "TranslatorNameSuffix", \
"Printout"],
Cell[276289, 10595, 64, 0, 70, 64, 0, "StyleData", "TranslatorNameSuffix", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[276390, 10600, 66, 1, 70, 40, 0, "StyleData", "TranslatorInstitution", \
"All",
  StyleMenuListing->None],
Cell[276459, 10603, 57, 0, 70, 57, 0, "StyleData", "TranslatorInstitution", \
"NumberedHeads"],
Cell[276519, 10605, 56, 0, 70, 56, 0, "StyleData", "TranslatorInstitution", \
"Presentation"],
Cell[276578, 10607, 52, 0, 70, 52, 0, "StyleData", "TranslatorInstitution", \
"Printout"],
Cell[276633, 10609, 65, 0, 70, 65, 0, "StyleData", "TranslatorInstitution", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[276735, 10614, 69, 1, 70, 43, 0, "StyleData", \
"TranslatorAltInstitution", "All",
  StyleMenuListing->None],
Cell[276807, 10617, 60, 0, 70, 60, 0, "StyleData", \
"TranslatorAltInstitution", "NumberedHeads"],
Cell[276870, 10619, 59, 0, 70, 59, 0, "StyleData", \
"TranslatorAltInstitution", "Presentation"],
Cell[276932, 10621, 55, 0, 70, 55, 0, "StyleData", \
"TranslatorAltInstitution", "Printout"],
Cell[276990, 10623, 68, 0, 70, 68, 0, "StyleData", \
"TranslatorAltInstitution", "NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[277107, 10629, 56, 0, 70, "Subsubsubsection"],

Cell[CellGroupData[{
Cell[277188, 10633, 54, 1, 70, 28, 0, "StyleData", "Publisher", "All",
  StyleMenuListing->None],
Cell[277245, 10636, 45, 0, 70, 45, 0, "StyleData", "Publisher", \
"NumberedHeads"],
Cell[277293, 10638, 44, 0, 70, 44, 0, "StyleData", "Publisher", \
"Presentation"],
Cell[277340, 10640, 40, 0, 70, 40, 0, "StyleData", "Publisher", "Printout"],
Cell[277383, 10642, 53, 0, 70, 53, 0, "StyleData", "Publisher", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[277473, 10647, 60, 1, 70, 34, 0, "StyleData", "PublisherCities", "All",
  StyleMenuListing->None],
Cell[277536, 10650, 51, 0, 70, 51, 0, "StyleData", "PublisherCities", \
"NumberedHeads"],
Cell[277590, 10652, 50, 0, 70, 50, 0, "StyleData", "PublisherCities", \
"Presentation"],
Cell[277643, 10654, 46, 0, 70, 46, 0, "StyleData", "PublisherCities", \
"Printout"],
Cell[277692, 10656, 59, 0, 70, 59, 0, "StyleData", "PublisherCities", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[277788, 10661, 57, 1, 70, 31, 0, "StyleData", "PublisherURL", "All",
  StyleMenuListing->None],
Cell[277848, 10664, 48, 0, 70, 48, 0, "StyleData", "PublisherURL", \
"NumberedHeads"],
Cell[277899, 10666, 47, 0, 70, 47, 0, "StyleData", "PublisherURL", \
"Presentation"],
Cell[277949, 10668, 43, 0, 70, 43, 0, "StyleData", "PublisherURL", \
"Printout"],
Cell[277995, 10670, 56, 0, 70, 56, 0, "StyleData", "PublisherURL", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[278088, 10675, 60, 1, 70, 34, 0, "StyleData", "PublicationYear", "All",
  StyleMenuListing->None],
Cell[278151, 10678, 51, 0, 70, 51, 0, "StyleData", "PublicationYear", \
"NumberedHeads"],
Cell[278205, 10680, 50, 0, 70, 50, 0, "StyleData", "PublicationYear", \
"Presentation"],
Cell[278258, 10682, 46, 0, 70, 46, 0, "StyleData", "PublicationYear", \
"Printout"],
Cell[278307, 10684, 59, 0, 70, 59, 0, "StyleData", "PublicationYear", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[278427, 10691, 44, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[278496, 10695, 60, 1, 70, 34, 0, "StyleData", "CopyrightNotice", "All",
  StyleMenuListing->None],
Cell[278559, 10698, 51, 0, 70, 51, 0, "StyleData", "CopyrightNotice", \
"NumberedHeads"],
Cell[278613, 10700, 50, 0, 70, 50, 0, "StyleData", "CopyrightNotice", \
"Presentation"],
Cell[278666, 10702, 46, 0, 70, 46, 0, "StyleData", "CopyrightNotice", \
"Printout"],
Cell[278715, 10704, 59, 0, 70, 59, 0, "StyleData", "CopyrightNotice", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[278811, 10709, 62, 1, 70, 36, 0, "StyleData", "PublishingHistory", "All",
  
  StyleMenuListing->None],
Cell[278876, 10712, 53, 0, 70, 53, 0, "StyleData", "PublishingHistory", \
"NumberedHeads"],
Cell[278932, 10714, 52, 0, 70, 52, 0, "StyleData", "PublishingHistory", \
"Presentation"],
Cell[278987, 10716, 48, 0, 70, 48, 0, "StyleData", "PublishingHistory", \
"Printout"],
Cell[279038, 10718, 61, 0, 70, 61, 0, "StyleData", "PublishingHistory", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[279136, 10723, 64, 1, 70, 38, 0, "StyleData", "CountryWherePrinted", \
"All",
  StyleMenuListing->None],
Cell[279203, 10726, 55, 0, 70, 55, 0, "StyleData", "CountryWherePrinted", \
"NumberedHeads"],
Cell[279261, 10728, 54, 0, 70, 54, 0, "StyleData", "CountryWherePrinted", \
"Presentation"],
Cell[279318, 10730, 50, 0, 70, 50, 0, "StyleData", "CountryWherePrinted", \
"Printout"],
Cell[279371, 10732, 63, 0, 70, 63, 0, "StyleData", "CountryWherePrinted", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[279471, 10737, 61, 1, 70, 35, 0, "StyleData", "PublisherAddress", "All",
  StyleMenuListing->None],
Cell[279535, 10740, 52, 0, 70, 52, 0, "StyleData", "PublisherAddress", \
"NumberedHeads"],
Cell[279590, 10742, 51, 0, 70, 51, 0, "StyleData", "PublisherAddress", \
"Presentation"],
Cell[279644, 10744, 47, 0, 70, 47, 0, "StyleData", "PublisherAddress", \
"Printout"],
Cell[279694, 10746, 60, 0, 70, 60, 0, "StyleData", "PublisherAddress", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[279791, 10751, 76, 1, 70, 50, 0, "StyleData", \
"LibraryofCongressCIPDataSection", "All",
  StyleMenuListing->None],
Cell[279870, 10754, 67, 0, 70, 67, 0, "StyleData", \
"LibraryofCongressCIPDataSection", "NumberedHeads"],
Cell[279940, 10756, 66, 0, 70, 66, 0, "StyleData", \
"LibraryofCongressCIPDataSection", "Presentation"],
Cell[280009, 10758, 62, 0, 70, 62, 0, "StyleData", \
"LibraryofCongressCIPDataSection", "Printout"],
Cell[280074, 10760, 75, 0, 70, 75, 0, "StyleData", \
"LibraryofCongressCIPDataSection", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[280186, 10765, 69, 1, 70, 43, 0, "StyleData", \
"LibraryofCongressCIPData", "All",
  StyleMenuListing->None],
Cell[280258, 10768, 60, 0, 70, 60, 0, "StyleData", \
"LibraryofCongressCIPData", "NumberedHeads"],
Cell[280321, 10770, 59, 0, 70, 59, 0, "StyleData", \
"LibraryofCongressCIPData", "Presentation"],
Cell[280383, 10772, 55, 0, 70, 55, 0, "StyleData", \
"LibraryofCongressCIPData", "Printout"],
Cell[280441, 10774, 68, 0, 70, 68, 0, "StyleData", \
"LibraryofCongressCIPData", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[280546, 10779, 49, 1, 70, 23, 0, "StyleData", "ISBN", "All",
  StyleMenuListing->None],
Cell[280598, 10782, 40, 0, 70, 40, 0, "StyleData", "ISBN", "NumberedHeads"],
Cell[280641, 10784, 39, 0, 70, 39, 0, "StyleData", "ISBN", "Presentation"],
Cell[280683, 10786, 35, 0, 70, 35, 0, "StyleData", "ISBN", "Printout"],
Cell[280721, 10788, 48, 0, 70, 48, 0, "StyleData", "ISBN", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[280806, 10793, 60, 1, 70, 34, 0, "StyleData", "PrintingNumbers", "All",
  StyleMenuListing->None],
Cell[280869, 10796, 51, 0, 70, 51, 0, "StyleData", "PrintingNumbers", \
"NumberedHeads"],
Cell[280923, 10798, 50, 0, 70, 50, 0, "StyleData", "PrintingNumbers", \
"Presentation"],
Cell[280976, 10800, 46, 0, 70, 46, 0, "StyleData", "PrintingNumbers", \
"Printout"],
Cell[281025, 10802, 59, 0, 70, 59, 0, "StyleData", "PrintingNumbers", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[281133, 10808, 50, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[281208, 10812, 64, 1, 70, 38, 0, "StyleData", "FrontMatterEpigraph", \
"All",
  StyleMenuListing->None],
Cell[281275, 10815, 55, 0, 70, 55, 0, "StyleData", "FrontMatterEpigraph", \
"NumberedHeads"],
Cell[281333, 10817, 54, 0, 70, 54, 0, "StyleData", "FrontMatterEpigraph", \
"Presentation"],
Cell[281390, 10819, 50, 0, 70, 50, 0, "StyleData", "FrontMatterEpigraph", \
"Printout"],
Cell[281443, 10821, 63, 0, 70, 63, 0, "StyleData", "FrontMatterEpigraph", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[281543, 10826, 94, 2, 70, 44, 0, "StyleData", \
"FrontMatterEpigraphAuthor", "All",
  StyleMenuListing->None],
Cell[281640, 10830, 61, 0, 70, 61, 0, "StyleData", \
"FrontMatterEpigraphAuthor", "NumberedHeads"],
Cell[281704, 10832, 60, 0, 70, 60, 0, "StyleData", \
"FrontMatterEpigraphAuthor", "Presentation"],
Cell[281767, 10834, 56, 0, 70, 56, 0, "StyleData", \
"FrontMatterEpigraphAuthor", "Printout"],
Cell[281826, 10836, 69, 0, 70, 69, 0, "StyleData", \
"FrontMatterEpigraphAuthor", "NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[281932, 10841, 94, 2, 70, 44, 0, "StyleData", \
"FrontMatterEpigraphSource", "All",
  StyleMenuListing->None],
Cell[282029, 10845, 61, 0, 70, 61, 0, "StyleData", \
"FrontMatterEpigraphSource", "NumberedHeads"],
Cell[282093, 10847, 60, 0, 70, 60, 0, "StyleData", \
"FrontMatterEpigraphSource", "Presentation"],
Cell[282156, 10849, 56, 0, 70, 56, 0, "StyleData", \
"FrontMatterEpigraphSource", "Printout"],
Cell[282215, 10851, 69, 0, 70, 69, 0, "StyleData", \
"FrontMatterEpigraphSource", "NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],
Cell[282311, 10855, 79, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[282415, 10859, 37, 0, 31, "Subsubsection"],

Cell[CellGroupData[{
Cell[282477, 10863, 59, 1, 70, 33, 0, "StyleData", "PrefaceSection", "All",
  StyleMenuListing->None],
Cell[282539, 10866, 50, 0, 70, 50, 0, "StyleData", "PrefaceSection", \
"NumberedHeads"],
Cell[282592, 10868, 49, 0, 70, 49, 0, "StyleData", "PrefaceSection", \
"Presentation"],
Cell[282644, 10870, 45, 0, 70, 45, 0, "StyleData", "PrefaceSection", \
"Printout"],
Cell[282692, 10872, 58, 0, 70, 58, 0, "StyleData", "PrefaceSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[282787, 10877, 52, 1, 70, 26, 0, "StyleData", "Preface", "All",
  StyleMenuListing->None],
Cell[282842, 10880, 43, 0, 70, 43, 0, "StyleData", "Preface", \
"NumberedHeads"],
Cell[282888, 10882, 42, 0, 70, 42, 0, "StyleData", "Preface", \
"Presentation"],
Cell[282933, 10884, 38, 0, 70, 38, 0, "StyleData", "Preface", "Printout"],
Cell[282974, 10886, 51, 0, 70, 51, 0, "StyleData", "Preface", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[283062, 10891, 58, 1, 70, 32, 0, "StyleData", "PrefaceAuthor", "All",
  StyleMenuListing->None],
Cell[283123, 10894, 49, 0, 70, 49, 0, "StyleData", "PrefaceAuthor", \
"NumberedHeads"],
Cell[283175, 10896, 48, 0, 70, 48, 0, "StyleData", "PrefaceAuthor", \
"Presentation"],
Cell[283226, 10898, 44, 0, 70, 44, 0, "StyleData", "PrefaceAuthor", \
"Printout"],
Cell[283273, 10900, 57, 0, 70, 57, 0, "StyleData", "PrefaceAuthor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[283379, 10906, 38, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[283442, 10910, 53, 1, 70, 27, 0, "StyleData", "Foreword", "All",
  StyleMenuListing->None],
Cell[283498, 10913, 44, 0, 70, 44, 0, "StyleData", "Foreword", \
"NumberedHeads"],
Cell[283545, 10915, 43, 0, 70, 43, 0, "StyleData", "Foreword", \
"Presentation"],
Cell[283591, 10917, 39, 0, 70, 39, 0, "StyleData", "Foreword", "Printout"],
Cell[283633, 10919, 52, 0, 70, 52, 0, "StyleData", "Foreword", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[283722, 10924, 59, 1, 70, 33, 0, "StyleData", "ForewordAuthor", "All",
  StyleMenuListing->None],
Cell[283784, 10927, 50, 0, 70, 50, 0, "StyleData", "ForewordAuthor", \
"NumberedHeads"],
Cell[283837, 10929, 49, 0, 70, 49, 0, "StyleData", "ForewordAuthor", \
"Presentation"],
Cell[283889, 10931, 45, 0, 70, 45, 0, "StyleData", "ForewordAuthor", \
"Printout"],
Cell[283937, 10933, 58, 0, 70, 58, 0, "StyleData", "ForewordAuthor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[284056, 10940, 104, 3, 39, "Subsection"],

Cell[CellGroupData[{
Cell[284185, 10947, 359, 10, 63, 32, 0, "StyleData", "BookPartLabel", "All",
  CounterIncrements->"Part",
  CounterAssignments->{{"Chapter", 0}},
  StyleMenuListing->None],
Cell[284547, 10959, 49, 0, 70, 49, 0, "StyleData", "BookPartLabel", \
"NumberedHeads"],
Cell[284599, 10961, 101, 2, 70, 48, 0, "StyleData", "BookPartLabel", \
"Presentation"],
Cell[284703, 10965, 121, 3, 70, 44, 0, "StyleData", "BookPartLabel", \
"Printout",
  StyleMenuListing->None],
Cell[284827, 10970, 134, 3, 70, 57, 0, "StyleData", "BookPartLabel", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[284998, 10978, 159, 5, 60, 33, 0, "StyleData", "BookPartNumber", "All",
  StyleMenuListing->None],
Cell[285160, 10985, 50, 0, 70, 50, 0, "StyleData", "BookPartNumber", \
"NumberedHeads"],
Cell[285213, 10987, 102, 2, 70, 49, 0, "StyleData", "BookPartNumber", \
"Presentation"],
Cell[285318, 10991, 147, 4, 70, 45, 0, "StyleData", "BookPartNumber", \
"Printout",
  StyleMenuListing->None],
Cell[285468, 10997, 160, 4, 70, 58, 0, "StyleData", "BookPartNumber", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[285665, 11006, 184, 6, 76, 32, 0, "StyleData", "BookPartTitle", "All",
  StyleMenuListing->None],
Cell[285852, 11014, 49, 0, 70, 49, 0, "StyleData", "BookPartTitle", \
"NumberedHeads"],
Cell[285904, 11016, 101, 2, 70, 48, 0, "StyleData", "BookPartTitle", \
"Presentation"],
Cell[286008, 11020, 122, 3, 70, 44, 0, "StyleData", "BookPartTitle", \
"Printout",
  StyleMenuListing->None],
Cell[286133, 11025, 135, 3, 70, 57, 0, "StyleData", "BookPartTitle", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[286305, 11033, 187, 6, 62, 35, 0, "StyleData", "BookPartSubtitle", "All",
  
  StyleMenuListing->None],
Cell[286495, 11041, 52, 0, 70, 52, 0, "StyleData", "BookPartSubtitle", \
"NumberedHeads"],
Cell[286550, 11043, 104, 2, 70, 51, 0, "StyleData", "BookPartSubtitle", \
"Presentation"],
Cell[286657, 11047, 125, 3, 70, 47, 0, "StyleData", "BookPartSubtitle", \
"Printout",
  StyleMenuListing->None],
Cell[286785, 11052, 138, 3, 70, 60, 0, "StyleData", "BookPartSubtitle", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[286960, 11060, 199, 6, 54, 38, 0, "StyleData", "BookPartSubsubtitle", \
"All",
  StyleMenuListing->None],
Cell[287162, 11068, 55, 0, 70, 55, 0, "StyleData", "BookPartSubsubtitle", \
"NumberedHeads"],
Cell[287220, 11070, 114, 2, 70, 54, 0, "StyleData", "BookPartSubsubtitle", \
"Presentation"],
Cell[287337, 11074, 136, 3, 70, 50, 0, "StyleData", "BookPartSubsubtitle", \
"Printout",
  StyleMenuListing->None],
Cell[287476, 11079, 149, 3, 70, 63, 0, "StyleData", "BookPartSubsubtitle", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[287662, 11087, 139, 4, 43, 31, 0, "StyleData", "BookPartText", "All",
  StyleMenuListing->None],
Cell[287804, 11093, 48, 0, 70, 48, 0, "StyleData", "BookPartText", \
"NumberedHeads"],
Cell[287855, 11095, 123, 3, 70, 47, 0, "StyleData", "BookPartText", \
"Presentation"],
Cell[287981, 11100, 143, 4, 70, 43, 0, "StyleData", "BookPartText", \
"Printout",
  StyleMenuListing->None],
Cell[288127, 11106, 156, 4, 70, 56, 0, "StyleData", "BookPartText", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[288320, 11115, 124, 3, 43, 39, 0, "StyleData", "BookPartTextNoIndent", \
"All",
  StyleMenuListing->None],
Cell[288447, 11120, 56, 0, 70, 56, 0, "StyleData", "BookPartTextNoIndent", \
"NumberedHeads"],
Cell[288506, 11122, 108, 2, 70, 55, 0, "StyleData", "BookPartTextNoIndent", \
"Presentation"],
Cell[288617, 11126, 128, 3, 70, 51, 0, "StyleData", "BookPartTextNoIndent", \
"Printout",
  StyleMenuListing->None],
Cell[288748, 11131, 141, 3, 70, 64, 0, "StyleData", "BookPartTextNoIndent", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[288938, 11140, 107, 3, 35, "Subsection"],

Cell[CellGroupData[{
Cell[289070, 11147, 601, 16, 70, 35, 0, "StyleData", "BookChapterLabel", \
"All",
  CounterIncrements->"Chapter",
  CounterAssignments->{{"Section", 0}, {"Subsection", 0}, {
      "Subsubsection", 0}, {"EquationNumbered", 0}, {"FigureCaption", 0}, {
      "PictureCaption", 0}, {"ProgramCaption", 0}, {"TableTitle", 0}},
  StyleMenuListing->None],
Cell[289674, 11165, 52, 0, 70, 52, 0, "StyleData", "BookChapterLabel", \
"NumberedHeads"],
Cell[289729, 11167, 129, 3, 70, 51, 0, "StyleData", "BookChapterLabel", \
"Presentation"],
Cell[289861, 11172, 97, 2, 70, 47, 0, "StyleData", "BookChapterLabel", \
"Printout"],
Cell[289961, 11176, 110, 2, 70, 60, 0, "StyleData", "BookChapterLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[290108, 11183, 185, 6, 70, 36, 0, "StyleData", "BookChapterNumber", \
"All",
  StyleMenuListing->None],
Cell[290296, 11191, 53, 0, 70, 53, 0, "StyleData", "BookChapterNumber", \
"NumberedHeads"],
Cell[290352, 11193, 68, 1, 70, 52, 0, "StyleData", "BookChapterNumber", \
"Presentation"],
Cell[290423, 11196, 64, 1, 70, 48, 0, "StyleData", "BookChapterNumber", \
"Printout"],
Cell[290490, 11199, 77, 1, 70, 61, 0, "StyleData", "BookChapterNumber", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[290604, 11205, 162, 5, 70, 35, 0, "StyleData", "BookChapterTitle", "All",
  
  StyleMenuListing->None],
Cell[290769, 11212, 52, 0, 70, 52, 0, "StyleData", "BookChapterTitle", \
"NumberedHeads"],
Cell[290824, 11214, 103, 2, 70, 51, 0, "StyleData", "BookChapterTitle", \
"Presentation"],
Cell[290930, 11218, 123, 3, 70, 47, 0, "StyleData", "BookChapterTitle", \
"Printout",
  StyleMenuListing->None],
Cell[291056, 11223, 136, 3, 70, 60, 0, "StyleData", "BookChapterTitle", \
"NumberedHeadsPrintout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[291229, 11231, 64, 1, 70, 38, 0, "StyleData", "BookChapterSubtitle", \
"All",
  StyleMenuListing->None],
Cell[291296, 11234, 55, 0, 70, 55, 0, "StyleData", "BookChapterSubtitle", \
"NumberedHeads"],
Cell[291354, 11236, 54, 0, 70, 54, 0, "StyleData", "BookChapterSubtitle", \
"Presentation"],
Cell[291411, 11238, 50, 0, 70, 50, 0, "StyleData", "BookChapterSubtitle", \
"Printout"],
Cell[291464, 11240, 63, 0, 70, 63, 0, "StyleData", "BookChapterSubtitle", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[291564, 11245, 67, 1, 70, 41, 0, "StyleData", "BookChapterSubsubtitle", \
"All",
  StyleMenuListing->None],
Cell[291634, 11248, 58, 0, 70, 58, 0, "StyleData", "BookChapterSubsubtitle", \
"NumberedHeads"],
Cell[291695, 11250, 57, 0, 70, 57, 0, "StyleData", "BookChapterSubsubtitle", \
"Presentation"],
Cell[291755, 11252, 53, 0, 70, 53, 0, "StyleData", "BookChapterSubsubtitle", \
"Printout"],
Cell[291811, 11254, 66, 0, 70, 66, 0, "StyleData", "BookChapterSubsubtitle", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[291926, 11260, 56, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[292007, 11265, 152, 4, 70, 27, 0, "StyleData", "Epigraph", "All",
  StyleMenuListing->None],
Cell[292162, 11271, 44, 0, 70, 44, 0, "StyleData", "Epigraph", \
"NumberedHeads"],
Cell[292209, 11273, 59, 1, 70, 43, 0, "StyleData", "Epigraph", \
"Presentation"],
Cell[292271, 11276, 90, 2, 70, 39, 0, "StyleData", "Epigraph", "Printout"],
Cell[292364, 11280, 103, 2, 70, 52, 0, "StyleData", "Epigraph", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[292504, 11287, 137, 3, 70, 33, 0, "StyleData", "EpigraphAuthor", "All",
  StyleMenuListing->None],
Cell[292644, 11292, 50, 0, 70, 50, 0, "StyleData", "EpigraphAuthor", \
"NumberedHeads"],
Cell[292697, 11294, 102, 2, 70, 49, 0, "StyleData", "EpigraphAuthor", \
"Presentation"],
Cell[292802, 11298, 98, 2, 70, 45, 0, "StyleData", "EpigraphAuthor", \
"Printout"],
Cell[292903, 11302, 111, 2, 70, 58, 0, "StyleData", "EpigraphAuthor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[293063, 11310, 37, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[293125, 11314, 33, 0, 70, "Subsubsection"],

Cell[CellGroupData[{
Cell[293183, 11318, 60, 1, 70, 34, 0, "StyleData", "GlossarySection", "All",
  StyleMenuListing->None],
Cell[293246, 11321, 51, 0, 70, 51, 0, "StyleData", "GlossarySection", \
"NumberedHeads"],
Cell[293300, 11323, 50, 0, 70, 50, 0, "StyleData", "GlossarySection", \
"Presentation"],
Cell[293353, 11325, 46, 0, 70, 46, 0, "StyleData", "GlossarySection", \
"Printout"],
Cell[293402, 11327, 59, 0, 70, 59, 0, "StyleData", "GlossarySection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[293498, 11332, 58, 1, 70, 32, 0, "StyleData", "GlossaryEntry", "All",
  StyleMenuListing->None],
Cell[293559, 11335, 49, 0, 70, 49, 0, "StyleData", "GlossaryEntry", \
"NumberedHeads"],
Cell[293611, 11337, 48, 0, 70, 48, 0, "StyleData", "GlossaryEntry", \
"Presentation"],
Cell[293662, 11339, 44, 0, 70, 44, 0, "StyleData", "GlossaryEntry", \
"Printout"],
Cell[293709, 11341, 57, 0, 70, 57, 0, "StyleData", "GlossaryEntry", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[293827, 11348, 52, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[293904, 11352, 53, 1, 70, 27, 0, "StyleData", "Colophon", "All",
  StyleMenuListing->None],
Cell[293960, 11355, 44, 0, 70, 44, 0, "StyleData", "Colophon", \
"NumberedHeads"],
Cell[294007, 11357, 43, 0, 70, 43, 0, "StyleData", "Colophon", \
"Presentation"],
Cell[294053, 11359, 39, 0, 70, 39, 0, "StyleData", "Colophon", "Printout"],
Cell[294095, 11361, 52, 0, 70, 52, 0, "StyleData", "Colophon", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[294184, 11366, 66, 1, 70, 40, 0, "StyleData", "AcknowledgmentsAuthor", \
"All",
  StyleMenuListing->None],
Cell[294253, 11369, 57, 0, 70, 57, 0, "StyleData", "AcknowledgmentsAuthor", \
"NumberedHeads"],
Cell[294313, 11371, 56, 0, 70, 56, 0, "StyleData", "AcknowledgmentsAuthor", \
"Presentation"],
Cell[294372, 11373, 52, 0, 70, 52, 0, "StyleData", "AcknowledgmentsAuthor", \
"Printout"],
Cell[294427, 11375, 65, 0, 70, 65, 0, "StyleData", "AcknowledgmentsAuthor", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[294553, 11382, 38, 0, 34, "Section"],
Cell[294594, 11384, 123, 4, 70, 25, 0, "StyleData", "Header", "All",
  StyleMenuListing->None],
Cell[294720, 11390, 122, 4, 70, 25, 0, "StyleData", "Footer", "All",
  StyleMenuListing->None],
Cell[294845, 11396, 127, 4, 70, 29, 0, "StyleData", "PageNumber", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[295009, 11405, 32, 0, 34, "Section"],
Cell[295044, 11407, 213, 5, 40, 34, 0, "StyleData", "TextSuperscript", "All",
  StyleMenuListing->None],
Cell[295260, 11414, 109, 3, 40, 32, 0, "StyleData", "TextSubscript", "All",
  StyleMenuListing->None],
Cell[295372, 11419, 48, 1, 40, 22, 0, "StyleData", "Nil", "All",
  StyleMenuListing->None],
Cell[295423, 11422, 69, 2, 40, 27, 0, "StyleData", "Verbatim", "All",
  StyleMenuListing->None],
Cell[295495, 11426, 117, 3, 40, 26, 0, "StyleData", "TeXName", "All",
  StyleMenuListing->None],
Cell[295615, 11431, 121, 3, 40, 28, 0, "StyleData", "LaTeXName", "All",
  StyleMenuListing->None],
Cell[295739, 11436, 123, 3, 40, 29, 0, "StyleData", "LaTeXeName", "All",
  StyleMenuListing->None],
Cell[295865, 11441, 114, 3, 40, 34, 0, "StyleData", "ChemicalElement", "All",
  StyleMenuListing->None],
Cell[295982, 11446, 90, 2, 40, 34, 0, "StyleData", "CustomCharacter", "All",
  StyleMenuListing->None],
Cell[296075, 11450, 52, 1, 40, 26, 0, "StyleData", "Palette", "All",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[296152, 11455, 561, 17, 8, 28, 0, "StyleData", "PageBreak", "All",
  StyleMenuListing->None],
Cell[296716, 11474, 119, 3, 70, 40, 0, "StyleData", "PageBreak", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[296872, 11482, 178, 6, 55, 31, 0, "StyleData", "CreationDate", "All",
  StyleMenuListing->None],
Cell[297053, 11490, 114, 3, 70, 43, 0, "StyleData", "CreationDate", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[297204, 11498, 39, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[297268, 11502, 150, 4, 70, 29, 0, "StyleData", "SingleLine", "All",
  StyleMenuListing->None],
Cell[297421, 11508, 136, 3, 70, 41, 0, "StyleData", "SingleLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[297594, 11516, 263, 8, 70, 29, 0, "StyleData", "DoubleLine", "All",
  StyleMenuListing->None],
Cell[297860, 11526, 90, 2, 70, 41, 0, "StyleData", "DoubleLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[297987, 11533, 287, 9, 70, 27, 0, "StyleData", "ThinLine", "All",
  StyleMenuListing->None],
Cell[298277, 11544, 39, 0, 70, 39, 0, "StyleData", "ThinLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[298353, 11549, 287, 9, 70, 29, 0, "StyleData", "MediumLine", "All",
  StyleMenuListing->None],
Cell[298643, 11560, 41, 0, 70, 41, 0, "StyleData", "MediumLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[298721, 11565, 286, 9, 70, 28, 0, "StyleData", "ThickLine", "All",
  StyleMenuListing->None],
Cell[299010, 11576, 40, 0, 70, 40, 0, "StyleData", "ThickLine", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[299087, 11581, 100, 2, 70, 25, 0, "StyleData", "Spacer", "All",
  StyleMenuListing->None],
Cell[299190, 11585, 37, 0, 70, 37, 0, "StyleData", "Spacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[299264, 11590, 55, 1, 70, 29, 0, "StyleData", "TextSpacer", "All",
  StyleMenuListing->None],
Cell[299322, 11593, 41, 0, 70, 41, 0, "StyleData", "TextSpacer", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[299400, 11598, 58, 1, 70, 32, 0, "StyleData", "SectionSpacer", "All",
  StyleMenuListing->None],
Cell[299461, 11601, 44, 0, 70, 44, 0, "StyleData", "SectionSpacer", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[299542, 11606, 59, 1, 70, 33, 0, "StyleData", "GraphicsSpacer", "All",
  StyleMenuListing->None],
Cell[299604, 11609, 45, 0, 70, 45, 0, "StyleData", "GraphicsSpacer", \
"Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[299698, 11615, 52, 1, 35, "Subsection"],

Cell[CellGroupData[{
Cell[299775, 11620, 307, 9, 70, 28, 0, "StyleData", "VitaGroup", "All",
  StyleMenuListing->None],
Cell[300085, 11631, 45, 0, 70, 45, 0, "StyleData", "VitaGroup", \
"NumberedHeads"],
Cell[300133, 11633, 152, 4, 70, 44, 0, "StyleData", "VitaGroup", \
"Presentation"],
Cell[300288, 11639, 115, 3, 70, 40, 0, "StyleData", "VitaGroup", "Printout"],
Cell[300406, 11644, 128, 3, 70, 53, 0, "StyleData", "VitaGroup", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[300571, 11652, 90, 2, 70, 29, 0, "StyleData", "VitaAuthor", "All",
  StyleMenuListing->None],
Cell[300664, 11656, 46, 0, 70, 46, 0, "StyleData", "VitaAuthor", \
"NumberedHeads"],
Cell[300713, 11658, 124, 3, 70, 45, 0, "StyleData", "VitaAuthor", \
"Presentation",
  StyleMenuListing->None],
Cell[300840, 11663, 90, 2, 70, 41, 0, "StyleData", "VitaAuthor", "Printout"],
Cell[300933, 11667, 103, 2, 70, 54, 0, "StyleData", "VitaAuthor", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[301073, 11674, 102, 2, 70, 41, 0, "StyleData", "VitaContactInformation", \
"All",
  StyleMenuListing->None],
Cell[301178, 11678, 58, 0, 70, 58, 0, "StyleData", "VitaContactInformation", \
"NumberedHeads"],
Cell[301239, 11680, 108, 2, 70, 57, 0, "StyleData", "VitaContactInformation", \
"Presentation"],
Cell[301350, 11684, 102, 2, 70, 53, 0, "StyleData", "VitaContactInformation", \
"Printout"],
Cell[301455, 11688, 115, 2, 70, 66, 0, "StyleData", "VitaContactInformation", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[301607, 11695, 202, 6, 70, 30, 0, "StyleData", "VitaSection", "All",
  StyleMenuListing->None],
Cell[301812, 11703, 47, 0, 70, 47, 0, "StyleData", "VitaSection", \
"NumberedHeads"],
Cell[301862, 11705, 98, 2, 70, 46, 0, "StyleData", "VitaSection", \
"Presentation"],
Cell[301963, 11709, 92, 2, 70, 42, 0, "StyleData", "VitaSection", \
"Printout"],
Cell[302058, 11713, 105, 2, 70, 55, 0, "StyleData", "VitaSection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[302200, 11720, 277, 8, 70, 33, 0, "StyleData", "VitaSubsection", "All",
  StyleMenuListing->None],
Cell[302480, 11730, 50, 0, 70, 50, 0, "StyleData", "VitaSubsection", \
"NumberedHeads"],
Cell[302533, 11732, 170, 4, 70, 49, 0, "StyleData", "VitaSubsection", \
"Presentation"],
Cell[302706, 11738, 95, 2, 70, 45, 0, "StyleData", "VitaSubsection", \
"Printout"],
Cell[302804, 11742, 108, 2, 70, 58, 0, "StyleData", "VitaSubsection", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[302949, 11749, 578, 12, 70, 27, 0, "StyleData", "VitaItem", "All",
  StyleMenuListing->None],
Cell[303530, 11763, 44, 0, 70, 44, 0, "StyleData", "VitaItem", \
"NumberedHeads"],
Cell[303577, 11765, 122, 3, 70, 43, 0, "StyleData", "VitaItem", \
"Presentation"],
Cell[303702, 11770, 88, 2, 70, 39, 0, "StyleData", "VitaItem", "Printout"],
Cell[303793, 11774, 101, 2, 70, 52, 0, "StyleData", "VitaItem", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[303931, 11781, 233, 7, 70, 32, 0, "StyleData", "VitaItemLabel", "All",
  StyleMenuListing->None],
Cell[304167, 11790, 49, 0, 70, 49, 0, "StyleData", "VitaItemLabel", \
"NumberedHeads"],
Cell[304219, 11792, 48, 0, 70, 48, 0, "StyleData", "VitaItemLabel", \
"Presentation"],
Cell[304270, 11794, 89, 2, 70, 44, 0, "StyleData", "VitaItemLabel", \
"Printout"],
Cell[304362, 11798, 102, 2, 70, 57, 0, "StyleData", "VitaItemLabel", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[304501, 11805, 328, 6, 70, 36, 0, "StyleData", "VitaItemParagraph", \
"All",
  CounterAssignments->{{"Item2Numbered", 0}, {"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[304832, 11813, 53, 0, 70, 53, 0, "StyleData", "VitaItemParagraph", \
"NumberedHeads"],
Cell[304888, 11815, 103, 2, 70, 52, 0, "StyleData", "VitaItemParagraph", \
"Presentation"],
Cell[304994, 11819, 98, 2, 70, 48, 0, "StyleData", "VitaItemParagraph", \
"Printout"],
Cell[305095, 11823, 111, 2, 70, 61, 0, "StyleData", "VitaItemParagraph", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[305243, 11830, 84, 2, 70, 23, 0, "StyleData", "Vita", "All",
  StyleMenuListing->None],
Cell[305330, 11834, 40, 0, 70, 40, 0, "StyleData", "Vita", "NumberedHeads"],
Cell[305373, 11836, 90, 2, 70, 39, 0, "StyleData", "Vita", "Presentation"],
Cell[305466, 11840, 68, 1, 70, 35, 0, "StyleData", "Vita", "Printout"],
Cell[305537, 11843, 81, 1, 70, 48, 0, "StyleData", "Vita", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[305667, 11850, 29, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[305721, 11854, 494, 12, 70, 27, 0, "StyleData", "Outline1", "All",
  CounterIncrements->"Outline1",
  CounterAssignments->{{"Outline2", 0}},
  StyleMenuListing->None],
Cell[306218, 11868, 44, 0, 70, 44, 0, "StyleData", "Outline1", \
"NumberedHeads"],
Cell[306265, 11870, 127, 3, 70, 43, 0, "StyleData", "Outline1", \
"Presentation"],
Cell[306395, 11875, 88, 2, 70, 39, 0, "StyleData", "Outline1", "Printout"],
Cell[306486, 11879, 101, 2, 70, 52, 0, "StyleData", "Outline1", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[306624, 11886, 133, 4, 70, 32, 0, "StyleData", "Outline1Label", "All",
  StyleMenuListing->None],
Cell[306760, 11892, 49, 0, 70, 49, 0, "StyleData", "Outline1Label", \
"NumberedHeads"],
Cell[306812, 11894, 77, 1, 70, 48, 0, "StyleData", "Outline1Label", \
"Presentation"],
Cell[306892, 11897, 73, 1, 70, 44, 0, "StyleData", "Outline1Label", \
"Printout"],
Cell[306968, 11900, 86, 1, 70, 57, 0, "StyleData", "Outline1Label", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[307091, 11906, 520, 13, 70, 27, 0, "StyleData", "Outline2", "All",
  CounterIncrements->"Outline2",
  CounterAssignments->{{"Outline3", 0}},
  StyleMenuListing->None],
Cell[307614, 11921, 44, 0, 70, 44, 0, "StyleData", "Outline2", \
"NumberedHeads"],
Cell[307661, 11923, 96, 2, 70, 43, 0, "StyleData", "Outline2", \
"Presentation"],
Cell[307760, 11927, 89, 2, 70, 39, 0, "StyleData", "Outline2", "Printout"],
Cell[307852, 11931, 102, 2, 70, 52, 0, "StyleData", "Outline2", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[307991, 11938, 133, 4, 70, 32, 0, "StyleData", "Outline2Label", "All",
  StyleMenuListing->None],
Cell[308127, 11944, 49, 0, 70, 49, 0, "StyleData", "Outline2Label", \
"NumberedHeads"],
Cell[308179, 11946, 77, 1, 70, 48, 0, "StyleData", "Outline2Label", \
"Presentation"],
Cell[308259, 11949, 73, 1, 70, 44, 0, "StyleData", "Outline2Label", \
"Printout"],
Cell[308335, 11952, 86, 1, 70, 57, 0, "StyleData", "Outline2Label", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[308458, 11958, 461, 11, 70, 27, 0, "StyleData", "Outline3", "All",
  CounterIncrements->"Outline3",
  CounterAssignments->{{"Outline4", 0}},
  StyleMenuListing->None],
Cell[308922, 11971, 44, 0, 70, 44, 0, "StyleData", "Outline3", \
"NumberedHeads"],
Cell[308969, 11973, 96, 2, 70, 43, 0, "StyleData", "Outline3", \
"Presentation"],
Cell[309068, 11977, 89, 2, 70, 39, 0, "StyleData", "Outline3", "Printout"],
Cell[309160, 11981, 102, 2, 70, 52, 0, "StyleData", "Outline3", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[309299, 11988, 133, 4, 70, 32, 0, "StyleData", "Outline3Label", "All",
  StyleMenuListing->None],
Cell[309435, 11994, 49, 0, 70, 49, 0, "StyleData", "Outline3Label", \
"NumberedHeads"],
Cell[309487, 11996, 77, 1, 70, 48, 0, "StyleData", "Outline3Label", \
"Presentation"],
Cell[309567, 11999, 73, 1, 70, 44, 0, "StyleData", "Outline3Label", \
"Printout"],
Cell[309643, 12002, 86, 1, 70, 57, 0, "StyleData", "Outline3Label", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[309766, 12008, 457, 11, 70, 27, 0, "StyleData", "Outline4", "All",
  CounterIncrements->"Outline4",
  StyleMenuListing->None],
Cell[310226, 12021, 44, 0, 70, 44, 0, "StyleData", "Outline4", \
"NumberedHeads"],
Cell[310273, 12023, 97, 2, 70, 43, 0, "StyleData", "Outline4", \
"Presentation"],
Cell[310373, 12027, 89, 2, 70, 39, 0, "StyleData", "Outline4", "Printout"],
Cell[310465, 12031, 102, 2, 70, 52, 0, "StyleData", "Outline4", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[310604, 12038, 133, 4, 70, 32, 0, "StyleData", "Outline4Label", "All",
  StyleMenuListing->None],
Cell[310740, 12044, 49, 0, 70, 49, 0, "StyleData", "Outline4Label", \
"NumberedHeads"],
Cell[310792, 12046, 77, 1, 70, 48, 0, "StyleData", "Outline4Label", \
"Presentation"],
Cell[310872, 12049, 73, 1, 70, 44, 0, "StyleData", "Outline4Label", \
"Printout"],
Cell[310948, 12052, 86, 1, 70, 57, 0, "StyleData", "Outline4Label", \
"NumberedHeadsPrintout"]
}, Closed]],

Cell[CellGroupData[{
Cell[311071, 12058, 283, 8, 70, 30, 0, "StyleData", "OutlineText", "All",
  CounterIncrements->"Text",
  StyleMenuListing->None],
Cell[311357, 12068, 47, 0, 70, 47, 0, "StyleData", "OutlineText", \
"NumberedHeads"],
Cell[311407, 12070, 98, 2, 70, 46, 0, "StyleData", "OutlineText", \
"Presentation"],
Cell[311508, 12074, 139, 4, 70, 42, 0, "StyleData", "OutlineText", \
"Printout"],
Cell[311650, 12080, 152, 4, 70, 55, 0, "StyleData", "OutlineText", \
"NumberedHeadsPrintout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[311851, 12090, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[311908, 12094, 811, 24, 70, 41, 0, "StyleData", \
"SlideShowNavigationBar", "All",
  CounterIncrements->"SlideShowNavigationBar",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[312722, 12120, 198, 5, 70, 53, 0, "StyleData", "SlideShowNavigationBar", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[312957, 12130, 322, 10, 70, 33, 0, "StyleData", "SlideHyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[313282, 12142, 49, 0, 70, 49, 0, "StyleData", "SlideHyperlink", \
"Presentation"],
Cell[313334, 12144, 45, 0, 70, 45, 0, "StyleData", "SlideHyperlink", \
"Printout"]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[313440, 12151, 32, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[313497, 12155, 71, 1, 39, "Subsection"],
Cell[313571, 12158, 92, 3, 38, 21, 0, "StyleData", "RM", "All",
  StyleMenuListing->None],
Cell[313666, 12163, 119, 3, 38, 21, 0, "StyleData", "BF", "All",
  StyleMenuListing->None],
Cell[313788, 12168, 159, 4, 38, 21, 0, "StyleData", "IT", "All",
  StyleMenuListing->None],
Cell[313950, 12174, 190, 4, 34, 28, 0, "StyleData", "SmallCaps", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[314177, 12183, 77, 1, 35, "Subsection"],
Cell[314257, 12186, 115, 4, 38, 21, 0, "StyleData", "TR", "All",
  StyleMenuListing->None],
Cell[314375, 12192, 205, 6, 38, 21, 0, "StyleData", "TI", "All",
  StyleMenuListing->None],
Cell[314583, 12200, 203, 6, 38, 21, 0, "StyleData", "TB", "All",
  StyleMenuListing->None],
Cell[314789, 12208, 215, 6, 38, 22, 0, "StyleData", "TBI", "All",
  StyleMenuListing->None],
Cell[315007, 12216, 294, 8, 37, 21, 0, "StyleData", "MR", "All",
  StyleMenuListing->None],
Cell[315304, 12226, 305, 8, 38, 21, 0, "StyleData", "MO", "All",
  StyleMenuListing->None],
Cell[315612, 12236, 303, 8, 37, 21, 0, "StyleData", "MB", "All",
  StyleMenuListing->None],
Cell[315918, 12246, 315, 8, 38, 22, 0, "StyleData", "MBO", "All",
  StyleMenuListing->None],
Cell[316236, 12256, 208, 6, 38, 21, 0, "StyleData", "SR", "All",
  StyleMenuListing->None],
Cell[316447, 12264, 219, 6, 38, 21, 0, "StyleData", "SO", "All",
  StyleMenuListing->None],
Cell[316669, 12272, 217, 6, 38, 21, 0, "StyleData", "SB", "All",
  StyleMenuListing->None],
Cell[316889, 12280, 229, 6, 38, 22, 0, "StyleData", "SBO", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[317155, 12291, 32, 0, 35, "Subsection"],

Cell[CellGroupData[{
Cell[317212, 12295, 386, 10, 40, 28, 0, "StyleData", "Hyperlink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[317601, 12307, 123, 3, 37, 40, 0, "StyleData", "Hyperlink", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[317761, 12315, 289, 8, 40, 29, 0, "StyleData", "XMLWebLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[318053, 12325, 108, 2, 70, 41, 0, "StyleData", "XMLWebLink", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[318198, 12332, 425, 12, 40, 27, 0, "StyleData", "PageLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[318626, 12346, 82, 2, 37, 39, 0, "StyleData", "PageLink", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[318745, 12353, 50, 0, 34, "Subsubsection"],

Cell[CellGroupData[{
Cell[318820, 12357, 313, 8, 40, 32, 0, "StyleData", "UserGuideLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[319136, 12367, 111, 2, 70, 44, 0, "StyleData", "UserGuideLink", \
"Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[319284, 12374, 313, 8, 40, 32, 0, "StyleData", "ReferenceLink", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->None],
Cell[319600, 12384, 111, 2, 70, 44, 0, "StyleData", "ReferenceLink", \
"Printout"]
}, Closed]]
}, Closed]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[319784, 12394, 25, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[319834, 12398, 65, 1, 39, "Subsection"],
Cell[319902, 12401, 304, 7, 122, "Text"],
Cell[320209, 12410, 314, 10, 40, 33, 0, "StyleData", "CellExpression", "All",
  StyleMenuListing->None],
Cell[320526, 12422, 106, 3, 40, 28, 0, "StyleData", "InputForm", "All",
  StyleMenuListing->None],
Cell[320635, 12427, 151, 5, 40, 29, 0, "StyleData", "OutputForm", "All",
  StyleMenuListing->None],
Cell[320789, 12434, 341, 8, 40, 31, 0, "StyleData", "StandardForm", "All",
  StyleMenuListing->None],
Cell[321133, 12444, 179, 5, 40, 34, 0, "StyleData", "TraditionalForm", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[321349, 12454, 53, 0, 35, "Subsection"],
Cell[321405, 12456, 122, 3, 70, 36, 0, "StyleData", "ReferenceTemplate", \
"All",
  StyleMenuListing->None],
Cell[321530, 12461, 136, 3, 70, 50, 0, "StyleData", \
"AuthorFormCustomizationTemplate", "All",
  StyleMenuListing->None],
Cell[321669, 12466, 119, 3, 70, 33, 0, "StyleData", "CSSDefinitions", "All",
  StyleMenuListing->None],
Cell[321791, 12471, 118, 3, 70, 32, 0, "StyleData", "LaTeXPreamble", "All",
  StyleMenuListing->None],
Cell[321912, 12476, 118, 3, 70, 32, 0, "StyleData", "DOCTYPEFormat", "All",
  StyleMenuListing->None],
Cell[322033, 12481, 122, 3, 70, 36, 0, "StyleData", "ValidationSetting", \
"All",
  StyleMenuListing->None],
Cell[322158, 12486, 124, 3, 70, 38, 0, "StyleData", "XRefPaletteSettings", \
"All",
  StyleMenuListing->None],
Cell[322285, 12491, 117, 3, 70, 31, 0, "StyleData", "MiscSettings", "All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[322439, 12499, 60, 1, 35, "Subsection"],
Cell[322502, 12502, 116, 5, 84, "Text"],
Cell[322621, 12509, 110, 3, 40, 29, 0, "StyleData", "InlineCell", "All",
  StyleMenuListing->None],
Cell[322734, 12514, 116, 2, 56, 36, 0, "StyleData", "InlineCellEditing", \
"All",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[322887, 12521, 55, 1, 39, "Subsection"],
Cell[322945, 12524, 122, 5, 70, "Text"],
Cell[323070, 12531, 226, 5, 70, 24, 0, "StyleData", "Paste", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[323299, 12538, 183, 4, 70, 29, 0, "StyleData", "StyleApply", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[323485, 12544, 257, 6, 70, 45, 0, "StyleData", \
"StyleApplyWithVerification", "All",
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic],
Cell[323745, 12552, 296, 7, 70, 35, 0, "StyleData", "ConvertCharacter", "All",
  
  StyleMenuListing->None,
  ButtonStyleMenuListing->Automatic]
}, Closed]],

Cell[CellGroupData[{
Cell[324078, 12564, 57, 1, 35, "Subsection"],
Cell[324138, 12567, 330, 9, 70, "Text"],
Cell[324471, 12578, 109, 2, 70, 35, 0, "StyleData", "UnmatchedBracket", "All",
  
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[324617, 12585, 61, 1, 35, "Subsection"],
Cell[324681, 12588, 189, 5, 70, 55, 0, "StyleData", \
"DialogStyleSheetMisapplicationEscape", "All",
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[324919, 12599, 30, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[324974, 12603, 60, 1, 70, "Subsection"],
Cell[325037, 12606, 364, 6, 70, "Text"],

Cell[CellGroupData[{
Cell[325426, 12616, 681, 20, 70, 24, 0, "StyleData", "Input", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],
Cell[326110, 12638, 130, 3, 70, 36, 0, "StyleData", "Input", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[326277, 12646, 900, 26, 70, 32, 0, "StyleData", "InputNumbered", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],
Cell[327180, 12674, 138, 3, 70, 44, 0, "StyleData", "InputNumbered", \
"Printout"]
}, Closed]],
Cell[327333, 12680, 325, 11, 70, 28, 0, "StyleData", "InputOnly", "All",
  CounterIncrements->"Input",
  StyleMenuListing->None],

Cell[CellGroupData[{
Cell[327683, 12695, 622, 18, 70, 25, 0, "StyleData", "Output", "All",
  CounterIncrements->"Output",
  StyleMenuListing->None],
Cell[328308, 12715, 86, 2, 70, 37, 0, "StyleData", "Output", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[328431, 12722, 516, 15, 70, 26, 0, "StyleData", "Message", "All",
  CounterIncrements->"Message",
  StyleMenuListing->None],
Cell[328950, 12739, 138, 3, 70, 38, 0, "StyleData", "Message", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[329125, 12747, 480, 14, 70, 24, 0, "StyleData", "Print", "All",
  CounterIncrements->"Print",
  StyleMenuListing->None],
Cell[329608, 12763, 109, 2, 70, 36, 0, "StyleData", "Print", "Printout"]
}, Closed]],
Cell[329732, 12768, 280, 7, 70, "Text"],

Cell[CellGroupData[{
Cell[330037, 12779, 519, 17, 70, 27, 0, "StyleData", "Graphics", "All",
  CounterIncrements->"Graphics",
  StyleMenuListing->None],
Cell[330559, 12798, 144, 4, 70, 39, 0, "StyleData", "Graphics", "Printout"]
}, Closed]],

Cell[CellGroupData[{
Cell[330740, 12807, 154, 5, 70, 28, 0, "StyleData", "CellLabel", "All",
  StyleMenuListing->None],
Cell[330897, 12814, 130, 4, 70, 40, 0, "StyleData", "CellLabel", "Printout"]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[331076, 12824, 67, 1, 70, "Subsection"],

Cell[CellGroupData[{
Cell[331168, 12829, 56, 1, 70, 30, 0, "StyleData", "MathCaption", "All",
  StyleMenuListing->None],
Cell[331227, 12832, 68, 1, 70, 42, 0, "StyleData", "MathCaption", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[331332, 12838, 53, 1, 70, 27, 0, "StyleData", "UserTips", "All",
  StyleMenuListing->None],
Cell[331388, 12841, 65, 1, 70, 39, 0, "StyleData", "UserTips", "Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[331490, 12847, 57, 1, 70, 31, 0, "StyleData", "UserTipsList", "All",
  StyleMenuListing->None],
Cell[331550, 12850, 69, 1, 70, 43, 0, "StyleData", "UserTipsList", "Printout",
  
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[331656, 12856, 57, 1, 70, 31, 0, "StyleData", "IndentedText", "All",
  StyleMenuListing->None],
Cell[331716, 12859, 69, 1, 70, 43, 0, "StyleData", "IndentedText", "Printout",
  
  StyleMenuListing->None]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{
Cell[331834, 12866, 45, 0, 70, "Subsection"],

Cell[CellGroupData[{
Cell[331904, 12870, 527, 14, 70, 35, 0, "StyleData", "Item1NumberedNew", \
"All",
  CounterIncrements->"Item1Numbered",
  CounterAssignments->{{"Item1Numbered", 0}},
  StyleMenuListing->None],
Cell[332434, 12886, 194, 6, 70, 47, 0, "StyleData", "Item1NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[332665, 12897, 511, 13, 70, 35, 0, "StyleData", "Item2NumberedNew", \
"All",
  CounterIncrements->"Item2Numbered",
  CounterAssignments->{{"Item2Numbered", 0}},
  StyleMenuListing->None],
Cell[333179, 12912, 195, 6, 70, 47, 0, "StyleData", "Item2NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]],

Cell[CellGroupData[{
Cell[333411, 12923, 511, 13, 70, 35, 0, "StyleData", "Item3NumberedNew", \
"All",
  CounterIncrements->"Item3Numbered",
  CounterAssignments->{{"Item3Numbered", 0}},
  StyleMenuListing->None],
Cell[333925, 12938, 195, 6, 70, 47, 0, "StyleData", "Item3NumberedNew", \
"Printout",
  StyleMenuListing->None]
}, Closed]]
}, Closed]]
}, Closed]]
}, Open  ]]
}
]
*)



(*******************************************************************
End of Mathematica Notebook file.
*******************************************************************)

